/*! kdbxweb v2.0.0-beta.2, (c) 2021 Antelle, opensource.org/licenses/MIT */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("crypto"), require("xmldom"));
	else if(typeof define === 'function' && define.amd)
		define(["crypto", "xmldom"], factory);
	else if(typeof exports === 'object')
		exports["kdbxweb"] = factory(require("crypto"), require("xmldom"));
	else
		root["kdbxweb"] = factory(root["crypto"], root["xmldom"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_crypto__, __WEBPACK_EXTERNAL_MODULE_xmldom__) {
return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "../node_modules/pako/index.js":
/*!*************************************!*\
  !*** ../node_modules/pako/index.js ***!
  \*************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

// Top level file is just a mixin of submodules & constants


var assign    = __webpack_require__(/*! ./lib/utils/common */ "../node_modules/pako/lib/utils/common.js").assign;

var deflate   = __webpack_require__(/*! ./lib/deflate */ "../node_modules/pako/lib/deflate.js");
var inflate   = __webpack_require__(/*! ./lib/inflate */ "../node_modules/pako/lib/inflate.js");
var constants = __webpack_require__(/*! ./lib/zlib/constants */ "../node_modules/pako/lib/zlib/constants.js");

var pako = {};

assign(pako, deflate, inflate, constants);

module.exports = pako;


/***/ }),

/***/ "../node_modules/pako/lib/deflate.js":
/*!*******************************************!*\
  !*** ../node_modules/pako/lib/deflate.js ***!
  \*******************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {




var zlib_deflate = __webpack_require__(/*! ./zlib/deflate */ "../node_modules/pako/lib/zlib/deflate.js");
var utils        = __webpack_require__(/*! ./utils/common */ "../node_modules/pako/lib/utils/common.js");
var strings      = __webpack_require__(/*! ./utils/strings */ "../node_modules/pako/lib/utils/strings.js");
var msg          = __webpack_require__(/*! ./zlib/messages */ "../node_modules/pako/lib/zlib/messages.js");
var ZStream      = __webpack_require__(/*! ./zlib/zstream */ "../node_modules/pako/lib/zlib/zstream.js");

var toString = Object.prototype.toString;

/* Public constants ==========================================================*/
/* ===========================================================================*/

var Z_NO_FLUSH      = 0;
var Z_FINISH        = 4;

var Z_OK            = 0;
var Z_STREAM_END    = 1;
var Z_SYNC_FLUSH    = 2;

var Z_DEFAULT_COMPRESSION = -1;

var Z_DEFAULT_STRATEGY    = 0;

var Z_DEFLATED  = 8;

/* ===========================================================================*/


/**
 * class Deflate
 *
 * Generic JS-style wrapper for zlib calls. If you don't need
 * streaming behaviour - use more simple functions: [[deflate]],
 * [[deflateRaw]] and [[gzip]].
 **/

/* internal
 * Deflate.chunks -> Array
 *
 * Chunks of output data, if [[Deflate#onData]] not overriden.
 **/

/**
 * Deflate.result -> Uint8Array|Array
 *
 * Compressed result, generated by default [[Deflate#onData]]
 * and [[Deflate#onEnd]] handlers. Filled after you push last chunk
 * (call [[Deflate#push]] with `Z_FINISH` / `true` param)  or if you
 * push a chunk with explicit flush (call [[Deflate#push]] with
 * `Z_SYNC_FLUSH` param).
 **/

/**
 * Deflate.err -> Number
 *
 * Error code after deflate finished. 0 (Z_OK) on success.
 * You will not need it in real life, because deflate errors
 * are possible only on wrong options or bad `onData` / `onEnd`
 * custom handlers.
 **/

/**
 * Deflate.msg -> String
 *
 * Error message, if [[Deflate.err]] != 0
 **/


/**
 * new Deflate(options)
 * - options (Object): zlib deflate options.
 *
 * Creates new deflator instance with specified params. Throws exception
 * on bad params. Supported options:
 *
 * - `level`
 * - `windowBits`
 * - `memLevel`
 * - `strategy`
 * - `dictionary`
 *
 * [http://zlib.net/manual.html#Advanced](http://zlib.net/manual.html#Advanced)
 * for more information on these.
 *
 * Additional options, for internal needs:
 *
 * - `chunkSize` - size of generated data chunks (16K by default)
 * - `raw` (Boolean) - do raw deflate
 * - `gzip` (Boolean) - create gzip wrapper
 * - `to` (String) - if equal to 'string', then result will be "binary string"
 *    (each char code [0..255])
 * - `header` (Object) - custom header for gzip
 *   - `text` (Boolean) - true if compressed data believed to be text
 *   - `time` (Number) - modification time, unix timestamp
 *   - `os` (Number) - operation system code
 *   - `extra` (Array) - array of bytes with extra data (max 65536)
 *   - `name` (String) - file name (binary string)
 *   - `comment` (String) - comment (binary string)
 *   - `hcrc` (Boolean) - true if header crc should be added
 *
 * ##### Example:
 *
 * ```javascript
 * var pako = require('pako')
 *   , chunk1 = Uint8Array([1,2,3,4,5,6,7,8,9])
 *   , chunk2 = Uint8Array([10,11,12,13,14,15,16,17,18,19]);
 *
 * var deflate = new pako.Deflate({ level: 3});
 *
 * deflate.push(chunk1, false);
 * deflate.push(chunk2, true);  // true -> last chunk
 *
 * if (deflate.err) { throw new Error(deflate.err); }
 *
 * console.log(deflate.result);
 * ```
 **/
function Deflate(options) {
  if (!(this instanceof Deflate)) return new Deflate(options);

  this.options = utils.assign({
    level: Z_DEFAULT_COMPRESSION,
    method: Z_DEFLATED,
    chunkSize: 16384,
    windowBits: 15,
    memLevel: 8,
    strategy: Z_DEFAULT_STRATEGY,
    to: ''
  }, options || {});

  var opt = this.options;

  if (opt.raw && (opt.windowBits > 0)) {
    opt.windowBits = -opt.windowBits;
  }

  else if (opt.gzip && (opt.windowBits > 0) && (opt.windowBits < 16)) {
    opt.windowBits += 16;
  }

  this.err    = 0;      // error code, if happens (0 = Z_OK)
  this.msg    = '';     // error message
  this.ended  = false;  // used to avoid multiple onEnd() calls
  this.chunks = [];     // chunks of compressed data

  this.strm = new ZStream();
  this.strm.avail_out = 0;

  var status = zlib_deflate.deflateInit2(
    this.strm,
    opt.level,
    opt.method,
    opt.windowBits,
    opt.memLevel,
    opt.strategy
  );

  if (status !== Z_OK) {
    throw new Error(msg[status]);
  }

  if (opt.header) {
    zlib_deflate.deflateSetHeader(this.strm, opt.header);
  }

  if (opt.dictionary) {
    var dict;
    // Convert data if needed
    if (typeof opt.dictionary === 'string') {
      // If we need to compress text, change encoding to utf8.
      dict = strings.string2buf(opt.dictionary);
    } else if (toString.call(opt.dictionary) === '[object ArrayBuffer]') {
      dict = new Uint8Array(opt.dictionary);
    } else {
      dict = opt.dictionary;
    }

    status = zlib_deflate.deflateSetDictionary(this.strm, dict);

    if (status !== Z_OK) {
      throw new Error(msg[status]);
    }

    this._dict_set = true;
  }
}

/**
 * Deflate#push(data[, mode]) -> Boolean
 * - data (Uint8Array|Array|ArrayBuffer|String): input data. Strings will be
 *   converted to utf8 byte sequence.
 * - mode (Number|Boolean): 0..6 for corresponding Z_NO_FLUSH..Z_TREE modes.
 *   See constants. Skipped or `false` means Z_NO_FLUSH, `true` meansh Z_FINISH.
 *
 * Sends input data to deflate pipe, generating [[Deflate#onData]] calls with
 * new compressed chunks. Returns `true` on success. The last data block must have
 * mode Z_FINISH (or `true`). That will flush internal pending buffers and call
 * [[Deflate#onEnd]]. For interim explicit flushes (without ending the stream) you
 * can use mode Z_SYNC_FLUSH, keeping the compression context.
 *
 * On fail call [[Deflate#onEnd]] with error code and return false.
 *
 * We strongly recommend to use `Uint8Array` on input for best speed (output
 * array format is detected automatically). Also, don't skip last param and always
 * use the same type in your code (boolean or number). That will improve JS speed.
 *
 * For regular `Array`-s make sure all elements are [0..255].
 *
 * ##### Example
 *
 * ```javascript
 * push(chunk, false); // push one of data chunks
 * ...
 * push(chunk, true);  // push last chunk
 * ```
 **/
Deflate.prototype.push = function (data, mode) {
  var strm = this.strm;
  var chunkSize = this.options.chunkSize;
  var status, _mode;

  if (this.ended) { return false; }

  _mode = (mode === ~~mode) ? mode : ((mode === true) ? Z_FINISH : Z_NO_FLUSH);

  // Convert data if needed
  if (typeof data === 'string') {
    // If we need to compress text, change encoding to utf8.
    strm.input = strings.string2buf(data);
  } else if (toString.call(data) === '[object ArrayBuffer]') {
    strm.input = new Uint8Array(data);
  } else {
    strm.input = data;
  }

  strm.next_in = 0;
  strm.avail_in = strm.input.length;

  do {
    if (strm.avail_out === 0) {
      strm.output = new utils.Buf8(chunkSize);
      strm.next_out = 0;
      strm.avail_out = chunkSize;
    }
    status = zlib_deflate.deflate(strm, _mode);    /* no bad return value */

    if (status !== Z_STREAM_END && status !== Z_OK) {
      this.onEnd(status);
      this.ended = true;
      return false;
    }
    if (strm.avail_out === 0 || (strm.avail_in === 0 && (_mode === Z_FINISH || _mode === Z_SYNC_FLUSH))) {
      if (this.options.to === 'string') {
        this.onData(strings.buf2binstring(utils.shrinkBuf(strm.output, strm.next_out)));
      } else {
        this.onData(utils.shrinkBuf(strm.output, strm.next_out));
      }
    }
  } while ((strm.avail_in > 0 || strm.avail_out === 0) && status !== Z_STREAM_END);

  // Finalize on the last chunk.
  if (_mode === Z_FINISH) {
    status = zlib_deflate.deflateEnd(this.strm);
    this.onEnd(status);
    this.ended = true;
    return status === Z_OK;
  }

  // callback interim results if Z_SYNC_FLUSH.
  if (_mode === Z_SYNC_FLUSH) {
    this.onEnd(Z_OK);
    strm.avail_out = 0;
    return true;
  }

  return true;
};


/**
 * Deflate#onData(chunk) -> Void
 * - chunk (Uint8Array|Array|String): ouput data. Type of array depends
 *   on js engine support. When string output requested, each chunk
 *   will be string.
 *
 * By default, stores data blocks in `chunks[]` property and glue
 * those in `onEnd`. Override this handler, if you need another behaviour.
 **/
Deflate.prototype.onData = function (chunk) {
  this.chunks.push(chunk);
};


/**
 * Deflate#onEnd(status) -> Void
 * - status (Number): deflate status. 0 (Z_OK) on success,
 *   other if not.
 *
 * Called once after you tell deflate that the input stream is
 * complete (Z_FINISH) or should be flushed (Z_SYNC_FLUSH)
 * or if an error happened. By default - join collected chunks,
 * free memory and fill `results` / `err` properties.
 **/
Deflate.prototype.onEnd = function (status) {
  // On success - join
  if (status === Z_OK) {
    if (this.options.to === 'string') {
      this.result = this.chunks.join('');
    } else {
      this.result = utils.flattenChunks(this.chunks);
    }
  }
  this.chunks = [];
  this.err = status;
  this.msg = this.strm.msg;
};


/**
 * deflate(data[, options]) -> Uint8Array|Array|String
 * - data (Uint8Array|Array|String): input data to compress.
 * - options (Object): zlib deflate options.
 *
 * Compress `data` with deflate algorithm and `options`.
 *
 * Supported options are:
 *
 * - level
 * - windowBits
 * - memLevel
 * - strategy
 * - dictionary
 *
 * [http://zlib.net/manual.html#Advanced](http://zlib.net/manual.html#Advanced)
 * for more information on these.
 *
 * Sugar (options):
 *
 * - `raw` (Boolean) - say that we work with raw stream, if you don't wish to specify
 *   negative windowBits implicitly.
 * - `to` (String) - if equal to 'string', then result will be "binary string"
 *    (each char code [0..255])
 *
 * ##### Example:
 *
 * ```javascript
 * var pako = require('pako')
 *   , data = Uint8Array([1,2,3,4,5,6,7,8,9]);
 *
 * console.log(pako.deflate(data));
 * ```
 **/
function deflate(input, options) {
  var deflator = new Deflate(options);

  deflator.push(input, true);

  // That will never happens, if you don't cheat with options :)
  if (deflator.err) { throw deflator.msg; }

  return deflator.result;
}


/**
 * deflateRaw(data[, options]) -> Uint8Array|Array|String
 * - data (Uint8Array|Array|String): input data to compress.
 * - options (Object): zlib deflate options.
 *
 * The same as [[deflate]], but creates raw data, without wrapper
 * (header and adler32 crc).
 **/
function deflateRaw(input, options) {
  options = options || {};
  options.raw = true;
  return deflate(input, options);
}


/**
 * gzip(data[, options]) -> Uint8Array|Array|String
 * - data (Uint8Array|Array|String): input data to compress.
 * - options (Object): zlib deflate options.
 *
 * The same as [[deflate]], but create gzip wrapper instead of
 * deflate one.
 **/
function gzip(input, options) {
  options = options || {};
  options.gzip = true;
  return deflate(input, options);
}


exports.Deflate = Deflate;
exports.deflate = deflate;
exports.deflateRaw = deflateRaw;
exports.gzip = gzip;


/***/ }),

/***/ "../node_modules/pako/lib/inflate.js":
/*!*******************************************!*\
  !*** ../node_modules/pako/lib/inflate.js ***!
  \*******************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {




var zlib_inflate = __webpack_require__(/*! ./zlib/inflate */ "../node_modules/pako/lib/zlib/inflate.js");
var utils        = __webpack_require__(/*! ./utils/common */ "../node_modules/pako/lib/utils/common.js");
var strings      = __webpack_require__(/*! ./utils/strings */ "../node_modules/pako/lib/utils/strings.js");
var c            = __webpack_require__(/*! ./zlib/constants */ "../node_modules/pako/lib/zlib/constants.js");
var msg          = __webpack_require__(/*! ./zlib/messages */ "../node_modules/pako/lib/zlib/messages.js");
var ZStream      = __webpack_require__(/*! ./zlib/zstream */ "../node_modules/pako/lib/zlib/zstream.js");
var GZheader     = __webpack_require__(/*! ./zlib/gzheader */ "../node_modules/pako/lib/zlib/gzheader.js");

var toString = Object.prototype.toString;

/**
 * class Inflate
 *
 * Generic JS-style wrapper for zlib calls. If you don't need
 * streaming behaviour - use more simple functions: [[inflate]]
 * and [[inflateRaw]].
 **/

/* internal
 * inflate.chunks -> Array
 *
 * Chunks of output data, if [[Inflate#onData]] not overriden.
 **/

/**
 * Inflate.result -> Uint8Array|Array|String
 *
 * Uncompressed result, generated by default [[Inflate#onData]]
 * and [[Inflate#onEnd]] handlers. Filled after you push last chunk
 * (call [[Inflate#push]] with `Z_FINISH` / `true` param) or if you
 * push a chunk with explicit flush (call [[Inflate#push]] with
 * `Z_SYNC_FLUSH` param).
 **/

/**
 * Inflate.err -> Number
 *
 * Error code after inflate finished. 0 (Z_OK) on success.
 * Should be checked if broken data possible.
 **/

/**
 * Inflate.msg -> String
 *
 * Error message, if [[Inflate.err]] != 0
 **/


/**
 * new Inflate(options)
 * - options (Object): zlib inflate options.
 *
 * Creates new inflator instance with specified params. Throws exception
 * on bad params. Supported options:
 *
 * - `windowBits`
 * - `dictionary`
 *
 * [http://zlib.net/manual.html#Advanced](http://zlib.net/manual.html#Advanced)
 * for more information on these.
 *
 * Additional options, for internal needs:
 *
 * - `chunkSize` - size of generated data chunks (16K by default)
 * - `raw` (Boolean) - do raw inflate
 * - `to` (String) - if equal to 'string', then result will be converted
 *   from utf8 to utf16 (javascript) string. When string output requested,
 *   chunk length can differ from `chunkSize`, depending on content.
 *
 * By default, when no options set, autodetect deflate/gzip data format via
 * wrapper header.
 *
 * ##### Example:
 *
 * ```javascript
 * var pako = require('pako')
 *   , chunk1 = Uint8Array([1,2,3,4,5,6,7,8,9])
 *   , chunk2 = Uint8Array([10,11,12,13,14,15,16,17,18,19]);
 *
 * var inflate = new pako.Inflate({ level: 3});
 *
 * inflate.push(chunk1, false);
 * inflate.push(chunk2, true);  // true -> last chunk
 *
 * if (inflate.err) { throw new Error(inflate.err); }
 *
 * console.log(inflate.result);
 * ```
 **/
function Inflate(options) {
  if (!(this instanceof Inflate)) return new Inflate(options);

  this.options = utils.assign({
    chunkSize: 16384,
    windowBits: 0,
    to: ''
  }, options || {});

  var opt = this.options;

  // Force window size for `raw` data, if not set directly,
  // because we have no header for autodetect.
  if (opt.raw && (opt.windowBits >= 0) && (opt.windowBits < 16)) {
    opt.windowBits = -opt.windowBits;
    if (opt.windowBits === 0) { opt.windowBits = -15; }
  }

  // If `windowBits` not defined (and mode not raw) - set autodetect flag for gzip/deflate
  if ((opt.windowBits >= 0) && (opt.windowBits < 16) &&
      !(options && options.windowBits)) {
    opt.windowBits += 32;
  }

  // Gzip header has no info about windows size, we can do autodetect only
  // for deflate. So, if window size not set, force it to max when gzip possible
  if ((opt.windowBits > 15) && (opt.windowBits < 48)) {
    // bit 3 (16) -> gzipped data
    // bit 4 (32) -> autodetect gzip/deflate
    if ((opt.windowBits & 15) === 0) {
      opt.windowBits |= 15;
    }
  }

  this.err    = 0;      // error code, if happens (0 = Z_OK)
  this.msg    = '';     // error message
  this.ended  = false;  // used to avoid multiple onEnd() calls
  this.chunks = [];     // chunks of compressed data

  this.strm   = new ZStream();
  this.strm.avail_out = 0;

  var status  = zlib_inflate.inflateInit2(
    this.strm,
    opt.windowBits
  );

  if (status !== c.Z_OK) {
    throw new Error(msg[status]);
  }

  this.header = new GZheader();

  zlib_inflate.inflateGetHeader(this.strm, this.header);
}

/**
 * Inflate#push(data[, mode]) -> Boolean
 * - data (Uint8Array|Array|ArrayBuffer|String): input data
 * - mode (Number|Boolean): 0..6 for corresponding Z_NO_FLUSH..Z_TREE modes.
 *   See constants. Skipped or `false` means Z_NO_FLUSH, `true` meansh Z_FINISH.
 *
 * Sends input data to inflate pipe, generating [[Inflate#onData]] calls with
 * new output chunks. Returns `true` on success. The last data block must have
 * mode Z_FINISH (or `true`). That will flush internal pending buffers and call
 * [[Inflate#onEnd]]. For interim explicit flushes (without ending the stream) you
 * can use mode Z_SYNC_FLUSH, keeping the decompression context.
 *
 * On fail call [[Inflate#onEnd]] with error code and return false.
 *
 * We strongly recommend to use `Uint8Array` on input for best speed (output
 * format is detected automatically). Also, don't skip last param and always
 * use the same type in your code (boolean or number). That will improve JS speed.
 *
 * For regular `Array`-s make sure all elements are [0..255].
 *
 * ##### Example
 *
 * ```javascript
 * push(chunk, false); // push one of data chunks
 * ...
 * push(chunk, true);  // push last chunk
 * ```
 **/
Inflate.prototype.push = function (data, mode) {
  var strm = this.strm;
  var chunkSize = this.options.chunkSize;
  var dictionary = this.options.dictionary;
  var status, _mode;
  var next_out_utf8, tail, utf8str;
  var dict;

  // Flag to properly process Z_BUF_ERROR on testing inflate call
  // when we check that all output data was flushed.
  var allowBufError = false;

  if (this.ended) { return false; }
  _mode = (mode === ~~mode) ? mode : ((mode === true) ? c.Z_FINISH : c.Z_NO_FLUSH);

  // Convert data if needed
  if (typeof data === 'string') {
    // Only binary strings can be decompressed on practice
    strm.input = strings.binstring2buf(data);
  } else if (toString.call(data) === '[object ArrayBuffer]') {
    strm.input = new Uint8Array(data);
  } else {
    strm.input = data;
  }

  strm.next_in = 0;
  strm.avail_in = strm.input.length;

  do {
    if (strm.avail_out === 0) {
      strm.output = new utils.Buf8(chunkSize);
      strm.next_out = 0;
      strm.avail_out = chunkSize;
    }

    status = zlib_inflate.inflate(strm, c.Z_NO_FLUSH);    /* no bad return value */

    if (status === c.Z_NEED_DICT && dictionary) {
      // Convert data if needed
      if (typeof dictionary === 'string') {
        dict = strings.string2buf(dictionary);
      } else if (toString.call(dictionary) === '[object ArrayBuffer]') {
        dict = new Uint8Array(dictionary);
      } else {
        dict = dictionary;
      }

      status = zlib_inflate.inflateSetDictionary(this.strm, dict);

    }

    if (status === c.Z_BUF_ERROR && allowBufError === true) {
      status = c.Z_OK;
      allowBufError = false;
    }

    if (status !== c.Z_STREAM_END && status !== c.Z_OK) {
      this.onEnd(status);
      this.ended = true;
      return false;
    }

    if (strm.next_out) {
      if (strm.avail_out === 0 || status === c.Z_STREAM_END || (strm.avail_in === 0 && (_mode === c.Z_FINISH || _mode === c.Z_SYNC_FLUSH))) {

        if (this.options.to === 'string') {

          next_out_utf8 = strings.utf8border(strm.output, strm.next_out);

          tail = strm.next_out - next_out_utf8;
          utf8str = strings.buf2string(strm.output, next_out_utf8);

          // move tail
          strm.next_out = tail;
          strm.avail_out = chunkSize - tail;
          if (tail) { utils.arraySet(strm.output, strm.output, next_out_utf8, tail, 0); }

          this.onData(utf8str);

        } else {
          this.onData(utils.shrinkBuf(strm.output, strm.next_out));
        }
      }
    }

    // When no more input data, we should check that internal inflate buffers
    // are flushed. The only way to do it when avail_out = 0 - run one more
    // inflate pass. But if output data not exists, inflate return Z_BUF_ERROR.
    // Here we set flag to process this error properly.
    //
    // NOTE. Deflate does not return error in this case and does not needs such
    // logic.
    if (strm.avail_in === 0 && strm.avail_out === 0) {
      allowBufError = true;
    }

  } while ((strm.avail_in > 0 || strm.avail_out === 0) && status !== c.Z_STREAM_END);

  if (status === c.Z_STREAM_END) {
    _mode = c.Z_FINISH;
  }

  // Finalize on the last chunk.
  if (_mode === c.Z_FINISH) {
    status = zlib_inflate.inflateEnd(this.strm);
    this.onEnd(status);
    this.ended = true;
    return status === c.Z_OK;
  }

  // callback interim results if Z_SYNC_FLUSH.
  if (_mode === c.Z_SYNC_FLUSH) {
    this.onEnd(c.Z_OK);
    strm.avail_out = 0;
    return true;
  }

  return true;
};


/**
 * Inflate#onData(chunk) -> Void
 * - chunk (Uint8Array|Array|String): ouput data. Type of array depends
 *   on js engine support. When string output requested, each chunk
 *   will be string.
 *
 * By default, stores data blocks in `chunks[]` property and glue
 * those in `onEnd`. Override this handler, if you need another behaviour.
 **/
Inflate.prototype.onData = function (chunk) {
  this.chunks.push(chunk);
};


/**
 * Inflate#onEnd(status) -> Void
 * - status (Number): inflate status. 0 (Z_OK) on success,
 *   other if not.
 *
 * Called either after you tell inflate that the input stream is
 * complete (Z_FINISH) or should be flushed (Z_SYNC_FLUSH)
 * or if an error happened. By default - join collected chunks,
 * free memory and fill `results` / `err` properties.
 **/
Inflate.prototype.onEnd = function (status) {
  // On success - join
  if (status === c.Z_OK) {
    if (this.options.to === 'string') {
      // Glue & convert here, until we teach pako to send
      // utf8 alligned strings to onData
      this.result = this.chunks.join('');
    } else {
      this.result = utils.flattenChunks(this.chunks);
    }
  }
  this.chunks = [];
  this.err = status;
  this.msg = this.strm.msg;
};


/**
 * inflate(data[, options]) -> Uint8Array|Array|String
 * - data (Uint8Array|Array|String): input data to decompress.
 * - options (Object): zlib inflate options.
 *
 * Decompress `data` with inflate/ungzip and `options`. Autodetect
 * format via wrapper header by default. That's why we don't provide
 * separate `ungzip` method.
 *
 * Supported options are:
 *
 * - windowBits
 *
 * [http://zlib.net/manual.html#Advanced](http://zlib.net/manual.html#Advanced)
 * for more information.
 *
 * Sugar (options):
 *
 * - `raw` (Boolean) - say that we work with raw stream, if you don't wish to specify
 *   negative windowBits implicitly.
 * - `to` (String) - if equal to 'string', then result will be converted
 *   from utf8 to utf16 (javascript) string. When string output requested,
 *   chunk length can differ from `chunkSize`, depending on content.
 *
 *
 * ##### Example:
 *
 * ```javascript
 * var pako = require('pako')
 *   , input = pako.deflate([1,2,3,4,5,6,7,8,9])
 *   , output;
 *
 * try {
 *   output = pako.inflate(input);
 * } catch (err)
 *   console.log(err);
 * }
 * ```
 **/
function inflate(input, options) {
  var inflator = new Inflate(options);

  inflator.push(input, true);

  // That will never happens, if you don't cheat with options :)
  if (inflator.err) { throw inflator.msg; }

  return inflator.result;
}


/**
 * inflateRaw(data[, options]) -> Uint8Array|Array|String
 * - data (Uint8Array|Array|String): input data to decompress.
 * - options (Object): zlib inflate options.
 *
 * The same as [[inflate]], but creates raw data, without wrapper
 * (header and adler32 crc).
 **/
function inflateRaw(input, options) {
  options = options || {};
  options.raw = true;
  return inflate(input, options);
}


/**
 * ungzip(data[, options]) -> Uint8Array|Array|String
 * - data (Uint8Array|Array|String): input data to decompress.
 * - options (Object): zlib inflate options.
 *
 * Just shortcut to [[inflate]], because it autodetects format
 * by header.content. Done for convenience.
 **/


exports.Inflate = Inflate;
exports.inflate = inflate;
exports.inflateRaw = inflateRaw;
exports.ungzip  = inflate;


/***/ }),

/***/ "../node_modules/pako/lib/utils/common.js":
/*!************************************************!*\
  !*** ../node_modules/pako/lib/utils/common.js ***!
  \************************************************/
/***/ ((__unused_webpack_module, exports) => {




var TYPED_OK =  (typeof Uint8Array !== 'undefined') &&
                (typeof Uint16Array !== 'undefined') &&
                (typeof Int32Array !== 'undefined');


exports.assign = function (obj /*from1, from2, from3, ...*/) {
  var sources = Array.prototype.slice.call(arguments, 1);
  while (sources.length) {
    var source = sources.shift();
    if (!source) { continue; }

    if (typeof source !== 'object') {
      throw new TypeError(source + 'must be non-object');
    }

    for (var p in source) {
      if (source.hasOwnProperty(p)) {
        obj[p] = source[p];
      }
    }
  }

  return obj;
};


// reduce buffer size, avoiding mem copy
exports.shrinkBuf = function (buf, size) {
  if (buf.length === size) { return buf; }
  if (buf.subarray) { return buf.subarray(0, size); }
  buf.length = size;
  return buf;
};


var fnTyped = {
  arraySet: function (dest, src, src_offs, len, dest_offs) {
    if (src.subarray && dest.subarray) {
      dest.set(src.subarray(src_offs, src_offs + len), dest_offs);
      return;
    }
    // Fallback to ordinary array
    for (var i = 0; i < len; i++) {
      dest[dest_offs + i] = src[src_offs + i];
    }
  },
  // Join array of chunks to single array.
  flattenChunks: function (chunks) {
    var i, l, len, pos, chunk, result;

    // calculate data length
    len = 0;
    for (i = 0, l = chunks.length; i < l; i++) {
      len += chunks[i].length;
    }

    // join chunks
    result = new Uint8Array(len);
    pos = 0;
    for (i = 0, l = chunks.length; i < l; i++) {
      chunk = chunks[i];
      result.set(chunk, pos);
      pos += chunk.length;
    }

    return result;
  }
};

var fnUntyped = {
  arraySet: function (dest, src, src_offs, len, dest_offs) {
    for (var i = 0; i < len; i++) {
      dest[dest_offs + i] = src[src_offs + i];
    }
  },
  // Join array of chunks to single array.
  flattenChunks: function (chunks) {
    return [].concat.apply([], chunks);
  }
};


// Enable/Disable typed arrays use, for testing
//
exports.setTyped = function (on) {
  if (on) {
    exports.Buf8  = Uint8Array;
    exports.Buf16 = Uint16Array;
    exports.Buf32 = Int32Array;
    exports.assign(exports, fnTyped);
  } else {
    exports.Buf8  = Array;
    exports.Buf16 = Array;
    exports.Buf32 = Array;
    exports.assign(exports, fnUntyped);
  }
};

exports.setTyped(TYPED_OK);


/***/ }),

/***/ "../node_modules/pako/lib/utils/strings.js":
/*!*************************************************!*\
  !*** ../node_modules/pako/lib/utils/strings.js ***!
  \*************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

// String encode/decode helpers



var utils = __webpack_require__(/*! ./common */ "../node_modules/pako/lib/utils/common.js");


// Quick check if we can use fast array to bin string conversion
//
// - apply(Array) can fail on Android 2.2
// - apply(Uint8Array) can fail on iOS 5.1 Safary
//
var STR_APPLY_OK = true;
var STR_APPLY_UIA_OK = true;

try { String.fromCharCode.apply(null, [ 0 ]); } catch (__) { STR_APPLY_OK = false; }
try { String.fromCharCode.apply(null, new Uint8Array(1)); } catch (__) { STR_APPLY_UIA_OK = false; }


// Table with utf8 lengths (calculated by first byte of sequence)
// Note, that 5 & 6-byte values and some 4-byte values can not be represented in JS,
// because max possible codepoint is 0x10ffff
var _utf8len = new utils.Buf8(256);
for (var q = 0; q < 256; q++) {
  _utf8len[q] = (q >= 252 ? 6 : q >= 248 ? 5 : q >= 240 ? 4 : q >= 224 ? 3 : q >= 192 ? 2 : 1);
}
_utf8len[254] = _utf8len[254] = 1; // Invalid sequence start


// convert string to array (typed, when possible)
exports.string2buf = function (str) {
  var buf, c, c2, m_pos, i, str_len = str.length, buf_len = 0;

  // count binary size
  for (m_pos = 0; m_pos < str_len; m_pos++) {
    c = str.charCodeAt(m_pos);
    if ((c & 0xfc00) === 0xd800 && (m_pos + 1 < str_len)) {
      c2 = str.charCodeAt(m_pos + 1);
      if ((c2 & 0xfc00) === 0xdc00) {
        c = 0x10000 + ((c - 0xd800) << 10) + (c2 - 0xdc00);
        m_pos++;
      }
    }
    buf_len += c < 0x80 ? 1 : c < 0x800 ? 2 : c < 0x10000 ? 3 : 4;
  }

  // allocate buffer
  buf = new utils.Buf8(buf_len);

  // convert
  for (i = 0, m_pos = 0; i < buf_len; m_pos++) {
    c = str.charCodeAt(m_pos);
    if ((c & 0xfc00) === 0xd800 && (m_pos + 1 < str_len)) {
      c2 = str.charCodeAt(m_pos + 1);
      if ((c2 & 0xfc00) === 0xdc00) {
        c = 0x10000 + ((c - 0xd800) << 10) + (c2 - 0xdc00);
        m_pos++;
      }
    }
    if (c < 0x80) {
      /* one byte */
      buf[i++] = c;
    } else if (c < 0x800) {
      /* two bytes */
      buf[i++] = 0xC0 | (c >>> 6);
      buf[i++] = 0x80 | (c & 0x3f);
    } else if (c < 0x10000) {
      /* three bytes */
      buf[i++] = 0xE0 | (c >>> 12);
      buf[i++] = 0x80 | (c >>> 6 & 0x3f);
      buf[i++] = 0x80 | (c & 0x3f);
    } else {
      /* four bytes */
      buf[i++] = 0xf0 | (c >>> 18);
      buf[i++] = 0x80 | (c >>> 12 & 0x3f);
      buf[i++] = 0x80 | (c >>> 6 & 0x3f);
      buf[i++] = 0x80 | (c & 0x3f);
    }
  }

  return buf;
};

// Helper (used in 2 places)
function buf2binstring(buf, len) {
  // use fallback for big arrays to avoid stack overflow
  if (len < 65537) {
    if ((buf.subarray && STR_APPLY_UIA_OK) || (!buf.subarray && STR_APPLY_OK)) {
      return String.fromCharCode.apply(null, utils.shrinkBuf(buf, len));
    }
  }

  var result = '';
  for (var i = 0; i < len; i++) {
    result += String.fromCharCode(buf[i]);
  }
  return result;
}


// Convert byte array to binary string
exports.buf2binstring = function (buf) {
  return buf2binstring(buf, buf.length);
};


// Convert binary string (typed, when possible)
exports.binstring2buf = function (str) {
  var buf = new utils.Buf8(str.length);
  for (var i = 0, len = buf.length; i < len; i++) {
    buf[i] = str.charCodeAt(i);
  }
  return buf;
};


// convert array to string
exports.buf2string = function (buf, max) {
  var i, out, c, c_len;
  var len = max || buf.length;

  // Reserve max possible length (2 words per char)
  // NB: by unknown reasons, Array is significantly faster for
  //     String.fromCharCode.apply than Uint16Array.
  var utf16buf = new Array(len * 2);

  for (out = 0, i = 0; i < len;) {
    c = buf[i++];
    // quick process ascii
    if (c < 0x80) { utf16buf[out++] = c; continue; }

    c_len = _utf8len[c];
    // skip 5 & 6 byte codes
    if (c_len > 4) { utf16buf[out++] = 0xfffd; i += c_len - 1; continue; }

    // apply mask on first byte
    c &= c_len === 2 ? 0x1f : c_len === 3 ? 0x0f : 0x07;
    // join the rest
    while (c_len > 1 && i < len) {
      c = (c << 6) | (buf[i++] & 0x3f);
      c_len--;
    }

    // terminated by end of string?
    if (c_len > 1) { utf16buf[out++] = 0xfffd; continue; }

    if (c < 0x10000) {
      utf16buf[out++] = c;
    } else {
      c -= 0x10000;
      utf16buf[out++] = 0xd800 | ((c >> 10) & 0x3ff);
      utf16buf[out++] = 0xdc00 | (c & 0x3ff);
    }
  }

  return buf2binstring(utf16buf, out);
};


// Calculate max possible position in utf8 buffer,
// that will not break sequence. If that's not possible
// - (very small limits) return max size as is.
//
// buf[] - utf8 bytes array
// max   - length limit (mandatory);
exports.utf8border = function (buf, max) {
  var pos;

  max = max || buf.length;
  if (max > buf.length) { max = buf.length; }

  // go back from last position, until start of sequence found
  pos = max - 1;
  while (pos >= 0 && (buf[pos] & 0xC0) === 0x80) { pos--; }

  // Fuckup - very small and broken sequence,
  // return max, because we should return something anyway.
  if (pos < 0) { return max; }

  // If we came to start of buffer - that means vuffer is too small,
  // return max too.
  if (pos === 0) { return max; }

  return (pos + _utf8len[buf[pos]] > max) ? pos : max;
};


/***/ }),

/***/ "../node_modules/pako/lib/zlib/adler32.js":
/*!************************************************!*\
  !*** ../node_modules/pako/lib/zlib/adler32.js ***!
  \************************************************/
/***/ ((module) => {



// Note: adler32 takes 12% for level 0 and 2% for level 6.
// It doesn't worth to make additional optimizationa as in original.
// Small size is preferable.

function adler32(adler, buf, len, pos) {
  var s1 = (adler & 0xffff) |0,
      s2 = ((adler >>> 16) & 0xffff) |0,
      n = 0;

  while (len !== 0) {
    // Set limit ~ twice less than 5552, to keep
    // s2 in 31-bits, because we force signed ints.
    // in other case %= will fail.
    n = len > 2000 ? 2000 : len;
    len -= n;

    do {
      s1 = (s1 + buf[pos++]) |0;
      s2 = (s2 + s1) |0;
    } while (--n);

    s1 %= 65521;
    s2 %= 65521;
  }

  return (s1 | (s2 << 16)) |0;
}


module.exports = adler32;


/***/ }),

/***/ "../node_modules/pako/lib/zlib/constants.js":
/*!**************************************************!*\
  !*** ../node_modules/pako/lib/zlib/constants.js ***!
  \**************************************************/
/***/ ((module) => {




module.exports = {

  /* Allowed flush values; see deflate() and inflate() below for details */
  Z_NO_FLUSH:         0,
  Z_PARTIAL_FLUSH:    1,
  Z_SYNC_FLUSH:       2,
  Z_FULL_FLUSH:       3,
  Z_FINISH:           4,
  Z_BLOCK:            5,
  Z_TREES:            6,

  /* Return codes for the compression/decompression functions. Negative values
  * are errors, positive values are used for special but normal events.
  */
  Z_OK:               0,
  Z_STREAM_END:       1,
  Z_NEED_DICT:        2,
  Z_ERRNO:           -1,
  Z_STREAM_ERROR:    -2,
  Z_DATA_ERROR:      -3,
  //Z_MEM_ERROR:     -4,
  Z_BUF_ERROR:       -5,
  //Z_VERSION_ERROR: -6,

  /* compression levels */
  Z_NO_COMPRESSION:         0,
  Z_BEST_SPEED:             1,
  Z_BEST_COMPRESSION:       9,
  Z_DEFAULT_COMPRESSION:   -1,


  Z_FILTERED:               1,
  Z_HUFFMAN_ONLY:           2,
  Z_RLE:                    3,
  Z_FIXED:                  4,
  Z_DEFAULT_STRATEGY:       0,

  /* Possible values of the data_type field (though see inflate()) */
  Z_BINARY:                 0,
  Z_TEXT:                   1,
  //Z_ASCII:                1, // = Z_TEXT (deprecated)
  Z_UNKNOWN:                2,

  /* The deflate compression method */
  Z_DEFLATED:               8
  //Z_NULL:                 null // Use -1 or null inline, depending on var type
};


/***/ }),

/***/ "../node_modules/pako/lib/zlib/crc32.js":
/*!**********************************************!*\
  !*** ../node_modules/pako/lib/zlib/crc32.js ***!
  \**********************************************/
/***/ ((module) => {



// Note: we can't get significant speed boost here.
// So write code to minimize size - no pregenerated tables
// and array tools dependencies.


// Use ordinary array, since untyped makes no boost here
function makeTable() {
  var c, table = [];

  for (var n = 0; n < 256; n++) {
    c = n;
    for (var k = 0; k < 8; k++) {
      c = ((c & 1) ? (0xEDB88320 ^ (c >>> 1)) : (c >>> 1));
    }
    table[n] = c;
  }

  return table;
}

// Create table on load. Just 255 signed longs. Not a problem.
var crcTable = makeTable();


function crc32(crc, buf, len, pos) {
  var t = crcTable,
      end = pos + len;

  crc ^= -1;

  for (var i = pos; i < end; i++) {
    crc = (crc >>> 8) ^ t[(crc ^ buf[i]) & 0xFF];
  }

  return (crc ^ (-1)); // >>> 0;
}


module.exports = crc32;


/***/ }),

/***/ "../node_modules/pako/lib/zlib/deflate.js":
/*!************************************************!*\
  !*** ../node_modules/pako/lib/zlib/deflate.js ***!
  \************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var utils   = __webpack_require__(/*! ../utils/common */ "../node_modules/pako/lib/utils/common.js");
var trees   = __webpack_require__(/*! ./trees */ "../node_modules/pako/lib/zlib/trees.js");
var adler32 = __webpack_require__(/*! ./adler32 */ "../node_modules/pako/lib/zlib/adler32.js");
var crc32   = __webpack_require__(/*! ./crc32 */ "../node_modules/pako/lib/zlib/crc32.js");
var msg     = __webpack_require__(/*! ./messages */ "../node_modules/pako/lib/zlib/messages.js");

/* Public constants ==========================================================*/
/* ===========================================================================*/


/* Allowed flush values; see deflate() and inflate() below for details */
var Z_NO_FLUSH      = 0;
var Z_PARTIAL_FLUSH = 1;
//var Z_SYNC_FLUSH    = 2;
var Z_FULL_FLUSH    = 3;
var Z_FINISH        = 4;
var Z_BLOCK         = 5;
//var Z_TREES         = 6;


/* Return codes for the compression/decompression functions. Negative values
 * are errors, positive values are used for special but normal events.
 */
var Z_OK            = 0;
var Z_STREAM_END    = 1;
//var Z_NEED_DICT     = 2;
//var Z_ERRNO         = -1;
var Z_STREAM_ERROR  = -2;
var Z_DATA_ERROR    = -3;
//var Z_MEM_ERROR     = -4;
var Z_BUF_ERROR     = -5;
//var Z_VERSION_ERROR = -6;


/* compression levels */
//var Z_NO_COMPRESSION      = 0;
//var Z_BEST_SPEED          = 1;
//var Z_BEST_COMPRESSION    = 9;
var Z_DEFAULT_COMPRESSION = -1;


var Z_FILTERED            = 1;
var Z_HUFFMAN_ONLY        = 2;
var Z_RLE                 = 3;
var Z_FIXED               = 4;
var Z_DEFAULT_STRATEGY    = 0;

/* Possible values of the data_type field (though see inflate()) */
//var Z_BINARY              = 0;
//var Z_TEXT                = 1;
//var Z_ASCII               = 1; // = Z_TEXT
var Z_UNKNOWN             = 2;


/* The deflate compression method */
var Z_DEFLATED  = 8;

/*============================================================================*/


var MAX_MEM_LEVEL = 9;
/* Maximum value for memLevel in deflateInit2 */
var MAX_WBITS = 15;
/* 32K LZ77 window */
var DEF_MEM_LEVEL = 8;


var LENGTH_CODES  = 29;
/* number of length codes, not counting the special END_BLOCK code */
var LITERALS      = 256;
/* number of literal bytes 0..255 */
var L_CODES       = LITERALS + 1 + LENGTH_CODES;
/* number of Literal or Length codes, including the END_BLOCK code */
var D_CODES       = 30;
/* number of distance codes */
var BL_CODES      = 19;
/* number of codes used to transfer the bit lengths */
var HEAP_SIZE     = 2 * L_CODES + 1;
/* maximum heap size */
var MAX_BITS  = 15;
/* All codes must not exceed MAX_BITS bits */

var MIN_MATCH = 3;
var MAX_MATCH = 258;
var MIN_LOOKAHEAD = (MAX_MATCH + MIN_MATCH + 1);

var PRESET_DICT = 0x20;

var INIT_STATE = 42;
var EXTRA_STATE = 69;
var NAME_STATE = 73;
var COMMENT_STATE = 91;
var HCRC_STATE = 103;
var BUSY_STATE = 113;
var FINISH_STATE = 666;

var BS_NEED_MORE      = 1; /* block not completed, need more input or more output */
var BS_BLOCK_DONE     = 2; /* block flush performed */
var BS_FINISH_STARTED = 3; /* finish started, need only more output at next deflate */
var BS_FINISH_DONE    = 4; /* finish done, accept no more input or output */

var OS_CODE = 0x03; // Unix :) . Don't detect, use this default.

function err(strm, errorCode) {
  strm.msg = msg[errorCode];
  return errorCode;
}

function rank(f) {
  return ((f) << 1) - ((f) > 4 ? 9 : 0);
}

function zero(buf) { var len = buf.length; while (--len >= 0) { buf[len] = 0; } }


/* =========================================================================
 * Flush as much pending output as possible. All deflate() output goes
 * through this function so some applications may wish to modify it
 * to avoid allocating a large strm->output buffer and copying into it.
 * (See also read_buf()).
 */
function flush_pending(strm) {
  var s = strm.state;

  //_tr_flush_bits(s);
  var len = s.pending;
  if (len > strm.avail_out) {
    len = strm.avail_out;
  }
  if (len === 0) { return; }

  utils.arraySet(strm.output, s.pending_buf, s.pending_out, len, strm.next_out);
  strm.next_out += len;
  s.pending_out += len;
  strm.total_out += len;
  strm.avail_out -= len;
  s.pending -= len;
  if (s.pending === 0) {
    s.pending_out = 0;
  }
}


function flush_block_only(s, last) {
  trees._tr_flush_block(s, (s.block_start >= 0 ? s.block_start : -1), s.strstart - s.block_start, last);
  s.block_start = s.strstart;
  flush_pending(s.strm);
}


function put_byte(s, b) {
  s.pending_buf[s.pending++] = b;
}


/* =========================================================================
 * Put a short in the pending buffer. The 16-bit value is put in MSB order.
 * IN assertion: the stream state is correct and there is enough room in
 * pending_buf.
 */
function putShortMSB(s, b) {
//  put_byte(s, (Byte)(b >> 8));
//  put_byte(s, (Byte)(b & 0xff));
  s.pending_buf[s.pending++] = (b >>> 8) & 0xff;
  s.pending_buf[s.pending++] = b & 0xff;
}


/* ===========================================================================
 * Read a new buffer from the current input stream, update the adler32
 * and total number of bytes read.  All deflate() input goes through
 * this function so some applications may wish to modify it to avoid
 * allocating a large strm->input buffer and copying from it.
 * (See also flush_pending()).
 */
function read_buf(strm, buf, start, size) {
  var len = strm.avail_in;

  if (len > size) { len = size; }
  if (len === 0) { return 0; }

  strm.avail_in -= len;

  // zmemcpy(buf, strm->next_in, len);
  utils.arraySet(buf, strm.input, strm.next_in, len, start);
  if (strm.state.wrap === 1) {
    strm.adler = adler32(strm.adler, buf, len, start);
  }

  else if (strm.state.wrap === 2) {
    strm.adler = crc32(strm.adler, buf, len, start);
  }

  strm.next_in += len;
  strm.total_in += len;

  return len;
}


/* ===========================================================================
 * Set match_start to the longest match starting at the given string and
 * return its length. Matches shorter or equal to prev_length are discarded,
 * in which case the result is equal to prev_length and match_start is
 * garbage.
 * IN assertions: cur_match is the head of the hash chain for the current
 *   string (strstart) and its distance is <= MAX_DIST, and prev_length >= 1
 * OUT assertion: the match length is not greater than s->lookahead.
 */
function longest_match(s, cur_match) {
  var chain_length = s.max_chain_length;      /* max hash chain length */
  var scan = s.strstart; /* current string */
  var match;                       /* matched string */
  var len;                           /* length of current match */
  var best_len = s.prev_length;              /* best match length so far */
  var nice_match = s.nice_match;             /* stop if match long enough */
  var limit = (s.strstart > (s.w_size - MIN_LOOKAHEAD)) ?
      s.strstart - (s.w_size - MIN_LOOKAHEAD) : 0/*NIL*/;

  var _win = s.window; // shortcut

  var wmask = s.w_mask;
  var prev  = s.prev;

  /* Stop when cur_match becomes <= limit. To simplify the code,
   * we prevent matches with the string of window index 0.
   */

  var strend = s.strstart + MAX_MATCH;
  var scan_end1  = _win[scan + best_len - 1];
  var scan_end   = _win[scan + best_len];

  /* The code is optimized for HASH_BITS >= 8 and MAX_MATCH-2 multiple of 16.
   * It is easy to get rid of this optimization if necessary.
   */
  // Assert(s->hash_bits >= 8 && MAX_MATCH == 258, "Code too clever");

  /* Do not waste too much time if we already have a good match: */
  if (s.prev_length >= s.good_match) {
    chain_length >>= 2;
  }
  /* Do not look for matches beyond the end of the input. This is necessary
   * to make deflate deterministic.
   */
  if (nice_match > s.lookahead) { nice_match = s.lookahead; }

  // Assert((ulg)s->strstart <= s->window_size-MIN_LOOKAHEAD, "need lookahead");

  do {
    // Assert(cur_match < s->strstart, "no future");
    match = cur_match;

    /* Skip to next match if the match length cannot increase
     * or if the match length is less than 2.  Note that the checks below
     * for insufficient lookahead only occur occasionally for performance
     * reasons.  Therefore uninitialized memory will be accessed, and
     * conditional jumps will be made that depend on those values.
     * However the length of the match is limited to the lookahead, so
     * the output of deflate is not affected by the uninitialized values.
     */

    if (_win[match + best_len]     !== scan_end  ||
        _win[match + best_len - 1] !== scan_end1 ||
        _win[match]                !== _win[scan] ||
        _win[++match]              !== _win[scan + 1]) {
      continue;
    }

    /* The check at best_len-1 can be removed because it will be made
     * again later. (This heuristic is not always a win.)
     * It is not necessary to compare scan[2] and match[2] since they
     * are always equal when the other bytes match, given that
     * the hash keys are equal and that HASH_BITS >= 8.
     */
    scan += 2;
    match++;
    // Assert(*scan == *match, "match[2]?");

    /* We check for insufficient lookahead only every 8th comparison;
     * the 256th check will be made at strstart+258.
     */
    do {
      /*jshint noempty:false*/
    } while (_win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
             _win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
             _win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
             _win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
             scan < strend);

    // Assert(scan <= s->window+(unsigned)(s->window_size-1), "wild scan");

    len = MAX_MATCH - (strend - scan);
    scan = strend - MAX_MATCH;

    if (len > best_len) {
      s.match_start = cur_match;
      best_len = len;
      if (len >= nice_match) {
        break;
      }
      scan_end1  = _win[scan + best_len - 1];
      scan_end   = _win[scan + best_len];
    }
  } while ((cur_match = prev[cur_match & wmask]) > limit && --chain_length !== 0);

  if (best_len <= s.lookahead) {
    return best_len;
  }
  return s.lookahead;
}


/* ===========================================================================
 * Fill the window when the lookahead becomes insufficient.
 * Updates strstart and lookahead.
 *
 * IN assertion: lookahead < MIN_LOOKAHEAD
 * OUT assertions: strstart <= window_size-MIN_LOOKAHEAD
 *    At least one byte has been read, or avail_in == 0; reads are
 *    performed for at least two bytes (required for the zip translate_eol
 *    option -- not supported here).
 */
function fill_window(s) {
  var _w_size = s.w_size;
  var p, n, m, more, str;

  //Assert(s->lookahead < MIN_LOOKAHEAD, "already enough lookahead");

  do {
    more = s.window_size - s.lookahead - s.strstart;

    // JS ints have 32 bit, block below not needed
    /* Deal with !@#$% 64K limit: */
    //if (sizeof(int) <= 2) {
    //    if (more == 0 && s->strstart == 0 && s->lookahead == 0) {
    //        more = wsize;
    //
    //  } else if (more == (unsigned)(-1)) {
    //        /* Very unlikely, but possible on 16 bit machine if
    //         * strstart == 0 && lookahead == 1 (input done a byte at time)
    //         */
    //        more--;
    //    }
    //}


    /* If the window is almost full and there is insufficient lookahead,
     * move the upper half to the lower one to make room in the upper half.
     */
    if (s.strstart >= _w_size + (_w_size - MIN_LOOKAHEAD)) {

      utils.arraySet(s.window, s.window, _w_size, _w_size, 0);
      s.match_start -= _w_size;
      s.strstart -= _w_size;
      /* we now have strstart >= MAX_DIST */
      s.block_start -= _w_size;

      /* Slide the hash table (could be avoided with 32 bit values
       at the expense of memory usage). We slide even when level == 0
       to keep the hash table consistent if we switch back to level > 0
       later. (Using level 0 permanently is not an optimal usage of
       zlib, so we don't care about this pathological case.)
       */

      n = s.hash_size;
      p = n;
      do {
        m = s.head[--p];
        s.head[p] = (m >= _w_size ? m - _w_size : 0);
      } while (--n);

      n = _w_size;
      p = n;
      do {
        m = s.prev[--p];
        s.prev[p] = (m >= _w_size ? m - _w_size : 0);
        /* If n is not on any hash chain, prev[n] is garbage but
         * its value will never be used.
         */
      } while (--n);

      more += _w_size;
    }
    if (s.strm.avail_in === 0) {
      break;
    }

    /* If there was no sliding:
     *    strstart <= WSIZE+MAX_DIST-1 && lookahead <= MIN_LOOKAHEAD - 1 &&
     *    more == window_size - lookahead - strstart
     * => more >= window_size - (MIN_LOOKAHEAD-1 + WSIZE + MAX_DIST-1)
     * => more >= window_size - 2*WSIZE + 2
     * In the BIG_MEM or MMAP case (not yet supported),
     *   window_size == input_size + MIN_LOOKAHEAD  &&
     *   strstart + s->lookahead <= input_size => more >= MIN_LOOKAHEAD.
     * Otherwise, window_size == 2*WSIZE so more >= 2.
     * If there was sliding, more >= WSIZE. So in all cases, more >= 2.
     */
    //Assert(more >= 2, "more < 2");
    n = read_buf(s.strm, s.window, s.strstart + s.lookahead, more);
    s.lookahead += n;

    /* Initialize the hash value now that we have some input: */
    if (s.lookahead + s.insert >= MIN_MATCH) {
      str = s.strstart - s.insert;
      s.ins_h = s.window[str];

      /* UPDATE_HASH(s, s->ins_h, s->window[str + 1]); */
      s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[str + 1]) & s.hash_mask;
//#if MIN_MATCH != 3
//        Call update_hash() MIN_MATCH-3 more times
//#endif
      while (s.insert) {
        /* UPDATE_HASH(s, s->ins_h, s->window[str + MIN_MATCH-1]); */
        s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[str + MIN_MATCH - 1]) & s.hash_mask;

        s.prev[str & s.w_mask] = s.head[s.ins_h];
        s.head[s.ins_h] = str;
        str++;
        s.insert--;
        if (s.lookahead + s.insert < MIN_MATCH) {
          break;
        }
      }
    }
    /* If the whole input has less than MIN_MATCH bytes, ins_h is garbage,
     * but this is not important since only literal bytes will be emitted.
     */

  } while (s.lookahead < MIN_LOOKAHEAD && s.strm.avail_in !== 0);

  /* If the WIN_INIT bytes after the end of the current data have never been
   * written, then zero those bytes in order to avoid memory check reports of
   * the use of uninitialized (or uninitialised as Julian writes) bytes by
   * the longest match routines.  Update the high water mark for the next
   * time through here.  WIN_INIT is set to MAX_MATCH since the longest match
   * routines allow scanning to strstart + MAX_MATCH, ignoring lookahead.
   */
//  if (s.high_water < s.window_size) {
//    var curr = s.strstart + s.lookahead;
//    var init = 0;
//
//    if (s.high_water < curr) {
//      /* Previous high water mark below current data -- zero WIN_INIT
//       * bytes or up to end of window, whichever is less.
//       */
//      init = s.window_size - curr;
//      if (init > WIN_INIT)
//        init = WIN_INIT;
//      zmemzero(s->window + curr, (unsigned)init);
//      s->high_water = curr + init;
//    }
//    else if (s->high_water < (ulg)curr + WIN_INIT) {
//      /* High water mark at or above current data, but below current data
//       * plus WIN_INIT -- zero out to current data plus WIN_INIT, or up
//       * to end of window, whichever is less.
//       */
//      init = (ulg)curr + WIN_INIT - s->high_water;
//      if (init > s->window_size - s->high_water)
//        init = s->window_size - s->high_water;
//      zmemzero(s->window + s->high_water, (unsigned)init);
//      s->high_water += init;
//    }
//  }
//
//  Assert((ulg)s->strstart <= s->window_size - MIN_LOOKAHEAD,
//    "not enough room for search");
}

/* ===========================================================================
 * Copy without compression as much as possible from the input stream, return
 * the current block state.
 * This function does not insert new strings in the dictionary since
 * uncompressible data is probably not useful. This function is used
 * only for the level=0 compression option.
 * NOTE: this function should be optimized to avoid extra copying from
 * window to pending_buf.
 */
function deflate_stored(s, flush) {
  /* Stored blocks are limited to 0xffff bytes, pending_buf is limited
   * to pending_buf_size, and each stored block has a 5 byte header:
   */
  var max_block_size = 0xffff;

  if (max_block_size > s.pending_buf_size - 5) {
    max_block_size = s.pending_buf_size - 5;
  }

  /* Copy as much as possible from input to output: */
  for (;;) {
    /* Fill the window as much as possible: */
    if (s.lookahead <= 1) {

      //Assert(s->strstart < s->w_size+MAX_DIST(s) ||
      //  s->block_start >= (long)s->w_size, "slide too late");
//      if (!(s.strstart < s.w_size + (s.w_size - MIN_LOOKAHEAD) ||
//        s.block_start >= s.w_size)) {
//        throw  new Error("slide too late");
//      }

      fill_window(s);
      if (s.lookahead === 0 && flush === Z_NO_FLUSH) {
        return BS_NEED_MORE;
      }

      if (s.lookahead === 0) {
        break;
      }
      /* flush the current block */
    }
    //Assert(s->block_start >= 0L, "block gone");
//    if (s.block_start < 0) throw new Error("block gone");

    s.strstart += s.lookahead;
    s.lookahead = 0;

    /* Emit a stored block if pending_buf will be full: */
    var max_start = s.block_start + max_block_size;

    if (s.strstart === 0 || s.strstart >= max_start) {
      /* strstart == 0 is possible when wraparound on 16-bit machine */
      s.lookahead = s.strstart - max_start;
      s.strstart = max_start;
      /*** FLUSH_BLOCK(s, 0); ***/
      flush_block_only(s, false);
      if (s.strm.avail_out === 0) {
        return BS_NEED_MORE;
      }
      /***/


    }
    /* Flush if we may have to slide, otherwise block_start may become
     * negative and the data will be gone:
     */
    if (s.strstart - s.block_start >= (s.w_size - MIN_LOOKAHEAD)) {
      /*** FLUSH_BLOCK(s, 0); ***/
      flush_block_only(s, false);
      if (s.strm.avail_out === 0) {
        return BS_NEED_MORE;
      }
      /***/
    }
  }

  s.insert = 0;

  if (flush === Z_FINISH) {
    /*** FLUSH_BLOCK(s, 1); ***/
    flush_block_only(s, true);
    if (s.strm.avail_out === 0) {
      return BS_FINISH_STARTED;
    }
    /***/
    return BS_FINISH_DONE;
  }

  if (s.strstart > s.block_start) {
    /*** FLUSH_BLOCK(s, 0); ***/
    flush_block_only(s, false);
    if (s.strm.avail_out === 0) {
      return BS_NEED_MORE;
    }
    /***/
  }

  return BS_NEED_MORE;
}

/* ===========================================================================
 * Compress as much as possible from the input stream, return the current
 * block state.
 * This function does not perform lazy evaluation of matches and inserts
 * new strings in the dictionary only for unmatched strings or for short
 * matches. It is used only for the fast compression options.
 */
function deflate_fast(s, flush) {
  var hash_head;        /* head of the hash chain */
  var bflush;           /* set if current block must be flushed */

  for (;;) {
    /* Make sure that we always have enough lookahead, except
     * at the end of the input file. We need MAX_MATCH bytes
     * for the next match, plus MIN_MATCH bytes to insert the
     * string following the next match.
     */
    if (s.lookahead < MIN_LOOKAHEAD) {
      fill_window(s);
      if (s.lookahead < MIN_LOOKAHEAD && flush === Z_NO_FLUSH) {
        return BS_NEED_MORE;
      }
      if (s.lookahead === 0) {
        break; /* flush the current block */
      }
    }

    /* Insert the string window[strstart .. strstart+2] in the
     * dictionary, and set hash_head to the head of the hash chain:
     */
    hash_head = 0/*NIL*/;
    if (s.lookahead >= MIN_MATCH) {
      /*** INSERT_STRING(s, s.strstart, hash_head); ***/
      s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + MIN_MATCH - 1]) & s.hash_mask;
      hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
      s.head[s.ins_h] = s.strstart;
      /***/
    }

    /* Find the longest match, discarding those <= prev_length.
     * At this point we have always match_length < MIN_MATCH
     */
    if (hash_head !== 0/*NIL*/ && ((s.strstart - hash_head) <= (s.w_size - MIN_LOOKAHEAD))) {
      /* To simplify the code, we prevent matches with the string
       * of window index 0 (in particular we have to avoid a match
       * of the string with itself at the start of the input file).
       */
      s.match_length = longest_match(s, hash_head);
      /* longest_match() sets match_start */
    }
    if (s.match_length >= MIN_MATCH) {
      // check_match(s, s.strstart, s.match_start, s.match_length); // for debug only

      /*** _tr_tally_dist(s, s.strstart - s.match_start,
                     s.match_length - MIN_MATCH, bflush); ***/
      bflush = trees._tr_tally(s, s.strstart - s.match_start, s.match_length - MIN_MATCH);

      s.lookahead -= s.match_length;

      /* Insert new strings in the hash table only if the match length
       * is not too large. This saves time but degrades compression.
       */
      if (s.match_length <= s.max_lazy_match/*max_insert_length*/ && s.lookahead >= MIN_MATCH) {
        s.match_length--; /* string at strstart already in table */
        do {
          s.strstart++;
          /*** INSERT_STRING(s, s.strstart, hash_head); ***/
          s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + MIN_MATCH - 1]) & s.hash_mask;
          hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
          s.head[s.ins_h] = s.strstart;
          /***/
          /* strstart never exceeds WSIZE-MAX_MATCH, so there are
           * always MIN_MATCH bytes ahead.
           */
        } while (--s.match_length !== 0);
        s.strstart++;
      } else
      {
        s.strstart += s.match_length;
        s.match_length = 0;
        s.ins_h = s.window[s.strstart];
        /* UPDATE_HASH(s, s.ins_h, s.window[s.strstart+1]); */
        s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + 1]) & s.hash_mask;

//#if MIN_MATCH != 3
//                Call UPDATE_HASH() MIN_MATCH-3 more times
//#endif
        /* If lookahead < MIN_MATCH, ins_h is garbage, but it does not
         * matter since it will be recomputed at next deflate call.
         */
      }
    } else {
      /* No match, output a literal byte */
      //Tracevv((stderr,"%c", s.window[s.strstart]));
      /*** _tr_tally_lit(s, s.window[s.strstart], bflush); ***/
      bflush = trees._tr_tally(s, 0, s.window[s.strstart]);

      s.lookahead--;
      s.strstart++;
    }
    if (bflush) {
      /*** FLUSH_BLOCK(s, 0); ***/
      flush_block_only(s, false);
      if (s.strm.avail_out === 0) {
        return BS_NEED_MORE;
      }
      /***/
    }
  }
  s.insert = ((s.strstart < (MIN_MATCH - 1)) ? s.strstart : MIN_MATCH - 1);
  if (flush === Z_FINISH) {
    /*** FLUSH_BLOCK(s, 1); ***/
    flush_block_only(s, true);
    if (s.strm.avail_out === 0) {
      return BS_FINISH_STARTED;
    }
    /***/
    return BS_FINISH_DONE;
  }
  if (s.last_lit) {
    /*** FLUSH_BLOCK(s, 0); ***/
    flush_block_only(s, false);
    if (s.strm.avail_out === 0) {
      return BS_NEED_MORE;
    }
    /***/
  }
  return BS_BLOCK_DONE;
}

/* ===========================================================================
 * Same as above, but achieves better compression. We use a lazy
 * evaluation for matches: a match is finally adopted only if there is
 * no better match at the next window position.
 */
function deflate_slow(s, flush) {
  var hash_head;          /* head of hash chain */
  var bflush;              /* set if current block must be flushed */

  var max_insert;

  /* Process the input block. */
  for (;;) {
    /* Make sure that we always have enough lookahead, except
     * at the end of the input file. We need MAX_MATCH bytes
     * for the next match, plus MIN_MATCH bytes to insert the
     * string following the next match.
     */
    if (s.lookahead < MIN_LOOKAHEAD) {
      fill_window(s);
      if (s.lookahead < MIN_LOOKAHEAD && flush === Z_NO_FLUSH) {
        return BS_NEED_MORE;
      }
      if (s.lookahead === 0) { break; } /* flush the current block */
    }

    /* Insert the string window[strstart .. strstart+2] in the
     * dictionary, and set hash_head to the head of the hash chain:
     */
    hash_head = 0/*NIL*/;
    if (s.lookahead >= MIN_MATCH) {
      /*** INSERT_STRING(s, s.strstart, hash_head); ***/
      s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + MIN_MATCH - 1]) & s.hash_mask;
      hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
      s.head[s.ins_h] = s.strstart;
      /***/
    }

    /* Find the longest match, discarding those <= prev_length.
     */
    s.prev_length = s.match_length;
    s.prev_match = s.match_start;
    s.match_length = MIN_MATCH - 1;

    if (hash_head !== 0/*NIL*/ && s.prev_length < s.max_lazy_match &&
        s.strstart - hash_head <= (s.w_size - MIN_LOOKAHEAD)/*MAX_DIST(s)*/) {
      /* To simplify the code, we prevent matches with the string
       * of window index 0 (in particular we have to avoid a match
       * of the string with itself at the start of the input file).
       */
      s.match_length = longest_match(s, hash_head);
      /* longest_match() sets match_start */

      if (s.match_length <= 5 &&
         (s.strategy === Z_FILTERED || (s.match_length === MIN_MATCH && s.strstart - s.match_start > 4096/*TOO_FAR*/))) {

        /* If prev_match is also MIN_MATCH, match_start is garbage
         * but we will ignore the current match anyway.
         */
        s.match_length = MIN_MATCH - 1;
      }
    }
    /* If there was a match at the previous step and the current
     * match is not better, output the previous match:
     */
    if (s.prev_length >= MIN_MATCH && s.match_length <= s.prev_length) {
      max_insert = s.strstart + s.lookahead - MIN_MATCH;
      /* Do not insert strings in hash table beyond this. */

      //check_match(s, s.strstart-1, s.prev_match, s.prev_length);

      /***_tr_tally_dist(s, s.strstart - 1 - s.prev_match,
                     s.prev_length - MIN_MATCH, bflush);***/
      bflush = trees._tr_tally(s, s.strstart - 1 - s.prev_match, s.prev_length - MIN_MATCH);
      /* Insert in hash table all strings up to the end of the match.
       * strstart-1 and strstart are already inserted. If there is not
       * enough lookahead, the last two strings are not inserted in
       * the hash table.
       */
      s.lookahead -= s.prev_length - 1;
      s.prev_length -= 2;
      do {
        if (++s.strstart <= max_insert) {
          /*** INSERT_STRING(s, s.strstart, hash_head); ***/
          s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + MIN_MATCH - 1]) & s.hash_mask;
          hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
          s.head[s.ins_h] = s.strstart;
          /***/
        }
      } while (--s.prev_length !== 0);
      s.match_available = 0;
      s.match_length = MIN_MATCH - 1;
      s.strstart++;

      if (bflush) {
        /*** FLUSH_BLOCK(s, 0); ***/
        flush_block_only(s, false);
        if (s.strm.avail_out === 0) {
          return BS_NEED_MORE;
        }
        /***/
      }

    } else if (s.match_available) {
      /* If there was no match at the previous position, output a
       * single literal. If there was a match but the current match
       * is longer, truncate the previous match to a single literal.
       */
      //Tracevv((stderr,"%c", s->window[s->strstart-1]));
      /*** _tr_tally_lit(s, s.window[s.strstart-1], bflush); ***/
      bflush = trees._tr_tally(s, 0, s.window[s.strstart - 1]);

      if (bflush) {
        /*** FLUSH_BLOCK_ONLY(s, 0) ***/
        flush_block_only(s, false);
        /***/
      }
      s.strstart++;
      s.lookahead--;
      if (s.strm.avail_out === 0) {
        return BS_NEED_MORE;
      }
    } else {
      /* There is no previous match to compare with, wait for
       * the next step to decide.
       */
      s.match_available = 1;
      s.strstart++;
      s.lookahead--;
    }
  }
  //Assert (flush != Z_NO_FLUSH, "no flush?");
  if (s.match_available) {
    //Tracevv((stderr,"%c", s->window[s->strstart-1]));
    /*** _tr_tally_lit(s, s.window[s.strstart-1], bflush); ***/
    bflush = trees._tr_tally(s, 0, s.window[s.strstart - 1]);

    s.match_available = 0;
  }
  s.insert = s.strstart < MIN_MATCH - 1 ? s.strstart : MIN_MATCH - 1;
  if (flush === Z_FINISH) {
    /*** FLUSH_BLOCK(s, 1); ***/
    flush_block_only(s, true);
    if (s.strm.avail_out === 0) {
      return BS_FINISH_STARTED;
    }
    /***/
    return BS_FINISH_DONE;
  }
  if (s.last_lit) {
    /*** FLUSH_BLOCK(s, 0); ***/
    flush_block_only(s, false);
    if (s.strm.avail_out === 0) {
      return BS_NEED_MORE;
    }
    /***/
  }

  return BS_BLOCK_DONE;
}


/* ===========================================================================
 * For Z_RLE, simply look for runs of bytes, generate matches only of distance
 * one.  Do not maintain a hash table.  (It will be regenerated if this run of
 * deflate switches away from Z_RLE.)
 */
function deflate_rle(s, flush) {
  var bflush;            /* set if current block must be flushed */
  var prev;              /* byte at distance one to match */
  var scan, strend;      /* scan goes up to strend for length of run */

  var _win = s.window;

  for (;;) {
    /* Make sure that we always have enough lookahead, except
     * at the end of the input file. We need MAX_MATCH bytes
     * for the longest run, plus one for the unrolled loop.
     */
    if (s.lookahead <= MAX_MATCH) {
      fill_window(s);
      if (s.lookahead <= MAX_MATCH && flush === Z_NO_FLUSH) {
        return BS_NEED_MORE;
      }
      if (s.lookahead === 0) { break; } /* flush the current block */
    }

    /* See how many times the previous byte repeats */
    s.match_length = 0;
    if (s.lookahead >= MIN_MATCH && s.strstart > 0) {
      scan = s.strstart - 1;
      prev = _win[scan];
      if (prev === _win[++scan] && prev === _win[++scan] && prev === _win[++scan]) {
        strend = s.strstart + MAX_MATCH;
        do {
          /*jshint noempty:false*/
        } while (prev === _win[++scan] && prev === _win[++scan] &&
                 prev === _win[++scan] && prev === _win[++scan] &&
                 prev === _win[++scan] && prev === _win[++scan] &&
                 prev === _win[++scan] && prev === _win[++scan] &&
                 scan < strend);
        s.match_length = MAX_MATCH - (strend - scan);
        if (s.match_length > s.lookahead) {
          s.match_length = s.lookahead;
        }
      }
      //Assert(scan <= s->window+(uInt)(s->window_size-1), "wild scan");
    }

    /* Emit match if have run of MIN_MATCH or longer, else emit literal */
    if (s.match_length >= MIN_MATCH) {
      //check_match(s, s.strstart, s.strstart - 1, s.match_length);

      /*** _tr_tally_dist(s, 1, s.match_length - MIN_MATCH, bflush); ***/
      bflush = trees._tr_tally(s, 1, s.match_length - MIN_MATCH);

      s.lookahead -= s.match_length;
      s.strstart += s.match_length;
      s.match_length = 0;
    } else {
      /* No match, output a literal byte */
      //Tracevv((stderr,"%c", s->window[s->strstart]));
      /*** _tr_tally_lit(s, s.window[s.strstart], bflush); ***/
      bflush = trees._tr_tally(s, 0, s.window[s.strstart]);

      s.lookahead--;
      s.strstart++;
    }
    if (bflush) {
      /*** FLUSH_BLOCK(s, 0); ***/
      flush_block_only(s, false);
      if (s.strm.avail_out === 0) {
        return BS_NEED_MORE;
      }
      /***/
    }
  }
  s.insert = 0;
  if (flush === Z_FINISH) {
    /*** FLUSH_BLOCK(s, 1); ***/
    flush_block_only(s, true);
    if (s.strm.avail_out === 0) {
      return BS_FINISH_STARTED;
    }
    /***/
    return BS_FINISH_DONE;
  }
  if (s.last_lit) {
    /*** FLUSH_BLOCK(s, 0); ***/
    flush_block_only(s, false);
    if (s.strm.avail_out === 0) {
      return BS_NEED_MORE;
    }
    /***/
  }
  return BS_BLOCK_DONE;
}

/* ===========================================================================
 * For Z_HUFFMAN_ONLY, do not look for matches.  Do not maintain a hash table.
 * (It will be regenerated if this run of deflate switches away from Huffman.)
 */
function deflate_huff(s, flush) {
  var bflush;             /* set if current block must be flushed */

  for (;;) {
    /* Make sure that we have a literal to write. */
    if (s.lookahead === 0) {
      fill_window(s);
      if (s.lookahead === 0) {
        if (flush === Z_NO_FLUSH) {
          return BS_NEED_MORE;
        }
        break;      /* flush the current block */
      }
    }

    /* Output a literal byte */
    s.match_length = 0;
    //Tracevv((stderr,"%c", s->window[s->strstart]));
    /*** _tr_tally_lit(s, s.window[s.strstart], bflush); ***/
    bflush = trees._tr_tally(s, 0, s.window[s.strstart]);
    s.lookahead--;
    s.strstart++;
    if (bflush) {
      /*** FLUSH_BLOCK(s, 0); ***/
      flush_block_only(s, false);
      if (s.strm.avail_out === 0) {
        return BS_NEED_MORE;
      }
      /***/
    }
  }
  s.insert = 0;
  if (flush === Z_FINISH) {
    /*** FLUSH_BLOCK(s, 1); ***/
    flush_block_only(s, true);
    if (s.strm.avail_out === 0) {
      return BS_FINISH_STARTED;
    }
    /***/
    return BS_FINISH_DONE;
  }
  if (s.last_lit) {
    /*** FLUSH_BLOCK(s, 0); ***/
    flush_block_only(s, false);
    if (s.strm.avail_out === 0) {
      return BS_NEED_MORE;
    }
    /***/
  }
  return BS_BLOCK_DONE;
}

/* Values for max_lazy_match, good_match and max_chain_length, depending on
 * the desired pack level (0..9). The values given below have been tuned to
 * exclude worst case performance for pathological files. Better values may be
 * found for specific files.
 */
function Config(good_length, max_lazy, nice_length, max_chain, func) {
  this.good_length = good_length;
  this.max_lazy = max_lazy;
  this.nice_length = nice_length;
  this.max_chain = max_chain;
  this.func = func;
}

var configuration_table;

configuration_table = [
  /*      good lazy nice chain */
  new Config(0, 0, 0, 0, deflate_stored),          /* 0 store only */
  new Config(4, 4, 8, 4, deflate_fast),            /* 1 max speed, no lazy matches */
  new Config(4, 5, 16, 8, deflate_fast),           /* 2 */
  new Config(4, 6, 32, 32, deflate_fast),          /* 3 */

  new Config(4, 4, 16, 16, deflate_slow),          /* 4 lazy matches */
  new Config(8, 16, 32, 32, deflate_slow),         /* 5 */
  new Config(8, 16, 128, 128, deflate_slow),       /* 6 */
  new Config(8, 32, 128, 256, deflate_slow),       /* 7 */
  new Config(32, 128, 258, 1024, deflate_slow),    /* 8 */
  new Config(32, 258, 258, 4096, deflate_slow)     /* 9 max compression */
];


/* ===========================================================================
 * Initialize the "longest match" routines for a new zlib stream
 */
function lm_init(s) {
  s.window_size = 2 * s.w_size;

  /*** CLEAR_HASH(s); ***/
  zero(s.head); // Fill with NIL (= 0);

  /* Set the default configuration parameters:
   */
  s.max_lazy_match = configuration_table[s.level].max_lazy;
  s.good_match = configuration_table[s.level].good_length;
  s.nice_match = configuration_table[s.level].nice_length;
  s.max_chain_length = configuration_table[s.level].max_chain;

  s.strstart = 0;
  s.block_start = 0;
  s.lookahead = 0;
  s.insert = 0;
  s.match_length = s.prev_length = MIN_MATCH - 1;
  s.match_available = 0;
  s.ins_h = 0;
}


function DeflateState() {
  this.strm = null;            /* pointer back to this zlib stream */
  this.status = 0;            /* as the name implies */
  this.pending_buf = null;      /* output still pending */
  this.pending_buf_size = 0;  /* size of pending_buf */
  this.pending_out = 0;       /* next pending byte to output to the stream */
  this.pending = 0;           /* nb of bytes in the pending buffer */
  this.wrap = 0;              /* bit 0 true for zlib, bit 1 true for gzip */
  this.gzhead = null;         /* gzip header information to write */
  this.gzindex = 0;           /* where in extra, name, or comment */
  this.method = Z_DEFLATED; /* can only be DEFLATED */
  this.last_flush = -1;   /* value of flush param for previous deflate call */

  this.w_size = 0;  /* LZ77 window size (32K by default) */
  this.w_bits = 0;  /* log2(w_size)  (8..16) */
  this.w_mask = 0;  /* w_size - 1 */

  this.window = null;
  /* Sliding window. Input bytes are read into the second half of the window,
   * and move to the first half later to keep a dictionary of at least wSize
   * bytes. With this organization, matches are limited to a distance of
   * wSize-MAX_MATCH bytes, but this ensures that IO is always
   * performed with a length multiple of the block size.
   */

  this.window_size = 0;
  /* Actual size of window: 2*wSize, except when the user input buffer
   * is directly used as sliding window.
   */

  this.prev = null;
  /* Link to older string with same hash index. To limit the size of this
   * array to 64K, this link is maintained only for the last 32K strings.
   * An index in this array is thus a window index modulo 32K.
   */

  this.head = null;   /* Heads of the hash chains or NIL. */

  this.ins_h = 0;       /* hash index of string to be inserted */
  this.hash_size = 0;   /* number of elements in hash table */
  this.hash_bits = 0;   /* log2(hash_size) */
  this.hash_mask = 0;   /* hash_size-1 */

  this.hash_shift = 0;
  /* Number of bits by which ins_h must be shifted at each input
   * step. It must be such that after MIN_MATCH steps, the oldest
   * byte no longer takes part in the hash key, that is:
   *   hash_shift * MIN_MATCH >= hash_bits
   */

  this.block_start = 0;
  /* Window position at the beginning of the current output block. Gets
   * negative when the window is moved backwards.
   */

  this.match_length = 0;      /* length of best match */
  this.prev_match = 0;        /* previous match */
  this.match_available = 0;   /* set if previous match exists */
  this.strstart = 0;          /* start of string to insert */
  this.match_start = 0;       /* start of matching string */
  this.lookahead = 0;         /* number of valid bytes ahead in window */

  this.prev_length = 0;
  /* Length of the best match at previous step. Matches not greater than this
   * are discarded. This is used in the lazy match evaluation.
   */

  this.max_chain_length = 0;
  /* To speed up deflation, hash chains are never searched beyond this
   * length.  A higher limit improves compression ratio but degrades the
   * speed.
   */

  this.max_lazy_match = 0;
  /* Attempt to find a better match only when the current match is strictly
   * smaller than this value. This mechanism is used only for compression
   * levels >= 4.
   */
  // That's alias to max_lazy_match, don't use directly
  //this.max_insert_length = 0;
  /* Insert new strings in the hash table only if the match length is not
   * greater than this length. This saves time but degrades compression.
   * max_insert_length is used only for compression levels <= 3.
   */

  this.level = 0;     /* compression level (1..9) */
  this.strategy = 0;  /* favor or force Huffman coding*/

  this.good_match = 0;
  /* Use a faster search when the previous match is longer than this */

  this.nice_match = 0; /* Stop searching when current match exceeds this */

              /* used by trees.c: */

  /* Didn't use ct_data typedef below to suppress compiler warning */

  // struct ct_data_s dyn_ltree[HEAP_SIZE];   /* literal and length tree */
  // struct ct_data_s dyn_dtree[2*D_CODES+1]; /* distance tree */
  // struct ct_data_s bl_tree[2*BL_CODES+1];  /* Huffman tree for bit lengths */

  // Use flat array of DOUBLE size, with interleaved fata,
  // because JS does not support effective
  this.dyn_ltree  = new utils.Buf16(HEAP_SIZE * 2);
  this.dyn_dtree  = new utils.Buf16((2 * D_CODES + 1) * 2);
  this.bl_tree    = new utils.Buf16((2 * BL_CODES + 1) * 2);
  zero(this.dyn_ltree);
  zero(this.dyn_dtree);
  zero(this.bl_tree);

  this.l_desc   = null;         /* desc. for literal tree */
  this.d_desc   = null;         /* desc. for distance tree */
  this.bl_desc  = null;         /* desc. for bit length tree */

  //ush bl_count[MAX_BITS+1];
  this.bl_count = new utils.Buf16(MAX_BITS + 1);
  /* number of codes at each bit length for an optimal tree */

  //int heap[2*L_CODES+1];      /* heap used to build the Huffman trees */
  this.heap = new utils.Buf16(2 * L_CODES + 1);  /* heap used to build the Huffman trees */
  zero(this.heap);

  this.heap_len = 0;               /* number of elements in the heap */
  this.heap_max = 0;               /* element of largest frequency */
  /* The sons of heap[n] are heap[2*n] and heap[2*n+1]. heap[0] is not used.
   * The same heap array is used to build all trees.
   */

  this.depth = new utils.Buf16(2 * L_CODES + 1); //uch depth[2*L_CODES+1];
  zero(this.depth);
  /* Depth of each subtree used as tie breaker for trees of equal frequency
   */

  this.l_buf = 0;          /* buffer index for literals or lengths */

  this.lit_bufsize = 0;
  /* Size of match buffer for literals/lengths.  There are 4 reasons for
   * limiting lit_bufsize to 64K:
   *   - frequencies can be kept in 16 bit counters
   *   - if compression is not successful for the first block, all input
   *     data is still in the window so we can still emit a stored block even
   *     when input comes from standard input.  (This can also be done for
   *     all blocks if lit_bufsize is not greater than 32K.)
   *   - if compression is not successful for a file smaller than 64K, we can
   *     even emit a stored file instead of a stored block (saving 5 bytes).
   *     This is applicable only for zip (not gzip or zlib).
   *   - creating new Huffman trees less frequently may not provide fast
   *     adaptation to changes in the input data statistics. (Take for
   *     example a binary file with poorly compressible code followed by
   *     a highly compressible string table.) Smaller buffer sizes give
   *     fast adaptation but have of course the overhead of transmitting
   *     trees more frequently.
   *   - I can't count above 4
   */

  this.last_lit = 0;      /* running index in l_buf */

  this.d_buf = 0;
  /* Buffer index for distances. To simplify the code, d_buf and l_buf have
   * the same number of elements. To use different lengths, an extra flag
   * array would be necessary.
   */

  this.opt_len = 0;       /* bit length of current block with optimal trees */
  this.static_len = 0;    /* bit length of current block with static trees */
  this.matches = 0;       /* number of string matches in current block */
  this.insert = 0;        /* bytes at end of window left to insert */


  this.bi_buf = 0;
  /* Output buffer. bits are inserted starting at the bottom (least
   * significant bits).
   */
  this.bi_valid = 0;
  /* Number of valid bits in bi_buf.  All bits above the last valid bit
   * are always zero.
   */

  // Used for window memory init. We safely ignore it for JS. That makes
  // sense only for pointers and memory check tools.
  //this.high_water = 0;
  /* High water mark offset in window for initialized bytes -- bytes above
   * this are set to zero in order to avoid memory check warnings when
   * longest match routines access bytes past the input.  This is then
   * updated to the new high water mark.
   */
}


function deflateResetKeep(strm) {
  var s;

  if (!strm || !strm.state) {
    return err(strm, Z_STREAM_ERROR);
  }

  strm.total_in = strm.total_out = 0;
  strm.data_type = Z_UNKNOWN;

  s = strm.state;
  s.pending = 0;
  s.pending_out = 0;

  if (s.wrap < 0) {
    s.wrap = -s.wrap;
    /* was made negative by deflate(..., Z_FINISH); */
  }
  s.status = (s.wrap ? INIT_STATE : BUSY_STATE);
  strm.adler = (s.wrap === 2) ?
    0  // crc32(0, Z_NULL, 0)
  :
    1; // adler32(0, Z_NULL, 0)
  s.last_flush = Z_NO_FLUSH;
  trees._tr_init(s);
  return Z_OK;
}


function deflateReset(strm) {
  var ret = deflateResetKeep(strm);
  if (ret === Z_OK) {
    lm_init(strm.state);
  }
  return ret;
}


function deflateSetHeader(strm, head) {
  if (!strm || !strm.state) { return Z_STREAM_ERROR; }
  if (strm.state.wrap !== 2) { return Z_STREAM_ERROR; }
  strm.state.gzhead = head;
  return Z_OK;
}


function deflateInit2(strm, level, method, windowBits, memLevel, strategy) {
  if (!strm) { // === Z_NULL
    return Z_STREAM_ERROR;
  }
  var wrap = 1;

  if (level === Z_DEFAULT_COMPRESSION) {
    level = 6;
  }

  if (windowBits < 0) { /* suppress zlib wrapper */
    wrap = 0;
    windowBits = -windowBits;
  }

  else if (windowBits > 15) {
    wrap = 2;           /* write gzip wrapper instead */
    windowBits -= 16;
  }


  if (memLevel < 1 || memLevel > MAX_MEM_LEVEL || method !== Z_DEFLATED ||
    windowBits < 8 || windowBits > 15 || level < 0 || level > 9 ||
    strategy < 0 || strategy > Z_FIXED) {
    return err(strm, Z_STREAM_ERROR);
  }


  if (windowBits === 8) {
    windowBits = 9;
  }
  /* until 256-byte window bug fixed */

  var s = new DeflateState();

  strm.state = s;
  s.strm = strm;

  s.wrap = wrap;
  s.gzhead = null;
  s.w_bits = windowBits;
  s.w_size = 1 << s.w_bits;
  s.w_mask = s.w_size - 1;

  s.hash_bits = memLevel + 7;
  s.hash_size = 1 << s.hash_bits;
  s.hash_mask = s.hash_size - 1;
  s.hash_shift = ~~((s.hash_bits + MIN_MATCH - 1) / MIN_MATCH);

  s.window = new utils.Buf8(s.w_size * 2);
  s.head = new utils.Buf16(s.hash_size);
  s.prev = new utils.Buf16(s.w_size);

  // Don't need mem init magic for JS.
  //s.high_water = 0;  /* nothing written to s->window yet */

  s.lit_bufsize = 1 << (memLevel + 6); /* 16K elements by default */

  s.pending_buf_size = s.lit_bufsize * 4;

  //overlay = (ushf *) ZALLOC(strm, s->lit_bufsize, sizeof(ush)+2);
  //s->pending_buf = (uchf *) overlay;
  s.pending_buf = new utils.Buf8(s.pending_buf_size);

  // It is offset from `s.pending_buf` (size is `s.lit_bufsize * 2`)
  //s->d_buf = overlay + s->lit_bufsize/sizeof(ush);
  s.d_buf = 1 * s.lit_bufsize;

  //s->l_buf = s->pending_buf + (1+sizeof(ush))*s->lit_bufsize;
  s.l_buf = (1 + 2) * s.lit_bufsize;

  s.level = level;
  s.strategy = strategy;
  s.method = method;

  return deflateReset(strm);
}

function deflateInit(strm, level) {
  return deflateInit2(strm, level, Z_DEFLATED, MAX_WBITS, DEF_MEM_LEVEL, Z_DEFAULT_STRATEGY);
}


function deflate(strm, flush) {
  var old_flush, s;
  var beg, val; // for gzip header write only

  if (!strm || !strm.state ||
    flush > Z_BLOCK || flush < 0) {
    return strm ? err(strm, Z_STREAM_ERROR) : Z_STREAM_ERROR;
  }

  s = strm.state;

  if (!strm.output ||
      (!strm.input && strm.avail_in !== 0) ||
      (s.status === FINISH_STATE && flush !== Z_FINISH)) {
    return err(strm, (strm.avail_out === 0) ? Z_BUF_ERROR : Z_STREAM_ERROR);
  }

  s.strm = strm; /* just in case */
  old_flush = s.last_flush;
  s.last_flush = flush;

  /* Write the header */
  if (s.status === INIT_STATE) {

    if (s.wrap === 2) { // GZIP header
      strm.adler = 0;  //crc32(0L, Z_NULL, 0);
      put_byte(s, 31);
      put_byte(s, 139);
      put_byte(s, 8);
      if (!s.gzhead) { // s->gzhead == Z_NULL
        put_byte(s, 0);
        put_byte(s, 0);
        put_byte(s, 0);
        put_byte(s, 0);
        put_byte(s, 0);
        put_byte(s, s.level === 9 ? 2 :
                    (s.strategy >= Z_HUFFMAN_ONLY || s.level < 2 ?
                     4 : 0));
        put_byte(s, OS_CODE);
        s.status = BUSY_STATE;
      }
      else {
        put_byte(s, (s.gzhead.text ? 1 : 0) +
                    (s.gzhead.hcrc ? 2 : 0) +
                    (!s.gzhead.extra ? 0 : 4) +
                    (!s.gzhead.name ? 0 : 8) +
                    (!s.gzhead.comment ? 0 : 16)
                );
        put_byte(s, s.gzhead.time & 0xff);
        put_byte(s, (s.gzhead.time >> 8) & 0xff);
        put_byte(s, (s.gzhead.time >> 16) & 0xff);
        put_byte(s, (s.gzhead.time >> 24) & 0xff);
        put_byte(s, s.level === 9 ? 2 :
                    (s.strategy >= Z_HUFFMAN_ONLY || s.level < 2 ?
                     4 : 0));
        put_byte(s, s.gzhead.os & 0xff);
        if (s.gzhead.extra && s.gzhead.extra.length) {
          put_byte(s, s.gzhead.extra.length & 0xff);
          put_byte(s, (s.gzhead.extra.length >> 8) & 0xff);
        }
        if (s.gzhead.hcrc) {
          strm.adler = crc32(strm.adler, s.pending_buf, s.pending, 0);
        }
        s.gzindex = 0;
        s.status = EXTRA_STATE;
      }
    }
    else // DEFLATE header
    {
      var header = (Z_DEFLATED + ((s.w_bits - 8) << 4)) << 8;
      var level_flags = -1;

      if (s.strategy >= Z_HUFFMAN_ONLY || s.level < 2) {
        level_flags = 0;
      } else if (s.level < 6) {
        level_flags = 1;
      } else if (s.level === 6) {
        level_flags = 2;
      } else {
        level_flags = 3;
      }
      header |= (level_flags << 6);
      if (s.strstart !== 0) { header |= PRESET_DICT; }
      header += 31 - (header % 31);

      s.status = BUSY_STATE;
      putShortMSB(s, header);

      /* Save the adler32 of the preset dictionary: */
      if (s.strstart !== 0) {
        putShortMSB(s, strm.adler >>> 16);
        putShortMSB(s, strm.adler & 0xffff);
      }
      strm.adler = 1; // adler32(0L, Z_NULL, 0);
    }
  }

//#ifdef GZIP
  if (s.status === EXTRA_STATE) {
    if (s.gzhead.extra/* != Z_NULL*/) {
      beg = s.pending;  /* start of bytes to update crc */

      while (s.gzindex < (s.gzhead.extra.length & 0xffff)) {
        if (s.pending === s.pending_buf_size) {
          if (s.gzhead.hcrc && s.pending > beg) {
            strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
          }
          flush_pending(strm);
          beg = s.pending;
          if (s.pending === s.pending_buf_size) {
            break;
          }
        }
        put_byte(s, s.gzhead.extra[s.gzindex] & 0xff);
        s.gzindex++;
      }
      if (s.gzhead.hcrc && s.pending > beg) {
        strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
      }
      if (s.gzindex === s.gzhead.extra.length) {
        s.gzindex = 0;
        s.status = NAME_STATE;
      }
    }
    else {
      s.status = NAME_STATE;
    }
  }
  if (s.status === NAME_STATE) {
    if (s.gzhead.name/* != Z_NULL*/) {
      beg = s.pending;  /* start of bytes to update crc */
      //int val;

      do {
        if (s.pending === s.pending_buf_size) {
          if (s.gzhead.hcrc && s.pending > beg) {
            strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
          }
          flush_pending(strm);
          beg = s.pending;
          if (s.pending === s.pending_buf_size) {
            val = 1;
            break;
          }
        }
        // JS specific: little magic to add zero terminator to end of string
        if (s.gzindex < s.gzhead.name.length) {
          val = s.gzhead.name.charCodeAt(s.gzindex++) & 0xff;
        } else {
          val = 0;
        }
        put_byte(s, val);
      } while (val !== 0);

      if (s.gzhead.hcrc && s.pending > beg) {
        strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
      }
      if (val === 0) {
        s.gzindex = 0;
        s.status = COMMENT_STATE;
      }
    }
    else {
      s.status = COMMENT_STATE;
    }
  }
  if (s.status === COMMENT_STATE) {
    if (s.gzhead.comment/* != Z_NULL*/) {
      beg = s.pending;  /* start of bytes to update crc */
      //int val;

      do {
        if (s.pending === s.pending_buf_size) {
          if (s.gzhead.hcrc && s.pending > beg) {
            strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
          }
          flush_pending(strm);
          beg = s.pending;
          if (s.pending === s.pending_buf_size) {
            val = 1;
            break;
          }
        }
        // JS specific: little magic to add zero terminator to end of string
        if (s.gzindex < s.gzhead.comment.length) {
          val = s.gzhead.comment.charCodeAt(s.gzindex++) & 0xff;
        } else {
          val = 0;
        }
        put_byte(s, val);
      } while (val !== 0);

      if (s.gzhead.hcrc && s.pending > beg) {
        strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
      }
      if (val === 0) {
        s.status = HCRC_STATE;
      }
    }
    else {
      s.status = HCRC_STATE;
    }
  }
  if (s.status === HCRC_STATE) {
    if (s.gzhead.hcrc) {
      if (s.pending + 2 > s.pending_buf_size) {
        flush_pending(strm);
      }
      if (s.pending + 2 <= s.pending_buf_size) {
        put_byte(s, strm.adler & 0xff);
        put_byte(s, (strm.adler >> 8) & 0xff);
        strm.adler = 0; //crc32(0L, Z_NULL, 0);
        s.status = BUSY_STATE;
      }
    }
    else {
      s.status = BUSY_STATE;
    }
  }
//#endif

  /* Flush as much pending output as possible */
  if (s.pending !== 0) {
    flush_pending(strm);
    if (strm.avail_out === 0) {
      /* Since avail_out is 0, deflate will be called again with
       * more output space, but possibly with both pending and
       * avail_in equal to zero. There won't be anything to do,
       * but this is not an error situation so make sure we
       * return OK instead of BUF_ERROR at next call of deflate:
       */
      s.last_flush = -1;
      return Z_OK;
    }

    /* Make sure there is something to do and avoid duplicate consecutive
     * flushes. For repeated and useless calls with Z_FINISH, we keep
     * returning Z_STREAM_END instead of Z_BUF_ERROR.
     */
  } else if (strm.avail_in === 0 && rank(flush) <= rank(old_flush) &&
    flush !== Z_FINISH) {
    return err(strm, Z_BUF_ERROR);
  }

  /* User must not provide more input after the first FINISH: */
  if (s.status === FINISH_STATE && strm.avail_in !== 0) {
    return err(strm, Z_BUF_ERROR);
  }

  /* Start a new block or continue the current one.
   */
  if (strm.avail_in !== 0 || s.lookahead !== 0 ||
    (flush !== Z_NO_FLUSH && s.status !== FINISH_STATE)) {
    var bstate = (s.strategy === Z_HUFFMAN_ONLY) ? deflate_huff(s, flush) :
      (s.strategy === Z_RLE ? deflate_rle(s, flush) :
        configuration_table[s.level].func(s, flush));

    if (bstate === BS_FINISH_STARTED || bstate === BS_FINISH_DONE) {
      s.status = FINISH_STATE;
    }
    if (bstate === BS_NEED_MORE || bstate === BS_FINISH_STARTED) {
      if (strm.avail_out === 0) {
        s.last_flush = -1;
        /* avoid BUF_ERROR next call, see above */
      }
      return Z_OK;
      /* If flush != Z_NO_FLUSH && avail_out == 0, the next call
       * of deflate should use the same flush parameter to make sure
       * that the flush is complete. So we don't have to output an
       * empty block here, this will be done at next call. This also
       * ensures that for a very small output buffer, we emit at most
       * one empty block.
       */
    }
    if (bstate === BS_BLOCK_DONE) {
      if (flush === Z_PARTIAL_FLUSH) {
        trees._tr_align(s);
      }
      else if (flush !== Z_BLOCK) { /* FULL_FLUSH or SYNC_FLUSH */

        trees._tr_stored_block(s, 0, 0, false);
        /* For a full flush, this empty block will be recognized
         * as a special marker by inflate_sync().
         */
        if (flush === Z_FULL_FLUSH) {
          /*** CLEAR_HASH(s); ***/             /* forget history */
          zero(s.head); // Fill with NIL (= 0);

          if (s.lookahead === 0) {
            s.strstart = 0;
            s.block_start = 0;
            s.insert = 0;
          }
        }
      }
      flush_pending(strm);
      if (strm.avail_out === 0) {
        s.last_flush = -1; /* avoid BUF_ERROR at next call, see above */
        return Z_OK;
      }
    }
  }
  //Assert(strm->avail_out > 0, "bug2");
  //if (strm.avail_out <= 0) { throw new Error("bug2");}

  if (flush !== Z_FINISH) { return Z_OK; }
  if (s.wrap <= 0) { return Z_STREAM_END; }

  /* Write the trailer */
  if (s.wrap === 2) {
    put_byte(s, strm.adler & 0xff);
    put_byte(s, (strm.adler >> 8) & 0xff);
    put_byte(s, (strm.adler >> 16) & 0xff);
    put_byte(s, (strm.adler >> 24) & 0xff);
    put_byte(s, strm.total_in & 0xff);
    put_byte(s, (strm.total_in >> 8) & 0xff);
    put_byte(s, (strm.total_in >> 16) & 0xff);
    put_byte(s, (strm.total_in >> 24) & 0xff);
  }
  else
  {
    putShortMSB(s, strm.adler >>> 16);
    putShortMSB(s, strm.adler & 0xffff);
  }

  flush_pending(strm);
  /* If avail_out is zero, the application will call deflate again
   * to flush the rest.
   */
  if (s.wrap > 0) { s.wrap = -s.wrap; }
  /* write the trailer only once! */
  return s.pending !== 0 ? Z_OK : Z_STREAM_END;
}

function deflateEnd(strm) {
  var status;

  if (!strm/*== Z_NULL*/ || !strm.state/*== Z_NULL*/) {
    return Z_STREAM_ERROR;
  }

  status = strm.state.status;
  if (status !== INIT_STATE &&
    status !== EXTRA_STATE &&
    status !== NAME_STATE &&
    status !== COMMENT_STATE &&
    status !== HCRC_STATE &&
    status !== BUSY_STATE &&
    status !== FINISH_STATE
  ) {
    return err(strm, Z_STREAM_ERROR);
  }

  strm.state = null;

  return status === BUSY_STATE ? err(strm, Z_DATA_ERROR) : Z_OK;
}


/* =========================================================================
 * Initializes the compression dictionary from the given byte
 * sequence without producing any compressed output.
 */
function deflateSetDictionary(strm, dictionary) {
  var dictLength = dictionary.length;

  var s;
  var str, n;
  var wrap;
  var avail;
  var next;
  var input;
  var tmpDict;

  if (!strm/*== Z_NULL*/ || !strm.state/*== Z_NULL*/) {
    return Z_STREAM_ERROR;
  }

  s = strm.state;
  wrap = s.wrap;

  if (wrap === 2 || (wrap === 1 && s.status !== INIT_STATE) || s.lookahead) {
    return Z_STREAM_ERROR;
  }

  /* when using zlib wrappers, compute Adler-32 for provided dictionary */
  if (wrap === 1) {
    /* adler32(strm->adler, dictionary, dictLength); */
    strm.adler = adler32(strm.adler, dictionary, dictLength, 0);
  }

  s.wrap = 0;   /* avoid computing Adler-32 in read_buf */

  /* if dictionary would fill window, just replace the history */
  if (dictLength >= s.w_size) {
    if (wrap === 0) {            /* already empty otherwise */
      /*** CLEAR_HASH(s); ***/
      zero(s.head); // Fill with NIL (= 0);
      s.strstart = 0;
      s.block_start = 0;
      s.insert = 0;
    }
    /* use the tail */
    // dictionary = dictionary.slice(dictLength - s.w_size);
    tmpDict = new utils.Buf8(s.w_size);
    utils.arraySet(tmpDict, dictionary, dictLength - s.w_size, s.w_size, 0);
    dictionary = tmpDict;
    dictLength = s.w_size;
  }
  /* insert dictionary into window and hash */
  avail = strm.avail_in;
  next = strm.next_in;
  input = strm.input;
  strm.avail_in = dictLength;
  strm.next_in = 0;
  strm.input = dictionary;
  fill_window(s);
  while (s.lookahead >= MIN_MATCH) {
    str = s.strstart;
    n = s.lookahead - (MIN_MATCH - 1);
    do {
      /* UPDATE_HASH(s, s->ins_h, s->window[str + MIN_MATCH-1]); */
      s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[str + MIN_MATCH - 1]) & s.hash_mask;

      s.prev[str & s.w_mask] = s.head[s.ins_h];

      s.head[s.ins_h] = str;
      str++;
    } while (--n);
    s.strstart = str;
    s.lookahead = MIN_MATCH - 1;
    fill_window(s);
  }
  s.strstart += s.lookahead;
  s.block_start = s.strstart;
  s.insert = s.lookahead;
  s.lookahead = 0;
  s.match_length = s.prev_length = MIN_MATCH - 1;
  s.match_available = 0;
  strm.next_in = next;
  strm.input = input;
  strm.avail_in = avail;
  s.wrap = wrap;
  return Z_OK;
}


exports.deflateInit = deflateInit;
exports.deflateInit2 = deflateInit2;
exports.deflateReset = deflateReset;
exports.deflateResetKeep = deflateResetKeep;
exports.deflateSetHeader = deflateSetHeader;
exports.deflate = deflate;
exports.deflateEnd = deflateEnd;
exports.deflateSetDictionary = deflateSetDictionary;
exports.deflateInfo = 'pako deflate (from Nodeca project)';

/* Not implemented
exports.deflateBound = deflateBound;
exports.deflateCopy = deflateCopy;
exports.deflateParams = deflateParams;
exports.deflatePending = deflatePending;
exports.deflatePrime = deflatePrime;
exports.deflateTune = deflateTune;
*/


/***/ }),

/***/ "../node_modules/pako/lib/zlib/gzheader.js":
/*!*************************************************!*\
  !*** ../node_modules/pako/lib/zlib/gzheader.js ***!
  \*************************************************/
/***/ ((module) => {




function GZheader() {
  /* true if compressed data believed to be text */
  this.text       = 0;
  /* modification time */
  this.time       = 0;
  /* extra flags (not used when writing a gzip file) */
  this.xflags     = 0;
  /* operating system */
  this.os         = 0;
  /* pointer to extra field or Z_NULL if none */
  this.extra      = null;
  /* extra field length (valid if extra != Z_NULL) */
  this.extra_len  = 0; // Actually, we don't need it in JS,
                       // but leave for few code modifications

  //
  // Setup limits is not necessary because in js we should not preallocate memory
  // for inflate use constant limit in 65536 bytes
  //

  /* space at extra (only when reading header) */
  // this.extra_max  = 0;
  /* pointer to zero-terminated file name or Z_NULL */
  this.name       = '';
  /* space at name (only when reading header) */
  // this.name_max   = 0;
  /* pointer to zero-terminated comment or Z_NULL */
  this.comment    = '';
  /* space at comment (only when reading header) */
  // this.comm_max   = 0;
  /* true if there was or will be a header crc */
  this.hcrc       = 0;
  /* true when done reading gzip header (not used when writing a gzip file) */
  this.done       = false;
}

module.exports = GZheader;


/***/ }),

/***/ "../node_modules/pako/lib/zlib/inffast.js":
/*!************************************************!*\
  !*** ../node_modules/pako/lib/zlib/inffast.js ***!
  \************************************************/
/***/ ((module) => {



// See state defs from inflate.js
var BAD = 30;       /* got a data error -- remain here until reset */
var TYPE = 12;      /* i: waiting for type bits, including last-flag bit */

/*
   Decode literal, length, and distance codes and write out the resulting
   literal and match bytes until either not enough input or output is
   available, an end-of-block is encountered, or a data error is encountered.
   When large enough input and output buffers are supplied to inflate(), for
   example, a 16K input buffer and a 64K output buffer, more than 95% of the
   inflate execution time is spent in this routine.

   Entry assumptions:

        state.mode === LEN
        strm.avail_in >= 6
        strm.avail_out >= 258
        start >= strm.avail_out
        state.bits < 8

   On return, state.mode is one of:

        LEN -- ran out of enough output space or enough available input
        TYPE -- reached end of block code, inflate() to interpret next block
        BAD -- error in block data

   Notes:

    - The maximum input bits used by a length/distance pair is 15 bits for the
      length code, 5 bits for the length extra, 15 bits for the distance code,
      and 13 bits for the distance extra.  This totals 48 bits, or six bytes.
      Therefore if strm.avail_in >= 6, then there is enough input to avoid
      checking for available input while decoding.

    - The maximum bytes that a single length/distance pair can output is 258
      bytes, which is the maximum length that can be coded.  inflate_fast()
      requires strm.avail_out >= 258 for each loop to avoid checking for
      output space.
 */
module.exports = function inflate_fast(strm, start) {
  var state;
  var _in;                    /* local strm.input */
  var last;                   /* have enough input while in < last */
  var _out;                   /* local strm.output */
  var beg;                    /* inflate()'s initial strm.output */
  var end;                    /* while out < end, enough space available */
//#ifdef INFLATE_STRICT
  var dmax;                   /* maximum distance from zlib header */
//#endif
  var wsize;                  /* window size or zero if not using window */
  var whave;                  /* valid bytes in the window */
  var wnext;                  /* window write index */
  // Use `s_window` instead `window`, avoid conflict with instrumentation tools
  var s_window;               /* allocated sliding window, if wsize != 0 */
  var hold;                   /* local strm.hold */
  var bits;                   /* local strm.bits */
  var lcode;                  /* local strm.lencode */
  var dcode;                  /* local strm.distcode */
  var lmask;                  /* mask for first level of length codes */
  var dmask;                  /* mask for first level of distance codes */
  var here;                   /* retrieved table entry */
  var op;                     /* code bits, operation, extra bits, or */
                              /*  window position, window bytes to copy */
  var len;                    /* match length, unused bytes */
  var dist;                   /* match distance */
  var from;                   /* where to copy match from */
  var from_source;


  var input, output; // JS specific, because we have no pointers

  /* copy state to local variables */
  state = strm.state;
  //here = state.here;
  _in = strm.next_in;
  input = strm.input;
  last = _in + (strm.avail_in - 5);
  _out = strm.next_out;
  output = strm.output;
  beg = _out - (start - strm.avail_out);
  end = _out + (strm.avail_out - 257);
//#ifdef INFLATE_STRICT
  dmax = state.dmax;
//#endif
  wsize = state.wsize;
  whave = state.whave;
  wnext = state.wnext;
  s_window = state.window;
  hold = state.hold;
  bits = state.bits;
  lcode = state.lencode;
  dcode = state.distcode;
  lmask = (1 << state.lenbits) - 1;
  dmask = (1 << state.distbits) - 1;


  /* decode literals and length/distances until end-of-block or not enough
     input data or output space */

  top:
  do {
    if (bits < 15) {
      hold += input[_in++] << bits;
      bits += 8;
      hold += input[_in++] << bits;
      bits += 8;
    }

    here = lcode[hold & lmask];

    dolen:
    for (;;) { // Goto emulation
      op = here >>> 24/*here.bits*/;
      hold >>>= op;
      bits -= op;
      op = (here >>> 16) & 0xff/*here.op*/;
      if (op === 0) {                          /* literal */
        //Tracevv((stderr, here.val >= 0x20 && here.val < 0x7f ?
        //        "inflate:         literal '%c'\n" :
        //        "inflate:         literal 0x%02x\n", here.val));
        output[_out++] = here & 0xffff/*here.val*/;
      }
      else if (op & 16) {                     /* length base */
        len = here & 0xffff/*here.val*/;
        op &= 15;                           /* number of extra bits */
        if (op) {
          if (bits < op) {
            hold += input[_in++] << bits;
            bits += 8;
          }
          len += hold & ((1 << op) - 1);
          hold >>>= op;
          bits -= op;
        }
        //Tracevv((stderr, "inflate:         length %u\n", len));
        if (bits < 15) {
          hold += input[_in++] << bits;
          bits += 8;
          hold += input[_in++] << bits;
          bits += 8;
        }
        here = dcode[hold & dmask];

        dodist:
        for (;;) { // goto emulation
          op = here >>> 24/*here.bits*/;
          hold >>>= op;
          bits -= op;
          op = (here >>> 16) & 0xff/*here.op*/;

          if (op & 16) {                      /* distance base */
            dist = here & 0xffff/*here.val*/;
            op &= 15;                       /* number of extra bits */
            if (bits < op) {
              hold += input[_in++] << bits;
              bits += 8;
              if (bits < op) {
                hold += input[_in++] << bits;
                bits += 8;
              }
            }
            dist += hold & ((1 << op) - 1);
//#ifdef INFLATE_STRICT
            if (dist > dmax) {
              strm.msg = 'invalid distance too far back';
              state.mode = BAD;
              break top;
            }
//#endif
            hold >>>= op;
            bits -= op;
            //Tracevv((stderr, "inflate:         distance %u\n", dist));
            op = _out - beg;                /* max distance in output */
            if (dist > op) {                /* see if copy from window */
              op = dist - op;               /* distance back in window */
              if (op > whave) {
                if (state.sane) {
                  strm.msg = 'invalid distance too far back';
                  state.mode = BAD;
                  break top;
                }

// (!) This block is disabled in zlib defailts,
// don't enable it for binary compatibility
//#ifdef INFLATE_ALLOW_INVALID_DISTANCE_TOOFAR_ARRR
//                if (len <= op - whave) {
//                  do {
//                    output[_out++] = 0;
//                  } while (--len);
//                  continue top;
//                }
//                len -= op - whave;
//                do {
//                  output[_out++] = 0;
//                } while (--op > whave);
//                if (op === 0) {
//                  from = _out - dist;
//                  do {
//                    output[_out++] = output[from++];
//                  } while (--len);
//                  continue top;
//                }
//#endif
              }
              from = 0; // window index
              from_source = s_window;
              if (wnext === 0) {           /* very common case */
                from += wsize - op;
                if (op < len) {         /* some from window */
                  len -= op;
                  do {
                    output[_out++] = s_window[from++];
                  } while (--op);
                  from = _out - dist;  /* rest from output */
                  from_source = output;
                }
              }
              else if (wnext < op) {      /* wrap around window */
                from += wsize + wnext - op;
                op -= wnext;
                if (op < len) {         /* some from end of window */
                  len -= op;
                  do {
                    output[_out++] = s_window[from++];
                  } while (--op);
                  from = 0;
                  if (wnext < len) {  /* some from start of window */
                    op = wnext;
                    len -= op;
                    do {
                      output[_out++] = s_window[from++];
                    } while (--op);
                    from = _out - dist;      /* rest from output */
                    from_source = output;
                  }
                }
              }
              else {                      /* contiguous in window */
                from += wnext - op;
                if (op < len) {         /* some from window */
                  len -= op;
                  do {
                    output[_out++] = s_window[from++];
                  } while (--op);
                  from = _out - dist;  /* rest from output */
                  from_source = output;
                }
              }
              while (len > 2) {
                output[_out++] = from_source[from++];
                output[_out++] = from_source[from++];
                output[_out++] = from_source[from++];
                len -= 3;
              }
              if (len) {
                output[_out++] = from_source[from++];
                if (len > 1) {
                  output[_out++] = from_source[from++];
                }
              }
            }
            else {
              from = _out - dist;          /* copy direct from output */
              do {                        /* minimum length is three */
                output[_out++] = output[from++];
                output[_out++] = output[from++];
                output[_out++] = output[from++];
                len -= 3;
              } while (len > 2);
              if (len) {
                output[_out++] = output[from++];
                if (len > 1) {
                  output[_out++] = output[from++];
                }
              }
            }
          }
          else if ((op & 64) === 0) {          /* 2nd level distance code */
            here = dcode[(here & 0xffff)/*here.val*/ + (hold & ((1 << op) - 1))];
            continue dodist;
          }
          else {
            strm.msg = 'invalid distance code';
            state.mode = BAD;
            break top;
          }

          break; // need to emulate goto via "continue"
        }
      }
      else if ((op & 64) === 0) {              /* 2nd level length code */
        here = lcode[(here & 0xffff)/*here.val*/ + (hold & ((1 << op) - 1))];
        continue dolen;
      }
      else if (op & 32) {                     /* end-of-block */
        //Tracevv((stderr, "inflate:         end of block\n"));
        state.mode = TYPE;
        break top;
      }
      else {
        strm.msg = 'invalid literal/length code';
        state.mode = BAD;
        break top;
      }

      break; // need to emulate goto via "continue"
    }
  } while (_in < last && _out < end);

  /* return unused bytes (on entry, bits < 8, so in won't go too far back) */
  len = bits >> 3;
  _in -= len;
  bits -= len << 3;
  hold &= (1 << bits) - 1;

  /* update state and return */
  strm.next_in = _in;
  strm.next_out = _out;
  strm.avail_in = (_in < last ? 5 + (last - _in) : 5 - (_in - last));
  strm.avail_out = (_out < end ? 257 + (end - _out) : 257 - (_out - end));
  state.hold = hold;
  state.bits = bits;
  return;
};


/***/ }),

/***/ "../node_modules/pako/lib/zlib/inflate.js":
/*!************************************************!*\
  !*** ../node_modules/pako/lib/zlib/inflate.js ***!
  \************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {




var utils         = __webpack_require__(/*! ../utils/common */ "../node_modules/pako/lib/utils/common.js");
var adler32       = __webpack_require__(/*! ./adler32 */ "../node_modules/pako/lib/zlib/adler32.js");
var crc32         = __webpack_require__(/*! ./crc32 */ "../node_modules/pako/lib/zlib/crc32.js");
var inflate_fast  = __webpack_require__(/*! ./inffast */ "../node_modules/pako/lib/zlib/inffast.js");
var inflate_table = __webpack_require__(/*! ./inftrees */ "../node_modules/pako/lib/zlib/inftrees.js");

var CODES = 0;
var LENS = 1;
var DISTS = 2;

/* Public constants ==========================================================*/
/* ===========================================================================*/


/* Allowed flush values; see deflate() and inflate() below for details */
//var Z_NO_FLUSH      = 0;
//var Z_PARTIAL_FLUSH = 1;
//var Z_SYNC_FLUSH    = 2;
//var Z_FULL_FLUSH    = 3;
var Z_FINISH        = 4;
var Z_BLOCK         = 5;
var Z_TREES         = 6;


/* Return codes for the compression/decompression functions. Negative values
 * are errors, positive values are used for special but normal events.
 */
var Z_OK            = 0;
var Z_STREAM_END    = 1;
var Z_NEED_DICT     = 2;
//var Z_ERRNO         = -1;
var Z_STREAM_ERROR  = -2;
var Z_DATA_ERROR    = -3;
var Z_MEM_ERROR     = -4;
var Z_BUF_ERROR     = -5;
//var Z_VERSION_ERROR = -6;

/* The deflate compression method */
var Z_DEFLATED  = 8;


/* STATES ====================================================================*/
/* ===========================================================================*/


var    HEAD = 1;       /* i: waiting for magic header */
var    FLAGS = 2;      /* i: waiting for method and flags (gzip) */
var    TIME = 3;       /* i: waiting for modification time (gzip) */
var    OS = 4;         /* i: waiting for extra flags and operating system (gzip) */
var    EXLEN = 5;      /* i: waiting for extra length (gzip) */
var    EXTRA = 6;      /* i: waiting for extra bytes (gzip) */
var    NAME = 7;       /* i: waiting for end of file name (gzip) */
var    COMMENT = 8;    /* i: waiting for end of comment (gzip) */
var    HCRC = 9;       /* i: waiting for header crc (gzip) */
var    DICTID = 10;    /* i: waiting for dictionary check value */
var    DICT = 11;      /* waiting for inflateSetDictionary() call */
var        TYPE = 12;      /* i: waiting for type bits, including last-flag bit */
var        TYPEDO = 13;    /* i: same, but skip check to exit inflate on new block */
var        STORED = 14;    /* i: waiting for stored size (length and complement) */
var        COPY_ = 15;     /* i/o: same as COPY below, but only first time in */
var        COPY = 16;      /* i/o: waiting for input or output to copy stored block */
var        TABLE = 17;     /* i: waiting for dynamic block table lengths */
var        LENLENS = 18;   /* i: waiting for code length code lengths */
var        CODELENS = 19;  /* i: waiting for length/lit and distance code lengths */
var            LEN_ = 20;      /* i: same as LEN below, but only first time in */
var            LEN = 21;       /* i: waiting for length/lit/eob code */
var            LENEXT = 22;    /* i: waiting for length extra bits */
var            DIST = 23;      /* i: waiting for distance code */
var            DISTEXT = 24;   /* i: waiting for distance extra bits */
var            MATCH = 25;     /* o: waiting for output space to copy string */
var            LIT = 26;       /* o: waiting for output space to write literal */
var    CHECK = 27;     /* i: waiting for 32-bit check value */
var    LENGTH = 28;    /* i: waiting for 32-bit length (gzip) */
var    DONE = 29;      /* finished check, done -- remain here until reset */
var    BAD = 30;       /* got a data error -- remain here until reset */
var    MEM = 31;       /* got an inflate() memory error -- remain here until reset */
var    SYNC = 32;      /* looking for synchronization bytes to restart inflate() */

/* ===========================================================================*/



var ENOUGH_LENS = 852;
var ENOUGH_DISTS = 592;
//var ENOUGH =  (ENOUGH_LENS+ENOUGH_DISTS);

var MAX_WBITS = 15;
/* 32K LZ77 window */
var DEF_WBITS = MAX_WBITS;


function zswap32(q) {
  return  (((q >>> 24) & 0xff) +
          ((q >>> 8) & 0xff00) +
          ((q & 0xff00) << 8) +
          ((q & 0xff) << 24));
}


function InflateState() {
  this.mode = 0;             /* current inflate mode */
  this.last = false;          /* true if processing last block */
  this.wrap = 0;              /* bit 0 true for zlib, bit 1 true for gzip */
  this.havedict = false;      /* true if dictionary provided */
  this.flags = 0;             /* gzip header method and flags (0 if zlib) */
  this.dmax = 0;              /* zlib header max distance (INFLATE_STRICT) */
  this.check = 0;             /* protected copy of check value */
  this.total = 0;             /* protected copy of output count */
  // TODO: may be {}
  this.head = null;           /* where to save gzip header information */

  /* sliding window */
  this.wbits = 0;             /* log base 2 of requested window size */
  this.wsize = 0;             /* window size or zero if not using window */
  this.whave = 0;             /* valid bytes in the window */
  this.wnext = 0;             /* window write index */
  this.window = null;         /* allocated sliding window, if needed */

  /* bit accumulator */
  this.hold = 0;              /* input bit accumulator */
  this.bits = 0;              /* number of bits in "in" */

  /* for string and stored block copying */
  this.length = 0;            /* literal or length of data to copy */
  this.offset = 0;            /* distance back to copy string from */

  /* for table and code decoding */
  this.extra = 0;             /* extra bits needed */

  /* fixed and dynamic code tables */
  this.lencode = null;          /* starting table for length/literal codes */
  this.distcode = null;         /* starting table for distance codes */
  this.lenbits = 0;           /* index bits for lencode */
  this.distbits = 0;          /* index bits for distcode */

  /* dynamic table building */
  this.ncode = 0;             /* number of code length code lengths */
  this.nlen = 0;              /* number of length code lengths */
  this.ndist = 0;             /* number of distance code lengths */
  this.have = 0;              /* number of code lengths in lens[] */
  this.next = null;              /* next available space in codes[] */

  this.lens = new utils.Buf16(320); /* temporary storage for code lengths */
  this.work = new utils.Buf16(288); /* work area for code table building */

  /*
   because we don't have pointers in js, we use lencode and distcode directly
   as buffers so we don't need codes
  */
  //this.codes = new utils.Buf32(ENOUGH);       /* space for code tables */
  this.lendyn = null;              /* dynamic table for length/literal codes (JS specific) */
  this.distdyn = null;             /* dynamic table for distance codes (JS specific) */
  this.sane = 0;                   /* if false, allow invalid distance too far */
  this.back = 0;                   /* bits back of last unprocessed length/lit */
  this.was = 0;                    /* initial length of match */
}

function inflateResetKeep(strm) {
  var state;

  if (!strm || !strm.state) { return Z_STREAM_ERROR; }
  state = strm.state;
  strm.total_in = strm.total_out = state.total = 0;
  strm.msg = ''; /*Z_NULL*/
  if (state.wrap) {       /* to support ill-conceived Java test suite */
    strm.adler = state.wrap & 1;
  }
  state.mode = HEAD;
  state.last = 0;
  state.havedict = 0;
  state.dmax = 32768;
  state.head = null/*Z_NULL*/;
  state.hold = 0;
  state.bits = 0;
  //state.lencode = state.distcode = state.next = state.codes;
  state.lencode = state.lendyn = new utils.Buf32(ENOUGH_LENS);
  state.distcode = state.distdyn = new utils.Buf32(ENOUGH_DISTS);

  state.sane = 1;
  state.back = -1;
  //Tracev((stderr, "inflate: reset\n"));
  return Z_OK;
}

function inflateReset(strm) {
  var state;

  if (!strm || !strm.state) { return Z_STREAM_ERROR; }
  state = strm.state;
  state.wsize = 0;
  state.whave = 0;
  state.wnext = 0;
  return inflateResetKeep(strm);

}

function inflateReset2(strm, windowBits) {
  var wrap;
  var state;

  /* get the state */
  if (!strm || !strm.state) { return Z_STREAM_ERROR; }
  state = strm.state;

  /* extract wrap request from windowBits parameter */
  if (windowBits < 0) {
    wrap = 0;
    windowBits = -windowBits;
  }
  else {
    wrap = (windowBits >> 4) + 1;
    if (windowBits < 48) {
      windowBits &= 15;
    }
  }

  /* set number of window bits, free window if different */
  if (windowBits && (windowBits < 8 || windowBits > 15)) {
    return Z_STREAM_ERROR;
  }
  if (state.window !== null && state.wbits !== windowBits) {
    state.window = null;
  }

  /* update state and reset the rest of it */
  state.wrap = wrap;
  state.wbits = windowBits;
  return inflateReset(strm);
}

function inflateInit2(strm, windowBits) {
  var ret;
  var state;

  if (!strm) { return Z_STREAM_ERROR; }
  //strm.msg = Z_NULL;                 /* in case we return an error */

  state = new InflateState();

  //if (state === Z_NULL) return Z_MEM_ERROR;
  //Tracev((stderr, "inflate: allocated\n"));
  strm.state = state;
  state.window = null/*Z_NULL*/;
  ret = inflateReset2(strm, windowBits);
  if (ret !== Z_OK) {
    strm.state = null/*Z_NULL*/;
  }
  return ret;
}

function inflateInit(strm) {
  return inflateInit2(strm, DEF_WBITS);
}


/*
 Return state with length and distance decoding tables and index sizes set to
 fixed code decoding.  Normally this returns fixed tables from inffixed.h.
 If BUILDFIXED is defined, then instead this routine builds the tables the
 first time it's called, and returns those tables the first time and
 thereafter.  This reduces the size of the code by about 2K bytes, in
 exchange for a little execution time.  However, BUILDFIXED should not be
 used for threaded applications, since the rewriting of the tables and virgin
 may not be thread-safe.
 */
var virgin = true;

var lenfix, distfix; // We have no pointers in JS, so keep tables separate

function fixedtables(state) {
  /* build fixed huffman tables if first call (may not be thread safe) */
  if (virgin) {
    var sym;

    lenfix = new utils.Buf32(512);
    distfix = new utils.Buf32(32);

    /* literal/length table */
    sym = 0;
    while (sym < 144) { state.lens[sym++] = 8; }
    while (sym < 256) { state.lens[sym++] = 9; }
    while (sym < 280) { state.lens[sym++] = 7; }
    while (sym < 288) { state.lens[sym++] = 8; }

    inflate_table(LENS,  state.lens, 0, 288, lenfix,   0, state.work, { bits: 9 });

    /* distance table */
    sym = 0;
    while (sym < 32) { state.lens[sym++] = 5; }

    inflate_table(DISTS, state.lens, 0, 32,   distfix, 0, state.work, { bits: 5 });

    /* do this just once */
    virgin = false;
  }

  state.lencode = lenfix;
  state.lenbits = 9;
  state.distcode = distfix;
  state.distbits = 5;
}


/*
 Update the window with the last wsize (normally 32K) bytes written before
 returning.  If window does not exist yet, create it.  This is only called
 when a window is already in use, or when output has been written during this
 inflate call, but the end of the deflate stream has not been reached yet.
 It is also called to create a window for dictionary data when a dictionary
 is loaded.

 Providing output buffers larger than 32K to inflate() should provide a speed
 advantage, since only the last 32K of output is copied to the sliding window
 upon return from inflate(), and since all distances after the first 32K of
 output will fall in the output data, making match copies simpler and faster.
 The advantage may be dependent on the size of the processor's data caches.
 */
function updatewindow(strm, src, end, copy) {
  var dist;
  var state = strm.state;

  /* if it hasn't been done already, allocate space for the window */
  if (state.window === null) {
    state.wsize = 1 << state.wbits;
    state.wnext = 0;
    state.whave = 0;

    state.window = new utils.Buf8(state.wsize);
  }

  /* copy state->wsize or less output bytes into the circular window */
  if (copy >= state.wsize) {
    utils.arraySet(state.window, src, end - state.wsize, state.wsize, 0);
    state.wnext = 0;
    state.whave = state.wsize;
  }
  else {
    dist = state.wsize - state.wnext;
    if (dist > copy) {
      dist = copy;
    }
    //zmemcpy(state->window + state->wnext, end - copy, dist);
    utils.arraySet(state.window, src, end - copy, dist, state.wnext);
    copy -= dist;
    if (copy) {
      //zmemcpy(state->window, end - copy, copy);
      utils.arraySet(state.window, src, end - copy, copy, 0);
      state.wnext = copy;
      state.whave = state.wsize;
    }
    else {
      state.wnext += dist;
      if (state.wnext === state.wsize) { state.wnext = 0; }
      if (state.whave < state.wsize) { state.whave += dist; }
    }
  }
  return 0;
}

function inflate(strm, flush) {
  var state;
  var input, output;          // input/output buffers
  var next;                   /* next input INDEX */
  var put;                    /* next output INDEX */
  var have, left;             /* available input and output */
  var hold;                   /* bit buffer */
  var bits;                   /* bits in bit buffer */
  var _in, _out;              /* save starting available input and output */
  var copy;                   /* number of stored or match bytes to copy */
  var from;                   /* where to copy match bytes from */
  var from_source;
  var here = 0;               /* current decoding table entry */
  var here_bits, here_op, here_val; // paked "here" denormalized (JS specific)
  //var last;                   /* parent table entry */
  var last_bits, last_op, last_val; // paked "last" denormalized (JS specific)
  var len;                    /* length to copy for repeats, bits to drop */
  var ret;                    /* return code */
  var hbuf = new utils.Buf8(4);    /* buffer for gzip header crc calculation */
  var opts;

  var n; // temporary var for NEED_BITS

  var order = /* permutation of code lengths */
    [ 16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15 ];


  if (!strm || !strm.state || !strm.output ||
      (!strm.input && strm.avail_in !== 0)) {
    return Z_STREAM_ERROR;
  }

  state = strm.state;
  if (state.mode === TYPE) { state.mode = TYPEDO; }    /* skip check */


  //--- LOAD() ---
  put = strm.next_out;
  output = strm.output;
  left = strm.avail_out;
  next = strm.next_in;
  input = strm.input;
  have = strm.avail_in;
  hold = state.hold;
  bits = state.bits;
  //---

  _in = have;
  _out = left;
  ret = Z_OK;

  inf_leave: // goto emulation
  for (;;) {
    switch (state.mode) {
    case HEAD:
      if (state.wrap === 0) {
        state.mode = TYPEDO;
        break;
      }
      //=== NEEDBITS(16);
      while (bits < 16) {
        if (have === 0) { break inf_leave; }
        have--;
        hold += input[next++] << bits;
        bits += 8;
      }
      //===//
      if ((state.wrap & 2) && hold === 0x8b1f) {  /* gzip header */
        state.check = 0/*crc32(0L, Z_NULL, 0)*/;
        //=== CRC2(state.check, hold);
        hbuf[0] = hold & 0xff;
        hbuf[1] = (hold >>> 8) & 0xff;
        state.check = crc32(state.check, hbuf, 2, 0);
        //===//

        //=== INITBITS();
        hold = 0;
        bits = 0;
        //===//
        state.mode = FLAGS;
        break;
      }
      state.flags = 0;           /* expect zlib header */
      if (state.head) {
        state.head.done = false;
      }
      if (!(state.wrap & 1) ||   /* check if zlib header allowed */
        (((hold & 0xff)/*BITS(8)*/ << 8) + (hold >> 8)) % 31) {
        strm.msg = 'incorrect header check';
        state.mode = BAD;
        break;
      }
      if ((hold & 0x0f)/*BITS(4)*/ !== Z_DEFLATED) {
        strm.msg = 'unknown compression method';
        state.mode = BAD;
        break;
      }
      //--- DROPBITS(4) ---//
      hold >>>= 4;
      bits -= 4;
      //---//
      len = (hold & 0x0f)/*BITS(4)*/ + 8;
      if (state.wbits === 0) {
        state.wbits = len;
      }
      else if (len > state.wbits) {
        strm.msg = 'invalid window size';
        state.mode = BAD;
        break;
      }
      state.dmax = 1 << len;
      //Tracev((stderr, "inflate:   zlib header ok\n"));
      strm.adler = state.check = 1/*adler32(0L, Z_NULL, 0)*/;
      state.mode = hold & 0x200 ? DICTID : TYPE;
      //=== INITBITS();
      hold = 0;
      bits = 0;
      //===//
      break;
    case FLAGS:
      //=== NEEDBITS(16); */
      while (bits < 16) {
        if (have === 0) { break inf_leave; }
        have--;
        hold += input[next++] << bits;
        bits += 8;
      }
      //===//
      state.flags = hold;
      if ((state.flags & 0xff) !== Z_DEFLATED) {
        strm.msg = 'unknown compression method';
        state.mode = BAD;
        break;
      }
      if (state.flags & 0xe000) {
        strm.msg = 'unknown header flags set';
        state.mode = BAD;
        break;
      }
      if (state.head) {
        state.head.text = ((hold >> 8) & 1);
      }
      if (state.flags & 0x0200) {
        //=== CRC2(state.check, hold);
        hbuf[0] = hold & 0xff;
        hbuf[1] = (hold >>> 8) & 0xff;
        state.check = crc32(state.check, hbuf, 2, 0);
        //===//
      }
      //=== INITBITS();
      hold = 0;
      bits = 0;
      //===//
      state.mode = TIME;
      /* falls through */
    case TIME:
      //=== NEEDBITS(32); */
      while (bits < 32) {
        if (have === 0) { break inf_leave; }
        have--;
        hold += input[next++] << bits;
        bits += 8;
      }
      //===//
      if (state.head) {
        state.head.time = hold;
      }
      if (state.flags & 0x0200) {
        //=== CRC4(state.check, hold)
        hbuf[0] = hold & 0xff;
        hbuf[1] = (hold >>> 8) & 0xff;
        hbuf[2] = (hold >>> 16) & 0xff;
        hbuf[3] = (hold >>> 24) & 0xff;
        state.check = crc32(state.check, hbuf, 4, 0);
        //===
      }
      //=== INITBITS();
      hold = 0;
      bits = 0;
      //===//
      state.mode = OS;
      /* falls through */
    case OS:
      //=== NEEDBITS(16); */
      while (bits < 16) {
        if (have === 0) { break inf_leave; }
        have--;
        hold += input[next++] << bits;
        bits += 8;
      }
      //===//
      if (state.head) {
        state.head.xflags = (hold & 0xff);
        state.head.os = (hold >> 8);
      }
      if (state.flags & 0x0200) {
        //=== CRC2(state.check, hold);
        hbuf[0] = hold & 0xff;
        hbuf[1] = (hold >>> 8) & 0xff;
        state.check = crc32(state.check, hbuf, 2, 0);
        //===//
      }
      //=== INITBITS();
      hold = 0;
      bits = 0;
      //===//
      state.mode = EXLEN;
      /* falls through */
    case EXLEN:
      if (state.flags & 0x0400) {
        //=== NEEDBITS(16); */
        while (bits < 16) {
          if (have === 0) { break inf_leave; }
          have--;
          hold += input[next++] << bits;
          bits += 8;
        }
        //===//
        state.length = hold;
        if (state.head) {
          state.head.extra_len = hold;
        }
        if (state.flags & 0x0200) {
          //=== CRC2(state.check, hold);
          hbuf[0] = hold & 0xff;
          hbuf[1] = (hold >>> 8) & 0xff;
          state.check = crc32(state.check, hbuf, 2, 0);
          //===//
        }
        //=== INITBITS();
        hold = 0;
        bits = 0;
        //===//
      }
      else if (state.head) {
        state.head.extra = null/*Z_NULL*/;
      }
      state.mode = EXTRA;
      /* falls through */
    case EXTRA:
      if (state.flags & 0x0400) {
        copy = state.length;
        if (copy > have) { copy = have; }
        if (copy) {
          if (state.head) {
            len = state.head.extra_len - state.length;
            if (!state.head.extra) {
              // Use untyped array for more conveniend processing later
              state.head.extra = new Array(state.head.extra_len);
            }
            utils.arraySet(
              state.head.extra,
              input,
              next,
              // extra field is limited to 65536 bytes
              // - no need for additional size check
              copy,
              /*len + copy > state.head.extra_max - len ? state.head.extra_max : copy,*/
              len
            );
            //zmemcpy(state.head.extra + len, next,
            //        len + copy > state.head.extra_max ?
            //        state.head.extra_max - len : copy);
          }
          if (state.flags & 0x0200) {
            state.check = crc32(state.check, input, copy, next);
          }
          have -= copy;
          next += copy;
          state.length -= copy;
        }
        if (state.length) { break inf_leave; }
      }
      state.length = 0;
      state.mode = NAME;
      /* falls through */
    case NAME:
      if (state.flags & 0x0800) {
        if (have === 0) { break inf_leave; }
        copy = 0;
        do {
          // TODO: 2 or 1 bytes?
          len = input[next + copy++];
          /* use constant limit because in js we should not preallocate memory */
          if (state.head && len &&
              (state.length < 65536 /*state.head.name_max*/)) {
            state.head.name += String.fromCharCode(len);
          }
        } while (len && copy < have);

        if (state.flags & 0x0200) {
          state.check = crc32(state.check, input, copy, next);
        }
        have -= copy;
        next += copy;
        if (len) { break inf_leave; }
      }
      else if (state.head) {
        state.head.name = null;
      }
      state.length = 0;
      state.mode = COMMENT;
      /* falls through */
    case COMMENT:
      if (state.flags & 0x1000) {
        if (have === 0) { break inf_leave; }
        copy = 0;
        do {
          len = input[next + copy++];
          /* use constant limit because in js we should not preallocate memory */
          if (state.head && len &&
              (state.length < 65536 /*state.head.comm_max*/)) {
            state.head.comment += String.fromCharCode(len);
          }
        } while (len && copy < have);
        if (state.flags & 0x0200) {
          state.check = crc32(state.check, input, copy, next);
        }
        have -= copy;
        next += copy;
        if (len) { break inf_leave; }
      }
      else if (state.head) {
        state.head.comment = null;
      }
      state.mode = HCRC;
      /* falls through */
    case HCRC:
      if (state.flags & 0x0200) {
        //=== NEEDBITS(16); */
        while (bits < 16) {
          if (have === 0) { break inf_leave; }
          have--;
          hold += input[next++] << bits;
          bits += 8;
        }
        //===//
        if (hold !== (state.check & 0xffff)) {
          strm.msg = 'header crc mismatch';
          state.mode = BAD;
          break;
        }
        //=== INITBITS();
        hold = 0;
        bits = 0;
        //===//
      }
      if (state.head) {
        state.head.hcrc = ((state.flags >> 9) & 1);
        state.head.done = true;
      }
      strm.adler = state.check = 0;
      state.mode = TYPE;
      break;
    case DICTID:
      //=== NEEDBITS(32); */
      while (bits < 32) {
        if (have === 0) { break inf_leave; }
        have--;
        hold += input[next++] << bits;
        bits += 8;
      }
      //===//
      strm.adler = state.check = zswap32(hold);
      //=== INITBITS();
      hold = 0;
      bits = 0;
      //===//
      state.mode = DICT;
      /* falls through */
    case DICT:
      if (state.havedict === 0) {
        //--- RESTORE() ---
        strm.next_out = put;
        strm.avail_out = left;
        strm.next_in = next;
        strm.avail_in = have;
        state.hold = hold;
        state.bits = bits;
        //---
        return Z_NEED_DICT;
      }
      strm.adler = state.check = 1/*adler32(0L, Z_NULL, 0)*/;
      state.mode = TYPE;
      /* falls through */
    case TYPE:
      if (flush === Z_BLOCK || flush === Z_TREES) { break inf_leave; }
      /* falls through */
    case TYPEDO:
      if (state.last) {
        //--- BYTEBITS() ---//
        hold >>>= bits & 7;
        bits -= bits & 7;
        //---//
        state.mode = CHECK;
        break;
      }
      //=== NEEDBITS(3); */
      while (bits < 3) {
        if (have === 0) { break inf_leave; }
        have--;
        hold += input[next++] << bits;
        bits += 8;
      }
      //===//
      state.last = (hold & 0x01)/*BITS(1)*/;
      //--- DROPBITS(1) ---//
      hold >>>= 1;
      bits -= 1;
      //---//

      switch ((hold & 0x03)/*BITS(2)*/) {
      case 0:                             /* stored block */
        //Tracev((stderr, "inflate:     stored block%s\n",
        //        state.last ? " (last)" : ""));
        state.mode = STORED;
        break;
      case 1:                             /* fixed block */
        fixedtables(state);
        //Tracev((stderr, "inflate:     fixed codes block%s\n",
        //        state.last ? " (last)" : ""));
        state.mode = LEN_;             /* decode codes */
        if (flush === Z_TREES) {
          //--- DROPBITS(2) ---//
          hold >>>= 2;
          bits -= 2;
          //---//
          break inf_leave;
        }
        break;
      case 2:                             /* dynamic block */
        //Tracev((stderr, "inflate:     dynamic codes block%s\n",
        //        state.last ? " (last)" : ""));
        state.mode = TABLE;
        break;
      case 3:
        strm.msg = 'invalid block type';
        state.mode = BAD;
      }
      //--- DROPBITS(2) ---//
      hold >>>= 2;
      bits -= 2;
      //---//
      break;
    case STORED:
      //--- BYTEBITS() ---// /* go to byte boundary */
      hold >>>= bits & 7;
      bits -= bits & 7;
      //---//
      //=== NEEDBITS(32); */
      while (bits < 32) {
        if (have === 0) { break inf_leave; }
        have--;
        hold += input[next++] << bits;
        bits += 8;
      }
      //===//
      if ((hold & 0xffff) !== ((hold >>> 16) ^ 0xffff)) {
        strm.msg = 'invalid stored block lengths';
        state.mode = BAD;
        break;
      }
      state.length = hold & 0xffff;
      //Tracev((stderr, "inflate:       stored length %u\n",
      //        state.length));
      //=== INITBITS();
      hold = 0;
      bits = 0;
      //===//
      state.mode = COPY_;
      if (flush === Z_TREES) { break inf_leave; }
      /* falls through */
    case COPY_:
      state.mode = COPY;
      /* falls through */
    case COPY:
      copy = state.length;
      if (copy) {
        if (copy > have) { copy = have; }
        if (copy > left) { copy = left; }
        if (copy === 0) { break inf_leave; }
        //--- zmemcpy(put, next, copy); ---
        utils.arraySet(output, input, next, copy, put);
        //---//
        have -= copy;
        next += copy;
        left -= copy;
        put += copy;
        state.length -= copy;
        break;
      }
      //Tracev((stderr, "inflate:       stored end\n"));
      state.mode = TYPE;
      break;
    case TABLE:
      //=== NEEDBITS(14); */
      while (bits < 14) {
        if (have === 0) { break inf_leave; }
        have--;
        hold += input[next++] << bits;
        bits += 8;
      }
      //===//
      state.nlen = (hold & 0x1f)/*BITS(5)*/ + 257;
      //--- DROPBITS(5) ---//
      hold >>>= 5;
      bits -= 5;
      //---//
      state.ndist = (hold & 0x1f)/*BITS(5)*/ + 1;
      //--- DROPBITS(5) ---//
      hold >>>= 5;
      bits -= 5;
      //---//
      state.ncode = (hold & 0x0f)/*BITS(4)*/ + 4;
      //--- DROPBITS(4) ---//
      hold >>>= 4;
      bits -= 4;
      //---//
//#ifndef PKZIP_BUG_WORKAROUND
      if (state.nlen > 286 || state.ndist > 30) {
        strm.msg = 'too many length or distance symbols';
        state.mode = BAD;
        break;
      }
//#endif
      //Tracev((stderr, "inflate:       table sizes ok\n"));
      state.have = 0;
      state.mode = LENLENS;
      /* falls through */
    case LENLENS:
      while (state.have < state.ncode) {
        //=== NEEDBITS(3);
        while (bits < 3) {
          if (have === 0) { break inf_leave; }
          have--;
          hold += input[next++] << bits;
          bits += 8;
        }
        //===//
        state.lens[order[state.have++]] = (hold & 0x07);//BITS(3);
        //--- DROPBITS(3) ---//
        hold >>>= 3;
        bits -= 3;
        //---//
      }
      while (state.have < 19) {
        state.lens[order[state.have++]] = 0;
      }
      // We have separate tables & no pointers. 2 commented lines below not needed.
      //state.next = state.codes;
      //state.lencode = state.next;
      // Switch to use dynamic table
      state.lencode = state.lendyn;
      state.lenbits = 7;

      opts = { bits: state.lenbits };
      ret = inflate_table(CODES, state.lens, 0, 19, state.lencode, 0, state.work, opts);
      state.lenbits = opts.bits;

      if (ret) {
        strm.msg = 'invalid code lengths set';
        state.mode = BAD;
        break;
      }
      //Tracev((stderr, "inflate:       code lengths ok\n"));
      state.have = 0;
      state.mode = CODELENS;
      /* falls through */
    case CODELENS:
      while (state.have < state.nlen + state.ndist) {
        for (;;) {
          here = state.lencode[hold & ((1 << state.lenbits) - 1)];/*BITS(state.lenbits)*/
          here_bits = here >>> 24;
          here_op = (here >>> 16) & 0xff;
          here_val = here & 0xffff;

          if ((here_bits) <= bits) { break; }
          //--- PULLBYTE() ---//
          if (have === 0) { break inf_leave; }
          have--;
          hold += input[next++] << bits;
          bits += 8;
          //---//
        }
        if (here_val < 16) {
          //--- DROPBITS(here.bits) ---//
          hold >>>= here_bits;
          bits -= here_bits;
          //---//
          state.lens[state.have++] = here_val;
        }
        else {
          if (here_val === 16) {
            //=== NEEDBITS(here.bits + 2);
            n = here_bits + 2;
            while (bits < n) {
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            //--- DROPBITS(here.bits) ---//
            hold >>>= here_bits;
            bits -= here_bits;
            //---//
            if (state.have === 0) {
              strm.msg = 'invalid bit length repeat';
              state.mode = BAD;
              break;
            }
            len = state.lens[state.have - 1];
            copy = 3 + (hold & 0x03);//BITS(2);
            //--- DROPBITS(2) ---//
            hold >>>= 2;
            bits -= 2;
            //---//
          }
          else if (here_val === 17) {
            //=== NEEDBITS(here.bits + 3);
            n = here_bits + 3;
            while (bits < n) {
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            //--- DROPBITS(here.bits) ---//
            hold >>>= here_bits;
            bits -= here_bits;
            //---//
            len = 0;
            copy = 3 + (hold & 0x07);//BITS(3);
            //--- DROPBITS(3) ---//
            hold >>>= 3;
            bits -= 3;
            //---//
          }
          else {
            //=== NEEDBITS(here.bits + 7);
            n = here_bits + 7;
            while (bits < n) {
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            //--- DROPBITS(here.bits) ---//
            hold >>>= here_bits;
            bits -= here_bits;
            //---//
            len = 0;
            copy = 11 + (hold & 0x7f);//BITS(7);
            //--- DROPBITS(7) ---//
            hold >>>= 7;
            bits -= 7;
            //---//
          }
          if (state.have + copy > state.nlen + state.ndist) {
            strm.msg = 'invalid bit length repeat';
            state.mode = BAD;
            break;
          }
          while (copy--) {
            state.lens[state.have++] = len;
          }
        }
      }

      /* handle error breaks in while */
      if (state.mode === BAD) { break; }

      /* check for end-of-block code (better have one) */
      if (state.lens[256] === 0) {
        strm.msg = 'invalid code -- missing end-of-block';
        state.mode = BAD;
        break;
      }

      /* build code tables -- note: do not change the lenbits or distbits
         values here (9 and 6) without reading the comments in inftrees.h
         concerning the ENOUGH constants, which depend on those values */
      state.lenbits = 9;

      opts = { bits: state.lenbits };
      ret = inflate_table(LENS, state.lens, 0, state.nlen, state.lencode, 0, state.work, opts);
      // We have separate tables & no pointers. 2 commented lines below not needed.
      // state.next_index = opts.table_index;
      state.lenbits = opts.bits;
      // state.lencode = state.next;

      if (ret) {
        strm.msg = 'invalid literal/lengths set';
        state.mode = BAD;
        break;
      }

      state.distbits = 6;
      //state.distcode.copy(state.codes);
      // Switch to use dynamic table
      state.distcode = state.distdyn;
      opts = { bits: state.distbits };
      ret = inflate_table(DISTS, state.lens, state.nlen, state.ndist, state.distcode, 0, state.work, opts);
      // We have separate tables & no pointers. 2 commented lines below not needed.
      // state.next_index = opts.table_index;
      state.distbits = opts.bits;
      // state.distcode = state.next;

      if (ret) {
        strm.msg = 'invalid distances set';
        state.mode = BAD;
        break;
      }
      //Tracev((stderr, 'inflate:       codes ok\n'));
      state.mode = LEN_;
      if (flush === Z_TREES) { break inf_leave; }
      /* falls through */
    case LEN_:
      state.mode = LEN;
      /* falls through */
    case LEN:
      if (have >= 6 && left >= 258) {
        //--- RESTORE() ---
        strm.next_out = put;
        strm.avail_out = left;
        strm.next_in = next;
        strm.avail_in = have;
        state.hold = hold;
        state.bits = bits;
        //---
        inflate_fast(strm, _out);
        //--- LOAD() ---
        put = strm.next_out;
        output = strm.output;
        left = strm.avail_out;
        next = strm.next_in;
        input = strm.input;
        have = strm.avail_in;
        hold = state.hold;
        bits = state.bits;
        //---

        if (state.mode === TYPE) {
          state.back = -1;
        }
        break;
      }
      state.back = 0;
      for (;;) {
        here = state.lencode[hold & ((1 << state.lenbits) - 1)];  /*BITS(state.lenbits)*/
        here_bits = here >>> 24;
        here_op = (here >>> 16) & 0xff;
        here_val = here & 0xffff;

        if (here_bits <= bits) { break; }
        //--- PULLBYTE() ---//
        if (have === 0) { break inf_leave; }
        have--;
        hold += input[next++] << bits;
        bits += 8;
        //---//
      }
      if (here_op && (here_op & 0xf0) === 0) {
        last_bits = here_bits;
        last_op = here_op;
        last_val = here_val;
        for (;;) {
          here = state.lencode[last_val +
                  ((hold & ((1 << (last_bits + last_op)) - 1))/*BITS(last.bits + last.op)*/ >> last_bits)];
          here_bits = here >>> 24;
          here_op = (here >>> 16) & 0xff;
          here_val = here & 0xffff;

          if ((last_bits + here_bits) <= bits) { break; }
          //--- PULLBYTE() ---//
          if (have === 0) { break inf_leave; }
          have--;
          hold += input[next++] << bits;
          bits += 8;
          //---//
        }
        //--- DROPBITS(last.bits) ---//
        hold >>>= last_bits;
        bits -= last_bits;
        //---//
        state.back += last_bits;
      }
      //--- DROPBITS(here.bits) ---//
      hold >>>= here_bits;
      bits -= here_bits;
      //---//
      state.back += here_bits;
      state.length = here_val;
      if (here_op === 0) {
        //Tracevv((stderr, here.val >= 0x20 && here.val < 0x7f ?
        //        "inflate:         literal '%c'\n" :
        //        "inflate:         literal 0x%02x\n", here.val));
        state.mode = LIT;
        break;
      }
      if (here_op & 32) {
        //Tracevv((stderr, "inflate:         end of block\n"));
        state.back = -1;
        state.mode = TYPE;
        break;
      }
      if (here_op & 64) {
        strm.msg = 'invalid literal/length code';
        state.mode = BAD;
        break;
      }
      state.extra = here_op & 15;
      state.mode = LENEXT;
      /* falls through */
    case LENEXT:
      if (state.extra) {
        //=== NEEDBITS(state.extra);
        n = state.extra;
        while (bits < n) {
          if (have === 0) { break inf_leave; }
          have--;
          hold += input[next++] << bits;
          bits += 8;
        }
        //===//
        state.length += hold & ((1 << state.extra) - 1)/*BITS(state.extra)*/;
        //--- DROPBITS(state.extra) ---//
        hold >>>= state.extra;
        bits -= state.extra;
        //---//
        state.back += state.extra;
      }
      //Tracevv((stderr, "inflate:         length %u\n", state.length));
      state.was = state.length;
      state.mode = DIST;
      /* falls through */
    case DIST:
      for (;;) {
        here = state.distcode[hold & ((1 << state.distbits) - 1)];/*BITS(state.distbits)*/
        here_bits = here >>> 24;
        here_op = (here >>> 16) & 0xff;
        here_val = here & 0xffff;

        if ((here_bits) <= bits) { break; }
        //--- PULLBYTE() ---//
        if (have === 0) { break inf_leave; }
        have--;
        hold += input[next++] << bits;
        bits += 8;
        //---//
      }
      if ((here_op & 0xf0) === 0) {
        last_bits = here_bits;
        last_op = here_op;
        last_val = here_val;
        for (;;) {
          here = state.distcode[last_val +
                  ((hold & ((1 << (last_bits + last_op)) - 1))/*BITS(last.bits + last.op)*/ >> last_bits)];
          here_bits = here >>> 24;
          here_op = (here >>> 16) & 0xff;
          here_val = here & 0xffff;

          if ((last_bits + here_bits) <= bits) { break; }
          //--- PULLBYTE() ---//
          if (have === 0) { break inf_leave; }
          have--;
          hold += input[next++] << bits;
          bits += 8;
          //---//
        }
        //--- DROPBITS(last.bits) ---//
        hold >>>= last_bits;
        bits -= last_bits;
        //---//
        state.back += last_bits;
      }
      //--- DROPBITS(here.bits) ---//
      hold >>>= here_bits;
      bits -= here_bits;
      //---//
      state.back += here_bits;
      if (here_op & 64) {
        strm.msg = 'invalid distance code';
        state.mode = BAD;
        break;
      }
      state.offset = here_val;
      state.extra = (here_op) & 15;
      state.mode = DISTEXT;
      /* falls through */
    case DISTEXT:
      if (state.extra) {
        //=== NEEDBITS(state.extra);
        n = state.extra;
        while (bits < n) {
          if (have === 0) { break inf_leave; }
          have--;
          hold += input[next++] << bits;
          bits += 8;
        }
        //===//
        state.offset += hold & ((1 << state.extra) - 1)/*BITS(state.extra)*/;
        //--- DROPBITS(state.extra) ---//
        hold >>>= state.extra;
        bits -= state.extra;
        //---//
        state.back += state.extra;
      }
//#ifdef INFLATE_STRICT
      if (state.offset > state.dmax) {
        strm.msg = 'invalid distance too far back';
        state.mode = BAD;
        break;
      }
//#endif
      //Tracevv((stderr, "inflate:         distance %u\n", state.offset));
      state.mode = MATCH;
      /* falls through */
    case MATCH:
      if (left === 0) { break inf_leave; }
      copy = _out - left;
      if (state.offset > copy) {         /* copy from window */
        copy = state.offset - copy;
        if (copy > state.whave) {
          if (state.sane) {
            strm.msg = 'invalid distance too far back';
            state.mode = BAD;
            break;
          }
// (!) This block is disabled in zlib defailts,
// don't enable it for binary compatibility
//#ifdef INFLATE_ALLOW_INVALID_DISTANCE_TOOFAR_ARRR
//          Trace((stderr, "inflate.c too far\n"));
//          copy -= state.whave;
//          if (copy > state.length) { copy = state.length; }
//          if (copy > left) { copy = left; }
//          left -= copy;
//          state.length -= copy;
//          do {
//            output[put++] = 0;
//          } while (--copy);
//          if (state.length === 0) { state.mode = LEN; }
//          break;
//#endif
        }
        if (copy > state.wnext) {
          copy -= state.wnext;
          from = state.wsize - copy;
        }
        else {
          from = state.wnext - copy;
        }
        if (copy > state.length) { copy = state.length; }
        from_source = state.window;
      }
      else {                              /* copy from output */
        from_source = output;
        from = put - state.offset;
        copy = state.length;
      }
      if (copy > left) { copy = left; }
      left -= copy;
      state.length -= copy;
      do {
        output[put++] = from_source[from++];
      } while (--copy);
      if (state.length === 0) { state.mode = LEN; }
      break;
    case LIT:
      if (left === 0) { break inf_leave; }
      output[put++] = state.length;
      left--;
      state.mode = LEN;
      break;
    case CHECK:
      if (state.wrap) {
        //=== NEEDBITS(32);
        while (bits < 32) {
          if (have === 0) { break inf_leave; }
          have--;
          // Use '|' insdead of '+' to make sure that result is signed
          hold |= input[next++] << bits;
          bits += 8;
        }
        //===//
        _out -= left;
        strm.total_out += _out;
        state.total += _out;
        if (_out) {
          strm.adler = state.check =
              /*UPDATE(state.check, put - _out, _out);*/
              (state.flags ? crc32(state.check, output, _out, put - _out) : adler32(state.check, output, _out, put - _out));

        }
        _out = left;
        // NB: crc32 stored as signed 32-bit int, zswap32 returns signed too
        if ((state.flags ? hold : zswap32(hold)) !== state.check) {
          strm.msg = 'incorrect data check';
          state.mode = BAD;
          break;
        }
        //=== INITBITS();
        hold = 0;
        bits = 0;
        //===//
        //Tracev((stderr, "inflate:   check matches trailer\n"));
      }
      state.mode = LENGTH;
      /* falls through */
    case LENGTH:
      if (state.wrap && state.flags) {
        //=== NEEDBITS(32);
        while (bits < 32) {
          if (have === 0) { break inf_leave; }
          have--;
          hold += input[next++] << bits;
          bits += 8;
        }
        //===//
        if (hold !== (state.total & 0xffffffff)) {
          strm.msg = 'incorrect length check';
          state.mode = BAD;
          break;
        }
        //=== INITBITS();
        hold = 0;
        bits = 0;
        //===//
        //Tracev((stderr, "inflate:   length matches trailer\n"));
      }
      state.mode = DONE;
      /* falls through */
    case DONE:
      ret = Z_STREAM_END;
      break inf_leave;
    case BAD:
      ret = Z_DATA_ERROR;
      break inf_leave;
    case MEM:
      return Z_MEM_ERROR;
    case SYNC:
      /* falls through */
    default:
      return Z_STREAM_ERROR;
    }
  }

  // inf_leave <- here is real place for "goto inf_leave", emulated via "break inf_leave"

  /*
     Return from inflate(), updating the total counts and the check value.
     If there was no progress during the inflate() call, return a buffer
     error.  Call updatewindow() to create and/or update the window state.
     Note: a memory error from inflate() is non-recoverable.
   */

  //--- RESTORE() ---
  strm.next_out = put;
  strm.avail_out = left;
  strm.next_in = next;
  strm.avail_in = have;
  state.hold = hold;
  state.bits = bits;
  //---

  if (state.wsize || (_out !== strm.avail_out && state.mode < BAD &&
                      (state.mode < CHECK || flush !== Z_FINISH))) {
    if (updatewindow(strm, strm.output, strm.next_out, _out - strm.avail_out)) {
      state.mode = MEM;
      return Z_MEM_ERROR;
    }
  }
  _in -= strm.avail_in;
  _out -= strm.avail_out;
  strm.total_in += _in;
  strm.total_out += _out;
  state.total += _out;
  if (state.wrap && _out) {
    strm.adler = state.check = /*UPDATE(state.check, strm.next_out - _out, _out);*/
      (state.flags ? crc32(state.check, output, _out, strm.next_out - _out) : adler32(state.check, output, _out, strm.next_out - _out));
  }
  strm.data_type = state.bits + (state.last ? 64 : 0) +
                    (state.mode === TYPE ? 128 : 0) +
                    (state.mode === LEN_ || state.mode === COPY_ ? 256 : 0);
  if (((_in === 0 && _out === 0) || flush === Z_FINISH) && ret === Z_OK) {
    ret = Z_BUF_ERROR;
  }
  return ret;
}

function inflateEnd(strm) {

  if (!strm || !strm.state /*|| strm->zfree == (free_func)0*/) {
    return Z_STREAM_ERROR;
  }

  var state = strm.state;
  if (state.window) {
    state.window = null;
  }
  strm.state = null;
  return Z_OK;
}

function inflateGetHeader(strm, head) {
  var state;

  /* check state */
  if (!strm || !strm.state) { return Z_STREAM_ERROR; }
  state = strm.state;
  if ((state.wrap & 2) === 0) { return Z_STREAM_ERROR; }

  /* save header structure */
  state.head = head;
  head.done = false;
  return Z_OK;
}

function inflateSetDictionary(strm, dictionary) {
  var dictLength = dictionary.length;

  var state;
  var dictid;
  var ret;

  /* check state */
  if (!strm /* == Z_NULL */ || !strm.state /* == Z_NULL */) { return Z_STREAM_ERROR; }
  state = strm.state;

  if (state.wrap !== 0 && state.mode !== DICT) {
    return Z_STREAM_ERROR;
  }

  /* check for correct dictionary identifier */
  if (state.mode === DICT) {
    dictid = 1; /* adler32(0, null, 0)*/
    /* dictid = adler32(dictid, dictionary, dictLength); */
    dictid = adler32(dictid, dictionary, dictLength, 0);
    if (dictid !== state.check) {
      return Z_DATA_ERROR;
    }
  }
  /* copy dictionary to window using updatewindow(), which will amend the
   existing dictionary if appropriate */
  ret = updatewindow(strm, dictionary, dictLength, dictLength);
  if (ret) {
    state.mode = MEM;
    return Z_MEM_ERROR;
  }
  state.havedict = 1;
  // Tracev((stderr, "inflate:   dictionary set\n"));
  return Z_OK;
}

exports.inflateReset = inflateReset;
exports.inflateReset2 = inflateReset2;
exports.inflateResetKeep = inflateResetKeep;
exports.inflateInit = inflateInit;
exports.inflateInit2 = inflateInit2;
exports.inflate = inflate;
exports.inflateEnd = inflateEnd;
exports.inflateGetHeader = inflateGetHeader;
exports.inflateSetDictionary = inflateSetDictionary;
exports.inflateInfo = 'pako inflate (from Nodeca project)';

/* Not implemented
exports.inflateCopy = inflateCopy;
exports.inflateGetDictionary = inflateGetDictionary;
exports.inflateMark = inflateMark;
exports.inflatePrime = inflatePrime;
exports.inflateSync = inflateSync;
exports.inflateSyncPoint = inflateSyncPoint;
exports.inflateUndermine = inflateUndermine;
*/


/***/ }),

/***/ "../node_modules/pako/lib/zlib/inftrees.js":
/*!*************************************************!*\
  !*** ../node_modules/pako/lib/zlib/inftrees.js ***!
  \*************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {




var utils = __webpack_require__(/*! ../utils/common */ "../node_modules/pako/lib/utils/common.js");

var MAXBITS = 15;
var ENOUGH_LENS = 852;
var ENOUGH_DISTS = 592;
//var ENOUGH = (ENOUGH_LENS+ENOUGH_DISTS);

var CODES = 0;
var LENS = 1;
var DISTS = 2;

var lbase = [ /* Length codes 257..285 base */
  3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 15, 17, 19, 23, 27, 31,
  35, 43, 51, 59, 67, 83, 99, 115, 131, 163, 195, 227, 258, 0, 0
];

var lext = [ /* Length codes 257..285 extra */
  16, 16, 16, 16, 16, 16, 16, 16, 17, 17, 17, 17, 18, 18, 18, 18,
  19, 19, 19, 19, 20, 20, 20, 20, 21, 21, 21, 21, 16, 72, 78
];

var dbase = [ /* Distance codes 0..29 base */
  1, 2, 3, 4, 5, 7, 9, 13, 17, 25, 33, 49, 65, 97, 129, 193,
  257, 385, 513, 769, 1025, 1537, 2049, 3073, 4097, 6145,
  8193, 12289, 16385, 24577, 0, 0
];

var dext = [ /* Distance codes 0..29 extra */
  16, 16, 16, 16, 17, 17, 18, 18, 19, 19, 20, 20, 21, 21, 22, 22,
  23, 23, 24, 24, 25, 25, 26, 26, 27, 27,
  28, 28, 29, 29, 64, 64
];

module.exports = function inflate_table(type, lens, lens_index, codes, table, table_index, work, opts)
{
  var bits = opts.bits;
      //here = opts.here; /* table entry for duplication */

  var len = 0;               /* a code's length in bits */
  var sym = 0;               /* index of code symbols */
  var min = 0, max = 0;          /* minimum and maximum code lengths */
  var root = 0;              /* number of index bits for root table */
  var curr = 0;              /* number of index bits for current table */
  var drop = 0;              /* code bits to drop for sub-table */
  var left = 0;                   /* number of prefix codes available */
  var used = 0;              /* code entries in table used */
  var huff = 0;              /* Huffman code */
  var incr;              /* for incrementing code, index */
  var fill;              /* index for replicating entries */
  var low;               /* low bits for current root entry */
  var mask;              /* mask for low root bits */
  var next;             /* next available space in table */
  var base = null;     /* base value table to use */
  var base_index = 0;
//  var shoextra;    /* extra bits table to use */
  var end;                    /* use base and extra for symbol > end */
  var count = new utils.Buf16(MAXBITS + 1); //[MAXBITS+1];    /* number of codes of each length */
  var offs = new utils.Buf16(MAXBITS + 1); //[MAXBITS+1];     /* offsets in table for each length */
  var extra = null;
  var extra_index = 0;

  var here_bits, here_op, here_val;

  /*
   Process a set of code lengths to create a canonical Huffman code.  The
   code lengths are lens[0..codes-1].  Each length corresponds to the
   symbols 0..codes-1.  The Huffman code is generated by first sorting the
   symbols by length from short to long, and retaining the symbol order
   for codes with equal lengths.  Then the code starts with all zero bits
   for the first code of the shortest length, and the codes are integer
   increments for the same length, and zeros are appended as the length
   increases.  For the deflate format, these bits are stored backwards
   from their more natural integer increment ordering, and so when the
   decoding tables are built in the large loop below, the integer codes
   are incremented backwards.

   This routine assumes, but does not check, that all of the entries in
   lens[] are in the range 0..MAXBITS.  The caller must assure this.
   1..MAXBITS is interpreted as that code length.  zero means that that
   symbol does not occur in this code.

   The codes are sorted by computing a count of codes for each length,
   creating from that a table of starting indices for each length in the
   sorted table, and then entering the symbols in order in the sorted
   table.  The sorted table is work[], with that space being provided by
   the caller.

   The length counts are used for other purposes as well, i.e. finding
   the minimum and maximum length codes, determining if there are any
   codes at all, checking for a valid set of lengths, and looking ahead
   at length counts to determine sub-table sizes when building the
   decoding tables.
   */

  /* accumulate lengths for codes (assumes lens[] all in 0..MAXBITS) */
  for (len = 0; len <= MAXBITS; len++) {
    count[len] = 0;
  }
  for (sym = 0; sym < codes; sym++) {
    count[lens[lens_index + sym]]++;
  }

  /* bound code lengths, force root to be within code lengths */
  root = bits;
  for (max = MAXBITS; max >= 1; max--) {
    if (count[max] !== 0) { break; }
  }
  if (root > max) {
    root = max;
  }
  if (max === 0) {                     /* no symbols to code at all */
    //table.op[opts.table_index] = 64;  //here.op = (var char)64;    /* invalid code marker */
    //table.bits[opts.table_index] = 1;   //here.bits = (var char)1;
    //table.val[opts.table_index++] = 0;   //here.val = (var short)0;
    table[table_index++] = (1 << 24) | (64 << 16) | 0;


    //table.op[opts.table_index] = 64;
    //table.bits[opts.table_index] = 1;
    //table.val[opts.table_index++] = 0;
    table[table_index++] = (1 << 24) | (64 << 16) | 0;

    opts.bits = 1;
    return 0;     /* no symbols, but wait for decoding to report error */
  }
  for (min = 1; min < max; min++) {
    if (count[min] !== 0) { break; }
  }
  if (root < min) {
    root = min;
  }

  /* check for an over-subscribed or incomplete set of lengths */
  left = 1;
  for (len = 1; len <= MAXBITS; len++) {
    left <<= 1;
    left -= count[len];
    if (left < 0) {
      return -1;
    }        /* over-subscribed */
  }
  if (left > 0 && (type === CODES || max !== 1)) {
    return -1;                      /* incomplete set */
  }

  /* generate offsets into symbol table for each length for sorting */
  offs[1] = 0;
  for (len = 1; len < MAXBITS; len++) {
    offs[len + 1] = offs[len] + count[len];
  }

  /* sort symbols by length, by symbol order within each length */
  for (sym = 0; sym < codes; sym++) {
    if (lens[lens_index + sym] !== 0) {
      work[offs[lens[lens_index + sym]]++] = sym;
    }
  }

  /*
   Create and fill in decoding tables.  In this loop, the table being
   filled is at next and has curr index bits.  The code being used is huff
   with length len.  That code is converted to an index by dropping drop
   bits off of the bottom.  For codes where len is less than drop + curr,
   those top drop + curr - len bits are incremented through all values to
   fill the table with replicated entries.

   root is the number of index bits for the root table.  When len exceeds
   root, sub-tables are created pointed to by the root entry with an index
   of the low root bits of huff.  This is saved in low to check for when a
   new sub-table should be started.  drop is zero when the root table is
   being filled, and drop is root when sub-tables are being filled.

   When a new sub-table is needed, it is necessary to look ahead in the
   code lengths to determine what size sub-table is needed.  The length
   counts are used for this, and so count[] is decremented as codes are
   entered in the tables.

   used keeps track of how many table entries have been allocated from the
   provided *table space.  It is checked for LENS and DIST tables against
   the constants ENOUGH_LENS and ENOUGH_DISTS to guard against changes in
   the initial root table size constants.  See the comments in inftrees.h
   for more information.

   sym increments through all symbols, and the loop terminates when
   all codes of length max, i.e. all codes, have been processed.  This
   routine permits incomplete codes, so another loop after this one fills
   in the rest of the decoding tables with invalid code markers.
   */

  /* set up for code type */
  // poor man optimization - use if-else instead of switch,
  // to avoid deopts in old v8
  if (type === CODES) {
    base = extra = work;    /* dummy value--not used */
    end = 19;

  } else if (type === LENS) {
    base = lbase;
    base_index -= 257;
    extra = lext;
    extra_index -= 257;
    end = 256;

  } else {                    /* DISTS */
    base = dbase;
    extra = dext;
    end = -1;
  }

  /* initialize opts for loop */
  huff = 0;                   /* starting code */
  sym = 0;                    /* starting code symbol */
  len = min;                  /* starting code length */
  next = table_index;              /* current table to fill in */
  curr = root;                /* current table index bits */
  drop = 0;                   /* current bits to drop from code for index */
  low = -1;                   /* trigger new sub-table when len > root */
  used = 1 << root;          /* use root table entries */
  mask = used - 1;            /* mask for comparing low */

  /* check available table space */
  if ((type === LENS && used > ENOUGH_LENS) ||
    (type === DISTS && used > ENOUGH_DISTS)) {
    return 1;
  }

  var i = 0;
  /* process all codes and make table entries */
  for (;;) {
    i++;
    /* create table entry */
    here_bits = len - drop;
    if (work[sym] < end) {
      here_op = 0;
      here_val = work[sym];
    }
    else if (work[sym] > end) {
      here_op = extra[extra_index + work[sym]];
      here_val = base[base_index + work[sym]];
    }
    else {
      here_op = 32 + 64;         /* end of block */
      here_val = 0;
    }

    /* replicate for those indices with low len bits equal to huff */
    incr = 1 << (len - drop);
    fill = 1 << curr;
    min = fill;                 /* save offset to next table */
    do {
      fill -= incr;
      table[next + (huff >> drop) + fill] = (here_bits << 24) | (here_op << 16) | here_val |0;
    } while (fill !== 0);

    /* backwards increment the len-bit code huff */
    incr = 1 << (len - 1);
    while (huff & incr) {
      incr >>= 1;
    }
    if (incr !== 0) {
      huff &= incr - 1;
      huff += incr;
    } else {
      huff = 0;
    }

    /* go to next symbol, update count, len */
    sym++;
    if (--count[len] === 0) {
      if (len === max) { break; }
      len = lens[lens_index + work[sym]];
    }

    /* create new sub-table if needed */
    if (len > root && (huff & mask) !== low) {
      /* if first time, transition to sub-tables */
      if (drop === 0) {
        drop = root;
      }

      /* increment past last table */
      next += min;            /* here min is 1 << curr */

      /* determine length of next table */
      curr = len - drop;
      left = 1 << curr;
      while (curr + drop < max) {
        left -= count[curr + drop];
        if (left <= 0) { break; }
        curr++;
        left <<= 1;
      }

      /* check for enough space */
      used += 1 << curr;
      if ((type === LENS && used > ENOUGH_LENS) ||
        (type === DISTS && used > ENOUGH_DISTS)) {
        return 1;
      }

      /* point entry in root table to sub-table */
      low = huff & mask;
      /*table.op[low] = curr;
      table.bits[low] = root;
      table.val[low] = next - opts.table_index;*/
      table[low] = (root << 24) | (curr << 16) | (next - table_index) |0;
    }
  }

  /* fill in remaining table entry if code is incomplete (guaranteed to have
   at most one remaining entry, since if the code is incomplete, the
   maximum code length that was allowed to get this far is one bit) */
  if (huff !== 0) {
    //table.op[next + huff] = 64;            /* invalid code marker */
    //table.bits[next + huff] = len - drop;
    //table.val[next + huff] = 0;
    table[next + huff] = ((len - drop) << 24) | (64 << 16) |0;
  }

  /* set return parameters */
  //opts.table_index += used;
  opts.bits = root;
  return 0;
};


/***/ }),

/***/ "../node_modules/pako/lib/zlib/messages.js":
/*!*************************************************!*\
  !*** ../node_modules/pako/lib/zlib/messages.js ***!
  \*************************************************/
/***/ ((module) => {



module.exports = {
  2:      'need dictionary',     /* Z_NEED_DICT       2  */
  1:      'stream end',          /* Z_STREAM_END      1  */
  0:      '',                    /* Z_OK              0  */
  '-1':   'file error',          /* Z_ERRNO         (-1) */
  '-2':   'stream error',        /* Z_STREAM_ERROR  (-2) */
  '-3':   'data error',          /* Z_DATA_ERROR    (-3) */
  '-4':   'insufficient memory', /* Z_MEM_ERROR     (-4) */
  '-5':   'buffer error',        /* Z_BUF_ERROR     (-5) */
  '-6':   'incompatible version' /* Z_VERSION_ERROR (-6) */
};


/***/ }),

/***/ "../node_modules/pako/lib/zlib/trees.js":
/*!**********************************************!*\
  !*** ../node_modules/pako/lib/zlib/trees.js ***!
  \**********************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {




var utils = __webpack_require__(/*! ../utils/common */ "../node_modules/pako/lib/utils/common.js");

/* Public constants ==========================================================*/
/* ===========================================================================*/


//var Z_FILTERED          = 1;
//var Z_HUFFMAN_ONLY      = 2;
//var Z_RLE               = 3;
var Z_FIXED               = 4;
//var Z_DEFAULT_STRATEGY  = 0;

/* Possible values of the data_type field (though see inflate()) */
var Z_BINARY              = 0;
var Z_TEXT                = 1;
//var Z_ASCII             = 1; // = Z_TEXT
var Z_UNKNOWN             = 2;

/*============================================================================*/


function zero(buf) { var len = buf.length; while (--len >= 0) { buf[len] = 0; } }

// From zutil.h

var STORED_BLOCK = 0;
var STATIC_TREES = 1;
var DYN_TREES    = 2;
/* The three kinds of block type */

var MIN_MATCH    = 3;
var MAX_MATCH    = 258;
/* The minimum and maximum match lengths */

// From deflate.h
/* ===========================================================================
 * Internal compression state.
 */

var LENGTH_CODES  = 29;
/* number of length codes, not counting the special END_BLOCK code */

var LITERALS      = 256;
/* number of literal bytes 0..255 */

var L_CODES       = LITERALS + 1 + LENGTH_CODES;
/* number of Literal or Length codes, including the END_BLOCK code */

var D_CODES       = 30;
/* number of distance codes */

var BL_CODES      = 19;
/* number of codes used to transfer the bit lengths */

var HEAP_SIZE     = 2 * L_CODES + 1;
/* maximum heap size */

var MAX_BITS      = 15;
/* All codes must not exceed MAX_BITS bits */

var Buf_size      = 16;
/* size of bit buffer in bi_buf */


/* ===========================================================================
 * Constants
 */

var MAX_BL_BITS = 7;
/* Bit length codes must not exceed MAX_BL_BITS bits */

var END_BLOCK   = 256;
/* end of block literal code */

var REP_3_6     = 16;
/* repeat previous bit length 3-6 times (2 bits of repeat count) */

var REPZ_3_10   = 17;
/* repeat a zero length 3-10 times  (3 bits of repeat count) */

var REPZ_11_138 = 18;
/* repeat a zero length 11-138 times  (7 bits of repeat count) */

/* eslint-disable comma-spacing,array-bracket-spacing */
var extra_lbits =   /* extra bits for each length code */
  [0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0];

var extra_dbits =   /* extra bits for each distance code */
  [0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13];

var extra_blbits =  /* extra bits for each bit length code */
  [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,7];

var bl_order =
  [16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15];
/* eslint-enable comma-spacing,array-bracket-spacing */

/* The lengths of the bit length codes are sent in order of decreasing
 * probability, to avoid transmitting the lengths for unused bit length codes.
 */

/* ===========================================================================
 * Local data. These are initialized only once.
 */

// We pre-fill arrays with 0 to avoid uninitialized gaps

var DIST_CODE_LEN = 512; /* see definition of array dist_code below */

// !!!! Use flat array insdead of structure, Freq = i*2, Len = i*2+1
var static_ltree  = new Array((L_CODES + 2) * 2);
zero(static_ltree);
/* The static literal tree. Since the bit lengths are imposed, there is no
 * need for the L_CODES extra codes used during heap construction. However
 * The codes 286 and 287 are needed to build a canonical tree (see _tr_init
 * below).
 */

var static_dtree  = new Array(D_CODES * 2);
zero(static_dtree);
/* The static distance tree. (Actually a trivial tree since all codes use
 * 5 bits.)
 */

var _dist_code    = new Array(DIST_CODE_LEN);
zero(_dist_code);
/* Distance codes. The first 256 values correspond to the distances
 * 3 .. 258, the last 256 values correspond to the top 8 bits of
 * the 15 bit distances.
 */

var _length_code  = new Array(MAX_MATCH - MIN_MATCH + 1);
zero(_length_code);
/* length code for each normalized match length (0 == MIN_MATCH) */

var base_length   = new Array(LENGTH_CODES);
zero(base_length);
/* First normalized length for each code (0 = MIN_MATCH) */

var base_dist     = new Array(D_CODES);
zero(base_dist);
/* First normalized distance for each code (0 = distance of 1) */


function StaticTreeDesc(static_tree, extra_bits, extra_base, elems, max_length) {

  this.static_tree  = static_tree;  /* static tree or NULL */
  this.extra_bits   = extra_bits;   /* extra bits for each code or NULL */
  this.extra_base   = extra_base;   /* base index for extra_bits */
  this.elems        = elems;        /* max number of elements in the tree */
  this.max_length   = max_length;   /* max bit length for the codes */

  // show if `static_tree` has data or dummy - needed for monomorphic objects
  this.has_stree    = static_tree && static_tree.length;
}


var static_l_desc;
var static_d_desc;
var static_bl_desc;


function TreeDesc(dyn_tree, stat_desc) {
  this.dyn_tree = dyn_tree;     /* the dynamic tree */
  this.max_code = 0;            /* largest code with non zero frequency */
  this.stat_desc = stat_desc;   /* the corresponding static tree */
}



function d_code(dist) {
  return dist < 256 ? _dist_code[dist] : _dist_code[256 + (dist >>> 7)];
}


/* ===========================================================================
 * Output a short LSB first on the stream.
 * IN assertion: there is enough room in pendingBuf.
 */
function put_short(s, w) {
//    put_byte(s, (uch)((w) & 0xff));
//    put_byte(s, (uch)((ush)(w) >> 8));
  s.pending_buf[s.pending++] = (w) & 0xff;
  s.pending_buf[s.pending++] = (w >>> 8) & 0xff;
}


/* ===========================================================================
 * Send a value on a given number of bits.
 * IN assertion: length <= 16 and value fits in length bits.
 */
function send_bits(s, value, length) {
  if (s.bi_valid > (Buf_size - length)) {
    s.bi_buf |= (value << s.bi_valid) & 0xffff;
    put_short(s, s.bi_buf);
    s.bi_buf = value >> (Buf_size - s.bi_valid);
    s.bi_valid += length - Buf_size;
  } else {
    s.bi_buf |= (value << s.bi_valid) & 0xffff;
    s.bi_valid += length;
  }
}


function send_code(s, c, tree) {
  send_bits(s, tree[c * 2]/*.Code*/, tree[c * 2 + 1]/*.Len*/);
}


/* ===========================================================================
 * Reverse the first len bits of a code, using straightforward code (a faster
 * method would use a table)
 * IN assertion: 1 <= len <= 15
 */
function bi_reverse(code, len) {
  var res = 0;
  do {
    res |= code & 1;
    code >>>= 1;
    res <<= 1;
  } while (--len > 0);
  return res >>> 1;
}


/* ===========================================================================
 * Flush the bit buffer, keeping at most 7 bits in it.
 */
function bi_flush(s) {
  if (s.bi_valid === 16) {
    put_short(s, s.bi_buf);
    s.bi_buf = 0;
    s.bi_valid = 0;

  } else if (s.bi_valid >= 8) {
    s.pending_buf[s.pending++] = s.bi_buf & 0xff;
    s.bi_buf >>= 8;
    s.bi_valid -= 8;
  }
}


/* ===========================================================================
 * Compute the optimal bit lengths for a tree and update the total bit length
 * for the current block.
 * IN assertion: the fields freq and dad are set, heap[heap_max] and
 *    above are the tree nodes sorted by increasing frequency.
 * OUT assertions: the field len is set to the optimal bit length, the
 *     array bl_count contains the frequencies for each bit length.
 *     The length opt_len is updated; static_len is also updated if stree is
 *     not null.
 */
function gen_bitlen(s, desc)
//    deflate_state *s;
//    tree_desc *desc;    /* the tree descriptor */
{
  var tree            = desc.dyn_tree;
  var max_code        = desc.max_code;
  var stree           = desc.stat_desc.static_tree;
  var has_stree       = desc.stat_desc.has_stree;
  var extra           = desc.stat_desc.extra_bits;
  var base            = desc.stat_desc.extra_base;
  var max_length      = desc.stat_desc.max_length;
  var h;              /* heap index */
  var n, m;           /* iterate over the tree elements */
  var bits;           /* bit length */
  var xbits;          /* extra bits */
  var f;              /* frequency */
  var overflow = 0;   /* number of elements with bit length too large */

  for (bits = 0; bits <= MAX_BITS; bits++) {
    s.bl_count[bits] = 0;
  }

  /* In a first pass, compute the optimal bit lengths (which may
   * overflow in the case of the bit length tree).
   */
  tree[s.heap[s.heap_max] * 2 + 1]/*.Len*/ = 0; /* root of the heap */

  for (h = s.heap_max + 1; h < HEAP_SIZE; h++) {
    n = s.heap[h];
    bits = tree[tree[n * 2 + 1]/*.Dad*/ * 2 + 1]/*.Len*/ + 1;
    if (bits > max_length) {
      bits = max_length;
      overflow++;
    }
    tree[n * 2 + 1]/*.Len*/ = bits;
    /* We overwrite tree[n].Dad which is no longer needed */

    if (n > max_code) { continue; } /* not a leaf node */

    s.bl_count[bits]++;
    xbits = 0;
    if (n >= base) {
      xbits = extra[n - base];
    }
    f = tree[n * 2]/*.Freq*/;
    s.opt_len += f * (bits + xbits);
    if (has_stree) {
      s.static_len += f * (stree[n * 2 + 1]/*.Len*/ + xbits);
    }
  }
  if (overflow === 0) { return; }

  // Trace((stderr,"\nbit length overflow\n"));
  /* This happens for example on obj2 and pic of the Calgary corpus */

  /* Find the first bit length which could increase: */
  do {
    bits = max_length - 1;
    while (s.bl_count[bits] === 0) { bits--; }
    s.bl_count[bits]--;      /* move one leaf down the tree */
    s.bl_count[bits + 1] += 2; /* move one overflow item as its brother */
    s.bl_count[max_length]--;
    /* The brother of the overflow item also moves one step up,
     * but this does not affect bl_count[max_length]
     */
    overflow -= 2;
  } while (overflow > 0);

  /* Now recompute all bit lengths, scanning in increasing frequency.
   * h is still equal to HEAP_SIZE. (It is simpler to reconstruct all
   * lengths instead of fixing only the wrong ones. This idea is taken
   * from 'ar' written by Haruhiko Okumura.)
   */
  for (bits = max_length; bits !== 0; bits--) {
    n = s.bl_count[bits];
    while (n !== 0) {
      m = s.heap[--h];
      if (m > max_code) { continue; }
      if (tree[m * 2 + 1]/*.Len*/ !== bits) {
        // Trace((stderr,"code %d bits %d->%d\n", m, tree[m].Len, bits));
        s.opt_len += (bits - tree[m * 2 + 1]/*.Len*/) * tree[m * 2]/*.Freq*/;
        tree[m * 2 + 1]/*.Len*/ = bits;
      }
      n--;
    }
  }
}


/* ===========================================================================
 * Generate the codes for a given tree and bit counts (which need not be
 * optimal).
 * IN assertion: the array bl_count contains the bit length statistics for
 * the given tree and the field len is set for all tree elements.
 * OUT assertion: the field code is set for all tree elements of non
 *     zero code length.
 */
function gen_codes(tree, max_code, bl_count)
//    ct_data *tree;             /* the tree to decorate */
//    int max_code;              /* largest code with non zero frequency */
//    ushf *bl_count;            /* number of codes at each bit length */
{
  var next_code = new Array(MAX_BITS + 1); /* next code value for each bit length */
  var code = 0;              /* running code value */
  var bits;                  /* bit index */
  var n;                     /* code index */

  /* The distribution counts are first used to generate the code values
   * without bit reversal.
   */
  for (bits = 1; bits <= MAX_BITS; bits++) {
    next_code[bits] = code = (code + bl_count[bits - 1]) << 1;
  }
  /* Check that the bit counts in bl_count are consistent. The last code
   * must be all ones.
   */
  //Assert (code + bl_count[MAX_BITS]-1 == (1<<MAX_BITS)-1,
  //        "inconsistent bit counts");
  //Tracev((stderr,"\ngen_codes: max_code %d ", max_code));

  for (n = 0;  n <= max_code; n++) {
    var len = tree[n * 2 + 1]/*.Len*/;
    if (len === 0) { continue; }
    /* Now reverse the bits */
    tree[n * 2]/*.Code*/ = bi_reverse(next_code[len]++, len);

    //Tracecv(tree != static_ltree, (stderr,"\nn %3d %c l %2d c %4x (%x) ",
    //     n, (isgraph(n) ? n : ' '), len, tree[n].Code, next_code[len]-1));
  }
}


/* ===========================================================================
 * Initialize the various 'constant' tables.
 */
function tr_static_init() {
  var n;        /* iterates over tree elements */
  var bits;     /* bit counter */
  var length;   /* length value */
  var code;     /* code value */
  var dist;     /* distance index */
  var bl_count = new Array(MAX_BITS + 1);
  /* number of codes at each bit length for an optimal tree */

  // do check in _tr_init()
  //if (static_init_done) return;

  /* For some embedded targets, global variables are not initialized: */
/*#ifdef NO_INIT_GLOBAL_POINTERS
  static_l_desc.static_tree = static_ltree;
  static_l_desc.extra_bits = extra_lbits;
  static_d_desc.static_tree = static_dtree;
  static_d_desc.extra_bits = extra_dbits;
  static_bl_desc.extra_bits = extra_blbits;
#endif*/

  /* Initialize the mapping length (0..255) -> length code (0..28) */
  length = 0;
  for (code = 0; code < LENGTH_CODES - 1; code++) {
    base_length[code] = length;
    for (n = 0; n < (1 << extra_lbits[code]); n++) {
      _length_code[length++] = code;
    }
  }
  //Assert (length == 256, "tr_static_init: length != 256");
  /* Note that the length 255 (match length 258) can be represented
   * in two different ways: code 284 + 5 bits or code 285, so we
   * overwrite length_code[255] to use the best encoding:
   */
  _length_code[length - 1] = code;

  /* Initialize the mapping dist (0..32K) -> dist code (0..29) */
  dist = 0;
  for (code = 0; code < 16; code++) {
    base_dist[code] = dist;
    for (n = 0; n < (1 << extra_dbits[code]); n++) {
      _dist_code[dist++] = code;
    }
  }
  //Assert (dist == 256, "tr_static_init: dist != 256");
  dist >>= 7; /* from now on, all distances are divided by 128 */
  for (; code < D_CODES; code++) {
    base_dist[code] = dist << 7;
    for (n = 0; n < (1 << (extra_dbits[code] - 7)); n++) {
      _dist_code[256 + dist++] = code;
    }
  }
  //Assert (dist == 256, "tr_static_init: 256+dist != 512");

  /* Construct the codes of the static literal tree */
  for (bits = 0; bits <= MAX_BITS; bits++) {
    bl_count[bits] = 0;
  }

  n = 0;
  while (n <= 143) {
    static_ltree[n * 2 + 1]/*.Len*/ = 8;
    n++;
    bl_count[8]++;
  }
  while (n <= 255) {
    static_ltree[n * 2 + 1]/*.Len*/ = 9;
    n++;
    bl_count[9]++;
  }
  while (n <= 279) {
    static_ltree[n * 2 + 1]/*.Len*/ = 7;
    n++;
    bl_count[7]++;
  }
  while (n <= 287) {
    static_ltree[n * 2 + 1]/*.Len*/ = 8;
    n++;
    bl_count[8]++;
  }
  /* Codes 286 and 287 do not exist, but we must include them in the
   * tree construction to get a canonical Huffman tree (longest code
   * all ones)
   */
  gen_codes(static_ltree, L_CODES + 1, bl_count);

  /* The static distance tree is trivial: */
  for (n = 0; n < D_CODES; n++) {
    static_dtree[n * 2 + 1]/*.Len*/ = 5;
    static_dtree[n * 2]/*.Code*/ = bi_reverse(n, 5);
  }

  // Now data ready and we can init static trees
  static_l_desc = new StaticTreeDesc(static_ltree, extra_lbits, LITERALS + 1, L_CODES, MAX_BITS);
  static_d_desc = new StaticTreeDesc(static_dtree, extra_dbits, 0,          D_CODES, MAX_BITS);
  static_bl_desc = new StaticTreeDesc(new Array(0), extra_blbits, 0,         BL_CODES, MAX_BL_BITS);

  //static_init_done = true;
}


/* ===========================================================================
 * Initialize a new block.
 */
function init_block(s) {
  var n; /* iterates over tree elements */

  /* Initialize the trees. */
  for (n = 0; n < L_CODES;  n++) { s.dyn_ltree[n * 2]/*.Freq*/ = 0; }
  for (n = 0; n < D_CODES;  n++) { s.dyn_dtree[n * 2]/*.Freq*/ = 0; }
  for (n = 0; n < BL_CODES; n++) { s.bl_tree[n * 2]/*.Freq*/ = 0; }

  s.dyn_ltree[END_BLOCK * 2]/*.Freq*/ = 1;
  s.opt_len = s.static_len = 0;
  s.last_lit = s.matches = 0;
}


/* ===========================================================================
 * Flush the bit buffer and align the output on a byte boundary
 */
function bi_windup(s)
{
  if (s.bi_valid > 8) {
    put_short(s, s.bi_buf);
  } else if (s.bi_valid > 0) {
    //put_byte(s, (Byte)s->bi_buf);
    s.pending_buf[s.pending++] = s.bi_buf;
  }
  s.bi_buf = 0;
  s.bi_valid = 0;
}

/* ===========================================================================
 * Copy a stored block, storing first the length and its
 * one's complement if requested.
 */
function copy_block(s, buf, len, header)
//DeflateState *s;
//charf    *buf;    /* the input data */
//unsigned len;     /* its length */
//int      header;  /* true if block header must be written */
{
  bi_windup(s);        /* align on byte boundary */

  if (header) {
    put_short(s, len);
    put_short(s, ~len);
  }
//  while (len--) {
//    put_byte(s, *buf++);
//  }
  utils.arraySet(s.pending_buf, s.window, buf, len, s.pending);
  s.pending += len;
}

/* ===========================================================================
 * Compares to subtrees, using the tree depth as tie breaker when
 * the subtrees have equal frequency. This minimizes the worst case length.
 */
function smaller(tree, n, m, depth) {
  var _n2 = n * 2;
  var _m2 = m * 2;
  return (tree[_n2]/*.Freq*/ < tree[_m2]/*.Freq*/ ||
         (tree[_n2]/*.Freq*/ === tree[_m2]/*.Freq*/ && depth[n] <= depth[m]));
}

/* ===========================================================================
 * Restore the heap property by moving down the tree starting at node k,
 * exchanging a node with the smallest of its two sons if necessary, stopping
 * when the heap property is re-established (each father smaller than its
 * two sons).
 */
function pqdownheap(s, tree, k)
//    deflate_state *s;
//    ct_data *tree;  /* the tree to restore */
//    int k;               /* node to move down */
{
  var v = s.heap[k];
  var j = k << 1;  /* left son of k */
  while (j <= s.heap_len) {
    /* Set j to the smallest of the two sons: */
    if (j < s.heap_len &&
      smaller(tree, s.heap[j + 1], s.heap[j], s.depth)) {
      j++;
    }
    /* Exit if v is smaller than both sons */
    if (smaller(tree, v, s.heap[j], s.depth)) { break; }

    /* Exchange v with the smallest son */
    s.heap[k] = s.heap[j];
    k = j;

    /* And continue down the tree, setting j to the left son of k */
    j <<= 1;
  }
  s.heap[k] = v;
}


// inlined manually
// var SMALLEST = 1;

/* ===========================================================================
 * Send the block data compressed using the given Huffman trees
 */
function compress_block(s, ltree, dtree)
//    deflate_state *s;
//    const ct_data *ltree; /* literal tree */
//    const ct_data *dtree; /* distance tree */
{
  var dist;           /* distance of matched string */
  var lc;             /* match length or unmatched char (if dist == 0) */
  var lx = 0;         /* running index in l_buf */
  var code;           /* the code to send */
  var extra;          /* number of extra bits to send */

  if (s.last_lit !== 0) {
    do {
      dist = (s.pending_buf[s.d_buf + lx * 2] << 8) | (s.pending_buf[s.d_buf + lx * 2 + 1]);
      lc = s.pending_buf[s.l_buf + lx];
      lx++;

      if (dist === 0) {
        send_code(s, lc, ltree); /* send a literal byte */
        //Tracecv(isgraph(lc), (stderr," '%c' ", lc));
      } else {
        /* Here, lc is the match length - MIN_MATCH */
        code = _length_code[lc];
        send_code(s, code + LITERALS + 1, ltree); /* send the length code */
        extra = extra_lbits[code];
        if (extra !== 0) {
          lc -= base_length[code];
          send_bits(s, lc, extra);       /* send the extra length bits */
        }
        dist--; /* dist is now the match distance - 1 */
        code = d_code(dist);
        //Assert (code < D_CODES, "bad d_code");

        send_code(s, code, dtree);       /* send the distance code */
        extra = extra_dbits[code];
        if (extra !== 0) {
          dist -= base_dist[code];
          send_bits(s, dist, extra);   /* send the extra distance bits */
        }
      } /* literal or match pair ? */

      /* Check that the overlay between pending_buf and d_buf+l_buf is ok: */
      //Assert((uInt)(s->pending) < s->lit_bufsize + 2*lx,
      //       "pendingBuf overflow");

    } while (lx < s.last_lit);
  }

  send_code(s, END_BLOCK, ltree);
}


/* ===========================================================================
 * Construct one Huffman tree and assigns the code bit strings and lengths.
 * Update the total bit length for the current block.
 * IN assertion: the field freq is set for all tree elements.
 * OUT assertions: the fields len and code are set to the optimal bit length
 *     and corresponding code. The length opt_len is updated; static_len is
 *     also updated if stree is not null. The field max_code is set.
 */
function build_tree(s, desc)
//    deflate_state *s;
//    tree_desc *desc; /* the tree descriptor */
{
  var tree     = desc.dyn_tree;
  var stree    = desc.stat_desc.static_tree;
  var has_stree = desc.stat_desc.has_stree;
  var elems    = desc.stat_desc.elems;
  var n, m;          /* iterate over heap elements */
  var max_code = -1; /* largest code with non zero frequency */
  var node;          /* new node being created */

  /* Construct the initial heap, with least frequent element in
   * heap[SMALLEST]. The sons of heap[n] are heap[2*n] and heap[2*n+1].
   * heap[0] is not used.
   */
  s.heap_len = 0;
  s.heap_max = HEAP_SIZE;

  for (n = 0; n < elems; n++) {
    if (tree[n * 2]/*.Freq*/ !== 0) {
      s.heap[++s.heap_len] = max_code = n;
      s.depth[n] = 0;

    } else {
      tree[n * 2 + 1]/*.Len*/ = 0;
    }
  }

  /* The pkzip format requires that at least one distance code exists,
   * and that at least one bit should be sent even if there is only one
   * possible code. So to avoid special checks later on we force at least
   * two codes of non zero frequency.
   */
  while (s.heap_len < 2) {
    node = s.heap[++s.heap_len] = (max_code < 2 ? ++max_code : 0);
    tree[node * 2]/*.Freq*/ = 1;
    s.depth[node] = 0;
    s.opt_len--;

    if (has_stree) {
      s.static_len -= stree[node * 2 + 1]/*.Len*/;
    }
    /* node is 0 or 1 so it does not have extra bits */
  }
  desc.max_code = max_code;

  /* The elements heap[heap_len/2+1 .. heap_len] are leaves of the tree,
   * establish sub-heaps of increasing lengths:
   */
  for (n = (s.heap_len >> 1/*int /2*/); n >= 1; n--) { pqdownheap(s, tree, n); }

  /* Construct the Huffman tree by repeatedly combining the least two
   * frequent nodes.
   */
  node = elems;              /* next internal node of the tree */
  do {
    //pqremove(s, tree, n);  /* n = node of least frequency */
    /*** pqremove ***/
    n = s.heap[1/*SMALLEST*/];
    s.heap[1/*SMALLEST*/] = s.heap[s.heap_len--];
    pqdownheap(s, tree, 1/*SMALLEST*/);
    /***/

    m = s.heap[1/*SMALLEST*/]; /* m = node of next least frequency */

    s.heap[--s.heap_max] = n; /* keep the nodes sorted by frequency */
    s.heap[--s.heap_max] = m;

    /* Create a new node father of n and m */
    tree[node * 2]/*.Freq*/ = tree[n * 2]/*.Freq*/ + tree[m * 2]/*.Freq*/;
    s.depth[node] = (s.depth[n] >= s.depth[m] ? s.depth[n] : s.depth[m]) + 1;
    tree[n * 2 + 1]/*.Dad*/ = tree[m * 2 + 1]/*.Dad*/ = node;

    /* and insert the new node in the heap */
    s.heap[1/*SMALLEST*/] = node++;
    pqdownheap(s, tree, 1/*SMALLEST*/);

  } while (s.heap_len >= 2);

  s.heap[--s.heap_max] = s.heap[1/*SMALLEST*/];

  /* At this point, the fields freq and dad are set. We can now
   * generate the bit lengths.
   */
  gen_bitlen(s, desc);

  /* The field len is now set, we can generate the bit codes */
  gen_codes(tree, max_code, s.bl_count);
}


/* ===========================================================================
 * Scan a literal or distance tree to determine the frequencies of the codes
 * in the bit length tree.
 */
function scan_tree(s, tree, max_code)
//    deflate_state *s;
//    ct_data *tree;   /* the tree to be scanned */
//    int max_code;    /* and its largest code of non zero frequency */
{
  var n;                     /* iterates over all tree elements */
  var prevlen = -1;          /* last emitted length */
  var curlen;                /* length of current code */

  var nextlen = tree[0 * 2 + 1]/*.Len*/; /* length of next code */

  var count = 0;             /* repeat count of the current code */
  var max_count = 7;         /* max repeat count */
  var min_count = 4;         /* min repeat count */

  if (nextlen === 0) {
    max_count = 138;
    min_count = 3;
  }
  tree[(max_code + 1) * 2 + 1]/*.Len*/ = 0xffff; /* guard */

  for (n = 0; n <= max_code; n++) {
    curlen = nextlen;
    nextlen = tree[(n + 1) * 2 + 1]/*.Len*/;

    if (++count < max_count && curlen === nextlen) {
      continue;

    } else if (count < min_count) {
      s.bl_tree[curlen * 2]/*.Freq*/ += count;

    } else if (curlen !== 0) {

      if (curlen !== prevlen) { s.bl_tree[curlen * 2]/*.Freq*/++; }
      s.bl_tree[REP_3_6 * 2]/*.Freq*/++;

    } else if (count <= 10) {
      s.bl_tree[REPZ_3_10 * 2]/*.Freq*/++;

    } else {
      s.bl_tree[REPZ_11_138 * 2]/*.Freq*/++;
    }

    count = 0;
    prevlen = curlen;

    if (nextlen === 0) {
      max_count = 138;
      min_count = 3;

    } else if (curlen === nextlen) {
      max_count = 6;
      min_count = 3;

    } else {
      max_count = 7;
      min_count = 4;
    }
  }
}


/* ===========================================================================
 * Send a literal or distance tree in compressed form, using the codes in
 * bl_tree.
 */
function send_tree(s, tree, max_code)
//    deflate_state *s;
//    ct_data *tree; /* the tree to be scanned */
//    int max_code;       /* and its largest code of non zero frequency */
{
  var n;                     /* iterates over all tree elements */
  var prevlen = -1;          /* last emitted length */
  var curlen;                /* length of current code */

  var nextlen = tree[0 * 2 + 1]/*.Len*/; /* length of next code */

  var count = 0;             /* repeat count of the current code */
  var max_count = 7;         /* max repeat count */
  var min_count = 4;         /* min repeat count */

  /* tree[max_code+1].Len = -1; */  /* guard already set */
  if (nextlen === 0) {
    max_count = 138;
    min_count = 3;
  }

  for (n = 0; n <= max_code; n++) {
    curlen = nextlen;
    nextlen = tree[(n + 1) * 2 + 1]/*.Len*/;

    if (++count < max_count && curlen === nextlen) {
      continue;

    } else if (count < min_count) {
      do { send_code(s, curlen, s.bl_tree); } while (--count !== 0);

    } else if (curlen !== 0) {
      if (curlen !== prevlen) {
        send_code(s, curlen, s.bl_tree);
        count--;
      }
      //Assert(count >= 3 && count <= 6, " 3_6?");
      send_code(s, REP_3_6, s.bl_tree);
      send_bits(s, count - 3, 2);

    } else if (count <= 10) {
      send_code(s, REPZ_3_10, s.bl_tree);
      send_bits(s, count - 3, 3);

    } else {
      send_code(s, REPZ_11_138, s.bl_tree);
      send_bits(s, count - 11, 7);
    }

    count = 0;
    prevlen = curlen;
    if (nextlen === 0) {
      max_count = 138;
      min_count = 3;

    } else if (curlen === nextlen) {
      max_count = 6;
      min_count = 3;

    } else {
      max_count = 7;
      min_count = 4;
    }
  }
}


/* ===========================================================================
 * Construct the Huffman tree for the bit lengths and return the index in
 * bl_order of the last bit length code to send.
 */
function build_bl_tree(s) {
  var max_blindex;  /* index of last bit length code of non zero freq */

  /* Determine the bit length frequencies for literal and distance trees */
  scan_tree(s, s.dyn_ltree, s.l_desc.max_code);
  scan_tree(s, s.dyn_dtree, s.d_desc.max_code);

  /* Build the bit length tree: */
  build_tree(s, s.bl_desc);
  /* opt_len now includes the length of the tree representations, except
   * the lengths of the bit lengths codes and the 5+5+4 bits for the counts.
   */

  /* Determine the number of bit length codes to send. The pkzip format
   * requires that at least 4 bit length codes be sent. (appnote.txt says
   * 3 but the actual value used is 4.)
   */
  for (max_blindex = BL_CODES - 1; max_blindex >= 3; max_blindex--) {
    if (s.bl_tree[bl_order[max_blindex] * 2 + 1]/*.Len*/ !== 0) {
      break;
    }
  }
  /* Update opt_len to include the bit length tree and counts */
  s.opt_len += 3 * (max_blindex + 1) + 5 + 5 + 4;
  //Tracev((stderr, "\ndyn trees: dyn %ld, stat %ld",
  //        s->opt_len, s->static_len));

  return max_blindex;
}


/* ===========================================================================
 * Send the header for a block using dynamic Huffman trees: the counts, the
 * lengths of the bit length codes, the literal tree and the distance tree.
 * IN assertion: lcodes >= 257, dcodes >= 1, blcodes >= 4.
 */
function send_all_trees(s, lcodes, dcodes, blcodes)
//    deflate_state *s;
//    int lcodes, dcodes, blcodes; /* number of codes for each tree */
{
  var rank;                    /* index in bl_order */

  //Assert (lcodes >= 257 && dcodes >= 1 && blcodes >= 4, "not enough codes");
  //Assert (lcodes <= L_CODES && dcodes <= D_CODES && blcodes <= BL_CODES,
  //        "too many codes");
  //Tracev((stderr, "\nbl counts: "));
  send_bits(s, lcodes - 257, 5); /* not +255 as stated in appnote.txt */
  send_bits(s, dcodes - 1,   5);
  send_bits(s, blcodes - 4,  4); /* not -3 as stated in appnote.txt */
  for (rank = 0; rank < blcodes; rank++) {
    //Tracev((stderr, "\nbl code %2d ", bl_order[rank]));
    send_bits(s, s.bl_tree[bl_order[rank] * 2 + 1]/*.Len*/, 3);
  }
  //Tracev((stderr, "\nbl tree: sent %ld", s->bits_sent));

  send_tree(s, s.dyn_ltree, lcodes - 1); /* literal tree */
  //Tracev((stderr, "\nlit tree: sent %ld", s->bits_sent));

  send_tree(s, s.dyn_dtree, dcodes - 1); /* distance tree */
  //Tracev((stderr, "\ndist tree: sent %ld", s->bits_sent));
}


/* ===========================================================================
 * Check if the data type is TEXT or BINARY, using the following algorithm:
 * - TEXT if the two conditions below are satisfied:
 *    a) There are no non-portable control characters belonging to the
 *       "black list" (0..6, 14..25, 28..31).
 *    b) There is at least one printable character belonging to the
 *       "white list" (9 {TAB}, 10 {LF}, 13 {CR}, 32..255).
 * - BINARY otherwise.
 * - The following partially-portable control characters form a
 *   "gray list" that is ignored in this detection algorithm:
 *   (7 {BEL}, 8 {BS}, 11 {VT}, 12 {FF}, 26 {SUB}, 27 {ESC}).
 * IN assertion: the fields Freq of dyn_ltree are set.
 */
function detect_data_type(s) {
  /* black_mask is the bit mask of black-listed bytes
   * set bits 0..6, 14..25, and 28..31
   * 0xf3ffc07f = binary 11110011111111111100000001111111
   */
  var black_mask = 0xf3ffc07f;
  var n;

  /* Check for non-textual ("black-listed") bytes. */
  for (n = 0; n <= 31; n++, black_mask >>>= 1) {
    if ((black_mask & 1) && (s.dyn_ltree[n * 2]/*.Freq*/ !== 0)) {
      return Z_BINARY;
    }
  }

  /* Check for textual ("white-listed") bytes. */
  if (s.dyn_ltree[9 * 2]/*.Freq*/ !== 0 || s.dyn_ltree[10 * 2]/*.Freq*/ !== 0 ||
      s.dyn_ltree[13 * 2]/*.Freq*/ !== 0) {
    return Z_TEXT;
  }
  for (n = 32; n < LITERALS; n++) {
    if (s.dyn_ltree[n * 2]/*.Freq*/ !== 0) {
      return Z_TEXT;
    }
  }

  /* There are no "black-listed" or "white-listed" bytes:
   * this stream either is empty or has tolerated ("gray-listed") bytes only.
   */
  return Z_BINARY;
}


var static_init_done = false;

/* ===========================================================================
 * Initialize the tree data structures for a new zlib stream.
 */
function _tr_init(s)
{

  if (!static_init_done) {
    tr_static_init();
    static_init_done = true;
  }

  s.l_desc  = new TreeDesc(s.dyn_ltree, static_l_desc);
  s.d_desc  = new TreeDesc(s.dyn_dtree, static_d_desc);
  s.bl_desc = new TreeDesc(s.bl_tree, static_bl_desc);

  s.bi_buf = 0;
  s.bi_valid = 0;

  /* Initialize the first block of the first file: */
  init_block(s);
}


/* ===========================================================================
 * Send a stored block
 */
function _tr_stored_block(s, buf, stored_len, last)
//DeflateState *s;
//charf *buf;       /* input block */
//ulg stored_len;   /* length of input block */
//int last;         /* one if this is the last block for a file */
{
  send_bits(s, (STORED_BLOCK << 1) + (last ? 1 : 0), 3);    /* send block type */
  copy_block(s, buf, stored_len, true); /* with header */
}


/* ===========================================================================
 * Send one empty static block to give enough lookahead for inflate.
 * This takes 10 bits, of which 7 may remain in the bit buffer.
 */
function _tr_align(s) {
  send_bits(s, STATIC_TREES << 1, 3);
  send_code(s, END_BLOCK, static_ltree);
  bi_flush(s);
}


/* ===========================================================================
 * Determine the best encoding for the current block: dynamic trees, static
 * trees or store, and output the encoded block to the zip file.
 */
function _tr_flush_block(s, buf, stored_len, last)
//DeflateState *s;
//charf *buf;       /* input block, or NULL if too old */
//ulg stored_len;   /* length of input block */
//int last;         /* one if this is the last block for a file */
{
  var opt_lenb, static_lenb;  /* opt_len and static_len in bytes */
  var max_blindex = 0;        /* index of last bit length code of non zero freq */

  /* Build the Huffman trees unless a stored block is forced */
  if (s.level > 0) {

    /* Check if the file is binary or text */
    if (s.strm.data_type === Z_UNKNOWN) {
      s.strm.data_type = detect_data_type(s);
    }

    /* Construct the literal and distance trees */
    build_tree(s, s.l_desc);
    // Tracev((stderr, "\nlit data: dyn %ld, stat %ld", s->opt_len,
    //        s->static_len));

    build_tree(s, s.d_desc);
    // Tracev((stderr, "\ndist data: dyn %ld, stat %ld", s->opt_len,
    //        s->static_len));
    /* At this point, opt_len and static_len are the total bit lengths of
     * the compressed block data, excluding the tree representations.
     */

    /* Build the bit length tree for the above two trees, and get the index
     * in bl_order of the last bit length code to send.
     */
    max_blindex = build_bl_tree(s);

    /* Determine the best encoding. Compute the block lengths in bytes. */
    opt_lenb = (s.opt_len + 3 + 7) >>> 3;
    static_lenb = (s.static_len + 3 + 7) >>> 3;

    // Tracev((stderr, "\nopt %lu(%lu) stat %lu(%lu) stored %lu lit %u ",
    //        opt_lenb, s->opt_len, static_lenb, s->static_len, stored_len,
    //        s->last_lit));

    if (static_lenb <= opt_lenb) { opt_lenb = static_lenb; }

  } else {
    // Assert(buf != (char*)0, "lost buf");
    opt_lenb = static_lenb = stored_len + 5; /* force a stored block */
  }

  if ((stored_len + 4 <= opt_lenb) && (buf !== -1)) {
    /* 4: two words for the lengths */

    /* The test buf != NULL is only necessary if LIT_BUFSIZE > WSIZE.
     * Otherwise we can't have processed more than WSIZE input bytes since
     * the last block flush, because compression would have been
     * successful. If LIT_BUFSIZE <= WSIZE, it is never too late to
     * transform a block into a stored block.
     */
    _tr_stored_block(s, buf, stored_len, last);

  } else if (s.strategy === Z_FIXED || static_lenb === opt_lenb) {

    send_bits(s, (STATIC_TREES << 1) + (last ? 1 : 0), 3);
    compress_block(s, static_ltree, static_dtree);

  } else {
    send_bits(s, (DYN_TREES << 1) + (last ? 1 : 0), 3);
    send_all_trees(s, s.l_desc.max_code + 1, s.d_desc.max_code + 1, max_blindex + 1);
    compress_block(s, s.dyn_ltree, s.dyn_dtree);
  }
  // Assert (s->compressed_len == s->bits_sent, "bad compressed size");
  /* The above check is made mod 2^32, for files larger than 512 MB
   * and uLong implemented on 32 bits.
   */
  init_block(s);

  if (last) {
    bi_windup(s);
  }
  // Tracev((stderr,"\ncomprlen %lu(%lu) ", s->compressed_len>>3,
  //       s->compressed_len-7*last));
}

/* ===========================================================================
 * Save the match info and tally the frequency counts. Return true if
 * the current block must be flushed.
 */
function _tr_tally(s, dist, lc)
//    deflate_state *s;
//    unsigned dist;  /* distance of matched string */
//    unsigned lc;    /* match length-MIN_MATCH or unmatched char (if dist==0) */
{
  //var out_length, in_length, dcode;

  s.pending_buf[s.d_buf + s.last_lit * 2]     = (dist >>> 8) & 0xff;
  s.pending_buf[s.d_buf + s.last_lit * 2 + 1] = dist & 0xff;

  s.pending_buf[s.l_buf + s.last_lit] = lc & 0xff;
  s.last_lit++;

  if (dist === 0) {
    /* lc is the unmatched char */
    s.dyn_ltree[lc * 2]/*.Freq*/++;
  } else {
    s.matches++;
    /* Here, lc is the match length - MIN_MATCH */
    dist--;             /* dist = match distance - 1 */
    //Assert((ush)dist < (ush)MAX_DIST(s) &&
    //       (ush)lc <= (ush)(MAX_MATCH-MIN_MATCH) &&
    //       (ush)d_code(dist) < (ush)D_CODES,  "_tr_tally: bad match");

    s.dyn_ltree[(_length_code[lc] + LITERALS + 1) * 2]/*.Freq*/++;
    s.dyn_dtree[d_code(dist) * 2]/*.Freq*/++;
  }

// (!) This block is disabled in zlib defailts,
// don't enable it for binary compatibility

//#ifdef TRUNCATE_BLOCK
//  /* Try to guess if it is profitable to stop the current block here */
//  if ((s.last_lit & 0x1fff) === 0 && s.level > 2) {
//    /* Compute an upper bound for the compressed length */
//    out_length = s.last_lit*8;
//    in_length = s.strstart - s.block_start;
//
//    for (dcode = 0; dcode < D_CODES; dcode++) {
//      out_length += s.dyn_dtree[dcode*2]/*.Freq*/ * (5 + extra_dbits[dcode]);
//    }
//    out_length >>>= 3;
//    //Tracev((stderr,"\nlast_lit %u, in %ld, out ~%ld(%ld%%) ",
//    //       s->last_lit, in_length, out_length,
//    //       100L - out_length*100L/in_length));
//    if (s.matches < (s.last_lit>>1)/*int /2*/ && out_length < (in_length>>1)/*int /2*/) {
//      return true;
//    }
//  }
//#endif

  return (s.last_lit === s.lit_bufsize - 1);
  /* We avoid equality with lit_bufsize because of wraparound at 64K
   * on 16 bit machines and because stored blocks are restricted to
   * 64K-1 bytes.
   */
}

exports._tr_init  = _tr_init;
exports._tr_stored_block = _tr_stored_block;
exports._tr_flush_block  = _tr_flush_block;
exports._tr_tally = _tr_tally;
exports._tr_align = _tr_align;


/***/ }),

/***/ "../node_modules/pako/lib/zlib/zstream.js":
/*!************************************************!*\
  !*** ../node_modules/pako/lib/zlib/zstream.js ***!
  \************************************************/
/***/ ((module) => {




function ZStream() {
  /* next input byte */
  this.input = null; // JS specific, because we have no pointers
  this.next_in = 0;
  /* number of bytes available at input */
  this.avail_in = 0;
  /* total number of input bytes read so far */
  this.total_in = 0;
  /* next output byte should be put there */
  this.output = null; // JS specific, because we have no pointers
  this.next_out = 0;
  /* remaining free space at output */
  this.avail_out = 0;
  /* total number of bytes output so far */
  this.total_out = 0;
  /* last error message, NULL if no error */
  this.msg = ''/*Z_NULL*/;
  /* not visible by applications */
  this.state = null;
  /* best guess about the data type: binary or text */
  this.data_type = 2/*Z_UNKNOWN*/;
  /* adler32 value of the uncompressed data */
  this.adler = 0;
}

module.exports = ZStream;


/***/ }),

/***/ "./crypto/chacha20.ts":
/*!****************************!*\
  !*** ./crypto/chacha20.ts ***!
  \****************************/
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ChaCha20 = void 0;
class ChaCha20 {
    constructor(key, nonce) {
        this._sigmaWords = [0x61707865, 0x3320646e, 0x79622d32, 0x6b206574];
        this._block = new Uint8Array(64);
        this._blockUsed = 64;
        this._x = new Uint32Array(16);
        const input = new Uint32Array(16);
        input[0] = this._sigmaWords[0];
        input[1] = this._sigmaWords[1];
        input[2] = this._sigmaWords[2];
        input[3] = this._sigmaWords[3];
        input[4] = u8to32le(key, 0);
        input[5] = u8to32le(key, 4);
        input[6] = u8to32le(key, 8);
        input[7] = u8to32le(key, 12);
        input[8] = u8to32le(key, 16);
        input[9] = u8to32le(key, 20);
        input[10] = u8to32le(key, 24);
        input[11] = u8to32le(key, 28);
        input[12] = 0; // counter
        if (nonce.length === 12) {
            input[13] = u8to32le(nonce, 0);
            input[14] = u8to32le(nonce, 4);
            input[15] = u8to32le(nonce, 8);
        }
        else {
            input[13] = 0;
            input[14] = u8to32le(nonce, 0);
            input[15] = u8to32le(nonce, 4);
        }
        this._input = input;
    }
    getBytes(numberOfBytes) {
        const out = new Uint8Array(numberOfBytes);
        for (let i = 0; i < numberOfBytes; i++) {
            if (this._blockUsed === 64) {
                this.generateBlock();
                this._blockUsed = 0;
            }
            out[i] = this._block[this._blockUsed];
            this._blockUsed++;
        }
        return out;
    }
    generateBlock() {
        const input = this._input;
        const x = this._x;
        const block = this._block;
        x.set(input);
        for (let i = 20; i > 0; i -= 2) {
            quarterRound(x, 0, 4, 8, 12);
            quarterRound(x, 1, 5, 9, 13);
            quarterRound(x, 2, 6, 10, 14);
            quarterRound(x, 3, 7, 11, 15);
            quarterRound(x, 0, 5, 10, 15);
            quarterRound(x, 1, 6, 11, 12);
            quarterRound(x, 2, 7, 8, 13);
            quarterRound(x, 3, 4, 9, 14);
        }
        for (let i = 16; i--;) {
            x[i] += input[i];
        }
        for (let i = 16; i--;) {
            u32to8le(block, 4 * i, x[i]);
        }
        input[12] += 1;
        if (!input[12]) {
            input[13] += 1;
        }
    }
    encrypt(data) {
        const length = data.length;
        const res = new Uint8Array(length);
        let pos = 0;
        const block = this._block;
        while (pos < length) {
            this.generateBlock();
            const blockLength = Math.min(length - pos, 64);
            for (let i = 0; i < blockLength; i++) {
                res[pos] = data[pos] ^ block[i];
                pos++;
            }
        }
        return res;
    }
}
exports.ChaCha20 = ChaCha20;
function quarterRound(x, a, b, c, d) {
    x[a] += x[b];
    x[d] = rotate(x[d] ^ x[a], 16);
    x[c] += x[d];
    x[b] = rotate(x[b] ^ x[c], 12);
    x[a] += x[b];
    x[d] = rotate(x[d] ^ x[a], 8);
    x[c] += x[d];
    x[b] = rotate(x[b] ^ x[c], 7);
}
function u8to32le(x, i) {
    return x[i] | (x[i + 1] << 8) | (x[i + 2] << 16) | (x[i + 3] << 24);
}
function u32to8le(x, i, u) {
    x[i] = u;
    u >>>= 8;
    x[i + 1] = u;
    u >>>= 8;
    x[i + 2] = u;
    u >>>= 8;
    x[i + 3] = u;
}
function rotate(v, c) {
    return (v << c) | (v >>> (32 - c));
}


/***/ }),

/***/ "./crypto/crypto-engine.ts":
/*!*********************************!*\
  !*** ./crypto/crypto-engine.ts ***!
  \*********************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.setArgon2Impl = exports.argon2 = exports.Argon2TypeArgon2id = exports.Argon2TypeArgon2d = exports.chacha20 = exports.random = exports.createAesCbc = exports.AesCbc = exports.hmacSha256 = exports.sha512 = exports.sha256 = void 0;
const kdbx_error_1 = __webpack_require__(/*! ../errors/kdbx-error */ "./errors/kdbx-error.ts");
const consts_1 = __webpack_require__(/*! ../defs/consts */ "./defs/consts.ts");
const byte_utils_1 = __webpack_require__(/*! ../utils/byte-utils */ "./utils/byte-utils.ts");
const chacha20_1 = __webpack_require__(/*! ./chacha20 */ "./crypto/chacha20.ts");
const nodeCrypto = __webpack_require__(/*! crypto */ "crypto");
const EmptySha256 = 'e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855';
const EmptySha512 = 'cf83e1357eefb8bdf1542850d66d8007d620e4050b5715dc83f4a921d36ce9ce' +
    '47d0d13c5d85f2b0ff8318d2877eec2f63b931bd47417a81a538327af927da3e';
// maxRandomQuota is the max number of random bytes you can asks for from the cryptoEngine
// https://developer.mozilla.org/en-US/docs/Web/API/Crypto/getRandomValues
const MaxRandomQuota = 65536;
function sha256(data) {
    var _a;
    if (!data.byteLength) {
        return Promise.resolve(byte_utils_1.arrayToBuffer(byte_utils_1.hexToBytes(EmptySha256)));
    }
    if ((_a = __webpack_require__.g.crypto) === null || _a === void 0 ? void 0 : _a.subtle) {
        return __webpack_require__.g.crypto.subtle.digest({ name: 'SHA-256' }, data);
    }
    else {
        return new Promise((resolve) => {
            const sha = nodeCrypto.createHash('sha256');
            const hash = sha.update(Buffer.from(data)).digest();
            resolve(hash.buffer);
        });
    }
}
exports.sha256 = sha256;
function sha512(data) {
    var _a;
    if (!data.byteLength) {
        return Promise.resolve(byte_utils_1.arrayToBuffer(byte_utils_1.hexToBytes(EmptySha512)));
    }
    if ((_a = __webpack_require__.g.crypto) === null || _a === void 0 ? void 0 : _a.subtle) {
        return __webpack_require__.g.crypto.subtle.digest({ name: 'SHA-512' }, data);
    }
    else {
        return new Promise((resolve) => {
            const sha = nodeCrypto.createHash('sha512');
            const hash = sha.update(Buffer.from(data)).digest();
            resolve(hash.buffer);
        });
    }
}
exports.sha512 = sha512;
function hmacSha256(key, data) {
    var _a;
    if ((_a = __webpack_require__.g.crypto) === null || _a === void 0 ? void 0 : _a.subtle) {
        const algo = { name: 'HMAC', hash: { name: 'SHA-256' } };
        return __webpack_require__.g.crypto.subtle
            .importKey('raw', key, algo, false, ['sign'])
            .then((subtleKey) => {
            return __webpack_require__.g.crypto.subtle.sign(algo, subtleKey, data);
        });
    }
    else {
        return new Promise((resolve) => {
            const hmac = nodeCrypto.createHmac('sha256', Buffer.from(key));
            const hash = hmac.update(Buffer.from(data)).digest();
            resolve(hash.buffer);
        });
    }
}
exports.hmacSha256 = hmacSha256;
class AesCbc {
}
exports.AesCbc = AesCbc;
class AesCbcSubtle extends AesCbc {
    get key() {
        if (!this._key) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'no key');
        }
        return this._key;
    }
    importKey(key) {
        return __webpack_require__.g.crypto.subtle
            .importKey('raw', key, { name: 'AES-CBC' }, false, ['encrypt', 'decrypt'])
            .then((key) => {
            this._key = key;
        });
    }
    encrypt(data, iv) {
        return __webpack_require__.g.crypto.subtle.encrypt({ name: 'AES-CBC', iv }, this.key, data);
    }
    decrypt(data, iv) {
        return __webpack_require__.g.crypto.subtle.decrypt({ name: 'AES-CBC', iv }, this.key, data).catch(() => {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidKey, 'invalid key');
        });
    }
}
class AesCbcNode extends AesCbc {
    get key() {
        if (!this._key) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'no key');
        }
        return this._key;
    }
    importKey(key) {
        this._key = key;
        return Promise.resolve();
    }
    encrypt(data, iv) {
        return Promise.resolve().then(() => {
            const cipher = nodeCrypto.createCipheriv('aes-256-cbc', Buffer.from(this.key), Buffer.from(iv));
            const block = cipher.update(Buffer.from(data));
            return byte_utils_1.arrayToBuffer(Buffer.concat([block, cipher.final()]));
        });
    }
    decrypt(data, iv) {
        return Promise.resolve()
            .then(() => {
            const cipher = nodeCrypto.createDecipheriv('aes-256-cbc', Buffer.from(this.key), Buffer.from(iv));
            const block = cipher.update(Buffer.from(data));
            return byte_utils_1.arrayToBuffer(Buffer.concat([block, cipher.final()]));
        })
            .catch(() => {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidKey, 'invalid key');
        });
    }
}
function createAesCbc() {
    var _a;
    if ((_a = __webpack_require__.g.crypto) === null || _a === void 0 ? void 0 : _a.subtle) {
        return new AesCbcSubtle();
    }
    else {
        return new AesCbcNode();
    }
}
exports.createAesCbc = createAesCbc;
function safeRandomWeb(len) {
    const randomBytes = new Uint8Array(len);
    while (len > 0) {
        let segmentSize = len % MaxRandomQuota;
        segmentSize = segmentSize > 0 ? segmentSize : MaxRandomQuota;
        const randomBytesSegment = new Uint8Array(segmentSize);
        __webpack_require__.g.crypto.getRandomValues(randomBytesSegment);
        len -= segmentSize;
        randomBytes.set(randomBytesSegment, len);
    }
    return randomBytes;
}
function random(len) {
    var _a;
    if ((_a = __webpack_require__.g.crypto) === null || _a === void 0 ? void 0 : _a.subtle) {
        return safeRandomWeb(len);
    }
    else {
        return new Uint8Array(nodeCrypto.randomBytes(len));
    }
}
exports.random = random;
function chacha20(data, key, iv) {
    return Promise.resolve().then(() => {
        const algo = new chacha20_1.ChaCha20(new Uint8Array(key), new Uint8Array(iv));
        return byte_utils_1.arrayToBuffer(algo.encrypt(new Uint8Array(data)));
    });
}
exports.chacha20 = chacha20;
exports.Argon2TypeArgon2d = 0;
exports.Argon2TypeArgon2id = 2;
let argon2impl;
function argon2(password, salt, memory, iterations, length, parallelism, type, version) {
    if (argon2impl) {
        return argon2impl(password, salt, memory, iterations, length, parallelism, type, version).then(byte_utils_1.arrayToBuffer);
    }
    return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.NotImplemented, 'Argon2 not implemented'));
}
exports.argon2 = argon2;
function setArgon2Impl(impl) {
    argon2impl = impl;
}
exports.setArgon2Impl = setArgon2Impl;


/***/ }),

/***/ "./crypto/hashed-block-transform.ts":
/*!******************************************!*\
  !*** ./crypto/hashed-block-transform.ts ***!
  \******************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.encrypt = exports.decrypt = void 0;
const binary_stream_1 = __webpack_require__(/*! ../utils/binary-stream */ "./utils/binary-stream.ts");
const CryptoEngine = __webpack_require__(/*! ../crypto/crypto-engine */ "./crypto/crypto-engine.ts");
const kdbx_error_1 = __webpack_require__(/*! ../errors/kdbx-error */ "./errors/kdbx-error.ts");
const byte_utils_1 = __webpack_require__(/*! ../utils/byte-utils */ "./utils/byte-utils.ts");
const consts_1 = __webpack_require__(/*! ../defs/consts */ "./defs/consts.ts");
const BlockSize = 1024 * 1024;
function decrypt(data) {
    return Promise.resolve().then(() => {
        const stm = new binary_stream_1.BinaryStream(data);
        const buffers = [];
        let // blockIndex = 0,
        blockLength = 0, blockHash, totalLength = 0;
        const next = () => {
            /* blockIndex = */ stm.getUint32(true);
            blockHash = stm.readBytes(32);
            blockLength = stm.getUint32(true);
            if (blockLength > 0) {
                totalLength += blockLength;
                const blockData = stm.readBytes(blockLength);
                return CryptoEngine.sha256(blockData).then((calculatedHash) => {
                    if (!byte_utils_1.arrayBufferEquals(calculatedHash, blockHash)) {
                        throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'invalid hash block');
                    }
                    else {
                        buffers.push(blockData);
                        return next();
                    }
                });
            }
            else {
                const ret = new Uint8Array(totalLength);
                let offset = 0;
                for (let i = 0; i < buffers.length; i++) {
                    ret.set(new Uint8Array(buffers[i]), offset);
                    offset += buffers[i].byteLength;
                }
                return Promise.resolve(ret.buffer);
            }
        };
        return next();
    });
}
exports.decrypt = decrypt;
function encrypt(data) {
    return Promise.resolve().then(() => {
        let bytesLeft = data.byteLength;
        let currentOffset = 0, blockIndex = 0, totalLength = 0;
        const buffers = [];
        const next = () => {
            if (bytesLeft > 0) {
                const blockLength = Math.min(BlockSize, bytesLeft);
                bytesLeft -= blockLength;
                const blockData = data.slice(currentOffset, currentOffset + blockLength);
                return CryptoEngine.sha256(blockData).then((blockHash) => {
                    const blockBuffer = new ArrayBuffer(4 + 32 + 4);
                    const stm = new binary_stream_1.BinaryStream(blockBuffer);
                    stm.setUint32(blockIndex, true);
                    stm.writeBytes(blockHash);
                    stm.setUint32(blockLength, true);
                    buffers.push(blockBuffer);
                    totalLength += blockBuffer.byteLength;
                    buffers.push(blockData);
                    totalLength += blockData.byteLength;
                    blockIndex++;
                    currentOffset += blockLength;
                    return next();
                });
            }
            else {
                const endBlockData = new ArrayBuffer(4 + 32 + 4);
                const view = new DataView(endBlockData);
                view.setUint32(0, blockIndex, true);
                buffers.push(endBlockData);
                totalLength += endBlockData.byteLength;
                const ret = new Uint8Array(totalLength);
                let offset = 0;
                for (let i = 0; i < buffers.length; i++) {
                    ret.set(new Uint8Array(buffers[i]), offset);
                    offset += buffers[i].byteLength;
                }
                return Promise.resolve(ret.buffer);
            }
        };
        return next();
    });
}
exports.encrypt = encrypt;


/***/ }),

/***/ "./crypto/hmac-block-transform.ts":
/*!****************************************!*\
  !*** ./crypto/hmac-block-transform.ts ***!
  \****************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.encrypt = exports.decrypt = exports.getHmacKey = void 0;
const int64_1 = __webpack_require__(/*! ../utils/int64 */ "./utils/int64.ts");
const byte_utils_1 = __webpack_require__(/*! ../utils/byte-utils */ "./utils/byte-utils.ts");
const CryptoEngine = __webpack_require__(/*! ../crypto/crypto-engine */ "./crypto/crypto-engine.ts");
const binary_stream_1 = __webpack_require__(/*! ../utils/binary-stream */ "./utils/binary-stream.ts");
const kdbx_error_1 = __webpack_require__(/*! ../errors/kdbx-error */ "./errors/kdbx-error.ts");
const consts_1 = __webpack_require__(/*! ../defs/consts */ "./defs/consts.ts");
const BlockSize = 1024 * 1024;
function getHmacKey(key, blockIndex) {
    const shaSrc = new Uint8Array(8 + key.byteLength);
    shaSrc.set(new Uint8Array(key), 8);
    const view = new DataView(shaSrc.buffer);
    view.setUint32(0, blockIndex.lo, true);
    view.setUint32(4, blockIndex.hi, true);
    return CryptoEngine.sha512(byte_utils_1.arrayToBuffer(shaSrc)).then((sha) => {
        byte_utils_1.zeroBuffer(shaSrc);
        return sha;
    });
}
exports.getHmacKey = getHmacKey;
function getBlockHmac(key, blockIndex, blockLength, blockData) {
    return getHmacKey(key, new int64_1.Int64(blockIndex)).then((blockKey) => {
        const blockDataForHash = new Uint8Array(blockData.byteLength + 4 + 8);
        const blockDataForHashView = new DataView(blockDataForHash.buffer);
        blockDataForHash.set(new Uint8Array(blockData), 4 + 8);
        blockDataForHashView.setInt32(0, blockIndex, true);
        blockDataForHashView.setInt32(8, blockLength, true);
        return CryptoEngine.hmacSha256(blockKey, blockDataForHash.buffer);
    });
}
function decrypt(data, key) {
    const stm = new binary_stream_1.BinaryStream(data);
    return Promise.resolve().then(() => {
        const buffers = [];
        let blockIndex = 0, blockLength = 0, blockHash, totalLength = 0;
        const next = () => {
            blockHash = stm.readBytes(32);
            blockLength = stm.getUint32(true);
            if (blockLength > 0) {
                totalLength += blockLength;
                const blockData = stm.readBytes(blockLength);
                return getBlockHmac(key, blockIndex, blockLength, blockData).then((calculatedBlockHash) => {
                    if (!byte_utils_1.arrayBufferEquals(calculatedBlockHash, blockHash)) {
                        throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'invalid hash block');
                    }
                    else {
                        buffers.push(blockData);
                        blockIndex++;
                        return next();
                    }
                });
            }
            else {
                const ret = new Uint8Array(totalLength);
                let offset = 0;
                for (let i = 0; i < buffers.length; i++) {
                    ret.set(new Uint8Array(buffers[i]), offset);
                    offset += buffers[i].byteLength;
                }
                return Promise.resolve(ret.buffer);
            }
        };
        return next();
    });
}
exports.decrypt = decrypt;
function encrypt(data, key) {
    return Promise.resolve().then(() => {
        let bytesLeft = data.byteLength;
        let currentOffset = 0, blockIndex = 0, totalLength = 0;
        const buffers = [];
        const next = () => {
            const blockLength = Math.min(BlockSize, bytesLeft);
            bytesLeft -= blockLength;
            const blockData = data.slice(currentOffset, currentOffset + blockLength);
            return getBlockHmac(key, blockIndex, blockLength, blockData).then((blockHash) => {
                const blockBuffer = new ArrayBuffer(32 + 4);
                const stm = new binary_stream_1.BinaryStream(blockBuffer);
                stm.writeBytes(blockHash);
                stm.setUint32(blockLength, true);
                buffers.push(blockBuffer);
                totalLength += blockBuffer.byteLength;
                if (blockData.byteLength > 0) {
                    buffers.push(blockData);
                    totalLength += blockData.byteLength;
                    blockIndex++;
                    currentOffset += blockLength;
                    return next();
                }
                else {
                    const ret = new Uint8Array(totalLength);
                    let offset = 0;
                    for (let i = 0; i < buffers.length; i++) {
                        ret.set(new Uint8Array(buffers[i]), offset);
                        offset += buffers[i].byteLength;
                    }
                    return ret.buffer;
                }
            });
        };
        return next();
    });
}
exports.encrypt = encrypt;


/***/ }),

/***/ "./crypto/key-encryptor-aes.ts":
/*!*************************************!*\
  !*** ./crypto/key-encryptor-aes.ts ***!
  \*************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.encrypt = void 0;
const CryptoEngine = __webpack_require__(/*! ./crypto-engine */ "./crypto/crypto-engine.ts");
const byte_utils_1 = __webpack_require__(/*! ../utils/byte-utils */ "./utils/byte-utils.ts");
const maxRoundsPreIteration = 10000;
const aesBlockSize = 16;
const credentialSize = 32;
/*
In order to simulate multiple rounds of ECB encryption, we do CBC encryption
across a zero buffer of large length with the IV being the desired plaintext.
The zero buffer does not contribute to the xor, so xoring the previous block
with the next one simulates running ECB multiple times. We limit the maximum
size of the zero buffer to prevent enormous memory usage.
*/
function encrypt(credentials, key, rounds) {
    const algo = CryptoEngine.createAesCbc();
    return algo
        .importKey(byte_utils_1.arrayToBuffer(key))
        .then(() => {
        const resolvers = [];
        for (let idx = 0; idx < credentialSize; idx += aesBlockSize) {
            resolvers.push(encryptBlock(algo, credentials.subarray(idx, idx + aesBlockSize), rounds));
        }
        return Promise.all(resolvers);
    })
        .then((results) => {
        const res = new Uint8Array(credentialSize);
        results.forEach((result, idx) => {
            const base = idx * aesBlockSize;
            for (let i = 0; i < aesBlockSize; ++i) {
                res[i + base] = result[i];
            }
            byte_utils_1.zeroBuffer(result);
        });
        return res;
    });
}
exports.encrypt = encrypt;
function encryptBlock(algo, iv, rounds) {
    let result = Promise.resolve(byte_utils_1.arrayToBuffer(iv));
    const buffer = new Uint8Array(aesBlockSize * Math.min(rounds, maxRoundsPreIteration));
    while (rounds > 0) {
        const currentRounds = Math.min(rounds, maxRoundsPreIteration);
        rounds -= currentRounds;
        const dataLen = aesBlockSize * currentRounds;
        const zeroData = buffer.length === dataLen ? buffer.buffer : byte_utils_1.arrayToBuffer(buffer.subarray(0, dataLen));
        result = encryptBlockBuffer(algo, result, zeroData);
    }
    return result.then((res) => {
        return new Uint8Array(res);
    });
}
function encryptBlockBuffer(algo, promisedIv, buffer) {
    return promisedIv
        .then((iv) => {
        return algo.encrypt(buffer, iv);
    })
        .then((buf) => {
        const res = byte_utils_1.arrayToBuffer(new Uint8Array(buf).subarray(-2 * aesBlockSize, -aesBlockSize));
        byte_utils_1.zeroBuffer(buf);
        return res;
    });
}


/***/ }),

/***/ "./crypto/key-encryptor-kdf.ts":
/*!*************************************!*\
  !*** ./crypto/key-encryptor-kdf.ts ***!
  \*************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.encrypt = void 0;
const CryptoEngine = __webpack_require__(/*! ../crypto/crypto-engine */ "./crypto/crypto-engine.ts");
const KeyEncryptorAes = __webpack_require__(/*! ./key-encryptor-aes */ "./crypto/key-encryptor-aes.ts");
const kdbx_error_1 = __webpack_require__(/*! ../errors/kdbx-error */ "./errors/kdbx-error.ts");
const consts_1 = __webpack_require__(/*! ../defs/consts */ "./defs/consts.ts");
const byte_utils_1 = __webpack_require__(/*! ../utils/byte-utils */ "./utils/byte-utils.ts");
const int64_1 = __webpack_require__(/*! ../utils/int64 */ "./utils/int64.ts");
function encrypt(key, kdfParams) {
    const uuid = kdfParams.get('$UUID');
    if (!uuid || !(uuid instanceof ArrayBuffer)) {
        return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'no kdf uuid'));
    }
    const kdfUuid = byte_utils_1.bytesToBase64(uuid);
    switch (kdfUuid) {
        case consts_1.KdfId.Argon2d:
            return encryptArgon2(key, kdfParams, CryptoEngine.Argon2TypeArgon2d);
        case consts_1.KdfId.Argon2id:
            return encryptArgon2(key, kdfParams, CryptoEngine.Argon2TypeArgon2id);
        case consts_1.KdfId.Aes:
            return encryptAes(key, kdfParams);
        default:
            return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.Unsupported, 'bad kdf'));
    }
}
exports.encrypt = encrypt;
function encryptArgon2(key, kdfParams, argon2type) {
    const salt = kdfParams.get('S');
    if (!(salt instanceof ArrayBuffer) || salt.byteLength !== 32) {
        return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'bad argon2 salt'));
    }
    const parallelism = toNumber(kdfParams.get('P'));
    if (typeof parallelism !== 'number' || parallelism < 1) {
        return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'bad argon2 parallelism'));
    }
    const iterations = toNumber(kdfParams.get('I'));
    if (typeof iterations !== 'number' || iterations < 1) {
        return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'bad argon2 iterations'));
    }
    const memory = toNumber(kdfParams.get('M'));
    if (typeof memory !== 'number' || memory < 1 || memory % 1024 !== 0) {
        return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'bad argon2 memory'));
    }
    const version = kdfParams.get('V');
    if (version !== 0x13 && version !== 0x10) {
        return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'bad argon2 version'));
    }
    const secretKey = kdfParams.get('K');
    if (secretKey) {
        return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.Unsupported, 'argon2 secret key'));
    }
    const assocData = kdfParams.get('A');
    if (assocData) {
        return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.Unsupported, 'argon2 assoc data'));
    }
    return CryptoEngine.argon2(key, salt, memory / 1024, iterations, 32, parallelism, argon2type, version);
}
function encryptAes(key, kdfParams) {
    const salt = kdfParams.get('S');
    if (!(salt instanceof ArrayBuffer) || salt.byteLength !== 32) {
        return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'bad aes salt'));
    }
    const rounds = toNumber(kdfParams.get('R'));
    if (typeof rounds !== 'number' || rounds < 1) {
        return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'bad aes rounds'));
    }
    return KeyEncryptorAes.encrypt(new Uint8Array(key), new Uint8Array(salt), rounds).then((key) => {
        return CryptoEngine.sha256(key).then((hash) => {
            byte_utils_1.zeroBuffer(key);
            return hash;
        });
    });
}
function toNumber(number) {
    if (typeof number === 'number') {
        return number;
    }
    else if (number instanceof int64_1.Int64) {
        return number.value;
    }
    return undefined;
}


/***/ }),

/***/ "./crypto/protect-salt-generator.ts":
/*!******************************************!*\
  !*** ./crypto/protect-salt-generator.ts ***!
  \******************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ProtectSaltGenerator = void 0;
const salsa20_1 = __webpack_require__(/*! ./salsa20 */ "./crypto/salsa20.ts");
const chacha20_1 = __webpack_require__(/*! ./chacha20 */ "./crypto/chacha20.ts");
const byte_utils_1 = __webpack_require__(/*! ../utils/byte-utils */ "./utils/byte-utils.ts");
const consts_1 = __webpack_require__(/*! ../defs/consts */ "./defs/consts.ts");
const kdbx_error_1 = __webpack_require__(/*! ../errors/kdbx-error */ "./errors/kdbx-error.ts");
const CryptoEngine = __webpack_require__(/*! ../crypto/crypto-engine */ "./crypto/crypto-engine.ts");
const SalsaNonce = new Uint8Array([0xe8, 0x30, 0x09, 0x4b, 0x97, 0x20, 0x5d, 0x2a]);
/**
 * Protect information used for decrypt and encrypt protected data fields
 * @constructor
 */
class ProtectSaltGenerator {
    constructor(algo) {
        this._algo = algo;
    }
    getSalt(len) {
        return byte_utils_1.arrayToBuffer(this._algo.getBytes(len));
    }
    static create(key, crsAlgorithm) {
        switch (crsAlgorithm) {
            case consts_1.CrsAlgorithm.Salsa20:
                return CryptoEngine.sha256(byte_utils_1.arrayToBuffer(key)).then((hash) => {
                    const key = new Uint8Array(hash);
                    const algo = new salsa20_1.Salsa20(key, SalsaNonce);
                    return new ProtectSaltGenerator(algo);
                });
            case consts_1.CrsAlgorithm.ChaCha20:
                return CryptoEngine.sha512(byte_utils_1.arrayToBuffer(key)).then((hash) => {
                    const key = new Uint8Array(hash, 0, 32);
                    const nonce = new Uint8Array(hash, 32, 12);
                    const algo = new chacha20_1.ChaCha20(key, nonce);
                    return new ProtectSaltGenerator(algo);
                });
            default:
                return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.Unsupported, 'crsAlgorithm'));
        }
    }
}
exports.ProtectSaltGenerator = ProtectSaltGenerator;


/***/ }),

/***/ "./crypto/protected-value.ts":
/*!***********************************!*\
  !*** ./crypto/protected-value.ts ***!
  \***********************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ProtectedValue = void 0;
const CryptoEngine = __webpack_require__(/*! ./crypto-engine */ "./crypto/crypto-engine.ts");
const byte_utils_1 = __webpack_require__(/*! ../utils/byte-utils */ "./utils/byte-utils.ts");
class ProtectedValue {
    constructor(value, salt) {
        this._value = new Uint8Array(value);
        this._salt = new Uint8Array(salt);
    }
    toString() {
        return byte_utils_1.bytesToBase64(this._value);
    }
    static fromString(str) {
        const bytes = byte_utils_1.stringToBytes(str), salt = CryptoEngine.random(bytes.length);
        for (let i = 0, len = bytes.length; i < len; i++) {
            bytes[i] ^= salt[i];
        }
        return new ProtectedValue(byte_utils_1.arrayToBuffer(bytes), byte_utils_1.arrayToBuffer(salt));
    }
    static fromBinary(binary) {
        const bytes = new Uint8Array(binary), salt = CryptoEngine.random(bytes.length);
        for (let i = 0, len = bytes.length; i < len; i++) {
            bytes[i] ^= salt[i];
        }
        return new ProtectedValue(byte_utils_1.arrayToBuffer(bytes), byte_utils_1.arrayToBuffer(salt));
    }
    includes(str) {
        if (str.length === 0) {
            return false;
        }
        const source = this._value, salt = this._salt, search = byte_utils_1.stringToBytes(str), sourceLen = source.length, searchLen = search.length, maxPos = sourceLen - searchLen;
        src: for (let sourceIx = 0; sourceIx <= maxPos; sourceIx++) {
            for (let searchIx = 0; searchIx < searchLen; searchIx++) {
                if ((source[sourceIx + searchIx] ^ salt[sourceIx + searchIx]) !==
                    search[searchIx]) {
                    continue src;
                }
            }
            return true;
        }
        return false;
    }
    getHash() {
        const binary = byte_utils_1.arrayToBuffer(this.getBinary());
        return CryptoEngine.sha256(binary).then((hash) => {
            byte_utils_1.zeroBuffer(binary);
            return hash;
        });
    }
    getText() {
        return byte_utils_1.bytesToString(this.getBinary());
    }
    getBinary() {
        const value = this._value, salt = this._salt;
        const bytes = new Uint8Array(value.byteLength);
        for (let i = bytes.length - 1; i >= 0; i--) {
            bytes[i] = value[i] ^ salt[i];
        }
        return bytes;
    }
    setSalt(newSalt) {
        const newSaltArr = new Uint8Array(newSalt);
        const value = this._value, salt = this._salt;
        for (let i = 0, len = value.length; i < len; i++) {
            value[i] = value[i] ^ salt[i] ^ newSaltArr[i];
            salt[i] = newSaltArr[i];
        }
    }
    clone() {
        return new ProtectedValue(this._value, this._salt);
    }
    get byteLength() {
        return this._value.byteLength;
    }
}
exports.ProtectedValue = ProtectedValue;


/***/ }),

/***/ "./crypto/salsa20.ts":
/*!***************************!*\
  !*** ./crypto/salsa20.ts ***!
  \***************************/
/***/ ((__unused_webpack_module, exports) => {


// code from this gist: https://gist.github.com/dchest/4582374 (no license declared)
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.Salsa20 = void 0;
class Salsa20 {
    constructor(key, nonce) {
        this._rounds = 20;
        this._sigmaWords = [0x61707865, 0x3320646e, 0x79622d32, 0x6b206574];
        // State
        this._keyWords = []; // key words
        this._nonceWords = [0, 0]; // nonce words
        this._counterWords = [0, 0]; // block counter words
        // Output buffer
        this._block = new Uint8Array(64); // output block of 64 bytes
        this._blockUsed = 64; // number of block bytes used
        this.setKey(key);
        this.setNonce(nonce);
    }
    // setKey sets the key to the given 32-byte array.
    setKey(key) {
        for (let i = 0, j = 0; i < 8; i++, j += 4) {
            this._keyWords[i] =
                (key[j] & 0xff) |
                    ((key[j + 1] & 0xff) << 8) |
                    ((key[j + 2] & 0xff) << 16) |
                    ((key[j + 3] & 0xff) << 24);
        }
        this.reset();
    }
    // setNonce sets the nonce to the given 8-byte array.
    setNonce(nonce) {
        this._nonceWords[0] =
            (nonce[0] & 0xff) |
                ((nonce[1] & 0xff) << 8) |
                ((nonce[2] & 0xff) << 16) |
                ((nonce[3] & 0xff) << 24);
        this._nonceWords[1] =
            (nonce[4] & 0xff) |
                ((nonce[5] & 0xff) << 8) |
                ((nonce[6] & 0xff) << 16) |
                ((nonce[7] & 0xff) << 24);
        this.reset();
    }
    // getBytes returns the next numberOfBytes bytes of stream.
    getBytes(numberOfBytes) {
        const out = new Uint8Array(numberOfBytes);
        for (let i = 0; i < numberOfBytes; i++) {
            if (this._blockUsed === 64) {
                this.generateBlock();
                this.incrementCounter();
                this._blockUsed = 0;
            }
            out[i] = this._block[this._blockUsed];
            this._blockUsed++;
        }
        return out;
    }
    getHexString(numberOfBytes) {
        const hex = [
            '0',
            '1',
            '2',
            '3',
            '4',
            '5',
            '6',
            '7',
            '8',
            '9',
            'a',
            'b',
            'c',
            'd',
            'e',
            'f'
        ];
        const out = [];
        const bytes = this.getBytes(numberOfBytes);
        for (let i = 0; i < bytes.length; i++) {
            out.push(hex[(bytes[i] >> 4) & 15]);
            out.push(hex[bytes[i] & 15]);
        }
        return out.join('');
    }
    reset() {
        this._counterWords[0] = 0;
        this._counterWords[1] = 0;
        this._blockUsed = 64;
    }
    incrementCounter() {
        // Note: maximum 2^64 blocks.
        this._counterWords[0] = (this._counterWords[0] + 1) & 0xffffffff;
        if (this._counterWords[0] === 0) {
            this._counterWords[1] = (this._counterWords[1] + 1) & 0xffffffff;
        }
    }
    // _generateBlock generates 64 bytes from key, nonce, and counter,
    // and puts the result into this.block.
    generateBlock() {
        const j0 = this._sigmaWords[0], j1 = this._keyWords[0], j2 = this._keyWords[1], j3 = this._keyWords[2], j4 = this._keyWords[3], j5 = this._sigmaWords[1], j6 = this._nonceWords[0], j7 = this._nonceWords[1], j8 = this._counterWords[0], j9 = this._counterWords[1], j10 = this._sigmaWords[2], j11 = this._keyWords[4], j12 = this._keyWords[5], j13 = this._keyWords[6], j14 = this._keyWords[7], j15 = this._sigmaWords[3];
        let x0 = j0, x1 = j1, x2 = j2, x3 = j3, x4 = j4, x5 = j5, x6 = j6, x7 = j7, x8 = j8, x9 = j9, x10 = j10, x11 = j11, x12 = j12, x13 = j13, x14 = j14, x15 = j15;
        let u;
        for (let i = 0; i < this._rounds; i += 2) {
            u = x0 + x12;
            x4 ^= (u << 7) | (u >>> (32 - 7));
            u = x4 + x0;
            x8 ^= (u << 9) | (u >>> (32 - 9));
            u = x8 + x4;
            x12 ^= (u << 13) | (u >>> (32 - 13));
            u = x12 + x8;
            x0 ^= (u << 18) | (u >>> (32 - 18));
            u = x5 + x1;
            x9 ^= (u << 7) | (u >>> (32 - 7));
            u = x9 + x5;
            x13 ^= (u << 9) | (u >>> (32 - 9));
            u = x13 + x9;
            x1 ^= (u << 13) | (u >>> (32 - 13));
            u = x1 + x13;
            x5 ^= (u << 18) | (u >>> (32 - 18));
            u = x10 + x6;
            x14 ^= (u << 7) | (u >>> (32 - 7));
            u = x14 + x10;
            x2 ^= (u << 9) | (u >>> (32 - 9));
            u = x2 + x14;
            x6 ^= (u << 13) | (u >>> (32 - 13));
            u = x6 + x2;
            x10 ^= (u << 18) | (u >>> (32 - 18));
            u = x15 + x11;
            x3 ^= (u << 7) | (u >>> (32 - 7));
            u = x3 + x15;
            x7 ^= (u << 9) | (u >>> (32 - 9));
            u = x7 + x3;
            x11 ^= (u << 13) | (u >>> (32 - 13));
            u = x11 + x7;
            x15 ^= (u << 18) | (u >>> (32 - 18));
            u = x0 + x3;
            x1 ^= (u << 7) | (u >>> (32 - 7));
            u = x1 + x0;
            x2 ^= (u << 9) | (u >>> (32 - 9));
            u = x2 + x1;
            x3 ^= (u << 13) | (u >>> (32 - 13));
            u = x3 + x2;
            x0 ^= (u << 18) | (u >>> (32 - 18));
            u = x5 + x4;
            x6 ^= (u << 7) | (u >>> (32 - 7));
            u = x6 + x5;
            x7 ^= (u << 9) | (u >>> (32 - 9));
            u = x7 + x6;
            x4 ^= (u << 13) | (u >>> (32 - 13));
            u = x4 + x7;
            x5 ^= (u << 18) | (u >>> (32 - 18));
            u = x10 + x9;
            x11 ^= (u << 7) | (u >>> (32 - 7));
            u = x11 + x10;
            x8 ^= (u << 9) | (u >>> (32 - 9));
            u = x8 + x11;
            x9 ^= (u << 13) | (u >>> (32 - 13));
            u = x9 + x8;
            x10 ^= (u << 18) | (u >>> (32 - 18));
            u = x15 + x14;
            x12 ^= (u << 7) | (u >>> (32 - 7));
            u = x12 + x15;
            x13 ^= (u << 9) | (u >>> (32 - 9));
            u = x13 + x12;
            x14 ^= (u << 13) | (u >>> (32 - 13));
            u = x14 + x13;
            x15 ^= (u << 18) | (u >>> (32 - 18));
        }
        x0 += j0;
        x1 += j1;
        x2 += j2;
        x3 += j3;
        x4 += j4;
        x5 += j5;
        x6 += j6;
        x7 += j7;
        x8 += j8;
        x9 += j9;
        x10 += j10;
        x11 += j11;
        x12 += j12;
        x13 += j13;
        x14 += j14;
        x15 += j15;
        this._block[0] = (x0 >>> 0) & 0xff;
        this._block[1] = (x0 >>> 8) & 0xff;
        this._block[2] = (x0 >>> 16) & 0xff;
        this._block[3] = (x0 >>> 24) & 0xff;
        this._block[4] = (x1 >>> 0) & 0xff;
        this._block[5] = (x1 >>> 8) & 0xff;
        this._block[6] = (x1 >>> 16) & 0xff;
        this._block[7] = (x1 >>> 24) & 0xff;
        this._block[8] = (x2 >>> 0) & 0xff;
        this._block[9] = (x2 >>> 8) & 0xff;
        this._block[10] = (x2 >>> 16) & 0xff;
        this._block[11] = (x2 >>> 24) & 0xff;
        this._block[12] = (x3 >>> 0) & 0xff;
        this._block[13] = (x3 >>> 8) & 0xff;
        this._block[14] = (x3 >>> 16) & 0xff;
        this._block[15] = (x3 >>> 24) & 0xff;
        this._block[16] = (x4 >>> 0) & 0xff;
        this._block[17] = (x4 >>> 8) & 0xff;
        this._block[18] = (x4 >>> 16) & 0xff;
        this._block[19] = (x4 >>> 24) & 0xff;
        this._block[20] = (x5 >>> 0) & 0xff;
        this._block[21] = (x5 >>> 8) & 0xff;
        this._block[22] = (x5 >>> 16) & 0xff;
        this._block[23] = (x5 >>> 24) & 0xff;
        this._block[24] = (x6 >>> 0) & 0xff;
        this._block[25] = (x6 >>> 8) & 0xff;
        this._block[26] = (x6 >>> 16) & 0xff;
        this._block[27] = (x6 >>> 24) & 0xff;
        this._block[28] = (x7 >>> 0) & 0xff;
        this._block[29] = (x7 >>> 8) & 0xff;
        this._block[30] = (x7 >>> 16) & 0xff;
        this._block[31] = (x7 >>> 24) & 0xff;
        this._block[32] = (x8 >>> 0) & 0xff;
        this._block[33] = (x8 >>> 8) & 0xff;
        this._block[34] = (x8 >>> 16) & 0xff;
        this._block[35] = (x8 >>> 24) & 0xff;
        this._block[36] = (x9 >>> 0) & 0xff;
        this._block[37] = (x9 >>> 8) & 0xff;
        this._block[38] = (x9 >>> 16) & 0xff;
        this._block[39] = (x9 >>> 24) & 0xff;
        this._block[40] = (x10 >>> 0) & 0xff;
        this._block[41] = (x10 >>> 8) & 0xff;
        this._block[42] = (x10 >>> 16) & 0xff;
        this._block[43] = (x10 >>> 24) & 0xff;
        this._block[44] = (x11 >>> 0) & 0xff;
        this._block[45] = (x11 >>> 8) & 0xff;
        this._block[46] = (x11 >>> 16) & 0xff;
        this._block[47] = (x11 >>> 24) & 0xff;
        this._block[48] = (x12 >>> 0) & 0xff;
        this._block[49] = (x12 >>> 8) & 0xff;
        this._block[50] = (x12 >>> 16) & 0xff;
        this._block[51] = (x12 >>> 24) & 0xff;
        this._block[52] = (x13 >>> 0) & 0xff;
        this._block[53] = (x13 >>> 8) & 0xff;
        this._block[54] = (x13 >>> 16) & 0xff;
        this._block[55] = (x13 >>> 24) & 0xff;
        this._block[56] = (x14 >>> 0) & 0xff;
        this._block[57] = (x14 >>> 8) & 0xff;
        this._block[58] = (x14 >>> 16) & 0xff;
        this._block[59] = (x14 >>> 24) & 0xff;
        this._block[60] = (x15 >>> 0) & 0xff;
        this._block[61] = (x15 >>> 8) & 0xff;
        this._block[62] = (x15 >>> 16) & 0xff;
        this._block[63] = (x15 >>> 24) & 0xff;
    }
}
exports.Salsa20 = Salsa20;


/***/ }),

/***/ "./defs/consts.ts":
/*!************************!*\
  !*** ./defs/consts.ts ***!
  \************************/
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.Icons = exports.Defaults = exports.AutoTypeObfuscationOptions = exports.CipherId = exports.KdfId = exports.CrsAlgorithm = exports.CompressionAlgorithm = exports.ErrorCodes = exports.Signatures = void 0;
exports.Signatures = {
    FileMagic: 0x9aa2d903,
    Sig2Kdbx: 0xb54bfb67,
    Sig2Kdb: 0xb54bfb65
};
exports.ErrorCodes = {
    NotImplemented: 'NotImplemented',
    InvalidArg: 'InvalidArg',
    BadSignature: 'BadSignature',
    InvalidVersion: 'InvalidVersion',
    Unsupported: 'Unsupported',
    FileCorrupt: 'FileCorrupt',
    InvalidKey: 'InvalidKey',
    MergeError: 'MergeError',
    InvalidState: 'InvalidState'
};
exports.CompressionAlgorithm = {
    None: 0,
    GZip: 1
};
exports.CrsAlgorithm = {
    Null: 0,
    ArcFourVariant: 1,
    Salsa20: 2,
    ChaCha20: 3
};
exports.KdfId = {
    Argon2: '72Nt34wpREuR96mkA+MKDA==',
    Argon2d: '72Nt34wpREuR96mkA+MKDA==',
    Argon2id: 'nimLGVbbR3OyPfw+xvCh5g==',
    Aes: 'ydnzmmKKRGC/dA0IwYpP6g=='
};
exports.CipherId = {
    Aes: 'McHy5r9xQ1C+WAUhavxa/w==',
    ChaCha20: '1gOKK4tvTLWlJDOaMdu1mg=='
};
exports.AutoTypeObfuscationOptions = {
    None: 0,
    UseClipboard: 1
};
exports.Defaults = {
    KeyEncryptionRounds: 300000,
    MntncHistoryDays: 365,
    HistoryMaxItems: 10,
    HistoryMaxSize: 6 * 1024 * 1024,
    RecycleBinName: 'Recycle Bin'
};
exports.Icons = {
    Key: 0,
    World: 1,
    Warning: 2,
    NetworkServer: 3,
    MarkedDirectory: 4,
    UserCommunication: 5,
    Parts: 6,
    Notepad: 7,
    WorldSocket: 8,
    Identity: 9,
    PaperReady: 10,
    Digicam: 11,
    IRCommunication: 12,
    MultiKeys: 13,
    Energy: 14,
    Scanner: 15,
    WorldStar: 16,
    CDRom: 17,
    Monitor: 18,
    EMail: 19,
    Configuration: 20,
    ClipboardReady: 21,
    PaperNew: 22,
    Screen: 23,
    EnergyCareful: 24,
    EMailBox: 25,
    Disk: 26,
    Drive: 27,
    PaperQ: 28,
    TerminalEncrypted: 29,
    Console: 30,
    Printer: 31,
    ProgramIcons: 32,
    Run: 33,
    Settings: 34,
    WorldComputer: 35,
    Archive: 36,
    Homebanking: 37,
    DriveWindows: 39,
    Clock: 39,
    EMailSearch: 40,
    PaperFlag: 41,
    Memory: 42,
    TrashBin: 43,
    Note: 44,
    Expired: 45,
    Info: 46,
    Package: 47,
    Folder: 48,
    FolderOpen: 49,
    FolderPackage: 50,
    LockOpen: 51,
    PaperLocked: 52,
    Checked: 53,
    Pen: 54,
    Thumbnail: 55,
    Book: 56,
    List: 57,
    UserKey: 58,
    Tool: 59,
    Home: 60,
    Star: 61,
    Tux: 62,
    Feather: 63,
    Apple: 64,
    Wiki: 65,
    Money: 66,
    Certificate: 67,
    BlackBerry: 68
};


/***/ }),

/***/ "./defs/xml-names.ts":
/*!***************************!*\
  !*** ./defs/xml-names.ts ***!
  \***************************/
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.Val = exports.Attr = exports.Elem = void 0;
exports.Elem = {
    DocNode: 'KeePassFile',
    Meta: 'Meta',
    Root: 'Root',
    Group: 'Group',
    Entry: 'Entry',
    Generator: 'Generator',
    HeaderHash: 'HeaderHash',
    SettingsChanged: 'SettingsChanged',
    DbName: 'DatabaseName',
    DbNameChanged: 'DatabaseNameChanged',
    DbDesc: 'DatabaseDescription',
    DbDescChanged: 'DatabaseDescriptionChanged',
    DbDefaultUser: 'DefaultUserName',
    DbDefaultUserChanged: 'DefaultUserNameChanged',
    DbMntncHistoryDays: 'MaintenanceHistoryDays',
    DbColor: 'Color',
    DbKeyChanged: 'MasterKeyChanged',
    DbKeyChangeRec: 'MasterKeyChangeRec',
    DbKeyChangeForce: 'MasterKeyChangeForce',
    RecycleBinEnabled: 'RecycleBinEnabled',
    RecycleBinUuid: 'RecycleBinUUID',
    RecycleBinChanged: 'RecycleBinChanged',
    EntryTemplatesGroup: 'EntryTemplatesGroup',
    EntryTemplatesGroupChanged: 'EntryTemplatesGroupChanged',
    HistoryMaxItems: 'HistoryMaxItems',
    HistoryMaxSize: 'HistoryMaxSize',
    LastSelectedGroup: 'LastSelectedGroup',
    LastTopVisibleGroup: 'LastTopVisibleGroup',
    MemoryProt: 'MemoryProtection',
    ProtTitle: 'ProtectTitle',
    ProtUserName: 'ProtectUserName',
    ProtPassword: 'ProtectPassword',
    ProtUrl: 'ProtectURL',
    ProtNotes: 'ProtectNotes',
    CustomIcons: 'CustomIcons',
    CustomIconItem: 'Icon',
    CustomIconItemID: 'UUID',
    CustomIconItemData: 'Data',
    AutoType: 'AutoType',
    History: 'History',
    Name: 'Name',
    Notes: 'Notes',
    Uuid: 'UUID',
    Icon: 'IconID',
    CustomIconID: 'CustomIconUUID',
    FgColor: 'ForegroundColor',
    BgColor: 'BackgroundColor',
    OverrideUrl: 'OverrideURL',
    Times: 'Times',
    Tags: 'Tags',
    CreationTime: 'CreationTime',
    LastModTime: 'LastModificationTime',
    LastAccessTime: 'LastAccessTime',
    ExpiryTime: 'ExpiryTime',
    Expires: 'Expires',
    UsageCount: 'UsageCount',
    LocationChanged: 'LocationChanged',
    GroupDefaultAutoTypeSeq: 'DefaultAutoTypeSequence',
    EnableAutoType: 'EnableAutoType',
    EnableSearching: 'EnableSearching',
    String: 'String',
    Binary: 'Binary',
    Key: 'Key',
    Value: 'Value',
    AutoTypeEnabled: 'Enabled',
    AutoTypeObfuscation: 'DataTransferObfuscation',
    AutoTypeDefaultSeq: 'DefaultSequence',
    AutoTypeItem: 'Association',
    Window: 'Window',
    KeystrokeSequence: 'KeystrokeSequence',
    Binaries: 'Binaries',
    IsExpanded: 'IsExpanded',
    LastTopVisibleEntry: 'LastTopVisibleEntry',
    DeletedObjects: 'DeletedObjects',
    DeletedObject: 'DeletedObject',
    DeletionTime: 'DeletionTime',
    CustomData: 'CustomData',
    StringDictExItem: 'Item'
};
exports.Attr = {
    Id: 'ID',
    Ref: 'Ref',
    Protected: 'Protected',
    ProtectedInMemPlainXml: 'ProtectInMemory',
    Compressed: 'Compressed'
};
exports.Val = {
    False: 'False',
    True: 'True'
};


/***/ }),

/***/ "./errors/kdbx-error.ts":
/*!******************************!*\
  !*** ./errors/kdbx-error.ts ***!
  \******************************/
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.KdbxError = void 0;
class KdbxError extends Error {
    constructor(code, message) {
        super('Error ' + code + (message ? ': ' + message : ''));
        this.name = 'KdbxError';
        this.code = code;
    }
}
exports.KdbxError = KdbxError;


/***/ }),

/***/ "./format/kdbx-binaries.ts":
/*!*********************************!*\
  !*** ./format/kdbx-binaries.ts ***!
  \*********************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.KdbxBinaries = void 0;
const CryptoEngine = __webpack_require__(/*! ./../crypto/crypto-engine */ "./crypto/crypto-engine.ts");
const protected_value_1 = __webpack_require__(/*! ../crypto/protected-value */ "./crypto/protected-value.ts");
const byte_utils_1 = __webpack_require__(/*! ../utils/byte-utils */ "./utils/byte-utils.ts");
class KdbxBinaries {
    constructor() {
        // temporary map used during database loading
        this._mapById = new Map();
        // in runtime, entries are addressed by hash
        this._mapByHash = new Map();
        // kept to be able to find binaries by id as well
        this._idToHash = new Map();
    }
    computeHashes() {
        // this method is called after the file is loaded
        const promises = [...this._mapById].map(([id, binary]) => KdbxBinaries.getBinaryHash(binary).then((hash) => {
            this._idToHash.set(id, hash);
            this._mapByHash.set(hash, binary);
        }));
        return Promise.all(promises).then(() => {
            // it won't be used anymore
            this._mapById.clear();
        });
    }
    static getBinaryHash(binary) {
        let promise;
        if (binary instanceof protected_value_1.ProtectedValue) {
            promise = binary.getHash();
        }
        else {
            binary = byte_utils_1.arrayToBuffer(binary);
            promise = CryptoEngine.sha256(binary);
        }
        return promise.then(byte_utils_1.bytesToHex);
    }
    add(value) {
        // called after load
        if (value instanceof Uint8Array) {
            value = byte_utils_1.arrayToBuffer(value);
        }
        return KdbxBinaries.getBinaryHash(value).then((hash) => {
            this._mapByHash.set(hash, value);
            return { hash, value };
        });
    }
    addWithNextId(value) {
        // called during load (v4), when building the id map
        const id = this._mapById.size.toString();
        this.addWithId(id, value);
    }
    addWithId(id, value) {
        // called during load (v3), when building the id map
        if (value instanceof Uint8Array) {
            value = byte_utils_1.arrayToBuffer(value);
        }
        this._mapById.set(id, value);
    }
    addWithHash(binary) {
        this._mapByHash.set(binary.hash, binary.value);
    }
    deleteWithHash(hash) {
        this._mapByHash.delete(hash);
    }
    getByRef(binaryRef) {
        const hash = this._idToHash.get(binaryRef.ref);
        if (!hash) {
            return undefined;
        }
        const value = this._mapByHash.get(hash);
        if (!value) {
            return undefined;
        }
        return { hash, value };
    }
    getRefByHash(hash) {
        const ref = [...this._mapByHash.keys()].indexOf(hash);
        if (ref < 0) {
            return undefined;
        }
        return { ref: ref.toString() };
    }
    getAll() {
        return [...this._mapByHash.values()].map((value, index) => {
            return { ref: index.toString(), value };
        });
    }
    getAllWithHashes() {
        return [...this._mapByHash].map(([hash, value]) => ({
            hash,
            value
        }));
    }
    getValueByHash(hash) {
        return this._mapByHash.get(hash);
    }
    static isKdbxBinaryRef(binary) {
        var _a;
        return !!((_a = binary) === null || _a === void 0 ? void 0 : _a.ref);
    }
    static isKdbxBinaryWithHash(binary) {
        var _a;
        return !!((_a = binary) === null || _a === void 0 ? void 0 : _a.hash);
    }
}
exports.KdbxBinaries = KdbxBinaries;


/***/ }),

/***/ "./format/kdbx-context.ts":
/*!********************************!*\
  !*** ./format/kdbx-context.ts ***!
  \********************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.KdbxContext = void 0;
const XmlUtils = __webpack_require__(/*! ./../utils/xml-utils */ "./utils/xml-utils.ts");
class KdbxContext {
    constructor(opts) {
        this.kdbx = opts.kdbx;
        this.exportXml = !!opts.exportXml;
    }
    setXmlDate(node, dt) {
        const isBinary = this.kdbx.versionMajor >= 4 && !this.exportXml;
        XmlUtils.setDate(node, dt, isBinary);
    }
}
exports.KdbxContext = KdbxContext;


/***/ }),

/***/ "./format/kdbx-credentials.ts":
/*!************************************!*\
  !*** ./format/kdbx-credentials.ts ***!
  \************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.KdbxCredentials = void 0;
const XmlUtils = __webpack_require__(/*! ../utils/xml-utils */ "./utils/xml-utils.ts");
const CryptoEngine = __webpack_require__(/*! ../crypto/crypto-engine */ "./crypto/crypto-engine.ts");
const protected_value_1 = __webpack_require__(/*! ../crypto/protected-value */ "./crypto/protected-value.ts");
const kdbx_error_1 = __webpack_require__(/*! ../errors/kdbx-error */ "./errors/kdbx-error.ts");
const consts_1 = __webpack_require__(/*! ../defs/consts */ "./defs/consts.ts");
const byte_utils_1 = __webpack_require__(/*! ../utils/byte-utils */ "./utils/byte-utils.ts");
class KdbxCredentials {
    constructor(password, keyFile, challengeResponse) {
        this.ready = Promise.all([
            this.setPassword(password),
            this.setKeyFile(keyFile),
            this.setChallengeResponse(challengeResponse)
        ]).then(() => this);
    }
    setPassword(password) {
        if (!password) {
            this._passwordHash = undefined;
            return Promise.resolve();
        }
        else if (password instanceof protected_value_1.ProtectedValue) {
            return password.getHash().then((hash) => {
                this._passwordHash = protected_value_1.ProtectedValue.fromBinary(hash);
            });
        }
        else {
            return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg, 'password'));
        }
    }
    setKeyFile(keyFile) {
        if (keyFile && !(keyFile instanceof ArrayBuffer) && !(keyFile instanceof Uint8Array)) {
            return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg, 'keyFile'));
        }
        if (keyFile) {
            if (keyFile.byteLength === 32) {
                this._keyFileHash = protected_value_1.ProtectedValue.fromBinary(byte_utils_1.arrayToBuffer(keyFile));
                return Promise.resolve();
            }
            let keyFileVersion;
            let dataEl;
            try {
                const keyFileStr = byte_utils_1.bytesToString(byte_utils_1.arrayToBuffer(keyFile));
                if (/^[a-f\d]{64}$/i.exec(keyFileStr)) {
                    const bytes = byte_utils_1.hexToBytes(keyFileStr);
                    this._keyFileHash = protected_value_1.ProtectedValue.fromBinary(bytes);
                    return Promise.resolve();
                }
                const xml = XmlUtils.parse(keyFileStr.trim());
                const metaEl = XmlUtils.getChildNode(xml.documentElement, 'Meta');
                if (!metaEl) {
                    return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg, 'Key file without meta'));
                }
                const versionEl = XmlUtils.getChildNode(metaEl, 'Version');
                if (!(versionEl === null || versionEl === void 0 ? void 0 : versionEl.textContent)) {
                    return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg, 'Key file without version'));
                }
                keyFileVersion = +versionEl.textContent.split('.')[0];
                const keyEl = XmlUtils.getChildNode(xml.documentElement, 'Key');
                if (!keyEl) {
                    return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg, 'Key file without key'));
                }
                dataEl = XmlUtils.getChildNode(keyEl, 'Data');
                if (!(dataEl === null || dataEl === void 0 ? void 0 : dataEl.textContent)) {
                    return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg, 'Key file without key'));
                }
            }
            catch (e) {
                return CryptoEngine.sha256(keyFile).then((hash) => {
                    this._keyFileHash = protected_value_1.ProtectedValue.fromBinary(hash);
                });
            }
            switch (keyFileVersion) {
                case 1:
                    this._keyFileHash = protected_value_1.ProtectedValue.fromBinary(byte_utils_1.base64ToBytes(dataEl.textContent));
                    break;
                case 2: {
                    const keyFileData = byte_utils_1.hexToBytes(dataEl.textContent.replace(/\s+/g, ''));
                    const keyFileDataHash = dataEl.getAttribute('Hash');
                    return CryptoEngine.sha256(keyFileData).then((computedHash) => {
                        const computedHashStr = byte_utils_1.bytesToHex(new Uint8Array(computedHash).subarray(0, 4)).toUpperCase();
                        if (computedHashStr !== keyFileDataHash) {
                            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'Key file data hash mismatch');
                        }
                        this._keyFileHash = protected_value_1.ProtectedValue.fromBinary(keyFileData);
                    });
                }
                default: {
                    return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'Bad keyfile version'));
                }
            }
        }
        else {
            this._keyFileHash = undefined;
        }
        return Promise.resolve();
    }
    setChallengeResponse(challengeResponse) {
        this._challengeResponse = challengeResponse;
        return Promise.resolve();
    }
    getHash(challenge) {
        return this.ready.then(() => {
            return this.getChallengeResponse(challenge).then((chalResp) => {
                const buffers = [];
                if (this._passwordHash) {
                    buffers.push(this._passwordHash.getBinary());
                }
                if (this._keyFileHash) {
                    buffers.push(this._keyFileHash.getBinary());
                }
                if (chalResp) {
                    if (chalResp instanceof Uint8Array) {
                        buffers.push(chalResp);
                    }
                    else {
                        buffers.push(new Uint8Array(chalResp));
                    }
                }
                const totalLength = buffers.reduce((acc, buf) => acc + buf.byteLength, 0);
                const allBytes = new Uint8Array(totalLength);
                let offset = 0;
                for (const buffer of buffers) {
                    allBytes.set(buffer, offset);
                    byte_utils_1.zeroBuffer(buffer);
                    offset += buffer.length;
                }
                return CryptoEngine.sha256(byte_utils_1.arrayToBuffer(allBytes)).then((hash) => {
                    byte_utils_1.zeroBuffer(allBytes);
                    return hash;
                });
            });
        });
    }
    getChallengeResponse(challenge) {
        return Promise.resolve().then(() => {
            if (!this._challengeResponse || !challenge) {
                return null;
            }
            return this._challengeResponse(challenge).then((response) => {
                return CryptoEngine.sha256(byte_utils_1.arrayToBuffer(response)).then((hash) => {
                    byte_utils_1.zeroBuffer(response);
                    return hash;
                });
            });
        });
    }
    static createRandomKeyFile(version = 1) {
        const keyLength = 32;
        const keyBytes = CryptoEngine.random(keyLength), salt = CryptoEngine.random(keyLength);
        for (let i = 0; i < keyLength; i++) {
            keyBytes[i] ^= salt[i];
            keyBytes[i] ^= (Math.random() * 1000) % 255;
        }
        return KdbxCredentials.createKeyFileWithHash(keyBytes, version);
    }
    static createKeyFileWithHash(keyBytes, version = 1) {
        const xmlVersion = version === 2 ? '2.0' : '1.00';
        const dataPadding = '        ';
        let makeDataElPromise;
        if (version === 2) {
            const keyDataPadding = dataPadding + '    ';
            makeDataElPromise = CryptoEngine.sha256(keyBytes).then((computedHash) => {
                const keyHash = byte_utils_1.bytesToHex(new Uint8Array(computedHash).subarray(0, 4)).toUpperCase();
                const keyStr = byte_utils_1.bytesToHex(keyBytes).toUpperCase();
                let dataElXml = dataPadding + '<Data Hash="' + keyHash + '">\n';
                for (let num = 0; num < 2; num++) {
                    const parts = [0, 1, 2, 3].map((ix) => {
                        return keyStr.substr(num * 32 + ix * 8, 8);
                    });
                    dataElXml += keyDataPadding;
                    dataElXml += parts.join(' ');
                    dataElXml += '\n';
                }
                dataElXml += dataPadding + '</Data>\n';
                return dataElXml;
            });
        }
        else {
            const dataElXml = dataPadding + '<Data>' + byte_utils_1.bytesToBase64(keyBytes) + '</Data>\n';
            makeDataElPromise = Promise.resolve(dataElXml);
        }
        return makeDataElPromise.then((dataElXml) => {
            const xml = '<?xml version="1.0" encoding="utf-8"?>\n' +
                '<KeyFile>\n' +
                '    <Meta>\n' +
                '        <Version>' +
                xmlVersion +
                '</Version>\n' +
                '    </Meta>\n' +
                '    <Key>\n' +
                dataElXml +
                '    </Key>\n' +
                '</KeyFile>';
            return byte_utils_1.stringToBytes(xml);
        });
    }
}
exports.KdbxCredentials = KdbxCredentials;


/***/ }),

/***/ "./format/kdbx-custom-data.ts":
/*!************************************!*\
  !*** ./format/kdbx-custom-data.ts ***!
  \************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.KdbxCustomData = void 0;
const XmlUtils = __webpack_require__(/*! ../utils/xml-utils */ "./utils/xml-utils.ts");
const XmlNames = __webpack_require__(/*! ../defs/xml-names */ "./defs/xml-names.ts");
class KdbxCustomData {
    static read(node) {
        const customData = new Map();
        for (let i = 0, cn = node.childNodes, len = cn.length; i < len; i++) {
            const childNode = cn[i];
            if (childNode.tagName === XmlNames.Elem.StringDictExItem) {
                this.readItem(childNode, customData);
            }
        }
        return customData;
    }
    static write(parentNode, customData) {
        if (!customData) {
            return;
        }
        const node = XmlUtils.addChildNode(parentNode, XmlNames.Elem.CustomData);
        for (const [key, value] of customData) {
            if (value) {
                const itemNode = XmlUtils.addChildNode(node, XmlNames.Elem.StringDictExItem);
                XmlUtils.setText(XmlUtils.addChildNode(itemNode, XmlNames.Elem.Key), key);
                XmlUtils.setText(XmlUtils.addChildNode(itemNode, XmlNames.Elem.Value), value);
            }
        }
    }
    static readItem(node, customData) {
        let key, value;
        for (let i = 0, cn = node.childNodes, len = cn.length; i < len; i++) {
            const childNode = cn[i];
            switch (childNode.tagName) {
                case XmlNames.Elem.Key:
                    key = XmlUtils.getText(childNode);
                    break;
                case XmlNames.Elem.Value:
                    value = XmlUtils.getText(childNode);
                    break;
            }
        }
        if (key && value !== undefined) {
            customData.set(key, value);
        }
    }
}
exports.KdbxCustomData = KdbxCustomData;


/***/ }),

/***/ "./format/kdbx-deleted-object.ts":
/*!***************************************!*\
  !*** ./format/kdbx-deleted-object.ts ***!
  \***************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.KdbxDeletedObject = void 0;
const XmlUtils = __webpack_require__(/*! ../utils/xml-utils */ "./utils/xml-utils.ts");
const XmlNames = __webpack_require__(/*! ../defs/xml-names */ "./defs/xml-names.ts");
class KdbxDeletedObject {
    readNode(node) {
        switch (node.tagName) {
            case XmlNames.Elem.Uuid:
                this.uuid = XmlUtils.getUuid(node);
                break;
            case XmlNames.Elem.DeletionTime:
                this.deletionTime = XmlUtils.getDate(node);
                break;
        }
    }
    write(parentNode, ctx) {
        const node = XmlUtils.addChildNode(parentNode, XmlNames.Elem.DeletedObject);
        XmlUtils.setUuid(XmlUtils.addChildNode(node, XmlNames.Elem.Uuid), this.uuid);
        ctx.setXmlDate(XmlUtils.addChildNode(node, XmlNames.Elem.DeletionTime), this.deletionTime);
    }
    static read(xmlNode) {
        const obj = new KdbxDeletedObject();
        for (let i = 0, cn = xmlNode.childNodes, len = cn.length; i < len; i++) {
            const childNode = cn[i];
            if (childNode.tagName) {
                obj.readNode(childNode);
            }
        }
        return obj;
    }
}
exports.KdbxDeletedObject = KdbxDeletedObject;


/***/ }),

/***/ "./format/kdbx-entry.ts":
/*!******************************!*\
  !*** ./format/kdbx-entry.ts ***!
  \******************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.KdbxEntry = void 0;
const XmlNames = __webpack_require__(/*! ./../defs/xml-names */ "./defs/xml-names.ts");
const XmlUtils = __webpack_require__(/*! ./../utils/xml-utils */ "./utils/xml-utils.ts");
const kdbx_times_1 = __webpack_require__(/*! ./kdbx-times */ "./format/kdbx-times.ts");
const consts_1 = __webpack_require__(/*! ../defs/consts */ "./defs/consts.ts");
const protected_value_1 = __webpack_require__(/*! ../crypto/protected-value */ "./crypto/protected-value.ts");
const kdbx_custom_data_1 = __webpack_require__(/*! ./kdbx-custom-data */ "./format/kdbx-custom-data.ts");
const kdbx_uuid_1 = __webpack_require__(/*! ./kdbx-uuid */ "./format/kdbx-uuid.ts");
const kdbx_binaries_1 = __webpack_require__(/*! ./kdbx-binaries */ "./format/kdbx-binaries.ts");
const TagsSplitRegex = /\s*[;,:]\s*/;
class KdbxEntry {
    constructor() {
        this.uuid = new kdbx_uuid_1.KdbxUuid();
        this.tags = [];
        this.times = new kdbx_times_1.KdbxTimes();
        this.fields = new Map();
        this.binaries = new Map();
        this.autoType = {
            enabled: true,
            obfuscation: consts_1.AutoTypeObfuscationOptions.None,
            items: []
        };
        this.history = [];
    }
    get lastModTime() {
        var _a, _b;
        return (_b = (_a = this.times.lastModTime) === null || _a === void 0 ? void 0 : _a.getTime()) !== null && _b !== void 0 ? _b : 0;
    }
    get locationChanged() {
        var _a, _b;
        return (_b = (_a = this.times.locationChanged) === null || _a === void 0 ? void 0 : _a.getTime()) !== null && _b !== void 0 ? _b : 0;
    }
    readNode(node, ctx) {
        var _a, _b;
        switch (node.tagName) {
            case XmlNames.Elem.Uuid:
                this.uuid = (_a = XmlUtils.getUuid(node)) !== null && _a !== void 0 ? _a : new kdbx_uuid_1.KdbxUuid();
                break;
            case XmlNames.Elem.Icon:
                this.icon = XmlUtils.getNumber(node) || consts_1.Icons.Key;
                break;
            case XmlNames.Elem.CustomIconID:
                this.customIcon = XmlUtils.getUuid(node);
                break;
            case XmlNames.Elem.FgColor:
                this.fgColor = XmlUtils.getText(node);
                break;
            case XmlNames.Elem.BgColor:
                this.bgColor = XmlUtils.getText(node);
                break;
            case XmlNames.Elem.OverrideUrl:
                this.overrideUrl = XmlUtils.getText(node);
                break;
            case XmlNames.Elem.Tags:
                this.tags = KdbxEntry.stringToTags((_b = XmlUtils.getText(node)) !== null && _b !== void 0 ? _b : '');
                break;
            case XmlNames.Elem.Times:
                this.times = kdbx_times_1.KdbxTimes.read(node);
                break;
            case XmlNames.Elem.String:
                this.readField(node);
                break;
            case XmlNames.Elem.Binary:
                this.readBinary(node, ctx);
                break;
            case XmlNames.Elem.AutoType:
                this.readAutoType(node);
                break;
            case XmlNames.Elem.History:
                this.readHistory(node, ctx);
                break;
            case XmlNames.Elem.CustomData:
                this.readCustomData(node);
                break;
        }
    }
    readField(node) {
        const keyNode = XmlUtils.getChildNode(node, XmlNames.Elem.Key), valueNode = XmlUtils.getChildNode(node, XmlNames.Elem.Value);
        if (keyNode && valueNode) {
            const key = XmlUtils.getText(keyNode), value = XmlUtils.getProtectedText(valueNode);
            if (key) {
                this.fields.set(key, value || '');
            }
        }
    }
    writeFields(parentNode) {
        for (const [field, value] of this.fields) {
            if (value !== undefined && value !== null) {
                const node = XmlUtils.addChildNode(parentNode, XmlNames.Elem.String);
                XmlUtils.setText(XmlUtils.addChildNode(node, XmlNames.Elem.Key), field);
                XmlUtils.setProtectedText(XmlUtils.addChildNode(node, XmlNames.Elem.Value), value);
            }
        }
    }
    readBinary(node, ctx) {
        const keyNode = XmlUtils.getChildNode(node, XmlNames.Elem.Key), valueNode = XmlUtils.getChildNode(node, XmlNames.Elem.Value);
        if (keyNode && valueNode) {
            const key = XmlUtils.getText(keyNode), value = XmlUtils.getProtectedBinary(valueNode);
            if (key && value) {
                if (kdbx_binaries_1.KdbxBinaries.isKdbxBinaryRef(value)) {
                    const binary = ctx.kdbx.binaries.getByRef(value);
                    if (binary) {
                        this.binaries.set(key, binary);
                    }
                }
                else {
                    this.binaries.set(key, value);
                }
            }
        }
    }
    writeBinaries(parentNode, ctx) {
        for (const [id, data] of this.binaries) {
            let bin;
            if (kdbx_binaries_1.KdbxBinaries.isKdbxBinaryWithHash(data)) {
                const binaryRef = ctx.kdbx.binaries.getRefByHash(data.hash);
                if (!binaryRef) {
                    return;
                }
                bin = binaryRef;
            }
            else {
                bin = data;
            }
            const node = XmlUtils.addChildNode(parentNode, XmlNames.Elem.Binary);
            XmlUtils.setText(XmlUtils.addChildNode(node, XmlNames.Elem.Key), id);
            XmlUtils.setProtectedBinary(XmlUtils.addChildNode(node, XmlNames.Elem.Value), bin);
        }
    }
    static stringToTags(str) {
        if (!str) {
            return [];
        }
        return str.split(TagsSplitRegex).filter((s) => s);
    }
    readAutoType(node) {
        var _a;
        for (let i = 0, cn = node.childNodes, len = cn.length; i < len; i++) {
            const childNode = cn[i];
            switch (childNode.tagName) {
                case XmlNames.Elem.AutoTypeEnabled:
                    this.autoType.enabled = (_a = XmlUtils.getBoolean(childNode)) !== null && _a !== void 0 ? _a : true;
                    break;
                case XmlNames.Elem.AutoTypeObfuscation:
                    this.autoType.obfuscation =
                        XmlUtils.getNumber(childNode) || consts_1.AutoTypeObfuscationOptions.None;
                    break;
                case XmlNames.Elem.AutoTypeDefaultSeq:
                    this.autoType.defaultSequence = XmlUtils.getText(childNode);
                    break;
                case XmlNames.Elem.AutoTypeItem:
                    this.readAutoTypeItem(childNode);
                    break;
            }
        }
    }
    readAutoTypeItem(node) {
        let window = '';
        let keystrokeSequence = '';
        for (let i = 0, cn = node.childNodes, len = cn.length; i < len; i++) {
            const childNode = cn[i];
            switch (childNode.tagName) {
                case XmlNames.Elem.Window:
                    window = XmlUtils.getText(childNode) || '';
                    break;
                case XmlNames.Elem.KeystrokeSequence:
                    keystrokeSequence = XmlUtils.getText(childNode) || '';
                    break;
            }
        }
        if (window && keystrokeSequence) {
            this.autoType.items.push({ window, keystrokeSequence });
        }
    }
    writeAutoType(parentNode) {
        const node = XmlUtils.addChildNode(parentNode, XmlNames.Elem.AutoType);
        XmlUtils.setBoolean(XmlUtils.addChildNode(node, XmlNames.Elem.AutoTypeEnabled), this.autoType.enabled);
        XmlUtils.setNumber(XmlUtils.addChildNode(node, XmlNames.Elem.AutoTypeObfuscation), this.autoType.obfuscation || consts_1.AutoTypeObfuscationOptions.None);
        if (this.autoType.defaultSequence) {
            XmlUtils.setText(XmlUtils.addChildNode(node, XmlNames.Elem.AutoTypeDefaultSeq), this.autoType.defaultSequence);
        }
        for (let i = 0; i < this.autoType.items.length; i++) {
            const item = this.autoType.items[i];
            const itemNode = XmlUtils.addChildNode(node, XmlNames.Elem.AutoTypeItem);
            XmlUtils.setText(XmlUtils.addChildNode(itemNode, XmlNames.Elem.Window), item.window);
            XmlUtils.setText(XmlUtils.addChildNode(itemNode, XmlNames.Elem.KeystrokeSequence), item.keystrokeSequence);
        }
    }
    readHistory(node, ctx) {
        for (let i = 0, cn = node.childNodes, len = cn.length; i < len; i++) {
            const childNode = cn[i];
            switch (childNode.tagName) {
                case XmlNames.Elem.Entry:
                    this.history.push(KdbxEntry.read(childNode, ctx));
                    break;
            }
        }
    }
    writeHistory(parentNode, ctx) {
        const historyNode = XmlUtils.addChildNode(parentNode, XmlNames.Elem.History);
        for (const historyEntry of this.history) {
            historyEntry.write(historyNode, ctx);
        }
    }
    readCustomData(node) {
        this.customData = kdbx_custom_data_1.KdbxCustomData.read(node);
    }
    writeCustomData(parentNode) {
        if (this.customData) {
            kdbx_custom_data_1.KdbxCustomData.write(parentNode, this.customData);
        }
    }
    setField(name, str, secure = false) {
        this.fields.set(name, secure ? protected_value_1.ProtectedValue.fromString(str) : str);
    }
    addHistoryTombstone(isAdded, dt) {
        if (!this._editState) {
            this._editState = { added: [], deleted: [] };
        }
        this._editState[isAdded ? 'added' : 'deleted'].push(dt.getTime());
    }
    write(parentNode, ctx) {
        const node = XmlUtils.addChildNode(parentNode, XmlNames.Elem.Entry);
        XmlUtils.setUuid(XmlUtils.addChildNode(node, XmlNames.Elem.Uuid), this.uuid);
        XmlUtils.setNumber(XmlUtils.addChildNode(node, XmlNames.Elem.Icon), this.icon || consts_1.Icons.Key);
        if (this.customIcon) {
            XmlUtils.setUuid(XmlUtils.addChildNode(node, XmlNames.Elem.CustomIconID), this.customIcon);
        }
        XmlUtils.setText(XmlUtils.addChildNode(node, XmlNames.Elem.FgColor), this.fgColor);
        XmlUtils.setText(XmlUtils.addChildNode(node, XmlNames.Elem.BgColor), this.bgColor);
        XmlUtils.setText(XmlUtils.addChildNode(node, XmlNames.Elem.OverrideUrl), this.overrideUrl);
        XmlUtils.setText(XmlUtils.addChildNode(node, XmlNames.Elem.Tags), this.tags.join(','));
        this.times.write(node, ctx);
        this.writeFields(node);
        this.writeBinaries(node, ctx);
        this.writeAutoType(node);
        this.writeCustomData(node);
        if (parentNode.tagName !== XmlNames.Elem.History) {
            this.writeHistory(node, ctx);
        }
    }
    pushHistory() {
        const historyEntry = new KdbxEntry();
        historyEntry.copyFrom(this);
        this.history.push(historyEntry);
        if (historyEntry.times.lastModTime) {
            this.addHistoryTombstone(true, historyEntry.times.lastModTime);
        }
    }
    removeHistory(index, count = 1) {
        for (let ix = index; ix < index + count; ix++) {
            if (ix < this.history.length) {
                const lastModTime = this.history[ix].times.lastModTime;
                if (lastModTime) {
                    this.addHistoryTombstone(false, lastModTime);
                }
            }
        }
        this.history.splice(index, count);
    }
    copyFrom(entry) {
        this.uuid = entry.uuid;
        this.icon = entry.icon;
        this.customIcon = entry.customIcon;
        this.fgColor = entry.fgColor;
        this.bgColor = entry.bgColor;
        this.overrideUrl = entry.overrideUrl;
        this.tags = entry.tags.slice();
        this.times = entry.times.clone();
        this.fields = new Map();
        for (const [name, value] of entry.fields) {
            if (value instanceof protected_value_1.ProtectedValue) {
                this.fields.set(name, value.clone());
            }
            else {
                this.fields.set(name, value);
            }
        }
        this.binaries = new Map();
        for (const [name, value] of entry.binaries) {
            if (value instanceof protected_value_1.ProtectedValue) {
                this.binaries.set(name, value.clone());
            }
            else if (kdbx_binaries_1.KdbxBinaries.isKdbxBinaryWithHash(value)) {
                this.binaries.set(name, { hash: value.hash, value: value.value });
            }
            else {
                this.binaries.set(name, value);
            }
        }
        this.autoType = JSON.parse(JSON.stringify(entry.autoType));
    }
    merge(objectMap) {
        const remoteEntry = objectMap.remoteEntries.get(this.uuid.id);
        if (!remoteEntry) {
            return;
        }
        const remoteHistory = remoteEntry.history.slice();
        if (this.lastModTime < remoteEntry.lastModTime) {
            // remote is more new; push current state to history and update
            this.pushHistory();
            this.copyFrom(remoteEntry);
        }
        else if (this.lastModTime > remoteEntry.lastModTime) {
            // local is more new; if remote state is not in history, push it
            const existsInHistory = this.history.some((historyEntry) => {
                return historyEntry.lastModTime === remoteEntry.lastModTime;
            });
            if (!existsInHistory) {
                const historyEntry = new KdbxEntry();
                historyEntry.copyFrom(remoteEntry);
                remoteHistory.push(historyEntry);
            }
        }
        this.history = this.mergeHistory(remoteHistory, remoteEntry.lastModTime);
    }
    /**
     * Merge entry history with remote entry history
     * Tombstones are stored locally and must be immediately discarded by replica after successful upstream push.
     * It's client responsibility, to save and load tombstones for local replica, and to clear them after successful upstream push.
     *
     * Implements remove-win OR-set CRDT with local tombstones stored in _editState.
     *
     * Format doesn't allow saving tombstones for history entries, so they are stored locally.
     * Any unmodified state from past or modifications of current state synced with central upstream will be successfully merged.
     * Assumes there's only one central upstream, may produce inconsistencies while merging outdated replica outside main upstream.
     * Phantom entries and phantom deletions will appear if remote replica checked out an old state and has just added a new state.
     * If a client is using central upstream for sync, the remote replica must first sync it state and
     * only after it update the upstream, so this should never happen.
     *
     * References:
     *
     * An Optimized Conflict-free Replicated Set arXiv:1210.3368 [cs.DC]
     * http://arxiv.org/abs/1210.3368
     *
     * Gene T. J. Wuu and Arthur J. Bernstein. Efficient solutions to the replicated log and dictionary
     * problems. In Symp. on Principles of Dist. Comp. (PODC), pages 233–242, Vancouver, BC, Canada, August 1984.
     * https://pages.lip6.fr/Marc.Shapiro/papers/RR-7687.pdf
     */
    mergeHistory(remoteHistory, remoteLastModTime) {
        // we can skip sorting but the history may not have been sorted
        this.history.sort((x, y) => x.lastModTime - y.lastModTime);
        remoteHistory.sort((x, y) => x.lastModTime - y.lastModTime);
        let historyIx = 0, remoteHistoryIx = 0;
        const newHistory = [];
        while (historyIx < this.history.length || remoteHistoryIx < remoteHistory.length) {
            const historyEntry = this.history[historyIx], remoteHistoryEntry = remoteHistory[remoteHistoryIx], entryTime = historyEntry && historyEntry.lastModTime, remoteEntryTime = remoteHistoryEntry && remoteHistoryEntry.lastModTime;
            if (entryTime === remoteEntryTime) {
                // exists in local and remote
                newHistory.push(historyEntry);
                historyIx++;
                remoteHistoryIx++;
                continue;
            }
            if (!historyEntry || entryTime > remoteEntryTime) {
                // local is absent
                if (!this._editState || this._editState.deleted.indexOf(remoteEntryTime) < 0) {
                    // added remotely
                    const remoteHistoryEntryClone = new KdbxEntry();
                    remoteHistoryEntryClone.copyFrom(remoteHistoryEntry);
                    newHistory.push(remoteHistoryEntryClone);
                } // else: deleted locally
                remoteHistoryIx++;
                continue;
            }
            // (!remoteHistoryEntry || entryTime < remoteEntryTime) && historyEntry
            // remote is absent
            if (this._editState && this._editState.added.indexOf(entryTime) >= 0) {
                // added locally
                newHistory.push(historyEntry);
            }
            else if (entryTime > remoteLastModTime) {
                // outdated replica history has ended
                newHistory.push(historyEntry);
            } // else: deleted remotely
            historyIx++;
        }
        return newHistory;
    }
    static create(meta, parentGroup) {
        const entry = new KdbxEntry();
        entry.uuid = kdbx_uuid_1.KdbxUuid.random();
        entry.icon = consts_1.Icons.Key;
        entry.times = kdbx_times_1.KdbxTimes.create();
        entry.parentGroup = parentGroup;
        entry.setField('Title', '', meta.memoryProtection.title);
        entry.setField('UserName', meta.defaultUser || '', meta.memoryProtection.userName);
        entry.setField('Password', '', meta.memoryProtection.password);
        entry.setField('URL', '', meta.memoryProtection.url);
        entry.setField('Notes', '', meta.memoryProtection.notes);
        entry.autoType.enabled =
            typeof parentGroup.enableAutoType === 'boolean' ? parentGroup.enableAutoType : true;
        entry.autoType.obfuscation = consts_1.AutoTypeObfuscationOptions.None;
        return entry;
    }
    static read(xmlNode, ctx, parentGroup) {
        const entry = new KdbxEntry();
        for (let i = 0, cn = xmlNode.childNodes, len = cn.length; i < len; i++) {
            const childNode = cn[i];
            if (childNode.tagName) {
                entry.readNode(childNode, ctx);
            }
        }
        if (entry.uuid.empty) {
            // some clients don't write ids
            entry.uuid = kdbx_uuid_1.KdbxUuid.random();
            for (let j = 0; j < entry.history.length; j++) {
                entry.history[j].uuid = entry.uuid;
            }
        }
        entry.parentGroup = parentGroup;
        return entry;
    }
}
exports.KdbxEntry = KdbxEntry;


/***/ }),

/***/ "./format/kdbx-format.ts":
/*!*******************************!*\
  !*** ./format/kdbx-format.ts ***!
  \*******************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.KdbxFormat = void 0;
const pako = __webpack_require__(/*! pako */ "../node_modules/pako/index.js");
const consts_1 = __webpack_require__(/*! ../defs/consts */ "./defs/consts.ts");
const kdbx_error_1 = __webpack_require__(/*! ../errors/kdbx-error */ "./errors/kdbx-error.ts");
const binary_stream_1 = __webpack_require__(/*! ../utils/binary-stream */ "./utils/binary-stream.ts");
const kdbx_context_1 = __webpack_require__(/*! ./kdbx-context */ "./format/kdbx-context.ts");
const kdbx_header_1 = __webpack_require__(/*! ./kdbx-header */ "./format/kdbx-header.ts");
const byte_utils_1 = __webpack_require__(/*! ../utils/byte-utils */ "./utils/byte-utils.ts");
const protect_salt_generator_1 = __webpack_require__(/*! ../crypto/protect-salt-generator */ "./crypto/protect-salt-generator.ts");
const XmlUtils = __webpack_require__(/*! ../utils/xml-utils */ "./utils/xml-utils.ts");
const HmacBlockTransform = __webpack_require__(/*! ../crypto/hmac-block-transform */ "./crypto/hmac-block-transform.ts");
const HashedBlockTransform = __webpack_require__(/*! ../crypto/hashed-block-transform */ "./crypto/hashed-block-transform.ts");
const CryptoEngine = __webpack_require__(/*! ../crypto/crypto-engine */ "./crypto/crypto-engine.ts");
const KeyEncryptorAes = __webpack_require__(/*! ../crypto/key-encryptor-aes */ "./crypto/key-encryptor-aes.ts");
const KeyEncryptorKdf = __webpack_require__(/*! ../crypto/key-encryptor-kdf */ "./crypto/key-encryptor-kdf.ts");
const int64_1 = __webpack_require__(/*! ../utils/int64 */ "./utils/int64.ts");
class KdbxFormat {
    constructor(kdbx) {
        this.kdbx = kdbx;
        this.ctx = new kdbx_context_1.KdbxContext({ kdbx });
    }
    load(data) {
        const stm = new binary_stream_1.BinaryStream(data);
        return this.kdbx.credentials.ready.then(() => {
            this.kdbx.header = kdbx_header_1.KdbxHeader.read(stm, this.ctx);
            if (this.kdbx.header.versionMajor === 3) {
                return this.loadV3(stm);
            }
            else if (this.kdbx.header.versionMajor === 4) {
                return this.loadV4(stm);
            }
            else {
                throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidVersion, `bad version: ${this.kdbx.versionMajor}`);
            }
        });
    }
    loadV3(stm) {
        return this.decryptXmlV3(stm).then((xmlStr) => {
            this.kdbx.xml = XmlUtils.parse(xmlStr);
            return this.setProtectedValues().then(() => {
                return this.kdbx.loadFromXml(this.ctx).then(() => {
                    return this.checkHeaderHashV3(stm).then(() => {
                        this.kdbx.xml = undefined;
                        return this.kdbx;
                    });
                });
            });
        });
    }
    loadV4(stm) {
        return this.getHeaderHash(stm).then((headerSha) => {
            const expectedHeaderSha = stm.readBytes(headerSha.byteLength);
            if (!byte_utils_1.arrayBufferEquals(expectedHeaderSha, headerSha)) {
                throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'header hash mismatch');
            }
            return this.computeKeysV4().then((keys) => {
                return this.getHeaderHmac(stm, keys.hmacKey).then((headerHmac) => {
                    const expectedHeaderHmac = stm.readBytes(headerHmac.byteLength);
                    if (!byte_utils_1.arrayBufferEquals(expectedHeaderHmac, headerHmac)) {
                        throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidKey);
                    }
                    return HmacBlockTransform.decrypt(stm.readBytesToEnd(), keys.hmacKey).then((data) => {
                        byte_utils_1.zeroBuffer(keys.hmacKey);
                        return this.decryptData(data, keys.cipherKey).then((data) => {
                            byte_utils_1.zeroBuffer(keys.cipherKey);
                            if (this.kdbx.header.compression === consts_1.CompressionAlgorithm.GZip) {
                                data = byte_utils_1.arrayToBuffer(pako.ungzip(new Uint8Array(data)));
                            }
                            stm = new binary_stream_1.BinaryStream(byte_utils_1.arrayToBuffer(data));
                            this.kdbx.header.readInnerHeader(stm, this.ctx);
                            data = stm.readBytesToEnd();
                            const xmlStr = byte_utils_1.bytesToString(data);
                            this.kdbx.xml = XmlUtils.parse(xmlStr);
                            return this.setProtectedValues().then(() => {
                                return this.kdbx.loadFromXml(this.ctx).then((kdbx) => {
                                    kdbx.xml = undefined;
                                    return kdbx;
                                });
                            });
                        });
                    });
                });
            });
        });
    }
    loadXml(xmlStr) {
        return this.kdbx.credentials.ready.then(() => {
            this.kdbx.header = kdbx_header_1.KdbxHeader.create();
            this.kdbx.xml = XmlUtils.parse(xmlStr);
            XmlUtils.protectPlainValues(this.kdbx.xml.documentElement);
            return this.kdbx.loadFromXml(this.ctx).then(() => {
                this.kdbx.xml = undefined;
                return this.kdbx;
            });
        });
    }
    save() {
        return this.kdbx.credentials.ready.then(() => {
            const stm = new binary_stream_1.BinaryStream();
            this.kdbx.header.generateSalts();
            this.kdbx.header.write(stm);
            if (this.kdbx.versionMajor === 3) {
                return this.saveV3(stm);
            }
            else if (this.kdbx.versionMajor === 4) {
                return this.saveV4(stm);
            }
            else {
                throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidVersion, `bad version: ${this.kdbx.versionMajor}`);
            }
        });
    }
    saveV3(stm) {
        return this.getHeaderHash(stm).then((headerHash) => {
            this.kdbx.meta.headerHash = headerHash;
            this.kdbx.buildXml(this.ctx);
            return this.getProtectSaltGenerator().then((gen) => {
                if (!this.kdbx.xml) {
                    throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'no xml');
                }
                XmlUtils.updateProtectedValuesSalt(this.kdbx.xml.documentElement, gen);
                return this.encryptXmlV3().then((data) => {
                    this.kdbx.xml = undefined;
                    stm.writeBytes(data);
                    return stm.getWrittenBytes();
                });
            });
        });
    }
    saveV4(stm) {
        this.kdbx.buildXml(this.ctx);
        return this.getHeaderHash(stm).then((headerSha) => {
            stm.writeBytes(headerSha);
            return this.computeKeysV4().then((keys) => {
                return this.getHeaderHmac(stm, keys.hmacKey).then((headerHmac) => {
                    stm.writeBytes(headerHmac);
                    return this.getProtectSaltGenerator().then((gen) => {
                        if (!this.kdbx.xml) {
                            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'no xml');
                        }
                        XmlUtils.updateProtectedValuesSalt(this.kdbx.xml.documentElement, gen);
                        const xml = XmlUtils.serialize(this.kdbx.xml);
                        const innerHeaderStm = new binary_stream_1.BinaryStream();
                        this.kdbx.header.writeInnerHeader(innerHeaderStm, this.ctx);
                        const innerHeaderData = innerHeaderStm.getWrittenBytes();
                        const xmlData = byte_utils_1.arrayToBuffer(byte_utils_1.stringToBytes(xml));
                        let data = new ArrayBuffer(innerHeaderData.byteLength + xmlData.byteLength);
                        const dataArr = new Uint8Array(data);
                        dataArr.set(new Uint8Array(innerHeaderData));
                        dataArr.set(new Uint8Array(xmlData), innerHeaderData.byteLength);
                        byte_utils_1.zeroBuffer(xmlData);
                        byte_utils_1.zeroBuffer(innerHeaderData);
                        if (this.kdbx.header.compression === consts_1.CompressionAlgorithm.GZip) {
                            data = byte_utils_1.arrayToBuffer(pako.gzip(new Uint8Array(data)));
                        }
                        return this.encryptData(byte_utils_1.arrayToBuffer(data), keys.cipherKey).then((data) => {
                            byte_utils_1.zeroBuffer(keys.cipherKey);
                            return HmacBlockTransform.encrypt(data, keys.hmacKey).then((data) => {
                                this.kdbx.xml = undefined;
                                byte_utils_1.zeroBuffer(keys.hmacKey);
                                stm.writeBytes(data);
                                return stm.getWrittenBytes();
                            });
                        });
                    });
                });
            });
        });
    }
    saveXml(prettyPrint = false) {
        return this.kdbx.credentials.ready.then(() => {
            this.kdbx.header.generateSalts();
            this.ctx.exportXml = true;
            this.kdbx.buildXml(this.ctx);
            if (!this.kdbx.xml) {
                throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'no xml');
            }
            XmlUtils.unprotectValues(this.kdbx.xml.documentElement);
            const xml = XmlUtils.serialize(this.kdbx.xml, prettyPrint);
            XmlUtils.protectUnprotectedValues(this.kdbx.xml.documentElement);
            this.kdbx.xml = undefined;
            return xml;
        });
    }
    decryptXmlV3(stm) {
        const data = stm.readBytesToEnd();
        return this.getMasterKeyV3().then((masterKey) => {
            return this.decryptData(data, masterKey).then((data) => {
                byte_utils_1.zeroBuffer(masterKey);
                data = this.trimStartBytesV3(data);
                return HashedBlockTransform.decrypt(data).then((data) => {
                    if (this.kdbx.header.compression === consts_1.CompressionAlgorithm.GZip) {
                        data = byte_utils_1.arrayToBuffer(pako.ungzip(new Uint8Array(data)));
                    }
                    return byte_utils_1.bytesToString(data);
                });
            });
        });
    }
    encryptXmlV3() {
        if (!this.kdbx.xml) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'no xml');
        }
        const xml = XmlUtils.serialize(this.kdbx.xml);
        let data = byte_utils_1.arrayToBuffer(byte_utils_1.stringToBytes(xml));
        if (this.kdbx.header.compression === consts_1.CompressionAlgorithm.GZip) {
            data = byte_utils_1.arrayToBuffer(pako.gzip(new Uint8Array(data)));
        }
        return HashedBlockTransform.encrypt(byte_utils_1.arrayToBuffer(data)).then((data) => {
            if (!this.kdbx.header.streamStartBytes) {
                throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'no header start bytes');
            }
            const ssb = new Uint8Array(this.kdbx.header.streamStartBytes);
            const newData = new Uint8Array(data.byteLength + ssb.length);
            newData.set(ssb);
            newData.set(new Uint8Array(data), ssb.length);
            data = newData;
            return this.getMasterKeyV3().then((masterKey) => {
                return this.encryptData(byte_utils_1.arrayToBuffer(data), masterKey).then((data) => {
                    byte_utils_1.zeroBuffer(masterKey);
                    return data;
                });
            });
        });
    }
    getMasterKeyV3() {
        return this.kdbx.credentials.getHash().then((credHash) => {
            if (!this.kdbx.header.transformSeed ||
                !this.kdbx.header.keyEncryptionRounds ||
                !this.kdbx.header.masterSeed) {
                throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'no header transform parameters');
            }
            const transformSeed = this.kdbx.header.transformSeed;
            const transformRounds = this.kdbx.header.keyEncryptionRounds;
            const masterSeed = this.kdbx.header.masterSeed;
            return this.kdbx.credentials.getChallengeResponse(masterSeed).then((chalResp) => {
                return KeyEncryptorAes.encrypt(new Uint8Array(credHash), transformSeed, transformRounds).then((encKey) => {
                    byte_utils_1.zeroBuffer(credHash);
                    return CryptoEngine.sha256(encKey).then((keyHash) => {
                        byte_utils_1.zeroBuffer(encKey);
                        const chalRespLength = chalResp ? chalResp.byteLength : 0;
                        const all = new Uint8Array(masterSeed.byteLength + keyHash.byteLength + chalRespLength);
                        all.set(new Uint8Array(masterSeed), 0);
                        if (chalResp) {
                            all.set(new Uint8Array(chalResp), masterSeed.byteLength);
                        }
                        all.set(new Uint8Array(keyHash), masterSeed.byteLength + chalRespLength);
                        byte_utils_1.zeroBuffer(keyHash);
                        byte_utils_1.zeroBuffer(masterSeed);
                        if (chalResp) {
                            byte_utils_1.zeroBuffer(chalResp);
                        }
                        return CryptoEngine.sha256(all.buffer).then((masterKey) => {
                            byte_utils_1.zeroBuffer(all.buffer);
                            return masterKey;
                        });
                    });
                });
            });
        });
    }
    trimStartBytesV3(data) {
        if (!this.kdbx.header.streamStartBytes) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'no stream start bytes');
        }
        const ssb = this.kdbx.header.streamStartBytes;
        if (data.byteLength < ssb.byteLength) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'short start bytes');
        }
        if (!byte_utils_1.arrayBufferEquals(data.slice(0, this.kdbx.header.streamStartBytes.byteLength), ssb)) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidKey);
        }
        return data.slice(ssb.byteLength);
    }
    setProtectedValues() {
        return this.getProtectSaltGenerator().then((gen) => {
            if (!this.kdbx.xml) {
                throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'no xml');
            }
            XmlUtils.setProtectedValues(this.kdbx.xml.documentElement, gen);
        });
    }
    getProtectSaltGenerator() {
        if (!this.kdbx.header.protectedStreamKey || !this.kdbx.header.crsAlgorithm) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'bad header parameters');
        }
        return protect_salt_generator_1.ProtectSaltGenerator.create(this.kdbx.header.protectedStreamKey, this.kdbx.header.crsAlgorithm);
    }
    getHeaderHash(stm) {
        if (!this.kdbx.header.endPos) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'no end pos');
        }
        const src = stm.readBytesNoAdvance(0, this.kdbx.header.endPos);
        return CryptoEngine.sha256(src);
    }
    getHeaderHmac(stm, key) {
        if (!this.kdbx.header.endPos) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'no end pos');
        }
        const src = stm.readBytesNoAdvance(0, this.kdbx.header.endPos);
        return HmacBlockTransform.getHmacKey(key, new int64_1.Int64(0xffffffff, 0xffffffff)).then((keySha) => {
            return CryptoEngine.hmacSha256(keySha, src);
        });
    }
    checkHeaderHashV3(stm) {
        if (this.kdbx.meta.headerHash) {
            const metaHash = this.kdbx.meta.headerHash;
            return this.getHeaderHash(stm).then((actualHash) => {
                if (!byte_utils_1.arrayBufferEquals(metaHash, actualHash)) {
                    throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'header hash mismatch');
                }
            });
        }
        else {
            return Promise.resolve();
        }
    }
    computeKeysV4() {
        const masterSeed = this.kdbx.header.masterSeed;
        if (!masterSeed || masterSeed.byteLength !== 32) {
            return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'bad master seed'));
        }
        const kdfParams = this.kdbx.header.kdfParameters;
        if (!kdfParams) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'no kdf params');
        }
        const kdfSalt = kdfParams.get('S');
        if (!(kdfSalt instanceof ArrayBuffer)) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'no salt');
        }
        return this.kdbx.credentials.getHash(kdfSalt).then((credHash) => {
            return KeyEncryptorKdf.encrypt(credHash, kdfParams).then((encKey) => {
                byte_utils_1.zeroBuffer(credHash);
                if (!encKey || encKey.byteLength !== 32) {
                    return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.Unsupported, 'bad derived key'));
                }
                const keyWithSeed = new Uint8Array(65);
                keyWithSeed.set(new Uint8Array(masterSeed), 0);
                keyWithSeed.set(new Uint8Array(encKey), masterSeed.byteLength);
                keyWithSeed[64] = 1;
                byte_utils_1.zeroBuffer(encKey);
                byte_utils_1.zeroBuffer(masterSeed);
                return Promise.all([
                    CryptoEngine.sha256(keyWithSeed.buffer.slice(0, 64)),
                    CryptoEngine.sha512(keyWithSeed.buffer)
                ]).then((keys) => {
                    byte_utils_1.zeroBuffer(keyWithSeed);
                    return { cipherKey: keys[0], hmacKey: keys[1] };
                });
            });
        });
    }
    decryptData(data, cipherKey) {
        const cipherId = this.kdbx.header.dataCipherUuid;
        if (!cipherId) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'no cipher id');
        }
        switch (cipherId.toString()) {
            case consts_1.CipherId.Aes:
                return this.transformDataV4Aes(data, cipherKey, false);
            case consts_1.CipherId.ChaCha20:
                return this.transformDataV4ChaCha20(data, cipherKey);
            default:
                return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.Unsupported, 'unsupported cipher'));
        }
    }
    encryptData(data, cipherKey) {
        const cipherId = this.kdbx.header.dataCipherUuid;
        if (!cipherId) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'no cipher id');
        }
        switch (cipherId.toString()) {
            case consts_1.CipherId.Aes:
                return this.transformDataV4Aes(data, cipherKey, true);
            case consts_1.CipherId.ChaCha20:
                return this.transformDataV4ChaCha20(data, cipherKey);
            default:
                return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.Unsupported, 'unsupported cipher'));
        }
    }
    transformDataV4Aes(data, cipherKey, encrypt) {
        const aesCbc = CryptoEngine.createAesCbc();
        const iv = this.kdbx.header.encryptionIV;
        if (!iv) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'no encryption IV');
        }
        return aesCbc.importKey(cipherKey).then(() => {
            return encrypt ? aesCbc.encrypt(data, iv) : aesCbc.decrypt(data, iv);
        });
    }
    transformDataV4ChaCha20(data, cipherKey) {
        const iv = this.kdbx.header.encryptionIV;
        if (!iv) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'no encryption IV');
        }
        return CryptoEngine.chacha20(data, cipherKey, iv);
    }
}
exports.KdbxFormat = KdbxFormat;


/***/ }),

/***/ "./format/kdbx-group.ts":
/*!******************************!*\
  !*** ./format/kdbx-group.ts ***!
  \******************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.KdbxGroup = void 0;
const XmlNames = __webpack_require__(/*! ./../defs/xml-names */ "./defs/xml-names.ts");
const XmlUtils = __webpack_require__(/*! ./../utils/xml-utils */ "./utils/xml-utils.ts");
const kdbx_times_1 = __webpack_require__(/*! ./kdbx-times */ "./format/kdbx-times.ts");
const kdbx_uuid_1 = __webpack_require__(/*! ./kdbx-uuid */ "./format/kdbx-uuid.ts");
const kdbx_entry_1 = __webpack_require__(/*! ./kdbx-entry */ "./format/kdbx-entry.ts");
const kdbx_custom_data_1 = __webpack_require__(/*! ./kdbx-custom-data */ "./format/kdbx-custom-data.ts");
const consts_1 = __webpack_require__(/*! ../defs/consts */ "./defs/consts.ts");
class KdbxGroup {
    constructor() {
        this.uuid = new kdbx_uuid_1.KdbxUuid();
        this.times = new kdbx_times_1.KdbxTimes();
        this.groups = [];
        this.entries = [];
    }
    get lastModTime() {
        var _a, _b;
        return (_b = (_a = this.times.lastModTime) === null || _a === void 0 ? void 0 : _a.getTime()) !== null && _b !== void 0 ? _b : 0;
    }
    get locationChanged() {
        var _a, _b;
        return (_b = (_a = this.times.locationChanged) === null || _a === void 0 ? void 0 : _a.getTime()) !== null && _b !== void 0 ? _b : 0;
    }
    readNode(node, ctx) {
        var _a, _b;
        switch (node.tagName) {
            case XmlNames.Elem.Uuid:
                this.uuid = (_a = XmlUtils.getUuid(node)) !== null && _a !== void 0 ? _a : new kdbx_uuid_1.KdbxUuid();
                break;
            case XmlNames.Elem.Name:
                this.name = XmlUtils.getText(node);
                break;
            case XmlNames.Elem.Notes:
                this.notes = XmlUtils.getText(node);
                break;
            case XmlNames.Elem.Icon:
                this.icon = XmlUtils.getNumber(node);
                break;
            case XmlNames.Elem.CustomIconID:
                this.customIcon = XmlUtils.getUuid(node);
                break;
            case XmlNames.Elem.Times:
                this.times = kdbx_times_1.KdbxTimes.read(node);
                break;
            case XmlNames.Elem.IsExpanded:
                this.expanded = (_b = XmlUtils.getBoolean(node)) !== null && _b !== void 0 ? _b : undefined;
                break;
            case XmlNames.Elem.GroupDefaultAutoTypeSeq:
                this.defaultAutoTypeSeq = XmlUtils.getText(node);
                break;
            case XmlNames.Elem.EnableAutoType:
                this.enableAutoType = XmlUtils.getBoolean(node);
                break;
            case XmlNames.Elem.EnableSearching:
                this.enableSearching = XmlUtils.getBoolean(node);
                break;
            case XmlNames.Elem.LastTopVisibleEntry:
                this.lastTopVisibleEntry = XmlUtils.getUuid(node);
                break;
            case XmlNames.Elem.Group:
                this.groups.push(KdbxGroup.read(node, ctx, this));
                break;
            case XmlNames.Elem.Entry:
                this.entries.push(kdbx_entry_1.KdbxEntry.read(node, ctx, this));
                break;
            case XmlNames.Elem.CustomData:
                this.customData = kdbx_custom_data_1.KdbxCustomData.read(node);
                break;
        }
    }
    write(parentNode, ctx) {
        const node = XmlUtils.addChildNode(parentNode, XmlNames.Elem.Group);
        XmlUtils.setUuid(XmlUtils.addChildNode(node, XmlNames.Elem.Uuid), this.uuid);
        XmlUtils.setText(XmlUtils.addChildNode(node, XmlNames.Elem.Name), this.name);
        XmlUtils.setText(XmlUtils.addChildNode(node, XmlNames.Elem.Notes), this.notes);
        XmlUtils.setNumber(XmlUtils.addChildNode(node, XmlNames.Elem.Icon), this.icon);
        if (this.customIcon) {
            XmlUtils.setUuid(XmlUtils.addChildNode(node, XmlNames.Elem.CustomIconID), this.customIcon);
        }
        if (this.customData) {
            kdbx_custom_data_1.KdbxCustomData.write(node, this.customData);
        }
        this.times.write(node, ctx);
        XmlUtils.setBoolean(XmlUtils.addChildNode(node, XmlNames.Elem.IsExpanded), this.expanded);
        XmlUtils.setText(XmlUtils.addChildNode(node, XmlNames.Elem.GroupDefaultAutoTypeSeq), this.defaultAutoTypeSeq);
        XmlUtils.setBoolean(XmlUtils.addChildNode(node, XmlNames.Elem.EnableAutoType), this.enableAutoType);
        XmlUtils.setBoolean(XmlUtils.addChildNode(node, XmlNames.Elem.EnableSearching), this.enableSearching);
        XmlUtils.setUuid(XmlUtils.addChildNode(node, XmlNames.Elem.LastTopVisibleEntry), this.lastTopVisibleEntry);
        for (const group of this.groups) {
            group.write(node, ctx);
        }
        for (const entry of this.entries) {
            entry.write(node, ctx);
        }
    }
    *allGroups() {
        yield this;
        for (const group of this.groups) {
            for (const g of group.allGroups()) {
                yield g;
            }
        }
    }
    *allEntries() {
        for (const group of this.allGroups()) {
            for (const entry of group.entries) {
                yield entry;
            }
        }
    }
    *allGroupsAndEntries() {
        yield this;
        for (const entry of this.entries) {
            yield entry;
        }
        for (const group of this.groups) {
            for (const item of group.allGroupsAndEntries()) {
                yield item;
            }
        }
    }
    merge(objectMap) {
        const remoteGroup = objectMap.remoteGroups.get(this.uuid.id);
        if (!remoteGroup) {
            return;
        }
        if (remoteGroup.lastModTime > this.lastModTime) {
            this.copyFrom(remoteGroup);
        }
        this.groups = this.mergeCollection(this.groups, remoteGroup.groups, objectMap.groups, objectMap.remoteGroups, objectMap.deleted);
        this.entries = this.mergeCollection(this.entries, remoteGroup.entries, objectMap.entries, objectMap.remoteEntries, objectMap.deleted);
        for (const group of this.groups) {
            group.merge(objectMap);
        }
        for (const entry of this.entries) {
            entry.merge(objectMap);
        }
    }
    /**
     * Merge object collection with remote collection
     * Implements 2P-set CRDT with tombstones stored in objectMap.deleted
     * Assumes tombstones are already merged
     */
    mergeCollection(collection, remoteCollection, objectMapItems, remoteObjectMapItems, deletedObjects) {
        const newItems = [];
        for (const item of collection) {
            if (!item.uuid || deletedObjects.has(item.uuid.id)) {
                continue; // item deleted
            }
            const remoteItem = remoteObjectMapItems.get(item.uuid.id);
            if (!remoteItem) {
                newItems.push(item); // item added locally
            }
            else if (remoteItem.locationChanged <= item.locationChanged) {
                newItems.push(item); // item not changed or moved to this group locally later than remote
            }
        }
        let ix = -1;
        for (const remoteItem of remoteCollection) {
            ix++;
            if (!remoteItem.uuid || deletedObjects.has(remoteItem.uuid.id)) {
                continue; // item already processed as local item or deleted
            }
            const item = objectMapItems.get(remoteItem.uuid.id);
            if (item && remoteItem.locationChanged > item.locationChanged) {
                item.parentGroup = this; // item moved to this group remotely later than local
                newItems.splice(KdbxGroup.findInsertIx(newItems, remoteCollection, ix), 0, item);
            }
            else if (!item) {
                // item created remotely
                let newItem;
                if (remoteItem instanceof KdbxGroup) {
                    const group = new KdbxGroup();
                    group.copyFrom(remoteItem);
                    newItem = group;
                }
                else {
                    const entry = new kdbx_entry_1.KdbxEntry();
                    entry.copyFrom(remoteItem);
                    newItem = entry;
                }
                newItem.parentGroup = this;
                newItems.splice(KdbxGroup.findInsertIx(newItems, remoteCollection, ix), 0, newItem);
            }
        }
        return newItems;
    }
    /**
     * Finds a best place to insert new item into collection
     */
    static findInsertIx(dst, src, srcIx) {
        let selectedIx = dst.length, selectedScore = -1;
        for (let dstIx = 0; dstIx <= dst.length; dstIx++) {
            let score = 0;
            const srcPrev = srcIx > 0 ? src[srcIx - 1].uuid.id : undefined, srcNext = srcIx + 1 < src.length ? src[srcIx + 1].uuid.id : undefined, dstPrev = dstIx > 0 ? dst[dstIx - 1].uuid.id : undefined, dstNext = dstIx < dst.length ? dst[dstIx].uuid.id : undefined;
            if (!srcPrev && !dstPrev) {
                score += 1; // start of sequence
            }
            else if (srcPrev === dstPrev) {
                score += 5; // previous element equals
            }
            if (!srcNext && !dstNext) {
                score += 2; // end of sequence
            }
            else if (srcNext === dstNext) {
                score += 5; // next element equals
            }
            if (score > selectedScore) {
                selectedIx = dstIx;
                selectedScore = score;
            }
        }
        return selectedIx;
    }
    copyFrom(group) {
        this.uuid = group.uuid;
        this.name = group.name;
        this.notes = group.notes;
        this.icon = group.icon;
        this.customIcon = group.customIcon;
        this.times = group.times.clone();
        this.expanded = group.expanded;
        this.defaultAutoTypeSeq = group.defaultAutoTypeSeq;
        this.enableAutoType = group.enableAutoType;
        this.enableSearching = group.enableSearching;
        this.lastTopVisibleEntry = group.lastTopVisibleEntry;
    }
    static create(name, parentGroup) {
        const group = new KdbxGroup();
        group.uuid = kdbx_uuid_1.KdbxUuid.random();
        group.icon = consts_1.Icons.Folder;
        group.times = kdbx_times_1.KdbxTimes.create();
        group.name = name;
        group.parentGroup = parentGroup;
        group.expanded = true;
        group.enableAutoType = null;
        group.enableSearching = null;
        group.lastTopVisibleEntry = new kdbx_uuid_1.KdbxUuid();
        return group;
    }
    static read(xmlNode, ctx, parentGroup) {
        const grp = new KdbxGroup();
        for (let i = 0, cn = xmlNode.childNodes, len = cn.length; i < len; i++) {
            const childNode = cn[i];
            if (childNode.tagName) {
                grp.readNode(childNode, ctx);
            }
        }
        if (grp.uuid.empty) {
            // some clients don't write ids
            grp.uuid = kdbx_uuid_1.KdbxUuid.random();
        }
        grp.parentGroup = parentGroup;
        return grp;
    }
}
exports.KdbxGroup = KdbxGroup;


/***/ }),

/***/ "./format/kdbx-header.ts":
/*!*******************************!*\
  !*** ./format/kdbx-header.ts ***!
  \*******************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


/* Docs for the KDBX header schema:
 * https://keepass.info/help/kb/kdbx_4.html#innerhdr
 */
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.KdbxHeader = void 0;
const consts_1 = __webpack_require__(/*! ../defs/consts */ "./defs/consts.ts");
const kdbx_uuid_1 = __webpack_require__(/*! ./kdbx-uuid */ "./format/kdbx-uuid.ts");
const var_dictionary_1 = __webpack_require__(/*! ../utils/var-dictionary */ "./utils/var-dictionary.ts");
const binary_stream_1 = __webpack_require__(/*! ../utils/binary-stream */ "./utils/binary-stream.ts");
const kdbx_error_1 = __webpack_require__(/*! ../errors/kdbx-error */ "./errors/kdbx-error.ts");
const byte_utils_1 = __webpack_require__(/*! ../utils/byte-utils */ "./utils/byte-utils.ts");
const CryptoEngine = __webpack_require__(/*! ../crypto/crypto-engine */ "./crypto/crypto-engine.ts");
const int64_1 = __webpack_require__(/*! ../utils/int64 */ "./utils/int64.ts");
const protected_value_1 = __webpack_require__(/*! ../crypto/protected-value */ "./crypto/protected-value.ts");
const HeaderFields = [
    { name: 'EndOfHeader' },
    { name: 'Comment' },
    { name: 'CipherID' },
    { name: 'CompressionFlags' },
    { name: 'MasterSeed' },
    { name: 'TransformSeed', ver: [3] },
    { name: 'TransformRounds', ver: [3] },
    { name: 'EncryptionIV' },
    { name: 'ProtectedStreamKey', ver: [3] },
    { name: 'StreamStartBytes', ver: [3] },
    { name: 'InnerRandomStreamID', ver: [3] },
    { name: 'KdfParameters', ver: [4] },
    { name: 'PublicCustomData', ver: [4] }
];
const InnerHeaderFields = [
    { name: 'EndOfHeader' },
    { name: 'InnerRandomStreamID' },
    { name: 'InnerRandomStreamKey' },
    { name: 'Binary', skipHeader: true }
];
const HeaderConst = {
    DefaultFileVersionMajor: 4,
    DefaultFileVersionMinor: 0,
    MaxFileVersionMajor: 4,
    MaxFileVersionMinor: 1,
    MaxSupportedVersion: 4,
    FlagBinaryProtected: 0x01,
    InnerHeaderBinaryFieldId: 0x03,
    DefaultKdfAlgo: consts_1.KdfId.Argon2d,
    DefaultKdfSaltLength: 32,
    DefaultKdfParallelism: 1,
    DefaultKdfIterations: 2,
    DefaultKdfMemory: 1024 * 1024,
    DefaultKdfVersion: 0x13,
    EndOfHeader: 0x0d0ad0a
};
const LastMinorVersions = {
    3: 1,
    4: 0
};
class KdbxHeader {
    constructor() {
        this.versionMajor = 0;
        this.versionMinor = 0;
    }
    readSignature(stm) {
        if (stm.byteLength < 8) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'not enough data');
        }
        const sig1 = stm.getUint32(true), sig2 = stm.getUint32(true);
        if (!(sig1 === consts_1.Signatures.FileMagic && sig2 === consts_1.Signatures.Sig2Kdbx)) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.BadSignature);
        }
    }
    writeSignature(stm) {
        stm.setUint32(consts_1.Signatures.FileMagic, true);
        stm.setUint32(consts_1.Signatures.Sig2Kdbx, true);
    }
    readVersion(stm) {
        const versionMinor = stm.getUint16(true);
        const versionMajor = stm.getUint16(true);
        if (versionMajor > HeaderConst.MaxSupportedVersion) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidVersion);
        }
        this.versionMinor = versionMinor;
        this.versionMajor = versionMajor;
    }
    writeVersion(stm) {
        if (!this.versionMajor) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'version is not set');
        }
        stm.setUint16(this.versionMinor, true);
        stm.setUint16(this.versionMajor, true);
    }
    readCipherID(bytes) {
        if (bytes.byteLength !== 16) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.Unsupported, 'cipher');
        }
        this.dataCipherUuid = new kdbx_uuid_1.KdbxUuid(bytes);
    }
    writeCipherID(stm) {
        if (!this.dataCipherUuid) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'cipher id is not set');
        }
        this.writeFieldSize(stm, 16);
        stm.writeBytes(this.dataCipherUuid.bytes);
    }
    readCompressionFlags(bytes) {
        const id = new DataView(bytes).getUint32(0, true);
        if (id < 0 || id >= Object.keys(consts_1.CompressionAlgorithm).length) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.Unsupported, 'compression');
        }
        this.compression = id;
    }
    writeCompressionFlags(stm) {
        if (!this.compression) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'compression is not set');
        }
        this.writeFieldSize(stm, 4);
        stm.setUint32(this.compression, true);
    }
    readMasterSeed(bytes) {
        this.masterSeed = bytes;
    }
    writeMasterSeed(stm) {
        if (!this.masterSeed) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'master seed is not set');
        }
        this.writeFieldBytes(stm, this.masterSeed);
    }
    readTransformSeed(bytes) {
        this.transformSeed = bytes;
    }
    writeTransformSeed(stm) {
        if (!this.transformSeed) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'transform seed is not set');
        }
        this.writeFieldBytes(stm, this.transformSeed);
    }
    readTransformRounds(bytes) {
        this.keyEncryptionRounds = new binary_stream_1.BinaryStream(bytes).getUint64(true);
    }
    writeTransformRounds(stm) {
        if (!this.keyEncryptionRounds) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'key encryption rounds is not set');
        }
        this.writeFieldSize(stm, 8);
        stm.setUint64(this.keyEncryptionRounds, true);
    }
    readEncryptionIV(bytes) {
        this.encryptionIV = bytes;
    }
    writeEncryptionIV(stm) {
        if (!this.encryptionIV) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'encryption IV is not set');
        }
        this.writeFieldBytes(stm, this.encryptionIV);
    }
    readProtectedStreamKey(bytes) {
        this.protectedStreamKey = bytes;
    }
    writeProtectedStreamKey(stm) {
        if (!this.protectedStreamKey) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'protected stream key is not set');
        }
        this.writeFieldBytes(stm, this.protectedStreamKey);
    }
    readStreamStartBytes(bytes) {
        this.streamStartBytes = bytes;
    }
    writeStreamStartBytes(stm) {
        if (!this.streamStartBytes) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'stream start bytes is not set');
        }
        this.writeFieldBytes(stm, this.streamStartBytes);
    }
    readInnerRandomStreamID(bytes) {
        this.crsAlgorithm = new DataView(bytes).getUint32(0, true);
    }
    writeInnerRandomStreamID(stm) {
        if (!this.crsAlgorithm) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'CRSAlgorithm is not set');
        }
        this.writeFieldSize(stm, 4);
        stm.setUint32(this.crsAlgorithm, true);
    }
    readInnerRandomStreamKey(bytes) {
        this.protectedStreamKey = bytes;
    }
    writeInnerRandomStreamKey(stm) {
        if (!this.protectedStreamKey) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'protected stream key is not set');
        }
        this.writeFieldBytes(stm, this.protectedStreamKey);
    }
    readKdfParameters(bytes) {
        this.kdfParameters = var_dictionary_1.VarDictionary.read(new binary_stream_1.BinaryStream(bytes));
    }
    writeKdfParameters(stm) {
        if (!this.kdfParameters) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'KDF parameters are not set');
        }
        const innerStream = new binary_stream_1.BinaryStream();
        this.kdfParameters.write(innerStream);
        this.writeFieldBytes(stm, innerStream.getWrittenBytes());
    }
    readPublicCustomData(bytes) {
        this.publicCustomData = var_dictionary_1.VarDictionary.read(new binary_stream_1.BinaryStream(bytes));
    }
    hasPublicCustomData() {
        return !!this.publicCustomData;
    }
    writePublicCustomData(stm) {
        if (this.publicCustomData) {
            const innerStream = new binary_stream_1.BinaryStream();
            this.publicCustomData.write(innerStream);
            this.writeFieldBytes(stm, innerStream.getWrittenBytes());
        }
    }
    readBinary(bytes, ctx) {
        const view = new DataView(bytes);
        const flags = view.getUint8(0);
        const isProtected = flags & HeaderConst.FlagBinaryProtected;
        const binaryData = bytes.slice(1); // Actual data comes after the flag byte
        const binary = isProtected ? protected_value_1.ProtectedValue.fromBinary(binaryData) : binaryData;
        ctx.kdbx.binaries.addWithNextId(binary);
    }
    writeBinary(stm, ctx) {
        if (this.versionMajor < 4) {
            return;
        }
        const binaries = ctx.kdbx.binaries.getAll();
        for (const binary of binaries) {
            stm.setUint8(HeaderConst.InnerHeaderBinaryFieldId);
            if (binary.value instanceof protected_value_1.ProtectedValue) {
                const binaryData = binary.value.getBinary();
                this.writeFieldSize(stm, binaryData.byteLength + 1);
                stm.setUint8(HeaderConst.FlagBinaryProtected);
                stm.writeBytes(binaryData);
                byte_utils_1.zeroBuffer(binaryData);
            }
            else {
                this.writeFieldSize(stm, binary.value.byteLength + 1);
                stm.setUint8(0);
                stm.writeBytes(binary.value);
            }
        }
    }
    writeEndOfHeader(stm) {
        this.writeFieldSize(stm, 4);
        stm.setUint32(HeaderConst.EndOfHeader, false);
    }
    readField(stm, fields, ctx) {
        const headerId = stm.getUint8();
        const size = this.readFieldSize(stm);
        const bytes = size > 0 ? stm.readBytes(size) : new ArrayBuffer(0);
        const headerField = fields[headerId];
        switch (headerField.name) {
            case 'EndOfHeader':
            case 'Comment':
                break;
            case 'CipherID':
                this.readCipherID(bytes);
                break;
            case 'CompressionFlags':
                this.readCompressionFlags(bytes);
                break;
            case 'MasterSeed':
                this.readMasterSeed(bytes);
                break;
            case 'TransformSeed':
                this.readTransformSeed(bytes);
                break;
            case 'TransformRounds':
                this.readTransformRounds(bytes);
                break;
            case 'EncryptionIV':
                this.readEncryptionIV(bytes);
                break;
            case 'ProtectedStreamKey':
                this.readProtectedStreamKey(bytes);
                break;
            case 'StreamStartBytes':
                this.readStreamStartBytes(bytes);
                break;
            case 'InnerRandomStreamID':
                this.readInnerRandomStreamID(bytes);
                break;
            case 'KdfParameters':
                this.readKdfParameters(bytes);
                break;
            case 'PublicCustomData':
                this.readPublicCustomData(bytes);
                break;
            case 'InnerRandomStreamKey':
                this.readInnerRandomStreamKey(bytes);
                break;
            case 'Binary':
                this.readBinary(bytes, ctx);
                break;
            default:
                throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg, `bad header field: ${headerField.name}`);
        }
        return headerId !== 0;
    }
    writeField(stm, headerId, fields, ctx) {
        const headerField = fields[headerId];
        if (headerField) {
            if (headerField.ver && !headerField.ver.includes(this.versionMajor)) {
                return;
            }
            switch (headerField.name) {
                case 'PublicCustomData':
                    if (!this.hasPublicCustomData()) {
                        return;
                    }
                    break;
                case 'Comment':
                    return;
            }
            if (!headerField.skipHeader) {
                stm.setUint8(headerId);
            }
            switch (headerField.name) {
                case 'EndOfHeader':
                    this.writeEndOfHeader(stm);
                    break;
                case 'CipherID':
                    this.writeCipherID(stm);
                    break;
                case 'CompressionFlags':
                    this.writeCompressionFlags(stm);
                    break;
                case 'MasterSeed':
                    this.writeMasterSeed(stm);
                    break;
                case 'TransformSeed':
                    this.writeTransformSeed(stm);
                    break;
                case 'TransformRounds':
                    this.writeTransformRounds(stm);
                    break;
                case 'EncryptionIV':
                    this.writeEncryptionIV(stm);
                    break;
                case 'ProtectedStreamKey':
                    this.writeProtectedStreamKey(stm);
                    break;
                case 'StreamStartBytes':
                    this.writeStreamStartBytes(stm);
                    break;
                case 'InnerRandomStreamID':
                    this.writeInnerRandomStreamID(stm);
                    break;
                case 'KdfParameters':
                    this.writeKdfParameters(stm);
                    break;
                case 'PublicCustomData':
                    this.writePublicCustomData(stm);
                    break;
                case 'InnerRandomStreamKey':
                    this.writeInnerRandomStreamKey(stm);
                    break;
                case 'Binary':
                    if (!ctx) {
                        throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg, 'context is not set');
                    }
                    this.writeBinary(stm, ctx);
                    break;
                default:
                    throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg, `Bad header field: ${headerField.name}`);
            }
        }
    }
    readFieldSize(stm) {
        return (this.versionMajor | 0) >= 4 ? stm.getUint32(true) : stm.getUint16(true);
    }
    writeFieldSize(stm, size) {
        if ((this.versionMajor | 0) >= 4) {
            stm.setUint32(size, true);
        }
        else {
            stm.setUint16(size, true);
        }
    }
    writeFieldBytes(stm, bytes) {
        this.writeFieldSize(stm, bytes.byteLength);
        stm.writeBytes(bytes);
    }
    validate() {
        if (!this.versionMajor || this.versionMinor === undefined) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'no version in header');
        }
        if (this.dataCipherUuid === undefined) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'no cipher in header');
        }
        if (this.compression === undefined) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'no compression in header');
        }
        if (!this.masterSeed) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'no master seed in header');
        }
        if (this.versionMajor < 4 && !this.transformSeed) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'no transform seed in header');
        }
        if (this.versionMajor < 4 && !this.keyEncryptionRounds) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'no key encryption rounds in header');
        }
        if (!this.encryptionIV) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'no encryption iv in header');
        }
        if (this.versionMajor < 4 && !this.protectedStreamKey) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'no protected stream key in header');
        }
        if (this.versionMajor < 4 && !this.streamStartBytes) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'no stream start bytes in header');
        }
        if (this.versionMajor < 4 && !this.crsAlgorithm) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'no crs algorithm in header');
        }
        if (this.versionMajor >= 4 && !this.kdfParameters) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'no kdf parameters in header');
        }
    }
    validateInner() {
        if (!this.protectedStreamKey) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'no protected stream key in header');
        }
        if (!this.crsAlgorithm) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'no crs algorithm in header');
        }
    }
    createKdfParameters(algo) {
        if (!algo) {
            algo = HeaderConst.DefaultKdfAlgo;
        }
        switch (algo) {
            case consts_1.KdfId.Argon2d:
            case consts_1.KdfId.Argon2id:
                this.kdfParameters = new var_dictionary_1.VarDictionary();
                this.kdfParameters.set('$UUID', var_dictionary_1.ValueType.Bytes, byte_utils_1.base64ToBytes(algo));
                this.kdfParameters.set('S', var_dictionary_1.ValueType.Bytes, CryptoEngine.random(HeaderConst.DefaultKdfSaltLength));
                this.kdfParameters.set('P', var_dictionary_1.ValueType.UInt32, HeaderConst.DefaultKdfParallelism);
                this.kdfParameters.set('I', var_dictionary_1.ValueType.UInt64, new int64_1.Int64(HeaderConst.DefaultKdfIterations));
                this.kdfParameters.set('M', var_dictionary_1.ValueType.UInt64, new int64_1.Int64(HeaderConst.DefaultKdfMemory));
                this.kdfParameters.set('V', var_dictionary_1.ValueType.UInt32, HeaderConst.DefaultKdfVersion);
                break;
            case consts_1.KdfId.Aes:
                this.kdfParameters = new var_dictionary_1.VarDictionary();
                this.kdfParameters.set('$UUID', var_dictionary_1.ValueType.Bytes, byte_utils_1.base64ToBytes(consts_1.KdfId.Aes));
                this.kdfParameters.set('S', var_dictionary_1.ValueType.Bytes, CryptoEngine.random(HeaderConst.DefaultKdfSaltLength));
                this.kdfParameters.set('R', var_dictionary_1.ValueType.UInt64, new int64_1.Int64(consts_1.Defaults.KeyEncryptionRounds));
                break;
            default:
                throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg, 'bad KDF algo');
        }
    }
    write(stm) {
        this.validate();
        this.writeSignature(stm);
        this.writeVersion(stm);
        for (let id = 1; id < HeaderFields.length; id++) {
            this.writeField(stm, id, HeaderFields);
        }
        this.writeField(stm, 0, HeaderFields);
        this.endPos = stm.pos;
    }
    writeInnerHeader(stm, ctx) {
        this.validateInner();
        for (let id = 1; id < InnerHeaderFields.length; id++) {
            this.writeField(stm, id, InnerHeaderFields, ctx);
        }
        this.writeField(stm, 0, InnerHeaderFields, ctx);
    }
    generateSalts() {
        this.masterSeed = CryptoEngine.random(32);
        if (this.versionMajor < 4) {
            this.transformSeed = CryptoEngine.random(32);
            this.streamStartBytes = CryptoEngine.random(32);
            this.protectedStreamKey = CryptoEngine.random(32);
            this.encryptionIV = CryptoEngine.random(16);
        }
        else {
            this.protectedStreamKey = CryptoEngine.random(64);
            if (!this.kdfParameters || !this.dataCipherUuid) {
                throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'no kdf params');
            }
            this.kdfParameters.set('S', var_dictionary_1.ValueType.Bytes, CryptoEngine.random(32));
            const ivLength = this.dataCipherUuid.toString() === consts_1.CipherId.ChaCha20 ? 12 : 16;
            this.encryptionIV = CryptoEngine.random(ivLength);
        }
    }
    setVersion(version) {
        if (version !== 3 && version !== 4) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg, 'bad file version');
        }
        this.versionMajor = version;
        this.versionMinor = LastMinorVersions[version];
        if (this.versionMajor === 4) {
            if (!this.kdfParameters) {
                this.createKdfParameters();
            }
            this.crsAlgorithm = consts_1.CrsAlgorithm.ChaCha20;
            this.keyEncryptionRounds = undefined;
        }
        else {
            this.kdfParameters = undefined;
            this.crsAlgorithm = consts_1.CrsAlgorithm.Salsa20;
            this.keyEncryptionRounds = consts_1.Defaults.KeyEncryptionRounds;
        }
    }
    setKdf(kdf) {
        this.createKdfParameters(kdf);
    }
    static read(stm, ctx) {
        const header = new KdbxHeader();
        header.readSignature(stm);
        header.readVersion(stm);
        while (header.readField(stm, HeaderFields, ctx)) { }
        header.endPos = stm.pos;
        header.validate();
        return header;
    }
    readInnerHeader(stm, ctx) {
        while (this.readField(stm, InnerHeaderFields, ctx)) { }
        this.validateInner();
    }
    static create() {
        const header = new KdbxHeader();
        header.versionMajor = HeaderConst.DefaultFileVersionMajor;
        header.versionMinor = HeaderConst.DefaultFileVersionMinor;
        header.dataCipherUuid = new kdbx_uuid_1.KdbxUuid(consts_1.CipherId.Aes);
        header.compression = consts_1.CompressionAlgorithm.GZip;
        header.crsAlgorithm = consts_1.CrsAlgorithm.ChaCha20;
        header.createKdfParameters();
        return header;
    }
}
exports.KdbxHeader = KdbxHeader;
KdbxHeader.MaxFileVersion = HeaderConst.MaxFileVersionMajor;


/***/ }),

/***/ "./format/kdbx-meta.ts":
/*!*****************************!*\
  !*** ./format/kdbx-meta.ts ***!
  \*****************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.KdbxMeta = void 0;
const kdbx_uuid_1 = __webpack_require__(/*! ./kdbx-uuid */ "./format/kdbx-uuid.ts");
const XmlUtils = __webpack_require__(/*! ../utils/xml-utils */ "./utils/xml-utils.ts");
const XmlNames = __webpack_require__(/*! ../defs/xml-names */ "./defs/xml-names.ts");
const kdbx_custom_data_1 = __webpack_require__(/*! ./kdbx-custom-data */ "./format/kdbx-custom-data.ts");
const kdbx_error_1 = __webpack_require__(/*! ../errors/kdbx-error */ "./errors/kdbx-error.ts");
const consts_1 = __webpack_require__(/*! ../defs/consts */ "./defs/consts.ts");
const kdbx_binaries_1 = __webpack_require__(/*! ./kdbx-binaries */ "./format/kdbx-binaries.ts");
const MetaConst = {
    Generator: 'KdbxWeb'
};
class KdbxMeta {
    constructor() {
        this._memoryProtection = {};
        this.customData = new Map();
        this.customIcons = new Map();
    }
    get editState() {
        return this._editState;
    }
    set editState(value) {
        this._editState = value;
    }
    getOrCreateEditState() {
        if (!this._editState) {
            this._editState = {};
        }
        return this._editState;
    }
    get name() {
        return this._name;
    }
    set name(value) {
        if (value !== this._name) {
            this._name = value;
            this.nameChanged = new Date();
        }
    }
    get desc() {
        return this._desc;
    }
    set desc(value) {
        if (value !== this._desc) {
            this._desc = value;
            this.descChanged = new Date();
        }
    }
    get defaultUser() {
        return this._defaultUser;
    }
    set defaultUser(value) {
        if (value !== this._defaultUser) {
            this._defaultUser = value;
            this.defaultUserChanged = new Date();
        }
    }
    get mntncHistoryDays() {
        return this._mntncHistoryDays;
    }
    set mntncHistoryDays(value) {
        if (value !== this._mntncHistoryDays) {
            this._mntncHistoryDays = value;
            this.getOrCreateEditState().mntncHistoryDaysChanged = new Date();
        }
    }
    get color() {
        return this._color;
    }
    set color(value) {
        if (value !== this._color) {
            this._color = value;
            this.getOrCreateEditState().colorChanged = new Date();
        }
    }
    get keyChangeRec() {
        return this._keyChangeRec;
    }
    set keyChangeRec(value) {
        if (value !== this._keyChangeRec) {
            this._keyChangeRec = value;
            this.getOrCreateEditState().keyChangeRecChanged = new Date();
        }
    }
    get keyChangeForce() {
        return this._keyChangeForce;
    }
    set keyChangeForce(value) {
        if (value !== this._keyChangeForce) {
            this._keyChangeForce = value;
            this.getOrCreateEditState().keyChangeForceChanged = new Date();
        }
    }
    get recycleBinEnabled() {
        return this._recycleBinEnabled;
    }
    set recycleBinEnabled(value) {
        if (value !== this._recycleBinEnabled) {
            this._recycleBinEnabled = value;
            this.recycleBinChanged = new Date();
        }
    }
    get recycleBinUuid() {
        return this._recycleBinUuid;
    }
    set recycleBinUuid(value) {
        if (value !== this._recycleBinUuid) {
            this._recycleBinUuid = value;
            this.recycleBinChanged = new Date();
        }
    }
    get entryTemplatesGroup() {
        return this._entryTemplatesGroup;
    }
    set entryTemplatesGroup(value) {
        if (value !== this._entryTemplatesGroup) {
            this._entryTemplatesGroup = value;
            this.entryTemplatesGroupChanged = new Date();
        }
    }
    get historyMaxItems() {
        return this._historyMaxItems;
    }
    set historyMaxItems(value) {
        if (value !== this._historyMaxItems) {
            this._historyMaxItems = value;
            this.getOrCreateEditState().historyMaxItemsChanged = new Date();
        }
    }
    get historyMaxSize() {
        return this._historyMaxSize;
    }
    set historyMaxSize(value) {
        if (value !== this._historyMaxSize) {
            this._historyMaxSize = value;
            this.getOrCreateEditState().historyMaxSizeChanged = new Date();
        }
    }
    get lastSelectedGroup() {
        return this._lastSelectedGroup;
    }
    set lastSelectedGroup(value) {
        if (value !== this._lastSelectedGroup) {
            this._lastSelectedGroup = value;
            this.getOrCreateEditState().lastSelectedGroupChanged = new Date();
        }
    }
    get lastTopVisibleGroup() {
        return this._lastTopVisibleGroup;
    }
    set lastTopVisibleGroup(value) {
        if (value !== this._lastTopVisibleGroup) {
            this._lastTopVisibleGroup = value;
            this.getOrCreateEditState().lastTopVisibleGroupChanged = new Date();
        }
    }
    get memoryProtection() {
        return this._memoryProtection;
    }
    set memoryProtection(value) {
        if (value !== this._memoryProtection) {
            this._memoryProtection = value;
            this.getOrCreateEditState().memoryProtectionChanged = new Date();
        }
    }
    readNode(node, ctx) {
        var _a;
        switch (node.tagName) {
            case XmlNames.Elem.Generator:
                this.generator = XmlUtils.getText(node);
                break;
            case XmlNames.Elem.HeaderHash:
                this.headerHash = XmlUtils.getBytes(node);
                break;
            case XmlNames.Elem.SettingsChanged:
                this.settingsChanged = XmlUtils.getDate(node);
                break;
            case XmlNames.Elem.DbName:
                this._name = XmlUtils.getText(node);
                break;
            case XmlNames.Elem.DbNameChanged:
                this.nameChanged = XmlUtils.getDate(node);
                break;
            case XmlNames.Elem.DbDesc:
                this._desc = XmlUtils.getText(node);
                break;
            case XmlNames.Elem.DbDescChanged:
                this.descChanged = XmlUtils.getDate(node);
                break;
            case XmlNames.Elem.DbDefaultUser:
                this._defaultUser = XmlUtils.getText(node);
                break;
            case XmlNames.Elem.DbDefaultUserChanged:
                this.defaultUserChanged = XmlUtils.getDate(node);
                break;
            case XmlNames.Elem.DbMntncHistoryDays:
                this._mntncHistoryDays = XmlUtils.getNumber(node);
                break;
            case XmlNames.Elem.DbColor:
                this._color = XmlUtils.getText(node);
                break;
            case XmlNames.Elem.DbKeyChanged:
                this.keyChanged = XmlUtils.getDate(node);
                break;
            case XmlNames.Elem.DbKeyChangeRec:
                this._keyChangeRec = XmlUtils.getNumber(node);
                break;
            case XmlNames.Elem.DbKeyChangeForce:
                this._keyChangeForce = XmlUtils.getNumber(node);
                break;
            case XmlNames.Elem.RecycleBinEnabled:
                this._recycleBinEnabled = (_a = XmlUtils.getBoolean(node)) !== null && _a !== void 0 ? _a : undefined;
                break;
            case XmlNames.Elem.RecycleBinUuid:
                this._recycleBinUuid = XmlUtils.getUuid(node);
                break;
            case XmlNames.Elem.RecycleBinChanged:
                this.recycleBinChanged = XmlUtils.getDate(node);
                break;
            case XmlNames.Elem.EntryTemplatesGroup:
                this._entryTemplatesGroup = XmlUtils.getUuid(node);
                break;
            case XmlNames.Elem.EntryTemplatesGroupChanged:
                this.entryTemplatesGroupChanged = XmlUtils.getDate(node);
                break;
            case XmlNames.Elem.HistoryMaxItems:
                this._historyMaxItems = XmlUtils.getNumber(node);
                break;
            case XmlNames.Elem.HistoryMaxSize:
                this._historyMaxSize = XmlUtils.getNumber(node);
                break;
            case XmlNames.Elem.LastSelectedGroup:
                this._lastSelectedGroup = XmlUtils.getUuid(node);
                break;
            case XmlNames.Elem.LastTopVisibleGroup:
                this._lastTopVisibleGroup = XmlUtils.getUuid(node);
                break;
            case XmlNames.Elem.MemoryProt:
                this.readMemoryProtection(node);
                break;
            case XmlNames.Elem.CustomIcons:
                this.readCustomIcons(node);
                break;
            case XmlNames.Elem.Binaries:
                this.readBinaries(node, ctx);
                break;
            case XmlNames.Elem.CustomData:
                this.readCustomData(node);
                break;
        }
    }
    readMemoryProtection(node) {
        var _a, _b, _c, _d, _e;
        for (let i = 0, cn = node.childNodes, len = cn.length; i < len; i++) {
            const childNode = cn[i];
            switch (childNode.tagName) {
                case XmlNames.Elem.ProtTitle:
                    this.memoryProtection.title = (_a = XmlUtils.getBoolean(childNode)) !== null && _a !== void 0 ? _a : undefined;
                    break;
                case XmlNames.Elem.ProtUserName:
                    this.memoryProtection.userName = (_b = XmlUtils.getBoolean(childNode)) !== null && _b !== void 0 ? _b : undefined;
                    break;
                case XmlNames.Elem.ProtPassword:
                    this.memoryProtection.password = (_c = XmlUtils.getBoolean(childNode)) !== null && _c !== void 0 ? _c : undefined;
                    break;
                case XmlNames.Elem.ProtUrl:
                    this.memoryProtection.url = (_d = XmlUtils.getBoolean(childNode)) !== null && _d !== void 0 ? _d : undefined;
                    break;
                case XmlNames.Elem.ProtNotes:
                    this.memoryProtection.notes = (_e = XmlUtils.getBoolean(childNode)) !== null && _e !== void 0 ? _e : undefined;
                    break;
            }
        }
    }
    writeMemoryProtection(parentNode) {
        const node = XmlUtils.addChildNode(parentNode, XmlNames.Elem.MemoryProt);
        XmlUtils.setBoolean(XmlUtils.addChildNode(node, XmlNames.Elem.ProtTitle), this.memoryProtection.title);
        XmlUtils.setBoolean(XmlUtils.addChildNode(node, XmlNames.Elem.ProtUserName), this.memoryProtection.userName);
        XmlUtils.setBoolean(XmlUtils.addChildNode(node, XmlNames.Elem.ProtPassword), this.memoryProtection.password);
        XmlUtils.setBoolean(XmlUtils.addChildNode(node, XmlNames.Elem.ProtUrl), this.memoryProtection.url);
        XmlUtils.setBoolean(XmlUtils.addChildNode(node, XmlNames.Elem.ProtNotes), this.memoryProtection.notes);
    }
    readCustomIcons(node) {
        for (let i = 0, cn = node.childNodes, len = cn.length; i < len; i++) {
            const childNode = cn[i];
            if (childNode.tagName === XmlNames.Elem.CustomIconItem) {
                this.readCustomIcon(childNode);
            }
        }
    }
    readCustomIcon(node) {
        let uuid, data;
        for (let i = 0, cn = node.childNodes, len = cn.length; i < len; i++) {
            const childNode = cn[i];
            switch (childNode.tagName) {
                case XmlNames.Elem.CustomIconItemID:
                    uuid = XmlUtils.getUuid(childNode);
                    break;
                case XmlNames.Elem.CustomIconItemData:
                    data = XmlUtils.getBytes(childNode);
                    break;
            }
        }
        if (uuid && data) {
            this.customIcons.set(uuid.id, data);
        }
    }
    writeCustomIcons(parentNode) {
        const node = XmlUtils.addChildNode(parentNode, XmlNames.Elem.CustomIcons);
        for (const [uuid, data] of this.customIcons) {
            if (data) {
                const itemNode = XmlUtils.addChildNode(node, XmlNames.Elem.CustomIconItem);
                XmlUtils.setUuid(XmlUtils.addChildNode(itemNode, XmlNames.Elem.CustomIconItemID), uuid);
                XmlUtils.setBytes(XmlUtils.addChildNode(itemNode, XmlNames.Elem.CustomIconItemData), data);
            }
        }
    }
    readBinaries(node, ctx) {
        for (let i = 0, cn = node.childNodes, len = cn.length; i < len; i++) {
            const childNode = cn[i];
            if (childNode.tagName === XmlNames.Elem.Binary) {
                this.readBinary(childNode, ctx);
            }
        }
    }
    readBinary(node, ctx) {
        const id = node.getAttribute(XmlNames.Attr.Id);
        const binary = XmlUtils.getProtectedBinary(node);
        if (id && binary) {
            if (kdbx_binaries_1.KdbxBinaries.isKdbxBinaryRef(binary)) {
                throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'Binary ref in meta');
            }
            ctx.kdbx.binaries.addWithId(id, binary);
        }
    }
    writeBinaries(parentNode, ctx) {
        const node = XmlUtils.addChildNode(parentNode, XmlNames.Elem.Binaries);
        const binaries = ctx.kdbx.binaries.getAll();
        for (const binary of binaries) {
            const itemNode = XmlUtils.addChildNode(node, XmlNames.Elem.Binary);
            itemNode.setAttribute(XmlNames.Attr.Id, binary.ref);
            XmlUtils.setProtectedBinary(itemNode, binary.value);
        }
    }
    readCustomData(node) {
        this.customData = kdbx_custom_data_1.KdbxCustomData.read(node);
    }
    writeCustomData(parentNode) {
        kdbx_custom_data_1.KdbxCustomData.write(parentNode, this.customData);
    }
    write(parentNode, ctx) {
        this.generator = MetaConst.Generator;
        const node = XmlUtils.addChildNode(parentNode, XmlNames.Elem.Meta);
        XmlUtils.setText(XmlUtils.addChildNode(node, XmlNames.Elem.Generator), MetaConst.Generator);
        if (ctx.kdbx.versionMajor < 4) {
            XmlUtils.setBytes(XmlUtils.addChildNode(node, XmlNames.Elem.HeaderHash), this.headerHash);
        }
        else if (this.settingsChanged) {
            ctx.setXmlDate(XmlUtils.addChildNode(node, XmlNames.Elem.SettingsChanged), this.settingsChanged);
        }
        XmlUtils.setText(XmlUtils.addChildNode(node, XmlNames.Elem.DbName), this.name);
        ctx.setXmlDate(XmlUtils.addChildNode(node, XmlNames.Elem.DbNameChanged), this.nameChanged);
        XmlUtils.setText(XmlUtils.addChildNode(node, XmlNames.Elem.DbDesc), this.desc);
        ctx.setXmlDate(XmlUtils.addChildNode(node, XmlNames.Elem.DbDescChanged), this.descChanged);
        XmlUtils.setText(XmlUtils.addChildNode(node, XmlNames.Elem.DbDefaultUser), this.defaultUser);
        ctx.setXmlDate(XmlUtils.addChildNode(node, XmlNames.Elem.DbDefaultUserChanged), this.defaultUserChanged);
        XmlUtils.setNumber(XmlUtils.addChildNode(node, XmlNames.Elem.DbMntncHistoryDays), this.mntncHistoryDays);
        XmlUtils.setText(XmlUtils.addChildNode(node, XmlNames.Elem.DbColor), this.color);
        ctx.setXmlDate(XmlUtils.addChildNode(node, XmlNames.Elem.DbKeyChanged), this.keyChanged);
        XmlUtils.setNumber(XmlUtils.addChildNode(node, XmlNames.Elem.DbKeyChangeRec), this.keyChangeRec);
        XmlUtils.setNumber(XmlUtils.addChildNode(node, XmlNames.Elem.DbKeyChangeForce), this.keyChangeForce);
        XmlUtils.setBoolean(XmlUtils.addChildNode(node, XmlNames.Elem.RecycleBinEnabled), this.recycleBinEnabled);
        XmlUtils.setUuid(XmlUtils.addChildNode(node, XmlNames.Elem.RecycleBinUuid), this.recycleBinUuid);
        ctx.setXmlDate(XmlUtils.addChildNode(node, XmlNames.Elem.RecycleBinChanged), this.recycleBinChanged);
        XmlUtils.setUuid(XmlUtils.addChildNode(node, XmlNames.Elem.EntryTemplatesGroup), this.entryTemplatesGroup);
        ctx.setXmlDate(XmlUtils.addChildNode(node, XmlNames.Elem.EntryTemplatesGroupChanged), this.entryTemplatesGroupChanged);
        XmlUtils.setNumber(XmlUtils.addChildNode(node, XmlNames.Elem.HistoryMaxItems), this.historyMaxItems);
        XmlUtils.setNumber(XmlUtils.addChildNode(node, XmlNames.Elem.HistoryMaxSize), this.historyMaxSize);
        XmlUtils.setUuid(XmlUtils.addChildNode(node, XmlNames.Elem.LastSelectedGroup), this.lastSelectedGroup);
        XmlUtils.setUuid(XmlUtils.addChildNode(node, XmlNames.Elem.LastTopVisibleGroup), this.lastTopVisibleGroup);
        this.writeMemoryProtection(node);
        this.writeCustomIcons(node);
        if (ctx.exportXml || ctx.kdbx.versionMajor < 4) {
            this.writeBinaries(node, ctx);
        }
        this.writeCustomData(node);
    }
    merge(remote, objectMap) {
        var _a, _b, _c, _d, _e, _f;
        if (this.needUpdate(remote.nameChanged, this.nameChanged)) {
            this._name = remote.name;
            this.nameChanged = remote.nameChanged;
        }
        if (this.needUpdate(remote.descChanged, this.descChanged)) {
            this._desc = remote.desc;
            this.descChanged = remote.descChanged;
        }
        if (this.needUpdate(remote.defaultUserChanged, this.defaultUserChanged)) {
            this._defaultUser = remote.defaultUser;
            this.defaultUserChanged = remote.defaultUserChanged;
        }
        if (this.needUpdate(remote.keyChanged, this.keyChanged)) {
            this.keyChanged = remote.keyChanged;
        }
        if (this.needUpdate(remote.settingsChanged, this.settingsChanged)) {
            this.settingsChanged = remote.settingsChanged;
        }
        if (this.needUpdate(remote.recycleBinChanged, this.recycleBinChanged)) {
            this._recycleBinEnabled = remote.recycleBinEnabled;
            this._recycleBinUuid = remote.recycleBinUuid;
            this.recycleBinChanged = remote.recycleBinChanged;
        }
        if (this.needUpdate(remote.entryTemplatesGroupChanged, this.entryTemplatesGroupChanged)) {
            this._entryTemplatesGroup = remote.entryTemplatesGroup;
            this.entryTemplatesGroupChanged = remote.entryTemplatesGroupChanged;
        }
        for (const [key, value] of remote.customData) {
            if (!this.customData.has(key) && !objectMap.deleted.has(key)) {
                this.customData.set(key, value);
            }
        }
        for (const [key, value] of remote.customIcons) {
            if (!this.customIcons.has(key) && !objectMap.deleted.has(key)) {
                this.customIcons.set(key, value);
            }
        }
        if (!((_a = this._editState) === null || _a === void 0 ? void 0 : _a.historyMaxItemsChanged)) {
            this.historyMaxItems = remote.historyMaxItems;
        }
        if (!((_b = this._editState) === null || _b === void 0 ? void 0 : _b.historyMaxSizeChanged)) {
            this.historyMaxSize = remote.historyMaxSize;
        }
        if (!((_c = this._editState) === null || _c === void 0 ? void 0 : _c.keyChangeRecChanged)) {
            this.keyChangeRec = remote.keyChangeRec;
        }
        if (!((_d = this._editState) === null || _d === void 0 ? void 0 : _d.keyChangeForceChanged)) {
            this.keyChangeForce = remote.keyChangeForce;
        }
        if (!((_e = this._editState) === null || _e === void 0 ? void 0 : _e.mntncHistoryDaysChanged)) {
            this.mntncHistoryDays = remote.mntncHistoryDays;
        }
        if (!((_f = this._editState) === null || _f === void 0 ? void 0 : _f.colorChanged)) {
            this.color = remote.color;
        }
    }
    needUpdate(remoteDate, localDate) {
        if (!remoteDate) {
            return false;
        }
        if (!localDate) {
            return true;
        }
        return remoteDate > localDate;
    }
    /**
     * Creates new meta
     * @returns {KdbxMeta}
     */
    static create() {
        const now = new Date();
        const meta = new KdbxMeta();
        meta.generator = MetaConst.Generator;
        meta.settingsChanged = now;
        meta.mntncHistoryDays = consts_1.Defaults.MntncHistoryDays;
        meta.recycleBinEnabled = true;
        meta.historyMaxItems = consts_1.Defaults.HistoryMaxItems;
        meta.historyMaxSize = consts_1.Defaults.HistoryMaxSize;
        meta.nameChanged = now;
        meta.descChanged = now;
        meta.defaultUserChanged = now;
        meta.recycleBinChanged = now;
        meta.keyChangeRec = -1;
        meta.keyChangeForce = -1;
        meta.entryTemplatesGroup = new kdbx_uuid_1.KdbxUuid();
        meta.entryTemplatesGroupChanged = now;
        meta.memoryProtection = {
            title: false,
            userName: false,
            password: true,
            url: false,
            notes: false
        };
        return meta;
    }
    static read(xmlNode, ctx) {
        const meta = new KdbxMeta();
        for (let i = 0, cn = xmlNode.childNodes, len = cn.length; i < len; i++) {
            const childNode = cn[i];
            if (childNode.tagName) {
                meta.readNode(childNode, ctx);
            }
        }
        return meta;
    }
}
exports.KdbxMeta = KdbxMeta;


/***/ }),

/***/ "./format/kdbx-times.ts":
/*!******************************!*\
  !*** ./format/kdbx-times.ts ***!
  \******************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.KdbxTimes = void 0;
const XmlNames = __webpack_require__(/*! ./../defs/xml-names */ "./defs/xml-names.ts");
const XmlUtils = __webpack_require__(/*! ./../utils/xml-utils */ "./utils/xml-utils.ts");
class KdbxTimes {
    readNode(node) {
        switch (node.tagName) {
            case XmlNames.Elem.CreationTime:
                this.creationTime = XmlUtils.getDate(node);
                break;
            case XmlNames.Elem.LastModTime:
                this.lastModTime = XmlUtils.getDate(node);
                break;
            case XmlNames.Elem.LastAccessTime:
                this.lastAccessTime = XmlUtils.getDate(node);
                break;
            case XmlNames.Elem.ExpiryTime:
                this.expiryTime = XmlUtils.getDate(node);
                break;
            case XmlNames.Elem.Expires:
                this.expires = XmlUtils.getBoolean(node);
                break;
            case XmlNames.Elem.UsageCount:
                this.usageCount = XmlUtils.getNumber(node);
                break;
            case XmlNames.Elem.LocationChanged:
                this.locationChanged = XmlUtils.getDate(node);
                break;
        }
    }
    clone() {
        const clone = new KdbxTimes();
        clone.creationTime = this.creationTime;
        clone.lastModTime = this.lastModTime;
        clone.lastAccessTime = this.lastAccessTime;
        clone.expiryTime = this.expiryTime;
        clone.expires = this.expires;
        clone.usageCount = this.usageCount;
        clone.locationChanged = this.locationChanged;
        return clone;
    }
    update() {
        const now = new Date();
        this.lastModTime = now;
        this.lastAccessTime = now;
    }
    write(parentNode, ctx) {
        const node = XmlUtils.addChildNode(parentNode, XmlNames.Elem.Times);
        ctx.setXmlDate(XmlUtils.addChildNode(node, XmlNames.Elem.CreationTime), this.creationTime);
        ctx.setXmlDate(XmlUtils.addChildNode(node, XmlNames.Elem.LastModTime), this.lastModTime);
        ctx.setXmlDate(XmlUtils.addChildNode(node, XmlNames.Elem.LastAccessTime), this.lastAccessTime);
        ctx.setXmlDate(XmlUtils.addChildNode(node, XmlNames.Elem.ExpiryTime), this.expiryTime);
        XmlUtils.setBoolean(XmlUtils.addChildNode(node, XmlNames.Elem.Expires), this.expires);
        XmlUtils.setNumber(XmlUtils.addChildNode(node, XmlNames.Elem.UsageCount), this.usageCount);
        ctx.setXmlDate(XmlUtils.addChildNode(node, XmlNames.Elem.LocationChanged), this.locationChanged);
    }
    static create() {
        const times = new KdbxTimes();
        const now = new Date();
        times.creationTime = now;
        times.lastModTime = now;
        times.lastAccessTime = now;
        times.expiryTime = now;
        times.expires = false;
        times.usageCount = 0;
        times.locationChanged = now;
        return times;
    }
    static read(xmlNode) {
        const obj = new KdbxTimes();
        for (let i = 0, cn = xmlNode.childNodes, len = cn.length; i < len; i++) {
            const childNode = cn[i];
            if (childNode.tagName) {
                obj.readNode(childNode);
            }
        }
        return obj;
    }
}
exports.KdbxTimes = KdbxTimes;


/***/ }),

/***/ "./format/kdbx-uuid.ts":
/*!*****************************!*\
  !*** ./format/kdbx-uuid.ts ***!
  \*****************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.KdbxUuid = void 0;
const byte_utils_1 = __webpack_require__(/*! ../utils/byte-utils */ "./utils/byte-utils.ts");
const consts_1 = __webpack_require__(/*! ../defs/consts */ "./defs/consts.ts");
const kdbx_error_1 = __webpack_require__(/*! ../errors/kdbx-error */ "./errors/kdbx-error.ts");
const CryptoEngine = __webpack_require__(/*! ../crypto/crypto-engine */ "./crypto/crypto-engine.ts");
const UuidLength = 16;
const EmptyUuidStr = 'AAAAAAAAAAAAAAAAAAAAAA==';
class KdbxUuid {
    constructor(ab) {
        if (ab === undefined) {
            ab = new ArrayBuffer(UuidLength);
        }
        else if (typeof ab === 'string') {
            ab = byte_utils_1.base64ToBytes(ab);
        }
        if (ab.byteLength !== UuidLength) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, `bad UUID length: ${ab.byteLength}`);
        }
        this.id = byte_utils_1.bytesToBase64(ab);
        this.empty = this.id === EmptyUuidStr;
    }
    equals(other) {
        return (other && other.toString() === this.toString()) || false;
    }
    get bytes() {
        return this.toBytes();
    }
    static random() {
        return new KdbxUuid(CryptoEngine.random(UuidLength));
    }
    toString() {
        return this.id;
    }
    valueOf() {
        return this.id;
    }
    toBytes() {
        return byte_utils_1.base64ToBytes(this.id);
    }
}
exports.KdbxUuid = KdbxUuid;


/***/ }),

/***/ "./format/kdbx.ts":
/*!************************!*\
  !*** ./format/kdbx.ts ***!
  \************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.Kdbx = void 0;
const XmlNames = __webpack_require__(/*! ../defs/xml-names */ "./defs/xml-names.ts");
const XmlUtils = __webpack_require__(/*! ./../utils/xml-utils */ "./utils/xml-utils.ts");
const kdbx_binaries_1 = __webpack_require__(/*! ./kdbx-binaries */ "./format/kdbx-binaries.ts");
const kdbx_deleted_object_1 = __webpack_require__(/*! ./kdbx-deleted-object */ "./format/kdbx-deleted-object.ts");
const kdbx_group_1 = __webpack_require__(/*! ./kdbx-group */ "./format/kdbx-group.ts");
const kdbx_meta_1 = __webpack_require__(/*! ./kdbx-meta */ "./format/kdbx-meta.ts");
const kdbx_credentials_1 = __webpack_require__(/*! ./kdbx-credentials */ "./format/kdbx-credentials.ts");
const kdbx_header_1 = __webpack_require__(/*! ./kdbx-header */ "./format/kdbx-header.ts");
const kdbx_error_1 = __webpack_require__(/*! ../errors/kdbx-error */ "./errors/kdbx-error.ts");
const consts_1 = __webpack_require__(/*! ../defs/consts */ "./defs/consts.ts");
const kdbx_format_1 = __webpack_require__(/*! ./kdbx-format */ "./format/kdbx-format.ts");
const kdbx_entry_1 = __webpack_require__(/*! ./kdbx-entry */ "./format/kdbx-entry.ts");
const kdbx_uuid_1 = __webpack_require__(/*! ./kdbx-uuid */ "./format/kdbx-uuid.ts");
class Kdbx {
    constructor() {
        this.header = new kdbx_header_1.KdbxHeader();
        this.credentials = new kdbx_credentials_1.KdbxCredentials(null);
        this.meta = new kdbx_meta_1.KdbxMeta();
        this.binaries = new kdbx_binaries_1.KdbxBinaries();
        this.groups = [];
        this.deletedObjects = [];
    }
    get versionMajor() {
        return this.header.versionMajor;
    }
    get versionMinor() {
        return this.header.versionMinor;
    }
    /**
     * Creates a new database
     */
    static create(credentials, name) {
        if (!(credentials instanceof kdbx_credentials_1.KdbxCredentials)) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg, 'credentials');
        }
        const kdbx = new Kdbx();
        kdbx.credentials = credentials;
        kdbx.header = kdbx_header_1.KdbxHeader.create();
        kdbx.meta = kdbx_meta_1.KdbxMeta.create();
        kdbx.meta._name = name;
        kdbx.createDefaultGroup();
        kdbx.createRecycleBin();
        kdbx.meta._lastSelectedGroup = kdbx.getDefaultGroup().uuid;
        kdbx.meta._lastTopVisibleGroup = kdbx.getDefaultGroup().uuid;
        return kdbx;
    }
    /**
     * Load a kdbx file
     * If there was an error loading file, throws an exception
     */
    static load(data, credentials) {
        if (!(data instanceof ArrayBuffer)) {
            return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg, 'data'));
        }
        if (!(credentials instanceof kdbx_credentials_1.KdbxCredentials)) {
            return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg, 'credentials'));
        }
        const kdbx = new Kdbx();
        kdbx.credentials = credentials;
        const format = new kdbx_format_1.KdbxFormat(kdbx);
        return format.load(data);
    }
    /**
     * Import database from an xml file
     * If there was an error loading file, throws an exception
     */
    static loadXml(data, credentials) {
        if (typeof data !== 'string') {
            return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg, 'data'));
        }
        if (!(credentials instanceof kdbx_credentials_1.KdbxCredentials)) {
            return Promise.reject(new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg, 'credentials'));
        }
        const kdbx = new Kdbx();
        kdbx.credentials = credentials;
        const format = new kdbx_format_1.KdbxFormat(kdbx);
        return format.loadXml(data);
    }
    /**
     * Save the db to ArrayBuffer
     */
    save() {
        const format = new kdbx_format_1.KdbxFormat(this);
        return format.save();
    }
    /**
     * Save the db as XML string
     */
    saveXml(prettyPrint = false) {
        const format = new kdbx_format_1.KdbxFormat(this);
        return format.saveXml(prettyPrint);
    }
    /**
     * Creates a default group, if it's not yet created
     */
    createDefaultGroup() {
        if (this.groups.length) {
            return;
        }
        const defaultGroup = kdbx_group_1.KdbxGroup.create(this.meta.name || '');
        defaultGroup.icon = consts_1.Icons.FolderOpen;
        defaultGroup.expanded = true;
        this.groups.push(defaultGroup);
    }
    /**
     * Creates a recycle bin group, if it's not yet created
     */
    createRecycleBin() {
        this.meta.recycleBinEnabled = true;
        if (this.meta.recycleBinUuid && this.getGroup(this.meta.recycleBinUuid)) {
            return;
        }
        const defGrp = this.getDefaultGroup();
        const recycleBin = kdbx_group_1.KdbxGroup.create(consts_1.Defaults.RecycleBinName, defGrp);
        recycleBin.icon = consts_1.Icons.TrashBin;
        recycleBin.enableAutoType = false;
        recycleBin.enableSearching = false;
        this.meta.recycleBinUuid = recycleBin.uuid;
        defGrp.groups.push(recycleBin);
    }
    /**
     * Adds a new group to an existing group
     */
    createGroup(group, name) {
        const subGroup = kdbx_group_1.KdbxGroup.create(name, group);
        group.groups.push(subGroup);
        return subGroup;
    }
    /**
     * Adds a new entry to a group
     */
    createEntry(group) {
        const entry = kdbx_entry_1.KdbxEntry.create(this.meta, group);
        group.entries.push(entry);
        return entry;
    }
    /**
     * Gets the default group
     */
    getDefaultGroup() {
        if (!this.groups[0]) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'empty default group');
        }
        return this.groups[0];
    }
    /**
     * Get a group by uuid, returns undefined if it's not found
     */
    getGroup(uuid, parentGroup) {
        const groups = parentGroup ? parentGroup.groups : this.groups;
        for (const group of groups) {
            if (group.uuid.equals(uuid)) {
                return group;
            }
            const res = this.getGroup(uuid, group);
            if (res) {
                return res;
            }
        }
    }
    /**
     * Move an object from one group to another
     * @param object - object to be moved
     * @param toGroup - target parent group
     * @param atIndex - index in target group (by default, insert to the end of the group)
     */
    move(object, toGroup, atIndex) {
        var _a;
        const containerProp = object instanceof kdbx_group_1.KdbxGroup ? 'groups' : 'entries';
        const fromContainer = (_a = object.parentGroup) === null || _a === void 0 ? void 0 : _a[containerProp];
        const ix = fromContainer === null || fromContainer === void 0 ? void 0 : fromContainer.indexOf(object);
        if (typeof ix !== 'number' || ix < 0) {
            return;
        }
        fromContainer.splice(ix, 1);
        if (toGroup) {
            const toContainer = toGroup[containerProp];
            if (typeof atIndex === 'number' && atIndex >= 0) {
                toContainer.splice(atIndex, 0, object);
            }
            else {
                toContainer.push(object);
            }
        }
        else {
            const now = new Date();
            if (object instanceof kdbx_group_1.KdbxGroup) {
                for (const item of object.allGroupsAndEntries()) {
                    const uuid = item.uuid;
                    this.addDeletedObject(uuid, now);
                }
            }
            else {
                if (object.uuid) {
                    this.addDeletedObject(object.uuid, now);
                }
            }
        }
        object.parentGroup = toGroup !== null && toGroup !== void 0 ? toGroup : undefined;
        object.times.locationChanged = new Date();
    }
    /**
     * Adds a so-called deleted object, this is used to keep track of objects during merging
     * @param uuid - object uuid
     * @param dt - deletion date
     */
    addDeletedObject(uuid, dt) {
        const deletedObject = new kdbx_deleted_object_1.KdbxDeletedObject();
        deletedObject.uuid = uuid;
        deletedObject.deletionTime = dt;
        this.deletedObjects.push(deletedObject);
    }
    /**
     * Delete an entry or a group
     * Depending on settings, removes either to trash, or completely
     */
    remove(object) {
        let toGroup = undefined;
        if (this.meta.recycleBinEnabled && this.meta.recycleBinUuid) {
            this.createRecycleBin();
            toGroup = this.getGroup(this.meta.recycleBinUuid);
        }
        this.move(object, toGroup);
    }
    /**
     * Creates a binary in the db and returns an object that can be put to entry.binaries
     */
    createBinary(value) {
        return this.binaries.add(value);
    }
    /**
     * Import an entry from another file
     * It's up to caller to decide what should happen to the original entry in the source file
     * Returns the new entry
     * @param entry - entry to be imported
     * @param group - target parent group
     * @param file - the source file containing the group
     */
    importEntry(entry, group, file) {
        const newEntry = new kdbx_entry_1.KdbxEntry();
        const uuid = kdbx_uuid_1.KdbxUuid.random();
        newEntry.copyFrom(entry);
        newEntry.uuid = uuid;
        for (const historyEntry of entry.history) {
            const newHistoryEntry = new kdbx_entry_1.KdbxEntry();
            newHistoryEntry.copyFrom(historyEntry);
            newHistoryEntry.uuid = uuid;
            newEntry.history.push(newHistoryEntry);
        }
        const binaries = new Map();
        const customIcons = new Set();
        for (const e of newEntry.history.concat(newEntry)) {
            if (e.customIcon) {
                customIcons.add(e.customIcon.id);
            }
            for (const binary of e.binaries.values()) {
                if (kdbx_binaries_1.KdbxBinaries.isKdbxBinaryWithHash(binary)) {
                    binaries.set(binary.hash, binary);
                }
            }
        }
        for (const binary of binaries.values()) {
            const fileBinary = file.binaries.getValueByHash(binary.hash);
            if (fileBinary && !this.binaries.getValueByHash(binary.hash)) {
                this.binaries.addWithHash(binary);
            }
        }
        for (const customIconId of customIcons) {
            const customIcon = file.meta.customIcons.get(customIconId);
            if (customIcon) {
                this.meta.customIcons.set(customIconId, customIcon);
            }
        }
        group.entries.push(newEntry);
        newEntry.parentGroup = group;
        newEntry.times.update();
        return newEntry;
    }
    /**
     * Perform database cleanup
     * @param settings.historyRules - remove extra history, it it doesn't match defined rules, e.g. records number
     * @param settings.customIcons - remove unused custom icons
     * @param settings.binaries - remove unused binaries
     */
    cleanup(settings) {
        const now = new Date();
        const historyMaxItems = (settings === null || settings === void 0 ? void 0 : settings.historyRules) &&
            typeof this.meta.historyMaxItems === 'number' &&
            this.meta.historyMaxItems >= 0
            ? this.meta.historyMaxItems
            : Infinity;
        const usedCustomIcons = new Set();
        const usedBinaries = new Set();
        const processEntry = (entry) => {
            if (entry.customIcon) {
                usedCustomIcons.add(entry.customIcon.id);
            }
            for (const binary of entry.binaries.values()) {
                if (kdbx_binaries_1.KdbxBinaries.isKdbxBinaryWithHash(binary)) {
                    usedBinaries.add(binary.hash);
                }
            }
        };
        for (const item of this.getDefaultGroup().allGroupsAndEntries()) {
            if (item instanceof kdbx_entry_1.KdbxEntry) {
                if (item.history.length > historyMaxItems) {
                    item.removeHistory(0, item.history.length - historyMaxItems);
                }
                processEntry(item);
                if (item.history) {
                    for (const historyEntry of item.history) {
                        processEntry(historyEntry);
                    }
                }
            }
            else {
                if (item.customIcon) {
                    usedCustomIcons.add(item.customIcon.id);
                }
            }
        }
        if (settings === null || settings === void 0 ? void 0 : settings.customIcons) {
            for (const customIcon of this.meta.customIcons.keys()) {
                if (!usedCustomIcons.has(customIcon)) {
                    const uuid = new kdbx_uuid_1.KdbxUuid(customIcon);
                    this.addDeletedObject(uuid, now);
                    this.meta.customIcons.delete(customIcon);
                }
            }
        }
        if (settings === null || settings === void 0 ? void 0 : settings.binaries) {
            for (const binary of this.binaries.getAllWithHashes()) {
                if (!usedBinaries.has(binary.hash)) {
                    this.binaries.deleteWithHash(binary.hash);
                }
            }
        }
    }
    /**
     * Merge the db with another db
     * Some parts of the remote DB are copied by reference, so it should NOT be modified after merge
     * Suggested use case:
     * - open the local db
     * - get a remote db somehow and open in
     * - merge the remote db into the local db: local.merge(remote)
     * - close the remote db
     * @param remote - database to merge in
     */
    merge(remote) {
        const root = this.getDefaultGroup();
        const remoteRoot = remote.getDefaultGroup();
        if (!root || !remoteRoot) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.MergeError, 'no default group');
        }
        if (!root.uuid.equals(remoteRoot.uuid)) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.MergeError, 'default group is different');
        }
        const objectMap = this.getObjectMap();
        for (const rem of remote.deletedObjects) {
            if (rem.uuid && rem.deletionTime && !objectMap.deleted.has(rem.uuid.id)) {
                this.deletedObjects.push(rem);
                objectMap.deleted.set(rem.uuid.id, rem.deletionTime);
            }
        }
        for (const remoteBinary of remote.binaries.getAllWithHashes()) {
            if (!this.binaries.getValueByHash(remoteBinary.hash)) {
                this.binaries.addWithHash(remoteBinary);
            }
        }
        const remoteObjectMap = remote.getObjectMap();
        objectMap.remoteEntries = remoteObjectMap.entries;
        objectMap.remoteGroups = remoteObjectMap.groups;
        this.meta.merge(remote.meta, objectMap);
        root.merge(objectMap);
        this.cleanup({ historyRules: true, customIcons: true, binaries: true });
    }
    /**
     * Gets editing state tombstones (for successful merge)
     * The replica must save this state with the db, assign in on opening the db,
     * and call removeLocalEditState on successful upstream push.
     * This state is JSON serializable.
     */
    getLocalEditState() {
        const editingState = {
            entries: {}
        };
        for (const entry of this.getDefaultGroup().allEntries()) {
            if (entry._editState && entry.uuid && editingState.entries) {
                editingState.entries[entry.uuid.id] = entry._editState;
            }
        }
        if (this.meta._editState) {
            editingState.meta = this.meta._editState;
        }
        return editingState;
    }
    /**
     * Sets editing state tombstones returned previously by getLocalEditState
     * The replica must call this method on opening the db to the state returned previously on getLocalEditState.
     * @param editingState - result of getLocalEditState invoked before on saving the db
     */
    setLocalEditState(editingState) {
        var _a;
        for (const entry of this.getDefaultGroup().allEntries()) {
            if ((_a = editingState.entries) === null || _a === void 0 ? void 0 : _a[entry.uuid.id]) {
                entry._editState = editingState.entries[entry.uuid.id];
            }
        }
        if (editingState.meta) {
            this.meta._editState = editingState.meta;
        }
    }
    /**
     * Removes editing state tombstones
     * Immediately after successful upstream push the replica must:
     * - call this method
     * - discard any previous state obtained by getLocalEditState call before
     */
    removeLocalEditState() {
        for (const entry of this.getDefaultGroup().allEntries()) {
            entry._editState = undefined;
        }
        this.meta._editState = undefined;
    }
    /**
     * Upgrade the file to latest version
     */
    upgrade() {
        this.setVersion(kdbx_header_1.KdbxHeader.MaxFileVersion);
    }
    /**
     * Set the file version to a specified number
     */
    setVersion(version) {
        this.meta.headerHash = undefined;
        this.meta.settingsChanged = new Date();
        this.header.setVersion(version);
    }
    /**
     * Set file key derivation function
     * @param kdf - KDF id, from KdfId
     */
    setKdf(kdf) {
        this.meta.headerHash = undefined;
        this.meta.settingsChanged = new Date();
        this.header.setKdf(kdf);
    }
    getObjectMap() {
        const objectMap = {
            entries: new Map(),
            groups: new Map(),
            remoteEntries: new Map(),
            remoteGroups: new Map(),
            deleted: new Map()
        };
        for (const item of this.getDefaultGroup().allGroupsAndEntries()) {
            if (objectMap.entries.has(item.uuid.id)) {
                throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.MergeError, `duplicate: ${item.uuid}`);
            }
            if (item instanceof kdbx_entry_1.KdbxEntry) {
                objectMap.entries.set(item.uuid.id, item);
            }
            else {
                objectMap.groups.set(item.uuid.id, item);
            }
        }
        for (const deletedObject of this.deletedObjects) {
            if (deletedObject.uuid && deletedObject.deletionTime) {
                objectMap.deleted.set(deletedObject.uuid.id, deletedObject.deletionTime);
            }
        }
        return objectMap;
    }
    loadFromXml(ctx) {
        if (!this.xml) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'xml is not set');
        }
        const doc = this.xml.documentElement;
        if (doc.tagName !== XmlNames.Elem.DocNode) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'bad xml root');
        }
        this.parseMeta(ctx);
        return this.binaries.computeHashes().then(() => {
            this.parseRoot(ctx);
            return this;
        });
    }
    parseMeta(ctx) {
        if (!this.xml) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'xml is not set');
        }
        const node = XmlUtils.getChildNode(this.xml.documentElement, XmlNames.Elem.Meta, 'no meta node');
        this.meta = kdbx_meta_1.KdbxMeta.read(node, ctx);
    }
    parseRoot(ctx) {
        if (!this.xml) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidState, 'xml is not set');
        }
        this.groups = [];
        this.deletedObjects = [];
        const node = XmlUtils.getChildNode(this.xml.documentElement, XmlNames.Elem.Root, 'no root node');
        for (let i = 0, cn = node.childNodes, len = cn.length; i < len; i++) {
            const childNode = cn[i];
            switch (childNode.tagName) {
                case XmlNames.Elem.Group:
                    this.readGroup(childNode, ctx);
                    break;
                case XmlNames.Elem.DeletedObjects:
                    this.readDeletedObjects(childNode);
                    break;
            }
        }
    }
    readDeletedObjects(node) {
        for (let i = 0, cn = node.childNodes, len = cn.length; i < len; i++) {
            const childNode = cn[i];
            switch (childNode.tagName) {
                case XmlNames.Elem.DeletedObject:
                    this.deletedObjects.push(kdbx_deleted_object_1.KdbxDeletedObject.read(childNode));
                    break;
            }
        }
    }
    readGroup(node, ctx) {
        this.groups.push(kdbx_group_1.KdbxGroup.read(node, ctx));
    }
    buildXml(ctx) {
        const xml = XmlUtils.create(XmlNames.Elem.DocNode);
        this.meta.write(xml.documentElement, ctx);
        const rootNode = XmlUtils.addChildNode(xml.documentElement, XmlNames.Elem.Root);
        for (const g of this.groups) {
            g.write(rootNode, ctx);
        }
        const delObjNode = XmlUtils.addChildNode(rootNode, XmlNames.Elem.DeletedObjects);
        for (const d of this.deletedObjects) {
            d.write(delObjNode, ctx);
        }
        this.xml = xml;
    }
}
exports.Kdbx = Kdbx;


/***/ }),

/***/ "./utils/binary-stream.ts":
/*!********************************!*\
  !*** ./utils/binary-stream.ts ***!
  \********************************/
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.BinaryStream = void 0;
class BinaryStream {
    constructor(arrayBuffer) {
        this._arrayBuffer = arrayBuffer || new ArrayBuffer(1024);
        this._dataView = new DataView(this._arrayBuffer);
        this._pos = 0;
        this._canExpand = !arrayBuffer;
    }
    get pos() {
        return this._pos;
    }
    get byteLength() {
        return this._arrayBuffer.byteLength;
    }
    readBytes(size) {
        const buffer = this._arrayBuffer.slice(this._pos, this._pos + size);
        this._pos += size;
        return buffer;
    }
    readBytesToEnd() {
        const size = this._arrayBuffer.byteLength - this._pos;
        return this.readBytes(size);
    }
    readBytesNoAdvance(startPos, endPos) {
        return this._arrayBuffer.slice(startPos, endPos);
    }
    writeBytes(bytes) {
        const arr = bytes instanceof ArrayBuffer ? new Uint8Array(bytes) : bytes;
        this.checkCapacity(arr.length);
        new Uint8Array(this._arrayBuffer).set(arr, this._pos);
        this._pos += arr.length;
    }
    getWrittenBytes() {
        return this._arrayBuffer.slice(0, this._pos);
    }
    checkCapacity(addBytes) {
        const available = this._arrayBuffer.byteLength - this._pos;
        if (this._canExpand && available < addBytes) {
            let newLen = this._arrayBuffer.byteLength;
            const requestedLen = this._pos + addBytes;
            while (newLen < requestedLen) {
                newLen *= 2;
            }
            const newData = new Uint8Array(newLen);
            newData.set(new Uint8Array(this._arrayBuffer));
            this._arrayBuffer = newData.buffer;
            this._dataView = new DataView(this._arrayBuffer);
        }
    }
    getInt8() {
        const value = this._dataView.getInt8(this._pos);
        this._pos += 1;
        return value;
    }
    setInt8(value) {
        this.checkCapacity(1);
        this._dataView.setInt8(this._pos, value);
        this._pos += 1;
    }
    getUint8() {
        const value = this._dataView.getUint8(this._pos);
        this._pos += 1;
        return value;
    }
    setUint8(value) {
        this.checkCapacity(1);
        this._dataView.setUint8(this._pos, value);
        this._pos += 1;
    }
    getInt16(littleEndian) {
        const value = this._dataView.getInt16(this._pos, littleEndian);
        this._pos += 2;
        return value;
    }
    setInt16(value, littleEndian) {
        this.checkCapacity(2);
        this._dataView.setInt16(this._pos, value, littleEndian);
        this._pos += 2;
    }
    getUint16(littleEndian) {
        const value = this._dataView.getUint16(this._pos, littleEndian);
        this._pos += 2;
        return value;
    }
    setUint16(value, littleEndian) {
        this.checkCapacity(2);
        this._dataView.setUint16(this._pos, value, littleEndian);
        this._pos += 2;
    }
    getInt32(littleEndian) {
        const value = this._dataView.getInt32(this._pos, littleEndian);
        this._pos += 4;
        return value;
    }
    setInt32(value, littleEndian) {
        this.checkCapacity(4);
        this._dataView.setInt32(this._pos, value, littleEndian);
        this._pos += 4;
    }
    getUint32(littleEndian) {
        const value = this._dataView.getUint32(this._pos, littleEndian);
        this._pos += 4;
        return value;
    }
    setUint32(value, littleEndian) {
        this.checkCapacity(4);
        this._dataView.setUint32(this._pos, value, littleEndian);
        this._pos += 4;
    }
    getFloat32(littleEndian) {
        const value = this._dataView.getFloat32(this._pos, littleEndian);
        this._pos += 4;
        return value;
    }
    setFloat32(value, littleEndian) {
        this.checkCapacity(4);
        this._dataView.setFloat32(this._pos, value, littleEndian);
        this._pos += 4;
    }
    getFloat64(littleEndian) {
        const value = this._dataView.getFloat64(this._pos, littleEndian);
        this._pos += 8;
        return value;
    }
    setFloat64(value, littleEndian) {
        this.checkCapacity(8);
        this._dataView.setFloat64(this._pos, value, littleEndian);
        this._pos += 8;
    }
    getUint64(littleEndian) {
        let part1 = this.getUint32(littleEndian), part2 = this.getUint32(littleEndian);
        if (littleEndian) {
            part2 *= 0x100000000;
        }
        else {
            part1 *= 0x100000000;
        }
        return part1 + part2;
    }
    setUint64(value, littleEndian) {
        if (littleEndian) {
            this.setUint32(value & 0xffffffff, true);
            this.setUint32(Math.floor(value / 0x100000000), true);
        }
        else {
            this.checkCapacity(8);
            this.setUint32(Math.floor(value / 0x100000000), false);
            this.setUint32(value & 0xffffffff, false);
        }
    }
}
exports.BinaryStream = BinaryStream;


/***/ }),

/***/ "./utils/byte-utils.ts":
/*!*****************************!*\
  !*** ./utils/byte-utils.ts ***!
  \*****************************/
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.zeroBuffer = exports.arrayToBuffer = exports.bytesToHex = exports.hexToBytes = exports.bytesToBase64 = exports.base64ToBytes = exports.stringToBytes = exports.bytesToString = exports.arrayBufferEquals = void 0;
const textEncoder = new TextEncoder();
const textDecoder = new TextDecoder();
function arrayBufferEquals(ab1, ab2) {
    if (ab1.byteLength !== ab2.byteLength) {
        return false;
    }
    const arr1 = new Uint8Array(ab1);
    const arr2 = new Uint8Array(ab2);
    for (let i = 0, len = arr1.length; i < len; i++) {
        if (arr1[i] !== arr2[i]) {
            return false;
        }
    }
    return true;
}
exports.arrayBufferEquals = arrayBufferEquals;
function bytesToString(arr) {
    if (arr instanceof ArrayBuffer) {
        arr = new Uint8Array(arr);
    }
    return textDecoder.decode(arr);
}
exports.bytesToString = bytesToString;
function stringToBytes(str) {
    return textEncoder.encode(str);
}
exports.stringToBytes = stringToBytes;
function base64ToBytes(str) {
    if (typeof Buffer === 'function') {
        const buffer = Buffer.from(str, 'base64');
        return new Uint8Array(buffer);
    }
    const byteStr = atob(str);
    const arr = new Uint8Array(byteStr.length);
    for (let i = 0; i < byteStr.length; i++) {
        arr[i] = byteStr.charCodeAt(i);
    }
    return arr;
}
exports.base64ToBytes = base64ToBytes;
function bytesToBase64(arr) {
    const intArr = arr instanceof ArrayBuffer ? new Uint8Array(arr) : arr;
    if (typeof Buffer === 'function') {
        const buffer = Buffer.from(arr);
        return buffer.toString('base64');
    }
    let str = '';
    for (let i = 0; i < intArr.length; i++) {
        str += String.fromCharCode(intArr[i]);
    }
    return btoa(str);
}
exports.bytesToBase64 = bytesToBase64;
function hexToBytes(hex) {
    const arr = new Uint8Array(Math.ceil(hex.length / 2));
    for (let i = 0; i < arr.length; i++) {
        arr[i] = parseInt(hex.substr(i * 2, 2), 16);
    }
    return arr;
}
exports.hexToBytes = hexToBytes;
function bytesToHex(arr) {
    const intArr = arr instanceof ArrayBuffer ? new Uint8Array(arr) : arr;
    let str = '';
    for (let i = 0; i < intArr.length; i++) {
        const byte = intArr[i].toString(16);
        if (byte.length === 1) {
            str += '0';
        }
        str += byte;
    }
    return str;
}
exports.bytesToHex = bytesToHex;
function arrayToBuffer(arr) {
    if (arr instanceof ArrayBuffer) {
        return arr;
    }
    const ab = arr.buffer;
    if (arr.byteOffset === 0 && arr.byteLength === ab.byteLength) {
        return ab;
    }
    return arr.buffer.slice(arr.byteOffset, arr.byteOffset + arr.byteLength);
}
exports.arrayToBuffer = arrayToBuffer;
function zeroBuffer(arr) {
    const intArr = arr instanceof ArrayBuffer ? new Uint8Array(arr) : arr;
    intArr.fill(0);
}
exports.zeroBuffer = zeroBuffer;


/***/ }),

/***/ "./utils/int64.ts":
/*!************************!*\
  !*** ./utils/int64.ts ***!
  \************************/
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.Int64 = void 0;
class Int64 {
    constructor(lo = 0, hi = 0) {
        this.lo = lo;
        this.hi = hi;
    }
    get value() {
        if (this.hi) {
            if (this.hi >= 0x200000) {
                throw new Error('too large number');
            }
            return this.hi * 0x100000000 + this.lo;
        }
        return this.lo;
    }
    valueOf() {
        return this.value;
    }
    static from(value) {
        if (value > 0x1fffffffffffff) {
            throw new Error('too large number');
        }
        const lo = value >>> 0;
        const hi = ((value - lo) / 0x100000000) >>> 0;
        return new Int64(lo, hi);
    }
}
exports.Int64 = Int64;


/***/ }),

/***/ "./utils/var-dictionary.ts":
/*!*********************************!*\
  !*** ./utils/var-dictionary.ts ***!
  \*********************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.VarDictionary = exports.ValueType = void 0;
const kdbx_error_1 = __webpack_require__(/*! ../errors/kdbx-error */ "./errors/kdbx-error.ts");
const consts_1 = __webpack_require__(/*! ../defs/consts */ "./defs/consts.ts");
const byte_utils_1 = __webpack_require__(/*! ./byte-utils */ "./utils/byte-utils.ts");
const int64_1 = __webpack_require__(/*! ./int64 */ "./utils/int64.ts");
const MaxSupportedVersion = 1;
const DefaultVersion = 0x0100;
var ValueType;
(function (ValueType) {
    ValueType[ValueType["UInt32"] = 4] = "UInt32";
    ValueType[ValueType["UInt64"] = 5] = "UInt64";
    ValueType[ValueType["Bool"] = 8] = "Bool";
    ValueType[ValueType["Int32"] = 12] = "Int32";
    ValueType[ValueType["Int64"] = 13] = "Int64";
    ValueType[ValueType["String"] = 24] = "String";
    ValueType[ValueType["Bytes"] = 66] = "Bytes";
})(ValueType = exports.ValueType || (exports.ValueType = {}));
class VarDictionary {
    constructor() {
        this._items = [];
        this._map = new Map();
    }
    keys() {
        return this._items.map((item) => item.key);
    }
    get length() {
        return this._items.length;
    }
    get(key) {
        const item = this._map.get(key);
        return item ? item.value : undefined;
    }
    set(key, type, value) {
        let item;
        switch (type) {
            case ValueType.UInt32:
                if (typeof value !== 'number' || value < 0) {
                    throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg);
                }
                item = { key, type, value };
                break;
            case ValueType.UInt64:
                if (!(value instanceof int64_1.Int64)) {
                    throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg);
                }
                item = { key, type, value };
                break;
            case ValueType.Bool:
                if (typeof value !== 'boolean') {
                    throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg);
                }
                item = { key, type, value };
                break;
            case ValueType.Int32:
                if (typeof value !== 'number') {
                    throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg);
                }
                item = { key, type, value };
                break;
            case ValueType.Int64:
                if (!(value instanceof int64_1.Int64)) {
                    throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg);
                }
                item = { key, type, value };
                break;
            case ValueType.String:
                if (typeof value !== 'string') {
                    throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg);
                }
                item = { key, type, value };
                break;
            case ValueType.Bytes:
                if (value instanceof Uint8Array) {
                    value = byte_utils_1.arrayToBuffer(value);
                }
                if (!(value instanceof ArrayBuffer)) {
                    throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg);
                }
                item = { key, type, value };
                break;
            default:
                throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidArg);
        }
        const existing = this._map.get(key);
        if (existing) {
            const ix = this._items.indexOf(existing);
            this._items.splice(ix, 1, item);
        }
        else {
            this._items.push(item);
        }
        this._map.set(key, item);
    }
    remove(key) {
        this._items = this._items.filter((item) => {
            return item.key !== key;
        });
        this._map.delete(key);
    }
    static read(stm) {
        const dict = new VarDictionary();
        dict.readVersion(stm);
        for (let item; (item = dict.readItem(stm));) {
            dict._items.push(item);
            dict._map.set(item.key, item);
        }
        return dict;
    }
    readVersion(stm) {
        stm.getUint8();
        const versionMajor = stm.getUint8();
        if (versionMajor === 0 || versionMajor > MaxSupportedVersion) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.InvalidVersion);
        }
    }
    readItem(stm) {
        const type = stm.getUint8();
        if (!type) {
            return undefined;
        }
        const keyLength = stm.getInt32(true);
        if (keyLength <= 0) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'bad key length');
        }
        const key = byte_utils_1.bytesToString(stm.readBytes(keyLength));
        const valueLength = stm.getInt32(true);
        if (valueLength < 0) {
            throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'bad value length');
        }
        switch (type) {
            case ValueType.UInt32: {
                if (valueLength !== 4) {
                    throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'bad uint32');
                }
                const value = stm.getUint32(true);
                return { key, type, value };
            }
            case ValueType.UInt64: {
                if (valueLength !== 8) {
                    throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'bad uint64');
                }
                const loInt = stm.getUint32(true);
                const hiInt = stm.getUint32(true);
                const value = new int64_1.Int64(loInt, hiInt);
                return { key, type, value };
            }
            case ValueType.Bool: {
                if (valueLength !== 1) {
                    throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'bad bool');
                }
                const value = stm.getUint8() !== 0;
                return { key, type, value };
            }
            case ValueType.Int32: {
                if (valueLength !== 4) {
                    throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'bad int32');
                }
                const value = stm.getInt32(true);
                return { key, type, value };
            }
            case ValueType.Int64: {
                if (valueLength !== 8) {
                    throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'bad int64');
                }
                const loUint = stm.getUint32(true);
                const hiUint = stm.getUint32(true);
                const value = new int64_1.Int64(loUint, hiUint);
                return { key, type, value };
            }
            case ValueType.String: {
                const value = byte_utils_1.bytesToString(stm.readBytes(valueLength));
                return { key, type, value };
            }
            case ValueType.Bytes: {
                const value = stm.readBytes(valueLength);
                return { key, type, value };
            }
            default:
                throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, `bad value type: ${type}`);
        }
    }
    write(stm) {
        this.writeVersion(stm);
        for (const item of this._items) {
            this.writeItem(stm, item);
        }
        stm.setUint8(0);
    }
    writeVersion(stm) {
        stm.setUint16(DefaultVersion, true);
    }
    writeItem(stm, item) {
        stm.setUint8(item.type);
        const keyBytes = byte_utils_1.stringToBytes(item.key);
        stm.setInt32(keyBytes.length, true);
        stm.writeBytes(keyBytes);
        switch (item.type) {
            case ValueType.UInt32:
                stm.setInt32(4, true);
                stm.setUint32(item.value, true);
                break;
            case ValueType.UInt64:
                stm.setInt32(8, true);
                stm.setUint32(item.value.lo, true);
                stm.setUint32(item.value.hi, true);
                break;
            case ValueType.Bool:
                stm.setInt32(1, true);
                stm.setUint8(item.value ? 1 : 0);
                break;
            case ValueType.Int32:
                stm.setInt32(4, true);
                stm.setInt32(item.value, true);
                break;
            case ValueType.Int64:
                stm.setInt32(8, true);
                stm.setUint32(item.value.lo, true);
                stm.setUint32(item.value.hi, true);
                break;
            case ValueType.String: {
                const strBytes = byte_utils_1.stringToBytes(item.value);
                stm.setInt32(strBytes.length, true);
                stm.writeBytes(strBytes);
                break;
            }
            case ValueType.Bytes: {
                const bytesBuffer = byte_utils_1.arrayToBuffer(item.value);
                stm.setInt32(bytesBuffer.byteLength, true);
                stm.writeBytes(bytesBuffer);
                break;
            }
            default:
                throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.Unsupported);
        }
    }
}
exports.VarDictionary = VarDictionary;
VarDictionary.ValueType = ValueType;


/***/ }),

/***/ "./utils/xml-utils.ts":
/*!****************************!*\
  !*** ./utils/xml-utils.ts ***!
  \****************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.protectPlainValues = exports.protectUnprotectedValues = exports.unprotectValues = exports.updateProtectedValuesSalt = exports.setProtectedValues = exports.traverse = exports.setProtectedBinary = exports.getProtectedBinary = exports.setProtectedText = exports.getProtectedText = exports.setUuid = exports.getUuid = exports.strToBoolean = exports.setBoolean = exports.getBoolean = exports.setNumber = exports.getNumber = exports.setDate = exports.getDate = exports.setBytes = exports.getBytes = exports.setText = exports.getText = exports.addChildNode = exports.getChildNode = exports.create = exports.serialize = exports.parse = void 0;
const kdbx_error_1 = __webpack_require__(/*! ../errors/kdbx-error */ "./errors/kdbx-error.ts");
const consts_1 = __webpack_require__(/*! ../defs/consts */ "./defs/consts.ts");
const XmlNames = __webpack_require__(/*! ../defs/xml-names */ "./defs/xml-names.ts");
const byte_utils_1 = __webpack_require__(/*! ./byte-utils */ "./utils/byte-utils.ts");
const int64_1 = __webpack_require__(/*! ./int64 */ "./utils/int64.ts");
const kdbx_uuid_1 = __webpack_require__(/*! ../format/kdbx-uuid */ "./format/kdbx-uuid.ts");
const protected_value_1 = __webpack_require__(/*! ../crypto/protected-value */ "./crypto/protected-value.ts");
const pako = __webpack_require__(/*! pako */ "../node_modules/pako/index.js");
const kdbx_binaries_1 = __webpack_require__(/*! ../format/kdbx-binaries */ "./format/kdbx-binaries.ts");
const dateRegex = /\.\d\d\d/;
const EpochSeconds = 62135596800;
function createDOMParser() {
    if (__webpack_require__.g.DOMParser) {
        return new __webpack_require__.g.DOMParser();
    }
    const parserArg = {
        errorHandler: {
            error: (e) => {
                throw e;
            },
            fatalError: (e) => {
                throw e;
            }
        }
    };
    /* eslint-disable @typescript-eslint/no-var-requires,@typescript-eslint/no-unsafe-assignment,@typescript-eslint/no-unsafe-call */
    const { DOMParser } = __webpack_require__(/*! xmldom */ "xmldom");
    return new DOMParser(parserArg);
    /* eslint-enable */
}
function createXMLSerializer() {
    if (__webpack_require__.g.XMLSerializer) {
        return new __webpack_require__.g.XMLSerializer();
    }
    /* eslint-disable @typescript-eslint/no-var-requires,@typescript-eslint/no-unsafe-assignment,@typescript-eslint/no-unsafe-call */
    const { XMLSerializer } = __webpack_require__(/*! xmldom */ "xmldom");
    return new XMLSerializer();
    /* eslint-enable */
}
function parse(xml) {
    const parser = createDOMParser();
    let doc;
    // eslint-disable-next-line no-control-regex
    xml = xml.replace(/[\x00-\x09\x0B-\x0C\x0E-\x1F]/g, '');
    try {
        doc = parser.parseFromString(xml, 'application/xml');
    }
    catch (e) {
        const errMsg = e instanceof Error ? e.message : String(e);
        throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, `bad xml: ${errMsg}`);
    }
    if (!doc.documentElement) {
        throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, 'bad xml');
    }
    const parserError = doc.getElementsByTagName('parsererror')[0];
    if (parserError) {
        throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, `bad xml: ${parserError.textContent}`);
    }
    return doc;
}
exports.parse = parse;
function serialize(doc, prettyPrint = false) {
    if (prettyPrint) {
        prettyPrintXmlNode(doc, 0);
    }
    let xml = createXMLSerializer().serializeToString(doc);
    if (prettyPrint && xml.startsWith('<?')) {
        xml = xml.replace(/^(<\?.*?\?>)</, '$1\n<');
    }
    return xml;
}
exports.serialize = serialize;
function prettyPrintXmlNode(node, indentationLevel) {
    const numChildNodes = node.childNodes.length;
    if (numChildNodes === 0) {
        return;
    }
    const formatStr = '\n' + '    '.repeat(indentationLevel);
    const prevFormatStr = indentationLevel > 0 ? '\n' + '    '.repeat(indentationLevel - 1) : '';
    const doc = node.ownerDocument || node;
    const childNodes = [];
    let childNode;
    for (let i = 0; i < numChildNodes; i++) {
        childNode = node.childNodes[i];
        if (childNode.nodeType !== doc.TEXT_NODE &&
            childNode.nodeType !== doc.PROCESSING_INSTRUCTION_NODE) {
            childNodes.push(childNode);
        }
    }
    for (let j = 0; j < childNodes.length; j++) {
        childNode = childNodes[j];
        const isFirstDocumentNode = indentationLevel === 0 && j === 0;
        if (!isFirstDocumentNode) {
            const textNodeBefore = doc.createTextNode(formatStr);
            node.insertBefore(textNodeBefore, childNode);
        }
        if (!childNode.nextSibling && indentationLevel > 0) {
            const textNodeAfter = doc.createTextNode(prevFormatStr);
            node.appendChild(textNodeAfter);
        }
        prettyPrintXmlNode(childNode, indentationLevel + 1);
    }
}
function create(rootNode) {
    return parse('<?xml version="1.0" encoding="utf-8" standalone="yes"?><' + rootNode + '/>');
}
exports.create = create;
function getChildNode(node, tagName, errorMsgIfAbsent) {
    if (node && node.childNodes) {
        for (let i = 0, cn = node.childNodes, len = cn.length; i < len; i++) {
            if (cn[i].tagName === tagName) {
                return cn[i];
            }
        }
    }
    if (errorMsgIfAbsent) {
        throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, errorMsgIfAbsent);
    }
    else {
        return null;
    }
}
exports.getChildNode = getChildNode;
function addChildNode(node, tagName) {
    return node.appendChild((node.ownerDocument || node).createElement(tagName));
}
exports.addChildNode = addChildNode;
function getText(node) {
    var _a;
    if (!(node === null || node === void 0 ? void 0 : node.childNodes)) {
        return undefined;
    }
    return node.protectedValue ? node.protectedValue.getText() : (_a = node.textContent) !== null && _a !== void 0 ? _a : undefined;
}
exports.getText = getText;
function setText(node, text) {
    node.textContent = text || '';
}
exports.setText = setText;
function getBytes(node) {
    const text = getText(node);
    return text ? byte_utils_1.arrayToBuffer(byte_utils_1.base64ToBytes(text)) : undefined;
}
exports.getBytes = getBytes;
function setBytes(node, bytes) {
    if (typeof bytes === 'string') {
        bytes = byte_utils_1.base64ToBytes(bytes);
    }
    setText(node, bytes ? byte_utils_1.bytesToBase64(byte_utils_1.arrayToBuffer(bytes)) : undefined);
}
exports.setBytes = setBytes;
function getDate(node) {
    const text = getText(node);
    if (!text) {
        return undefined;
    }
    if (text.indexOf(':') > 0) {
        return new Date(text);
    }
    const bytes = new DataView(byte_utils_1.arrayToBuffer(byte_utils_1.base64ToBytes(text)));
    const secondsFrom00 = new int64_1.Int64(bytes.getUint32(0, true), bytes.getUint32(4, true)).value;
    const diff = (secondsFrom00 - EpochSeconds) * 1000;
    return new Date(diff);
}
exports.getDate = getDate;
function setDate(node, date, binary = false) {
    if (date) {
        if (binary) {
            const secondsFrom00 = Math.floor(date.getTime() / 1000) + EpochSeconds;
            const bytes = new DataView(new ArrayBuffer(8));
            const val64 = int64_1.Int64.from(secondsFrom00);
            bytes.setUint32(0, val64.lo, true);
            bytes.setUint32(4, val64.hi, true);
            setText(node, byte_utils_1.bytesToBase64(bytes.buffer));
        }
        else {
            setText(node, date.toISOString().replace(dateRegex, ''));
        }
    }
    else {
        setText(node, '');
    }
}
exports.setDate = setDate;
function getNumber(node) {
    const text = getText(node);
    return text ? +text : undefined;
}
exports.getNumber = getNumber;
function setNumber(node, number) {
    setText(node, typeof number === 'number' && !isNaN(number) ? number.toString() : undefined);
}
exports.setNumber = setNumber;
function getBoolean(node) {
    const text = getText(node);
    return text ? strToBoolean(text) : undefined;
}
exports.getBoolean = getBoolean;
function setBoolean(node, boolean) {
    setText(node, boolean === undefined ? '' : boolean === null ? 'null' : boolean ? 'True' : 'False');
}
exports.setBoolean = setBoolean;
function strToBoolean(str) {
    switch (str === null || str === void 0 ? void 0 : str.toLowerCase()) {
        case 'true':
            return true;
        case 'false':
            return false;
        case 'null':
            return null;
    }
    return undefined;
}
exports.strToBoolean = strToBoolean;
function getUuid(node) {
    const bytes = getBytes(node);
    return bytes ? new kdbx_uuid_1.KdbxUuid(bytes) : undefined;
}
exports.getUuid = getUuid;
function setUuid(node, uuid) {
    const uuidBytes = uuid instanceof kdbx_uuid_1.KdbxUuid ? uuid.toBytes() : uuid;
    setBytes(node, uuidBytes);
}
exports.setUuid = setUuid;
function getProtectedText(node) {
    var _a;
    return (_a = (node.protectedValue || node.textContent)) !== null && _a !== void 0 ? _a : undefined;
}
exports.getProtectedText = getProtectedText;
function setProtectedText(node, text) {
    if (text instanceof protected_value_1.ProtectedValue) {
        node.protectedValue = text;
        node.setAttribute(XmlNames.Attr.Protected, 'True');
    }
    else {
        setText(node, text);
    }
}
exports.setProtectedText = setProtectedText;
function getProtectedBinary(node) {
    if (node.protectedValue) {
        return node.protectedValue;
    }
    const text = node.textContent;
    const ref = node.getAttribute(XmlNames.Attr.Ref);
    if (ref) {
        return { ref };
    }
    if (!text) {
        return undefined;
    }
    const compressed = strToBoolean(node.getAttribute(XmlNames.Attr.Compressed));
    let bytes = byte_utils_1.base64ToBytes(text);
    if (compressed) {
        bytes = pako.ungzip(bytes);
    }
    return byte_utils_1.arrayToBuffer(bytes);
}
exports.getProtectedBinary = getProtectedBinary;
function setProtectedBinary(node, binary) {
    if (binary instanceof protected_value_1.ProtectedValue) {
        node.protectedValue = binary;
        node.setAttribute(XmlNames.Attr.Protected, 'True');
    }
    else if (kdbx_binaries_1.KdbxBinaries.isKdbxBinaryRef(binary)) {
        node.setAttribute(XmlNames.Attr.Ref, binary.ref);
    }
    else {
        setBytes(node, binary);
    }
}
exports.setProtectedBinary = setProtectedBinary;
function traverse(node, callback) {
    callback(node);
    for (let i = 0, cn = node.childNodes, len = cn.length; i < len; i++) {
        const childNode = cn[i];
        if (childNode.tagName) {
            traverse(childNode, callback);
        }
    }
}
exports.traverse = traverse;
function setProtectedValues(node, protectSaltGenerator) {
    traverse(node, (node) => {
        if (strToBoolean(node.getAttribute(XmlNames.Attr.Protected))) {
            try {
                const value = byte_utils_1.arrayToBuffer(byte_utils_1.base64ToBytes(node.textContent || ''));
                if (value.byteLength) {
                    const salt = protectSaltGenerator.getSalt(value.byteLength);
                    node.protectedValue = new protected_value_1.ProtectedValue(value, salt);
                }
            }
            catch (e) {
                throw new kdbx_error_1.KdbxError(consts_1.ErrorCodes.FileCorrupt, `bad protected value at line ${node.lineNumber}: ${e}`);
            }
        }
    });
}
exports.setProtectedValues = setProtectedValues;
function updateProtectedValuesSalt(node, protectSaltGenerator) {
    traverse(node, (node) => {
        if (strToBoolean(node.getAttribute(XmlNames.Attr.Protected)) && node.protectedValue) {
            const newSalt = protectSaltGenerator.getSalt(node.protectedValue.byteLength);
            node.protectedValue.setSalt(newSalt);
            node.textContent = node.protectedValue.toString();
        }
    });
}
exports.updateProtectedValuesSalt = updateProtectedValuesSalt;
function unprotectValues(node) {
    traverse(node, (node) => {
        if (strToBoolean(node.getAttribute(XmlNames.Attr.Protected)) && node.protectedValue) {
            node.removeAttribute(XmlNames.Attr.Protected);
            node.setAttribute(XmlNames.Attr.ProtectedInMemPlainXml, 'True');
            node.textContent = node.protectedValue.getText();
        }
    });
}
exports.unprotectValues = unprotectValues;
function protectUnprotectedValues(node) {
    traverse(node, (node) => {
        if (strToBoolean(node.getAttribute(XmlNames.Attr.ProtectedInMemPlainXml)) &&
            node.protectedValue) {
            node.removeAttribute(XmlNames.Attr.ProtectedInMemPlainXml);
            node.setAttribute(XmlNames.Attr.Protected, 'True');
            node.textContent = node.protectedValue.toString();
        }
    });
}
exports.protectUnprotectedValues = protectUnprotectedValues;
function protectPlainValues(node) {
    traverse(node, (node) => {
        if (strToBoolean(node.getAttribute(XmlNames.Attr.ProtectedInMemPlainXml))) {
            node.protectedValue = protected_value_1.ProtectedValue.fromString(node.textContent || '');
            node.textContent = node.protectedValue.toString();
            node.removeAttribute(XmlNames.Attr.ProtectedInMemPlainXml);
            node.setAttribute(XmlNames.Attr.Protected, 'True');
        }
    });
}
exports.protectPlainValues = protectPlainValues;


/***/ }),

/***/ "crypto":
/*!*************************!*\
  !*** external "crypto" ***!
  \*************************/
/***/ ((module) => {

module.exports = __WEBPACK_EXTERNAL_MODULE_crypto__;

/***/ }),

/***/ "xmldom":
/*!*************************!*\
  !*** external "xmldom" ***!
  \*************************/
/***/ ((module) => {

module.exports = __WEBPACK_EXTERNAL_MODULE_xmldom__;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/global */
/******/ 	(() => {
/******/ 		__webpack_require__.g = (function() {
/******/ 			if (typeof globalThis === 'object') return globalThis;
/******/ 			try {
/******/ 				return this || new Function('return this')();
/******/ 			} catch (e) {
/******/ 				if (typeof window === 'object') return window;
/******/ 			}
/******/ 		})();
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
(() => {
var exports = __webpack_exports__;
/*!******************!*\
  !*** ./index.ts ***!
  \******************/

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.XmlUtils = exports.VarDictionary = exports.Int64 = exports.ByteUtils = exports.BinaryStream = exports.KdbxUuid = exports.KdbxTimes = exports.KdbxMeta = exports.KdbxHeader = exports.KdbxGroup = exports.KdbxFormat = exports.KdbxEntry = exports.KdbxDeletedObject = exports.KdbxCustomData = exports.Credentials = exports.KdbxCredentials = exports.KdbxContext = exports.KdbxBinaries = exports.Kdbx = exports.KdbxError = exports.XmlNames = exports.Consts = exports.Salsa20 = exports.ProtectedValue = exports.ProtectSaltGenerator = exports.KeyEncryptorKdf = exports.KeyEncryptorAes = exports.HmacBlockTransform = exports.HashedBlockTransform = exports.CryptoEngine = exports.ChaCha20 = void 0;
const chacha20_1 = __webpack_require__(/*! ./crypto/chacha20 */ "./crypto/chacha20.ts");
Object.defineProperty(exports, "ChaCha20", ({ enumerable: true, get: function () { return chacha20_1.ChaCha20; } }));
const CryptoEngine = __webpack_require__(/*! ./crypto/crypto-engine */ "./crypto/crypto-engine.ts");
exports.CryptoEngine = CryptoEngine;
const HashedBlockTransform = __webpack_require__(/*! ./crypto/hashed-block-transform */ "./crypto/hashed-block-transform.ts");
exports.HashedBlockTransform = HashedBlockTransform;
const HmacBlockTransform = __webpack_require__(/*! ./crypto/hmac-block-transform */ "./crypto/hmac-block-transform.ts");
exports.HmacBlockTransform = HmacBlockTransform;
const KeyEncryptorAes = __webpack_require__(/*! ./crypto/key-encryptor-aes */ "./crypto/key-encryptor-aes.ts");
exports.KeyEncryptorAes = KeyEncryptorAes;
const KeyEncryptorKdf = __webpack_require__(/*! ./crypto/key-encryptor-kdf */ "./crypto/key-encryptor-kdf.ts");
exports.KeyEncryptorKdf = KeyEncryptorKdf;
const protect_salt_generator_1 = __webpack_require__(/*! ./crypto/protect-salt-generator */ "./crypto/protect-salt-generator.ts");
Object.defineProperty(exports, "ProtectSaltGenerator", ({ enumerable: true, get: function () { return protect_salt_generator_1.ProtectSaltGenerator; } }));
const protected_value_1 = __webpack_require__(/*! ./crypto/protected-value */ "./crypto/protected-value.ts");
Object.defineProperty(exports, "ProtectedValue", ({ enumerable: true, get: function () { return protected_value_1.ProtectedValue; } }));
const salsa20_1 = __webpack_require__(/*! ./crypto/salsa20 */ "./crypto/salsa20.ts");
Object.defineProperty(exports, "Salsa20", ({ enumerable: true, get: function () { return salsa20_1.Salsa20; } }));
const Consts = __webpack_require__(/*! ./defs/consts */ "./defs/consts.ts");
exports.Consts = Consts;
const XmlNames = __webpack_require__(/*! ./defs/xml-names */ "./defs/xml-names.ts");
exports.XmlNames = XmlNames;
const kdbx_error_1 = __webpack_require__(/*! ./errors/kdbx-error */ "./errors/kdbx-error.ts");
Object.defineProperty(exports, "KdbxError", ({ enumerable: true, get: function () { return kdbx_error_1.KdbxError; } }));
const kdbx_1 = __webpack_require__(/*! ./format/kdbx */ "./format/kdbx.ts");
Object.defineProperty(exports, "Kdbx", ({ enumerable: true, get: function () { return kdbx_1.Kdbx; } }));
const kdbx_binaries_1 = __webpack_require__(/*! ./format/kdbx-binaries */ "./format/kdbx-binaries.ts");
Object.defineProperty(exports, "KdbxBinaries", ({ enumerable: true, get: function () { return kdbx_binaries_1.KdbxBinaries; } }));
const kdbx_context_1 = __webpack_require__(/*! ./format/kdbx-context */ "./format/kdbx-context.ts");
Object.defineProperty(exports, "KdbxContext", ({ enumerable: true, get: function () { return kdbx_context_1.KdbxContext; } }));
const kdbx_credentials_1 = __webpack_require__(/*! ./format/kdbx-credentials */ "./format/kdbx-credentials.ts");
Object.defineProperty(exports, "KdbxCredentials", ({ enumerable: true, get: function () { return kdbx_credentials_1.KdbxCredentials; } }));
Object.defineProperty(exports, "Credentials", ({ enumerable: true, get: function () { return kdbx_credentials_1.KdbxCredentials; } }));
const kdbx_custom_data_1 = __webpack_require__(/*! ./format/kdbx-custom-data */ "./format/kdbx-custom-data.ts");
Object.defineProperty(exports, "KdbxCustomData", ({ enumerable: true, get: function () { return kdbx_custom_data_1.KdbxCustomData; } }));
const kdbx_deleted_object_1 = __webpack_require__(/*! ./format/kdbx-deleted-object */ "./format/kdbx-deleted-object.ts");
Object.defineProperty(exports, "KdbxDeletedObject", ({ enumerable: true, get: function () { return kdbx_deleted_object_1.KdbxDeletedObject; } }));
const kdbx_entry_1 = __webpack_require__(/*! ./format/kdbx-entry */ "./format/kdbx-entry.ts");
Object.defineProperty(exports, "KdbxEntry", ({ enumerable: true, get: function () { return kdbx_entry_1.KdbxEntry; } }));
const kdbx_format_1 = __webpack_require__(/*! ./format/kdbx-format */ "./format/kdbx-format.ts");
Object.defineProperty(exports, "KdbxFormat", ({ enumerable: true, get: function () { return kdbx_format_1.KdbxFormat; } }));
const kdbx_group_1 = __webpack_require__(/*! ./format/kdbx-group */ "./format/kdbx-group.ts");
Object.defineProperty(exports, "KdbxGroup", ({ enumerable: true, get: function () { return kdbx_group_1.KdbxGroup; } }));
const kdbx_header_1 = __webpack_require__(/*! ./format/kdbx-header */ "./format/kdbx-header.ts");
Object.defineProperty(exports, "KdbxHeader", ({ enumerable: true, get: function () { return kdbx_header_1.KdbxHeader; } }));
const kdbx_meta_1 = __webpack_require__(/*! ./format/kdbx-meta */ "./format/kdbx-meta.ts");
Object.defineProperty(exports, "KdbxMeta", ({ enumerable: true, get: function () { return kdbx_meta_1.KdbxMeta; } }));
const kdbx_times_1 = __webpack_require__(/*! ./format/kdbx-times */ "./format/kdbx-times.ts");
Object.defineProperty(exports, "KdbxTimes", ({ enumerable: true, get: function () { return kdbx_times_1.KdbxTimes; } }));
const kdbx_uuid_1 = __webpack_require__(/*! ./format/kdbx-uuid */ "./format/kdbx-uuid.ts");
Object.defineProperty(exports, "KdbxUuid", ({ enumerable: true, get: function () { return kdbx_uuid_1.KdbxUuid; } }));
const binary_stream_1 = __webpack_require__(/*! ./utils/binary-stream */ "./utils/binary-stream.ts");
Object.defineProperty(exports, "BinaryStream", ({ enumerable: true, get: function () { return binary_stream_1.BinaryStream; } }));
const ByteUtils = __webpack_require__(/*! ./utils/byte-utils */ "./utils/byte-utils.ts");
exports.ByteUtils = ByteUtils;
const int64_1 = __webpack_require__(/*! ./utils/int64 */ "./utils/int64.ts");
Object.defineProperty(exports, "Int64", ({ enumerable: true, get: function () { return int64_1.Int64; } }));
const var_dictionary_1 = __webpack_require__(/*! ./utils/var-dictionary */ "./utils/var-dictionary.ts");
Object.defineProperty(exports, "VarDictionary", ({ enumerable: true, get: function () { return var_dictionary_1.VarDictionary; } }));
const XmlUtils = __webpack_require__(/*! ./utils/xml-utils */ "./utils/xml-utils.ts");
exports.XmlUtils = XmlUtils;

})();

/******/ 	return __webpack_exports__;
/******/ })()
;
});
//# sourceMappingURL=kdbxweb.js.map